GNU bug report logs - #38457
27.0.50; dabbrev-expand regression due to message change

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Stephen Berman <stephen.berman@HIDDEN>; Keywords: fixed; merged with #38560; Done: Juri Linkov <juri@HIDDEN>; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 22 Jan 2020 00:46:30 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 21 19:46:30 2020
Received: from localhost ([127.0.0.1]:48733 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iu4AA-0000R5-2w
	for submit <at> debbugs.gnu.org; Tue, 21 Jan 2020 19:46:30 -0500
Received: from mail-lf1-f45.google.com ([209.85.167.45]:46647)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1iu4A9-0000LX-3g
 for 38457 <at> debbugs.gnu.org; Tue, 21 Jan 2020 19:46:29 -0500
Received: by mail-lf1-f45.google.com with SMTP id z26so3874377lfg.13
 for <38457 <at> debbugs.gnu.org>; Tue, 21 Jan 2020 16:46:28 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=I4Ip+Tt++PgG7kkoJU1HIt94xlAkF5U0Iwf6c1G6W6Y=;
 b=sJ0VBnhODQTFBvJzg9+1MNCVk25gMymCmZCqqEPw3u3fofggGxRLZeLQdIfgcftZXv
 t9yuEWUIoXN7eSE/cfeUFn4yQ/mIQWz2LpoYD3h5zTjx2QA6S12hgiW2pTfjKIdAXidq
 6+eEm2524CvjVZYJDZdkxvWFXUrUKLRL5V51yJ5X2SZY5p17n7QjlXeFNYHyJ0wdb5pG
 T88sqgpZUyYVaa7fVFjHTHsYBkBchXGasUR0SSH/pH43O0IJ5MLRHbqCS8orxJr7odrF
 A055PKBQL7vNJXbH5tk5rqPCddJGFCcuyiMOOLKJCvAR+zfsDCsuv2AMdlCDeqFgv9CR
 qUIA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=I4Ip+Tt++PgG7kkoJU1HIt94xlAkF5U0Iwf6c1G6W6Y=;
 b=LkVB4xODpG/2EvFZp29vcYr8aCRNjJc+tXFKW5wk7qGdWzTHUlM3vJFX4ilKi3uQil
 a4yFka5h9jPt70bv97U7UaAj2QIGj6LBqijL7zK2hCc/XCPlQJPtcS6tjizThfMe+kLa
 4t5UR6imuqCIbulc6QrXOg9AobA8NXih0BfLfoMHQPTrlkOiOfVsQmKUXLx4dU8hvxpF
 +lLjP9Ip4xaON3os+WVeq8CPEixvUAg7uC2TyjfckfuwXLTgqsLMuAbgSrBKdSmeZINs
 E8wt6wO0XVEtP71sma8J+e19FxTTMdd8VVxgr/QKwO3MZpamNaXJyFmMW93RBsdOzbKj
 RYdA==
X-Gm-Message-State: APjAAAUKijKL8GJ2GWdu/Q3E2SeOy+yO1JdfxELYYGtKzz7L26MVbYHs
 crZv+UGXvPk8Qy5lMyBFRX4=
X-Google-Smtp-Source: APXvYqyFbQhyKs6I+452IEH5f+ed1wPSp+2waE62H9cmGlJsTVitGdTP1ZgYmYIXJD17UsTMq2+YmQ==
X-Received: by 2002:a19:c014:: with SMTP id q20mr240186lff.209.1579653983059; 
 Tue, 21 Jan 2020 16:46:23 -0800 (PST)
Received: from [192.168.1.142] ([178.252.127.239])
 by smtp.googlemail.com with ESMTPSA id l5sm19643946lje.1.2020.01.21.16.46.21
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Tue, 21 Jan 2020 16:46:21 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Eli Zaretskii <eliz@HIDDEN>, Stefan Monnier <monnier@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> <83eewsuzhn.fsf@HIDDEN>
 <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
 <e14efe07-0724-23d9-7f93-08094cd3c4f6@HIDDEN> <83pnfh18ir.fsf@HIDDEN>
 <b2db4d11-fe28-a6be-a63a-5dd346a35e4b@HIDDEN> <83a76gwzu6.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <af119c89-7e03-cc7a-2771-245eb14c289b@HIDDEN>
Date: Wed, 22 Jan 2020 03:46:21 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <83a76gwzu6.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  On 21.01.2020 19:15, Eli Zaretskii wrote: > Thanks. For the
 record, I only see the problem if I type "C-h f f"; > neither "C-h f asd"
 nor "C-h f ft" reproduce the issue, because the > list of the cand [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [178.252.127.239 listed in dnsbl.sorbs.net]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (dgutov[at]yandex.ru)
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
 mail domains are different
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.167.45 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.167.45 listed in wl.mailspike.net]
 0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and
 EnvelopeFrom freemail headers are different
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

On 21.01.2020 19:15, Eli Zaretskii wrote:
> Thanks.  For the record, I only see the problem if I type "C-h f f";
> neither "C-h f asd" nor "C-h f ft" reproduce the issue, because the
> list of the candidates displayed by Icomplete is too short.

Ah, that's right. I was using a small-ish window, one that Emacs opens 
by default. Nothing close to fullscreen.

> I think it is (was) just random, see below.

Hmm, guess so. Though it must have been a peculiar kind of random.

> Solution: use overlay priority.

Thank you, Eli.

I will push my Ido patch shortly as well.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 21 Jan 2020 16:15:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jan 21 11:15:16 2020
Received: from localhost ([127.0.0.1]:48304 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itwBP-0005jJ-SI
	for submit <at> debbugs.gnu.org; Tue, 21 Jan 2020 11:15:16 -0500
Received: from eggs.gnu.org ([209.51.188.92]:53907)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1itwBO-0005j3-A3
 for 38457 <at> debbugs.gnu.org; Tue, 21 Jan 2020 11:15:15 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:48311)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1itwBI-0005k9-8g; Tue, 21 Jan 2020 11:15:08 -0500
Received: from [176.228.60.248] (port=4177 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1itwBC-0008TH-Qf; Tue, 21 Jan 2020 11:15:04 -0500
Date: Tue, 21 Jan 2020 18:15:13 +0200
Message-Id: <83a76gwzu6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>, Stefan Monnier <monnier@HIDDEN>
In-reply-to: <b2db4d11-fe28-a6be-a63a-5dd346a35e4b@HIDDEN> (message from
 Dmitry Gutov on Mon, 20 Jan 2020 15:30:06 +0300)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> <83eewsuzhn.fsf@HIDDEN>
 <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
 <e14efe07-0724-23d9-7f93-08094cd3c4f6@HIDDEN> <83pnfh18ir.fsf@HIDDEN>
 <b2db4d11-fe28-a6be-a63a-5dd346a35e4b@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
> From: Dmitry Gutov <dgutov@HIDDEN>
> Date: Mon, 20 Jan 2020 15:30:06 +0300
> 
> On 18.01.2020 11:19, Eli Zaretskii wrote:
> 
> >>>> No.  The cursor is always displayed after the overlay string.  If you
> >>>> want it to do anything else, you need to put a 'cursor' property on
> >>>> the overlay string.
> >>>
> >>> We do that there.
> >>
> >> And yet, the message appears before the cursor in the described
> >> circumstances.
> > 
> > Can I have a simple reproducer for this, so I could see what's going
> > on there?
> 
> A couple scenarios:
> 
> 1. M-x icomplete-mode
> 2. M-: (run-with-idle-timer 2 nil (lambda () (message "beep")))
> 2. C-h f
> 3. Input something that will lead to either [Matched] or [No Matches],
> e.g. 'asd'.
> 4. See [beep] appear before the cursor.
> 
> OR
> 
> 1. M-: (setq resize-mini-windows nil)
> 2. M-x icomplete-mode
> (The same reproduces with Ido with my patch posted)
> 2. M-: (run-with-idle-timer 2 nil (lambda () (message "beep")))
> 3. C-h f
> 4. Input anything at all. E.g. something that will have matches, like 
> 'ft' or just 'f'.
> 5. See [beep] appear before the cursor.

Thanks.  For the record, I only see the problem if I type "C-h f f";
neither "C-h f asd" nor "C-h f ft" reproduce the issue, because the
list of the candidates displayed by Icomplete is too short.

> Strangely, whether it appears before or after the cursor (at the very 
> end of the minibuffer), is affected by the value of 
> 'resize-mini-windows' (???).

I think it is (was) just random, see below.

There were 2 separate problems here.  First, Icomplete displays the
completion candidates as an after-string, so we end up having 2
overlays at EOB, both of them with after-strings.  Question: which one
of them will be displayed first?  Answer: it isn't predictable, you
are at the mercy of the overlay-sorting order when all the criteria
for sorting compare equal.  So sometimes the "beep" thing is displayed
before the candidate list/"Not matched" and sometimes after.
Moreover, if it happens to be after, and resize-mini-windows is nil,
and the list of candidates is too long to be displayed in its
entirety, then "beep" will not be shown at all.

Solution: use overlay priority.  You will see that I gave the overlay
produced by set-minibuffer-message a very high priority.  But I'm not
wedded to that number, I just don't know what the likes of Ivy, Helm,
and other heavily customized environments could do in their completion
features.  If we can make the priority lower, say, 101, I'd be much
happier.  CC'ing Stefan who I hope will have some useful input on this
matter.

The second problem is with setting the cursor when we have several
overlays with after-strings one after another.  When this happens, it
is generally not enough to use the 'cursor' property of t on the
overlay string character where you want the cursor, you need to use a
number.  Which I did.  The reason is that overlay strings are
problematic in this case, because the code which sets the cursor
cannot know where the overlay start was in the buffer (unlike with
strings that come from display properties), so it needs more help, and
the integer value of the 'cursor' property provides that help.

I only tested the fix (now on the emacs-27 branch) with Icomplete, but
I think Ido will work correctly as well, if you use your patch there.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 20 Jan 2020 12:30:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Jan 20 07:30:23 2020
Received: from localhost ([127.0.0.1]:44471 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1itWCA-0007YI-V9
	for submit <at> debbugs.gnu.org; Mon, 20 Jan 2020 07:30:23 -0500
Received: from mail-lf1-f51.google.com ([209.85.167.51]:32917)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1itWC6-0007OM-3e
 for 38457 <at> debbugs.gnu.org; Mon, 20 Jan 2020 07:30:18 -0500
Received: by mail-lf1-f51.google.com with SMTP id n25so23940887lfl.0
 for <38457 <at> debbugs.gnu.org>; Mon, 20 Jan 2020 04:30:14 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=j1hmiffPOcNtlodebWPDprtYKG9ITfF/homzE/DI81E=;
 b=fDtqxfG74uAAM4s8OEHDda0dTOCehKSlL51tPcRRKkjqlaLrUayemaLdamc15lwOvS
 InfFk+gRW9JaOgaojVGuq5zXTiiD/PX6tKjLHYZ51EXfPvoN0HCzoxftmQHA/a6SdEtS
 avkFLsELjDoOyYAMJhv7j88iT/e7JaK5Eg6Vpea1KtkcGaHgQrLXmkA1g1GsDK0daN0V
 46c+Up3lSOsSU+nJj7gK2PTF7Bm5tPc2dnTUdS8oE6ABHTrHQzTxVTggelgwvXGS6yg0
 ANw0Dfdn8F15qT9tnBASGKgc/8Nm6N8835HxGUf5M/vEt3xkFIoXu1MO/GxrhBXClFkJ
 4v2g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=j1hmiffPOcNtlodebWPDprtYKG9ITfF/homzE/DI81E=;
 b=aD+ab3a0rhqqjvIw1agmI98sbuuXHCqcdA+9QfMrJQXS7C+Yo8T04RrhiAfEeANyom
 3QkyJdVcx4GmEYNTQaCKnkfs938ydEW0rW6LDY9NUPKUVm1Sa+g3WkFV0VfI1E+YgQ4X
 EVu+lgEP5gHcN8mewdVjTrKSdvyaqoGBkYuaF2hoBlJmYBePVM6ORjnvk93z1B51+K9j
 dbwDNWU4byTNz2faR7Dh9UXBSs9ofGCeAlU2lb5ARohjJ9pjRyIpCKA/SbwXDwHBDNVw
 iZZWaL6u3hDS8hHC9ZJrRBYaZnLpfGw0kJ8G81LIuBiythd2TpQMp54jx6FehPat8tVC
 sPDw==
X-Gm-Message-State: APjAAAUUN0flEwJilBEeFZ8N8M3G9kfW7KxBW1aYxUB7EduhACeaflmT
 9nOjtx+l2bboKOyHK6G5orw=
X-Google-Smtp-Source: APXvYqzm70gRDDtnmfYFo9PYUeB4Fr+RK7HoJp8MaRyvJhYxCa4dQIo1+m3E+O2ErZy0Rmp2gKR9uw==
X-Received: by 2002:a19:84d:: with SMTP id 74mr12926037lfi.122.1579523408057; 
 Mon, 20 Jan 2020 04:30:08 -0800 (PST)
Received: from [192.168.1.142] ([178.252.127.239])
 by smtp.googlemail.com with ESMTPSA id r2sm5034487lff.63.2020.01.20.04.30.06
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 20 Jan 2020 04:30:07 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> <83eewsuzhn.fsf@HIDDEN>
 <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
 <e14efe07-0724-23d9-7f93-08094cd3c4f6@HIDDEN> <83pnfh18ir.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <b2db4d11-fe28-a6be-a63a-5dd346a35e4b@HIDDEN>
Date: Mon, 20 Jan 2020 15:30:06 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <83pnfh18ir.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  On 18.01.2020 11:19, Eli Zaretskii wrote: >>>> No.  The cursor
    is always displayed after the overlay string.  If you >>>> want it to do
    anything else, you need to put a 'cursor' property on >>>> the overlay string.
    >>> >>> We do that there. [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
                             [178.252.127.239 listed in dnsbl.sorbs.net]
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.167.51 listed in list.dnswl.org]
  0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
                             mail domains are different
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (raaahh[at]gmail.com)
 -0.0 SPF_PASS               SPF: sender matches SPF record
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.167.51 listed in wl.mailspike.net]
  0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and
                             EnvelopeFrom freemail headers are
                             different
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

On 18.01.2020 11:19, Eli Zaretskii wrote:

>>>> No.  The cursor is always displayed after the overlay string.  If you
>>>> want it to do anything else, you need to put a 'cursor' property on
>>>> the overlay string.
>>>
>>> We do that there.
>>
>> And yet, the message appears before the cursor in the described
>> circumstances.
> 
> Can I have a simple reproducer for this, so I could see what's going
> on there?

A couple scenarios:

1. M-x icomplete-mode
2. M-: (run-with-idle-timer 2 nil (lambda () (message "beep")))
2. C-h f
3. Input something that will lead to either [Matched] or [No Matches],
e.g. 'asd'.
4. See [beep] appear before the cursor.

OR

1. M-: (setq resize-mini-windows nil)
2. M-x icomplete-mode
(The same reproduces with Ido with my patch posted)
2. M-: (run-with-idle-timer 2 nil (lambda () (message "beep")))
3. C-h f
4. Input anything at all. E.g. something that will have matches, like 
'ft' or just 'f'.
5. See [beep] appear before the cursor.

Strangely, whether it appears before or after the cursor (at the very 
end of the minibuffer), is affected by the value of 
'resize-mini-windows' (???).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Jan 2020 08:19:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jan 18 03:19:47 2020
Received: from localhost ([127.0.0.1]:40411 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1isjKd-00064J-Bv
	for submit <at> debbugs.gnu.org; Sat, 18 Jan 2020 03:19:47 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58271)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1isjKa-000646-R7
 for 38457 <at> debbugs.gnu.org; Sat, 18 Jan 2020 03:19:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49119)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1isjKU-0004uI-DG; Sat, 18 Jan 2020 03:19:38 -0500
Received: from [176.228.60.248] (port=2334 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1isjKT-00081l-Sq; Sat, 18 Jan 2020 03:19:38 -0500
Date: Sat, 18 Jan 2020 10:19:40 +0200
Message-Id: <83pnfh18ir.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
In-reply-to: <e14efe07-0724-23d9-7f93-08094cd3c4f6@HIDDEN> (message from
 Dmitry Gutov on Sat, 18 Jan 2020 03:59:31 +0300)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> <83eewsuzhn.fsf@HIDDEN>
 <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
 <e14efe07-0724-23d9-7f93-08094cd3c4f6@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Dmitry Gutov <dgutov@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
> Date: Sat, 18 Jan 2020 03:59:31 +0300
> 
> On 25.12.2019 19:49, Dmitry Gutov wrote:
> > On 25.12.2019 18:44, Eli Zaretskii wrote:
> >> No.  The cursor is always displayed after the overlay string.  If you
> >> want it to do anything else, you need to put a 'cursor' property on
> >> the overlay string.
> > 
> > We do that there.
> 
> And yet, the message appears before the cursor in the described 
> circumstances.

Can I have a simple reproducer for this, so I could see what's going
on there?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Jan 2020 01:00:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 17 20:00:43 2020
Received: from localhost ([127.0.0.1]:40331 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iscTi-0001xP-Tc
	for submit <at> debbugs.gnu.org; Fri, 17 Jan 2020 20:00:43 -0500
Received: from mail-lf1-f43.google.com ([209.85.167.43]:46083)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1iscTd-0001x9-H8
 for 38457 <at> debbugs.gnu.org; Fri, 17 Jan 2020 20:00:41 -0500
Received: by mail-lf1-f43.google.com with SMTP id f15so19683323lfl.13
 for <38457 <at> debbugs.gnu.org>; Fri, 17 Jan 2020 17:00:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:from:to:cc:references:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=j3dPF1039iyFmjiHYbIY7fsY7TU7UpQqfv9j+DzPBFQ=;
 b=SyRj91KB93r7hmQuAtsZweOWQ1W6tI8SVe/0qpbqPG3qw1hbp1Y8R/3IbZCUnRL/IU
 zTbJUVQhwZaGej7/gQw78UIbvTXQbRfQR8R8bfRscF2aMMFjlcBPY+Ixmw1xs8NrhYfd
 pQYXVw3ZmTIjmSwDOCNpv94CC5Jcaj3vHq9FClqysFQGD30KvDxyeTWZxoPQGf3C57EH
 otUSCkVTPNQFkNZep2j8Ndkdn47mPGqzUMbiGwUe2DOPW7SAmQdEz/JCrCR7lTtP+W2G
 57YVmszJfRWNwdmMZMd7RL6DcmEIedLGyLFdrukhsQ85iAvwVqQykxXypTNV0+bTCZO/
 L/ww==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:from:to:cc:references:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=j3dPF1039iyFmjiHYbIY7fsY7TU7UpQqfv9j+DzPBFQ=;
 b=Ecm+akV7i9bf3gi4tJova/OZ0k1emCPzIafMy1t4VfeKIpR7nXmZj36Wb8AiZZBeGG
 DKQSxUTNGesJhmGQ6efqEsdjyN+75axwBBVxFurkNZcgbGORXkh/qUjBsvMy8y84PNS4
 agDvroDJqP74kyurWQZuoJl3Orp6op2ZRKB228nL4Z6KexGFVHp6Z6AIe/v86tDAPwBc
 o9FDTNh2EGaIFedp/7vDjHXI4VVZUeVF/O4CtbFrO5HF09UP8Bk3JbR/o2Sn82xwn57B
 GPXg+C2UqA2Nv1pprDWtzL+lF84cIgyc7kSj0AlWiWvYRAd5x5lGJGizgFffBv3obpNs
 Ra1g==
X-Gm-Message-State: APjAAAUoRpreKY+EWnmMdLrLrJvEBXk9KmVyne9OeY0ia/44xc4TmQjt
 HWUyJbjCv2gHyGeLTgjpB1aGniFq6V0=
X-Google-Smtp-Source: APXvYqxwaxsXnktdkLkuWkBBVvvQpAhFsswnaIQX0aJqwtkl0xPHxbq7zqWBu4zwal/8lATZCK1jow==
X-Received: by 2002:a19:ac43:: with SMTP id r3mr7230335lfc.156.1579309231087; 
 Fri, 17 Jan 2020 17:00:31 -0800 (PST)
Received: from [192.168.1.142] ([178.252.127.239])
 by smtp.googlemail.com with ESMTPSA id o10sm12975384lfn.20.2020.01.17.17.00.30
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Fri, 17 Jan 2020 17:00:30 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
From: Dmitry Gutov <dgutov@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN>
Message-ID: <1ce4fada-b608-359e-b2cc-34fb8b229cf4@HIDDEN>
Date: Sat, 18 Jan 2020 04:00:30 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Eli, don't you think we should iron out this new feature's
 interaction with icomplete and ido before the release? On 25.12.2019 19:30,
 Dmitry Gutov wrote: > >> Could ido-mode use an overlay the same way as it's
 used in icomplete >> that plays nicely with the set-minibuffer-message
 overlay? > > This seems to work, [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
 [178.252.127.239 listed in dnsbl.sorbs.net]
 -0.0 SPF_PASS               SPF: sender matches SPF record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (dgutov[at]yandex.ru)
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
 mail domains are different
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [209.85.167.43 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
 [209.85.167.43 listed in wl.mailspike.net]
 0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and
 EnvelopeFrom freemail headers are different
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

Eli, don't you think we should iron out this new feature's interaction 
with icomplete and ido before the release?

On 25.12.2019 19:30, Dmitry Gutov wrote:
> 
>> Could ido-mode use an overlay the same way as it's used in icomplete
>> that plays nicely with the set-minibuffer-message overlay?
> 
> This seems to work, but it needs more testing:
> 
> diff --git a/lisp/ido.el b/lisp/ido.el
> index 79f259b819..d47450fc40 100644
> --- a/lisp/ido.el
> +++ b/lisp/ido.el
> @@ -4492,6 +4492,8 @@ ido-initiate-auto-merge
>       (ido-tidy))
>         (throw 'ido contents))))
> 
> +(defvar ido--overlay nil)
> +
>   (defun ido-exhibit ()
>     "Post command hook for Ido."
>     ;; Find matching files and display a list in the minibuffer.
> @@ -4726,7 +4728,12 @@ ido-exhibit
>       (let ((inf (ido-completions contents)))
>         (setq ido-show-confirm-message nil)
>         (ido-trace "inf" inf)
> -      (insert inf))
> +          (when ido--overlay
> +            (delete-overlay ido--overlay))
> +          (let ((o (make-overlay (point-max) (point-max) nil t t)))
> +            (when (> (length inf) 0)
> +              (put-text-property 0 1 'cursor t inf))
> +            (overlay-put o 'after-string inf)
> +            (setq ido--overlay o)))
>       ))))
> 
>   (defun ido-completions (name)





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Jan 2020 00:59:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jan 17 19:59:41 2020
Received: from localhost ([127.0.0.1]:40326 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iscSj-0001u6-G9
	for submit <at> debbugs.gnu.org; Fri, 17 Jan 2020 19:59:41 -0500
Received: from mail-lj1-f175.google.com ([209.85.208.175]:40133)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1iscSh-0001tr-MV
 for 38457 <at> debbugs.gnu.org; Fri, 17 Jan 2020 19:59:40 -0500
Received: by mail-lj1-f175.google.com with SMTP id u1so28267082ljk.7
 for <38457 <at> debbugs.gnu.org>; Fri, 17 Jan 2020 16:59:39 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:from:to:cc:references:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=tb7/J3BYDjP33J7ncUkG8glT3Nn5pitwnVC8mnsdGz4=;
 b=G4MeL2nBbeNOL+4q4yycvAm3BllsJX/wQP6p5mqEnVp+kGOKqkuE36/5PhInArzDUa
 Ba5HuX+w7ZAGPykGESJYvL8T6rIbZQ64hBWQIFz0cKjlTjD8c/RaFJBKZGs2Fty1TfPz
 LmOy3KNkDAxuYK46VoZNnMpKWeJ36x6+yagfVCqaBHGOeoBENXYz5SfycxZWVVYdVuDZ
 K7gevjirKuHdDhQ0GZZUJMjy4Zx+6e10lj8Lbdi+Ns5rLKReDoySP+B2qcW9sUW7/Y8O
 eq0FXpLWTj+Qzmei5OunMJqp9azkvgZLYAaWqWwOpQl0ujmD7hp+/aB0Hsf9SfJILWLB
 pzpw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:from:to:cc:references:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=tb7/J3BYDjP33J7ncUkG8glT3Nn5pitwnVC8mnsdGz4=;
 b=Aa2kISFuL1FCvx2ntGFUrf6YO44ywfJYZ3ErBvNBLBj6UcEnZff3OhpOkj47wC6tih
 MHIoJV0N8a7cKUwLocJOg9E8vqvLyUhTZH2cStSSSPbrJNeIzHkJsB+U61KpW1p//2za
 z7SdRUEwG66ZFW8Ndp0bZ7kF7EotNBJJE4jJJis5j1bswzj1q9qSOHnV4TWrpnOsUDYA
 A1/zlXDiX12oIHezm14knyUcujH+WN6JVimAsUmyhdd2h8/Dv1znp4zwe+dduzdwdXuO
 dnbnsC1kKcUBQqlSVFu15/8k16TsxuS9ioqCY3PDIByZSzT1gX6uMpViAj8r6Sfjj5r1
 TW9A==
X-Gm-Message-State: APjAAAW46Xbrh8A65AunYGlgDtROyozWdju9q+J1hOsIhe3vzzUnOb/I
 RPlJPH4rJUKS2sE3Mp6on8hb2aPc9Rk=
X-Google-Smtp-Source: APXvYqxSydbC/Xq3vbosJemdtcov1Xmrz7IPEaBllYffMon1+13EdrpHzOjIn6CW5GP8ebIuullV8A==
X-Received: by 2002:a05:651c:1032:: with SMTP id
 w18mr6670649ljm.61.1579309173431; 
 Fri, 17 Jan 2020 16:59:33 -0800 (PST)
Received: from [192.168.1.142] ([178.252.127.239])
 by smtp.googlemail.com with ESMTPSA id f22sm13137605ljh.74.2020.01.17.16.59.31
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Fri, 17 Jan 2020 16:59:32 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
From: Dmitry Gutov <dgutov@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> <83eewsuzhn.fsf@HIDDEN>
 <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
Message-ID: <e14efe07-0724-23d9-7f93-08094cd3c4f6@HIDDEN>
Date: Sat, 18 Jan 2020 03:59:31 +0300
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 8bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  On 25.12.2019 19:49, Dmitry Gutov wrote: > On 25.12.2019 18:44,
    Eli Zaretskii wrote: >> No.  The cursor is always displayed after the overlay
    string.  If you >> want it to do anything else, you need [...] 
 
 Content analysis details:   (2.0 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  1.5 RCVD_IN_SORBS_WEB      RBL: SORBS: sender is an abusable web server
                             [178.252.127.239 listed in dnsbl.sorbs.net]
 -0.0 SPF_PASS               SPF: sender matches SPF record
  0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
                             provider (raaahh[at]gmail.com)
  0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
  0.2 HEADER_FROM_DIFFERENT_DOMAINS From and EnvelopeFrom 2nd level
                             mail domains are different
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
                              no trust
                             [209.85.208.175 listed in list.dnswl.org]
 -0.0 RCVD_IN_MSPIKE_H2      RBL: Average reputation (+2)
                             [209.85.208.175 listed in wl.mailspike.net]
  0.2 FREEMAIL_FORGED_FROMDOMAIN 2nd level domains in From and
                             EnvelopeFrom freemail headers are
                             different
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 1.0 (+)

On 25.12.2019 19:49, Dmitry Gutov wrote:
> On 25.12.2019 18:44, Eli Zaretskii wrote:
>> No.  The cursor is always displayed after the overlay string.  If you
>> want it to do anything else, you need to put a 'cursor' property on
>> the overlay string.
> 
> We do that there.

And yet, the message appears before the cursor in the described 
circumstances.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 25 Dec 2019 16:50:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 25 11:50:12 2019
Received: from localhost ([127.0.0.1]:54646 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ik9rQ-0004RP-IE
	for submit <at> debbugs.gnu.org; Wed, 25 Dec 2019 11:50:12 -0500
Received: from mail-lf1-f52.google.com ([209.85.167.52]:39721)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1ik9rO-0004R6-2n
 for 38457 <at> debbugs.gnu.org; Wed, 25 Dec 2019 11:50:10 -0500
Received: by mail-lf1-f52.google.com with SMTP id y1so17068977lfb.6
 for <38457 <at> debbugs.gnu.org>; Wed, 25 Dec 2019 08:50:09 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=YLzF5IqqlytQf1RWHBlbdkFaMtgvcyn/ZkSEpCt0QSc=;
 b=p2q4suSLO8jJWslRs0RDW5El4w1B9Rf5zeb1RBh74ErodSpcFZYNUeFOZ9v3xpPEFP
 A21dbF0mDKFyhQxt9rfMDhwwIwwR2r8sV7lf53Z7BoKLX1Z4pCGzcDDaZYRwOlH01lOx
 QOOwYS6P2wrRwLmMov5fsn8C1GO6rdsRhB1oeVcg3TpkykkTtppH9EuXAr7ERAYFav8l
 I7bGS6XWagZV5+E0tqWUWM3reS1Oqp3Y57J5F/cmTHV5Pa7tOXGC3dm7AR54SlU7QHcx
 LnxrZ7kXr+CiX9ykQmQ/rtzbicCGtegsQoZjHFRWsHZWvnV9GdlOYRBXUKTupWO4Ujj0
 sa/g==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=YLzF5IqqlytQf1RWHBlbdkFaMtgvcyn/ZkSEpCt0QSc=;
 b=tHMR1tEpvv9lF84exOgOLeaIB7fpY/NA222L6pF3CMRR8KkODEHyBBMSYQdV3yyfFi
 Z2M6vflP+QPjl8gO+X2Sq1e93qBisWsjx2wvgXFArGTMOSRQIJR0yhXmJp7LU1PKhd3k
 Ebq1faSMf3B+pdSEshoBNp4DKabeyPIq20aoqcawGM/Jv5Mz6Bf7S1CpuorDAhKslOox
 kgv7HcmyMN2ZPj5AwevDR37y3HtcZBqlsWzTqz3ElgxLQZjACAVD0txaukTJWP+7WsBf
 yRJDCLlSKmWBIHWkEh5dHSnyfRlJNJ1amlTQ2ZK8CUcZf/J9AHMlBS6jTaxHu3brPjoq
 mAaw==
X-Gm-Message-State: APjAAAXrg4J/cdl3e9uzLexJPOJrrc0neev9ZRWd5LJbkL4bGHrXqzov
 Q8VHArOw+H5hrpmZYJxB3oM=
X-Google-Smtp-Source: APXvYqzQp1uzfO1vfRGwHIW4eIBLhdkfjfU/h8ZAjVFizz6SJxtRsdGai4uj6Lw1ow2tJTfEuRJlvw==
X-Received: by 2002:ac2:5975:: with SMTP id h21mr22890264lfp.165.1577292604019; 
 Wed, 25 Dec 2019 08:50:04 -0800 (PST)
Received: from [172.18.118.211] ([79.104.7.197])
 by smtp.googlemail.com with ESMTPSA id y72sm11892339lfa.12.2019.12.25.08.50.02
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Wed, 25 Dec 2019 08:50:03 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> <83eewsuzhn.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <074b4fef-797b-af22-62a8-7c67f2d14c51@HIDDEN>
Date: Wed, 25 Dec 2019 18:49:57 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <83eewsuzhn.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 25.12.2019 18:44, Eli Zaretskii wrote:
> No.  The cursor is always displayed after the overlay string.  If you
> want it to do anything else, you need to put a 'cursor' property on
> the overlay string.

We do that there.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 25 Dec 2019 16:44:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 25 11:44:23 2019
Received: from localhost ([127.0.0.1]:54635 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ik9ln-0004IN-Gw
	for submit <at> debbugs.gnu.org; Wed, 25 Dec 2019 11:44:23 -0500
Received: from eggs.gnu.org ([209.51.188.92]:53400)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ik9ll-0004IA-TL
 for 38457 <at> debbugs.gnu.org; Wed, 25 Dec 2019 11:44:22 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:32874)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ik9lg-0001bU-5s; Wed, 25 Dec 2019 11:44:16 -0500
Received: from [176.228.60.248] (port=4912 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ik9le-00011W-SO; Wed, 25 Dec 2019 11:44:15 -0500
Date: Wed, 25 Dec 2019 18:44:04 +0200
Message-Id: <83eewsuzhn.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
In-reply-to: <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN> (message from
 Dmitry Gutov on Wed, 25 Dec 2019 18:30:57 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
 <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Dmitry Gutov <dgutov@HIDDEN>
> Date: Wed, 25 Dec 2019 18:30:57 +0200
> Cc: 38457 <at> debbugs.gnu.org
> 
> > Code in set-minibuffer-message was copied from minibuffer-message
> > where handling of the cursor and after-string overlay was intentional.
> 
> Since after-string is used, shouldn't it always appear *after* the cursor?

No.  The cursor is always displayed after the overlay string.  If you
want it to do anything else, you need to put a 'cursor' property on
the overlay string.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 25 Dec 2019 16:31:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 25 11:31:08 2019
Received: from localhost ([127.0.0.1]:54622 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ik9Yx-0003zx-Sp
	for submit <at> debbugs.gnu.org; Wed, 25 Dec 2019 11:31:08 -0500
Received: from mail-lj1-f169.google.com ([209.85.208.169]:39334)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1ik9Yx-0003zU-7C
 for 38457 <at> debbugs.gnu.org; Wed, 25 Dec 2019 11:31:07 -0500
Received: by mail-lj1-f169.google.com with SMTP id l2so23065004lja.6
 for <38457 <at> debbugs.gnu.org>; Wed, 25 Dec 2019 08:31:07 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:from:subject:to:cc:references:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=qLF4FHv1Jc3AridGLLxlVvT1Nz0J+oKHEESUXz4xi3s=;
 b=DwJI52jq8U9GkMqLnupy+7XmPD+ewkx6RQ8Bt/pADESbQibNol7fsqqfXKP2Mxbr8B
 IZCZ0vYBJjzmgylnPW3qKRa+JM1zZcgmmnGgVHCWPeF4kGXV9vVwxbypxCQB4HwZFgOY
 hy6cfByCfRLDNb612W4gbTbl92rBX9hRctdIuQNuOSzoZezFAztk9UxnJknHW5PjF3QC
 WbrkPWr72DJPiDslg1zbaX9vNJ8aw/7xBZIGCkNP7Of4i89oRCYsypvy0+PZbVXtqAbR
 hlH/x9Cj8Tt3lnGV24vAwhYo2BNpXmAdPJe/D+UsXC2EUrWclLbFFeY+UQz4ar800jzw
 +TAg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:from:subject:to:cc:references:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=qLF4FHv1Jc3AridGLLxlVvT1Nz0J+oKHEESUXz4xi3s=;
 b=NKnfXix8lSTwIXB7ESOkUYlDNpqZjrypDCy86S0Jv8Q/Mx2IHrqe4+feroKRnnIUX8
 R58Svc6AgTO4rU4Js9dwLEVCjLnowku6PFIupKFAxkVdptO4zWlWZBZoY1oJSKB+083p
 aYeWs9F8ClCXAinDrWSuVLwfhPMYmvMKYmh25Z2H54kfWwgQRmOhMcb2A0S6I3dnVpeI
 PBV6b7QHqVQ8TfUuvtAjvQacyOc09GUaXv7tP+pIYER2iT8ORnTVQStX0iurbZb9y2dc
 fTA/AJpBOK916a4IHw3yJZ7zhGxqR+o/fiB0Yz5wqrZDVDjhMR4kH5ls09V7O6C1//6C
 fKew==
X-Gm-Message-State: APjAAAW/V5DTRbC+Djb7L33kjwmrImrfjaCh7StESbjn2HQCDibKjtQG
 LMA/+TXEa+OT1zrzVC+vUE9qnVNw3QyqjA==
X-Google-Smtp-Source: APXvYqxONcG6YkkOHg/V69yeUKEwiXlHTcRiSCeKL5MwGHsVOJyPfI5J3EHgalQL0PqCt+GLi1etAg==
X-Received: by 2002:a2e:3a13:: with SMTP id h19mr24149449lja.16.1577291460853; 
 Wed, 25 Dec 2019 08:31:00 -0800 (PST)
Received: from [172.18.118.211] ([79.104.7.197])
 by smtp.googlemail.com with ESMTPSA id s16sm11799823lfc.35.2019.12.25.08.30.59
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Wed, 25 Dec 2019 08:31:00 -0800 (PST)
From: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Juri Linkov <juri@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
 <87sgl9p9q3.fsf@HIDDEN>
Message-ID: <858f4dc2-a955-9ce5-6cf7-aa2c00c2f01d@HIDDEN>
Date: Wed, 25 Dec 2019 18:30:57 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <87sgl9p9q3.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 25.12.2019 1:47, Juri Linkov wrote:
>>> IDK, I tried to set resize-mini-windows to nil and in icomplete-mode
>>> can see the message.
>>
>> My bad, last time I was trying it was with ido-mode. There, the message
>> comes at the end of all completions.
>>
>> With icomplete, however, it's printed before the completions. And it also
>> appears to the left of the cursor. Is that intentional?
> 
> Code in set-minibuffer-message was copied from minibuffer-message
> where handling of the cursor and after-string overlay was intentional.

Since after-string is used, shouldn't it always appear *after* the cursor?

> Could ido-mode use an overlay the same way as it's used in icomplete
> that plays nicely with the set-minibuffer-message overlay?

This seems to work, but it needs more testing:

diff --git a/lisp/ido.el b/lisp/ido.el
index 79f259b819..d47450fc40 100644
--- a/lisp/ido.el
+++ b/lisp/ido.el
@@ -4492,6 +4492,8 @@ ido-initiate-auto-merge
  	(ido-tidy))
        (throw 'ido contents))))

+(defvar ido--overlay nil)
+
  (defun ido-exhibit ()
    "Post command hook for Ido."
    ;; Find matching files and display a list in the minibuffer.
@@ -4726,7 +4728,12 @@ ido-exhibit
  	(let ((inf (ido-completions contents)))
  	  (setq ido-show-confirm-message nil)
  	  (ido-trace "inf" inf)
-	  (insert inf))
+          (when ido--overlay
+            (delete-overlay ido--overlay))
+          (let ((o (make-overlay (point-max) (point-max) nil t t)))
+            (when (> (length inf) 0)
+              (put-text-property 0 1 'cursor t inf))
+            (overlay-put o 'after-string inf)
+            (setq ido--overlay o)))
  	))))

  (defun ido-completions (name)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 25 Dec 2019 02:14:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 24 21:14:36 2019
Received: from localhost ([127.0.0.1]:53194 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijwC3-0005o2-QO
	for submit <at> debbugs.gnu.org; Tue, 24 Dec 2019 21:14:36 -0500
Received: from cheetah.birch.relay.mailchannels.net ([23.83.209.34]:61999)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ijwC1-0005ns-Aq
 for 38457 <at> debbugs.gnu.org; Tue, 24 Dec 2019 21:14:34 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 16153500D38;
 Wed, 25 Dec 2019 02:14:32 +0000 (UTC)
Received: from pdx1-sub0-mail-a50.g.dreamhost.com
 (100-96-206-10.trex.outbound.svc.cluster.local [100.96.206.10])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id A55DC500CCA;
 Wed, 25 Dec 2019 02:14:31 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a50.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 25 Dec 2019 02:14:32 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Print-Cooperative: 56edd4bb736d3120_1577240071900_744745157
X-MC-Loop-Signature: 1577240071899:3105062130
X-MC-Ingress-Time: 1577240071899
Received: from pdx1-sub0-mail-a50.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a50.g.dreamhost.com (Postfix) with ESMTP id 64DA87F07C;
 Tue, 24 Dec 2019 18:14:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=N08kSHSqKe5rtVQRpOQiToK7lwA=; b=
 yjYu+CO7hR/XoY750YZb3m12xx86hhrbXmyFn/Xe1OdXukvAi/LzAlf6X8Ceh4fm
 ODOaaBpcIzWKji7yeUV69REkMJ/4BkA7lugxjPkUcNGNGoRN542ON3kSXo/ofQVz
 hTsrxWVOXxYu68ILKjouK6lUI4yuWWGOGxPCgfoh9V0=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a50.g.dreamhost.com (Postfix) with ESMTPSA id 6DCFF7F077;
 Tue, 24 Dec 2019 18:14:23 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a50
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
 <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
Date: Wed, 25 Dec 2019 01:47:16 +0200
In-Reply-To: <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN> (Dmitry Gutov's
 message of "Tue, 24 Dec 2019 02:42:07 +0200")
Message-ID: <87sgl9p9q3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddvvddgudeglecutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefhvffuohhfffgjkfgfgggtsehttdertddtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtjedrudekieenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdejrddukeeipdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepughguhhtohhvseihrghnuggvgidrrhhunecuvehluhhsthgvrhfuihiivgepud
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> IDK, I tried to set resize-mini-windows to nil and in icomplete-mode
>> can see the message.
>
> My bad, last time I was trying it was with ido-mode. There, the message
> comes at the end of all completions.
>
> With icomplete, however, it's printed before the completions. And it also
> appears to the left of the cursor. Is that intentional?

Code in set-minibuffer-message was copied from minibuffer-message
where handling of the cursor and after-string overlay was intentional.

Could ido-mode use an overlay the same way as it's used in icomplete
that plays nicely with the set-minibuffer-message overlay?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 24 Dec 2019 17:50:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 24 12:50:46 2019
Received: from localhost ([127.0.0.1]:53070 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijoKT-0006eM-OK
	for submit <at> debbugs.gnu.org; Tue, 24 Dec 2019 12:50:45 -0500
Received: from eggs.gnu.org ([209.51.188.92]:42271)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ijoKS-0006e9-7X
 for 38457 <at> debbugs.gnu.org; Tue, 24 Dec 2019 12:50:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47631)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ijoKM-0003QU-2S; Tue, 24 Dec 2019 12:50:38 -0500
Received: from [176.228.60.248] (port=4898 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ijoKD-0004ia-QJ; Tue, 24 Dec 2019 12:50:30 -0500
Date: Tue, 24 Dec 2019 19:50:17 +0200
Message-Id: <83v9q5vciu.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87fth965z1.fsf@HIDDEN> (message from Lars Ingebrigtsen on Tue, 
 24 Dec 2019 17:30:58 +0100)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
 <87a77zpbab.fsf@HIDDEN> <83y2viaksg.fsf@HIDDEN> <87fth965z1.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, rms@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: juri@HIDDEN,  38457 <at> debbugs.gnu.org,  stephen.berman@HIDDEN,
>   rms@HIDDEN
> Date: Tue, 24 Dec 2019 17:30:58 +0100
> 
> Eli Zaretskii <eliz@HIDDEN> writes:
> 
> > Do you have an opinion on my later suggestion, to insert the
> > minibuffer contents before the message text, when 'message' is called
> > with a minibuffer being active?
> 
> Sorry; I missed that one.  Hm...  That does immediately sound like an
> even better solution, but I'd have to see it in action first.

Not exactly what I suggested, but something similar is already in
action (both master and emacs-27 branches), courtesy of Juri.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 24 Dec 2019 16:31:10 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 24 11:31:10 2019
Received: from localhost ([127.0.0.1]:53026 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijn5S-0001ok-GX
	for submit <at> debbugs.gnu.org; Tue, 24 Dec 2019 11:31:10 -0500
Received: from quimby.gnus.org ([95.216.78.240]:44314)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1ijn5Q-0001j6-LE
 for 38457 <at> debbugs.gnu.org; Tue, 24 Dec 2019 11:31:08 -0500
Received: from 77.16.52.139.tmi.telenormobil.no ([77.16.52.139] helo=sandy)
 by quimby.gnus.org with esmtpsa (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1ijn5H-0007Kq-HL; Tue, 24 Dec 2019 17:31:02 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
 <87a77zpbab.fsf@HIDDEN> <83y2viaksg.fsf@HIDDEN>
Date: Tue, 24 Dec 2019 17:30:58 +0100
In-Reply-To: <83y2viaksg.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 11 Dec
 2019 18:28:47 +0200")
Message-ID: <87fth965z1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.60 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > Do you have an opinion
 on my later suggestion, to insert the > minibuffer contents before the message
 text, when 'message' is called > with a minibuffer being active? 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 0.0 TVD_RCVD_IP            Message was received from an IP address
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, rms@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> Do you have an opinion on my later suggestion, to insert the
> minibuffer contents before the message text, when 'message' is called
> with a minibuffer being active?

Sorry; I missed that one.  Hm...  That does immediately sound like an
even better solution, but I'd have to see it in action first.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 24 Dec 2019 00:42:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 23 19:42:17 2019
Received: from localhost ([127.0.0.1]:51819 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijYHB-0000pz-Kp
	for submit <at> debbugs.gnu.org; Mon, 23 Dec 2019 19:42:17 -0500
Received: from mail-wr1-f51.google.com ([209.85.221.51]:34829)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1ijYHA-0000pn-1i
 for 38457 <at> debbugs.gnu.org; Mon, 23 Dec 2019 19:42:16 -0500
Received: by mail-wr1-f51.google.com with SMTP id g17so18445113wro.2
 for <38457 <at> debbugs.gnu.org>; Mon, 23 Dec 2019 16:42:15 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=abJSFoO7TTnEv3csB9jF6ZJJl05ZWc5swDcoUXjT1fI=;
 b=eZFGLWr4qZmOuWbmMEiQaMcvVdYEZnS05kg6LHBqexrbiTIYYPdkRwuGaNVgP24d5d
 OGbHEXzAzJyAfi4WemJ1hL/TbsDHBguNKNnNGlCpuRTQq1hSGoPgWVVLclbiQ1Ne7SEw
 cnde+bVSgJBgWG9VhpBP9yUktVcFGWAVza5Zx0bvOmWkWOqgapTsofmY/hJGDxAAqMec
 3+JRsnZazhojjhZAMpzpjQUZG0x8Sh0+m/JoXzDtDmKBr7yKtXql/bQKHg7n/saJZrQR
 ZkPcOxJCAZkVPnTIHxCTDO5G5YbLf3SJNCj8nfgzO87rS+aTDCsehnoqPs9WrazW6h6V
 PWNg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=abJSFoO7TTnEv3csB9jF6ZJJl05ZWc5swDcoUXjT1fI=;
 b=HnzyDNj+ATHy0RJJdJMQhjswmgs8wmgmuBUav94toG39wf0HWpa8F9Xp1z+Qhgl7e+
 xzAR7vP+dG7eBy8Tj9RoPl3MLkNTVKe43H39V06hQ7R4VidV6Zs2UTDH//7NxxIlSFRU
 RCMeYfGCnSnFIbmlve8QGfDIbXk8qCzirGENNKehgKBQkvFBgyEShjL270immK4CTQrs
 CHRVWbnQBGv9mq+ol44qoJhgkt1q9rv0NitW2bnpSq/0QsC7Y8AJwB3uA7Xw5enutHWl
 zQZcuWAPvKCvEiw7O1le0mpIUxLZwm/DcWR8Wr99dqXvkJXTz3qzOzQZMcnitr0E4a9T
 IrtQ==
X-Gm-Message-State: APjAAAUhaIGjKL9+mFNoUvdwZfwOT649I698wWNKMBpWcbDa7XxBE/kn
 XhHp6Kpp2e46EcT5BLa4ZEaKRUJCuk8=
X-Google-Smtp-Source: APXvYqzkHfBdAd2/G+aGLvoE2qPrDVw19UiZ5LmTvTPQXYKHCwO+uyaJGJEp5VVuqgEUJvcNfTf+Cw==
X-Received: by 2002:a5d:4d4a:: with SMTP id a10mr32506399wru.220.1577148129820; 
 Mon, 23 Dec 2019 16:42:09 -0800 (PST)
Received: from [192.168.0.2] ([212.50.117.215])
 by smtp.googlemail.com with ESMTPSA id o194sm988053wme.45.2019.12.23.16.42.08
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 23 Dec 2019 16:42:08 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Juri Linkov <juri@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
 <874kxqpsse.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <416b122a-287e-5c47-8979-feb22b2bba81@HIDDEN>
Date: Tue, 24 Dec 2019 02:42:07 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <874kxqpsse.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 24.12.2019 0:58, Juri Linkov wrote:
> IDK, I tried to set resize-mini-windows to nil and in icomplete-mode
> can see the message.

My bad, last time I was trying it was with ido-mode. There, the message 
comes at the end of all completions.

With icomplete, however, it's printed before the completions. And it 
also appears to the left of the cursor. Is that intentional?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 23 Dec 2019 23:17:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 23 18:17:17 2019
Received: from localhost ([127.0.0.1]:51782 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijWwu-0005Nm-UN
	for submit <at> debbugs.gnu.org; Mon, 23 Dec 2019 18:17:17 -0500
Received: from bisque.elm.relay.mailchannels.net ([23.83.212.18]:53041)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ijWws-0005Nc-Ed
 for 38457 <at> debbugs.gnu.org; Mon, 23 Dec 2019 18:17:15 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 69BEB1A0FCD;
 Mon, 23 Dec 2019 23:17:13 +0000 (UTC)
Received: from pdx1-sub0-mail-a35.g.dreamhost.com
 (100-96-206-10.trex.outbound.svc.cluster.local [100.96.206.10])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id DD3F81A0D1E;
 Mon, 23 Dec 2019 23:17:12 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a35.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Mon, 23 Dec 2019 23:17:13 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-White-Dime: 396286105f731c3a_1577143033138_3859809356
X-MC-Loop-Signature: 1577143033138:632885194
X-MC-Ingress-Time: 1577143033138
Received: from pdx1-sub0-mail-a35.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a35.g.dreamhost.com (Postfix) with ESMTP id CBA237F086;
 Mon, 23 Dec 2019 15:17:07 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=AkMORZ7u9X4U8wBNENXjOCdiTtA=; b=
 kMjn5yRHgrh0R0pYum/ZdP8rphXPXvCTtlOECkIZNyS4bmLvCLXEN79gyrr0VvAj
 q51tUENk4+Z26+RvJtanOAfJd1URX0pdKcn4BO7zueU/vJjNTSu5bBQZrydtu1Xx
 F46deXgkjGJIcC9VRnvKprpdrtRLZDb4Ihy53qYmfK4=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a35.g.dreamhost.com (Postfix) with ESMTPSA id 360FC7F249;
 Mon, 23 Dec 2019 15:17:04 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a35
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
 <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
Date: Tue, 24 Dec 2019 00:58:13 +0200
In-Reply-To: <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN> (Dmitry Gutov's
 message of "Mon, 23 Dec 2019 12:10:37 +0200")
Message-ID: <874kxqpsse.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddvuddgtdejucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegughhuthhovheshigrnhguvgigrdhruhenucevlhhushhtvghrufhiiigvpedv
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> Here's something else to consider: if the user has resize-mini-windows set
> to nil, and the user has icomplete-mode on (for instance), the message
> might not be visible behind the (almost cut off) list of completions.
>
> And even of resize-mini-windows has the default value, the message might
> appear so far from where the user is looking to be almost unnoticeable.

IDK, I tried to set resize-mini-windows to nil and in icomplete-mode
can see the message.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 23 Dec 2019 10:10:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 23 05:10:47 2019
Received: from localhost ([127.0.0.1]:50589 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijKfn-0007b6-A1
	for submit <at> debbugs.gnu.org; Mon, 23 Dec 2019 05:10:47 -0500
Received: from mail-wr1-f53.google.com ([209.85.221.53]:46247)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1ijKfl-0007as-V0
 for 38457 <at> debbugs.gnu.org; Mon, 23 Dec 2019 05:10:46 -0500
Received: by mail-wr1-f53.google.com with SMTP id z7so15965587wrl.13
 for <38457 <at> debbugs.gnu.org>; Mon, 23 Dec 2019 02:10:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=SAvft7/mg/WDkkZn/YL/t48LUpFZQ7UnxZBuJh1Gaq0=;
 b=JyP4qBZ1Vr0dxpOIK0LOSok+OSYbhkVQkhvbhmnHAKdaexvmt4K/Ut9cKVHWAq3dv5
 ZfmlhJZFL6Z7xx8P4+EmwSZ9lbKhNtahgWyOoCqysZFiTQi/62QG0Bq+66pq6o7YFfZv
 hc6xsGp0XYJmlfFwDilhcQ1zVOm7pSmOe4s+1AGAmjRqLro/7sEzAXnMbWeXQjNKB5oI
 BEMEsXL/64Uq0QwZOdL0eH2653jSP9R+8/n5cawXM+7HlR1NblRrQn88oNOF20hf48zo
 k6lN5g6+/BWuVQqxISB/OlEP5lx1F9JOTTbDPpDZqK8UGCtM6NyK1ILm9XXEnfVY8LUx
 vqaQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=SAvft7/mg/WDkkZn/YL/t48LUpFZQ7UnxZBuJh1Gaq0=;
 b=kMWhpacWF1HFmU6JBvypXczeMC3w8NUmMNt9iPRCBQmCXsooqM8XU05LhqqUpN+hzp
 cf4WqigXXzG5e8TcEWgZzqrvH2sxzh1Ee/218cbVkkDTv29JVaEdDc741zws3K2wIvTv
 q3In+fSiU0U2SL55c0cHj4k1ZDTwWKXWUfIjW3+tzR5/wGxgkn/dlgxsVojbIuhUDESC
 hqNqgLPIQX5VGHjXdg6LGeRQwQOUk1ZSlMg5quzR/+5uzr3VuVYULPnL2lQoLmuxExmV
 SBj2DYwmYDldBzyj7WMfmhPOHx1v5JCwYMClKiBfLlIQqRQa2n+/kkLHmPUJx3sW4bE5
 RkCQ==
X-Gm-Message-State: APjAAAVnzba0E41+3mlN75l0PEOZbzNgOZ2stDeS8THFak8EW2K+7e8E
 4V/h2WIDHQHKYeCVdxGYnsdpDc/uxGI=
X-Google-Smtp-Source: APXvYqxWjHfnLdPPl1kxkoffnmQg4VTgZ43ldA1WeVXAmOYsGMVUX5f7G5E3gT2+/iZoc/7tuS+Vsw==
X-Received: by 2002:adf:dfc1:: with SMTP id q1mr28886810wrn.155.1577095839880; 
 Mon, 23 Dec 2019 02:10:39 -0800 (PST)
Received: from [192.168.0.2] ([212.50.117.215])
 by smtp.googlemail.com with ESMTPSA id x1sm19530511wru.50.2019.12.23.02.10.38
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 23 Dec 2019 02:10:39 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Juri Linkov <juri@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87muc27prn.fsf@HIDDEN>
 <83tv6acgq5.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
 <87tv5tfiao.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <393793a7-236f-dfce-edc7-100472ad9be2@HIDDEN>
Date: Mon, 23 Dec 2019 12:10:37 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <87tv5tfiao.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 22.12.2019 0:03, Juri Linkov wrote:
> For compatibility with minibuffer-message this code was copied
> from minibuffer-message.  And indeed there is only one space
> between the minibuffer contents and the message.  If you see two spaces,
> maybe this is due to misconfiguration?

Seems you are right, sorry about that. I've pulled the latest master, 
rebuilt, and there are no extra spaces. Maybe it was caused by 
minimess.el in my init dir, IDK.

Here's something else to consider: if the user has resize-mini-windows 
set to nil, and the user has icomplete-mode on (for instance), the 
message might not be visible behind the (almost cut off) list of 
completions.

And even of resize-mini-windows has the default value, the message might 
appear so far from where the user is looking to be almost unnoticeable.

Should we try to reuse the area on the bottom-left's window mode-line? 
Like eldoc-minibuffer-message does.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 22 Dec 2019 19:02:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 22 14:02:56 2019
Received: from localhost ([127.0.0.1]:50235 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ij6VE-0006Rl-Ly
	for submit <at> debbugs.gnu.org; Sun, 22 Dec 2019 14:02:56 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58407)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ij6VD-0006RY-ET
 for 38457 <at> debbugs.gnu.org; Sun, 22 Dec 2019 14:02:55 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:46762)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ij6V6-00045Z-CT; Sun, 22 Dec 2019 14:02:48 -0500
Received: from [176.228.60.248] (port=4855 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ij6V5-00084d-Nq; Sun, 22 Dec 2019 14:02:48 -0500
Date: Sun, 22 Dec 2019 21:02:28 +0200
Message-Id: <83r20wxjy3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87v9q9fibb.fsf@HIDDEN> (message from Juri Linkov on
 Sun, 22 Dec 2019 00:02:48 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <87muc27prn.fsf@HIDDEN>
 <83tv6acgq5.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <83a77n1lgl.fsf@HIDDEN> <87v9q9fibb.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Sun, 22 Dec 2019 00:02:48 +0200
> 
> Pushed with the nil default of minibuffer-message-clear-timeout.
> Also added documentation to docstrings and to the manual.
> Please check if everything is alright.

Thanks, it's fine (I made some minor wording changes).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.
bug marked as fixed in version 27.0.50, send any further explanations to 38457 <at> debbugs.gnu.org and Stephen Berman <stephen.berman@HIDDEN> Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 21 Dec 2019 22:10:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 21 17:10:23 2019
Received: from localhost ([127.0.0.1]:48855 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iimx4-0007rQ-Ra
	for submit <at> debbugs.gnu.org; Sat, 21 Dec 2019 17:10:23 -0500
Received: from bonobo.birch.relay.mailchannels.net ([23.83.209.22]:31363)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1iimx3-0007rI-82
 for 38457 <at> debbugs.gnu.org; Sat, 21 Dec 2019 17:10:21 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 29D375A09FB;
 Sat, 21 Dec 2019 22:10:20 +0000 (UTC)
Received: from pdx1-sub0-mail-a1.g.dreamhost.com
 (100-96-206-10.trex.outbound.svc.cluster.local [100.96.206.10])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id B656E5A0277;
 Sat, 21 Dec 2019 22:10:19 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a1.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sat, 21 Dec 2019 22:10:20 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Slimy-Harbor: 46c84e2417e51aae_1576966219975_800565302
X-MC-Loop-Signature: 1576966219975:2480155656
X-MC-Ingress-Time: 1576966219975
Received: from pdx1-sub0-mail-a1.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a1.g.dreamhost.com (Postfix) with ESMTP id 7310D7F61B;
 Sat, 21 Dec 2019 14:10:14 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=xfM67h9MFUHoa2nOitMOW2LwNk8=; b=
 ub1OObxs2gAbK13YHAkv5y+Ylo0go2AE7igJgSn4t2bEUT3XPEP6CqwKtrXmFpST
 qFxjFaBn6hTrECsVcEGJxTX9JDaqD+ijJvBap8sEBbsxCZodGERgNqWJwFWUPgfN
 885ouldHxMjgTuVR+/VUnIwbBZBoxYlNHZpvhaA6jl8=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a1.g.dreamhost.com (Postfix) with ESMTPSA id 03E457F619;
 Sat, 21 Dec 2019 14:10:12 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a1
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
 <87fthgdkq9.fsf@HIDDEN> <87sglg9bd5.fsf@HIDDEN>
 <838sn71l7t.fsf@HIDDEN>
Date: Sun, 22 Dec 2019 00:09:22 +0200
In-Reply-To: <838sn71l7t.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 20 Dec
 2019 09:59:18 +0200")
Message-ID: <87r20xfi71.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvdduhedgudehfecutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefhvffuohhfffgjkfgfgggtsehttdertddtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtjedrudekieenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdejrddukeeipdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepvghlihiisehgnhhurdhorhhgnecuvehluhhsthgvrhfuihiivgepfe
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> This patch now makes easy to implement message stacking that solves the
>> issue of several successive calls to message resulting in the user only
>> seeing the last message.  This problem was raised many times, and now
>> with a function consisting of 12 lines of code attached below, such
>> messages are never lost anymore.
>
> Not sure I understand how this will work in practice, UX-wise.  Will
> the mini-window be resized to show several lines of messages?  If so,
> did you try this with resize-mini-windows set to nil?

Actually, it works well only when resize-mini-windows is 'grow-only'.

>> It's eyebrow-raising how many messages were missed before.
>> For example, on startup now it shows 3 lines of messages
>> I've never seen before:
>> 
>>   Desktop: 1 frame, 19 buffers restored.
>>   15.095076566 seconds
>>   Package cl is deprecated
>
> I guess people who have many things happen at startup will like this
> feature.  But I'm not sure we should enable this by default in Emacs
> 27.  WDYT?

I posted a request for comments on emacs-devel.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 21 Dec 2019 22:10:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 21 17:10:11 2019
Received: from localhost ([127.0.0.1]:48852 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iimwt-0007r0-IF
	for submit <at> debbugs.gnu.org; Sat, 21 Dec 2019 17:10:11 -0500
Received: from aye.elm.relay.mailchannels.net ([23.83.212.6]:31315)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1iimwp-0007qk-Qc
 for 38457 <at> debbugs.gnu.org; Sat, 21 Dec 2019 17:10:08 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id DA834500F15;
 Sat, 21 Dec 2019 22:10:06 +0000 (UTC)
Received: from pdx1-sub0-mail-a1.g.dreamhost.com
 (100-96-4-18.trex.outbound.svc.cluster.local [100.96.4.18])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 6E60B501172;
 Sat, 21 Dec 2019 22:10:06 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a1.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sat, 21 Dec 2019 22:10:06 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Invention-Left: 6c63200527a45990_1576966206681_1155836511
X-MC-Loop-Signature: 1576966206681:352501549
X-MC-Ingress-Time: 1576966206681
Received: from pdx1-sub0-mail-a1.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a1.g.dreamhost.com (Postfix) with ESMTP id 1704B7F613;
 Sat, 21 Dec 2019 14:10:01 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=zs9cHF4igJQnHGSPNMgIgmxmHq4=; b=
 ZO/zxqQpEvBVWkBB3VRBJSM6o3mDtJEkdu/nbYBo5hwaulQsirayPqVdV3hrsXYc
 AgfUrwesYx0FNSscjbcwYA7z3+t6qHmoMTHff2Bx2YYn+MasT/W8CXwVV1OsyaOD
 SmoYsU/Eb5F1dm8iM2D+3wZwCk0U6CRoSD7lq64y+Lc=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a1.g.dreamhost.com (Postfix) with ESMTPSA id B3F267F616;
 Sat, 21 Dec 2019 14:09:58 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a1
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <87muc27prn.fsf@HIDDEN>
 <83tv6acgq5.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
Date: Sun, 22 Dec 2019 00:03:51 +0200
In-Reply-To: <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN> (Dmitry Gutov's
 message of "Fri, 20 Dec 2019 16:29:25 +0200")
Message-ID: <87tv5tfiao.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvdduhedgudehfecutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefhvffuohhfffgjkfgfgggtsehttdertddtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtjedrudekieenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdejrddukeeipdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepughguhhtohhvseihrghnuggvgidrrhhunecuvehluhhsthgvrhfuihiivgepvd
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> Here's something that's a matter of taste, but:
>
>> +      (setq message (if (string-match-p "\\` *\\[.+\\]\\'" message)
>> +                        ;; Make sure we can put-text-property.
>> +                        (copy-sequence message)
>> +                      (concat " [" message "]")))
>
> I prefer how it looks without an extra space here. Meaning
>
>   (concat "[" message "]")
>
> instead of
>
>   (concat " [" message "]")
>
> . Apparently minibuffer contents always end with a space already?

For compatibility with minibuffer-message this code was copied
from minibuffer-message.  And indeed there is only one space
between the minibuffer contents and the message.  If you see two spaces,
maybe this is due to misconfiguration?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 21 Dec 2019 22:10:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 21 17:10:02 2019
Received: from localhost ([127.0.0.1]:48847 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iimwk-0007qG-Cm
	for submit <at> debbugs.gnu.org; Sat, 21 Dec 2019 17:10:02 -0500
Received: from cheetah.birch.relay.mailchannels.net ([23.83.209.34]:42584)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>)
 id 1iimwi-0007pv-M6; Sat, 21 Dec 2019 17:10:01 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 7E7721A11E2;
 Sat, 21 Dec 2019 22:09:59 +0000 (UTC)
Received: from pdx1-sub0-mail-a1.g.dreamhost.com
 (100-96-196-67.trex.outbound.svc.cluster.local [100.96.196.67])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 199321A11F0;
 Sat, 21 Dec 2019 22:09:59 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a1.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sat, 21 Dec 2019 22:09:59 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Whispering-Society: 25d020fa65aadf96_1576966199329_4204037498
X-MC-Loop-Signature: 1576966199329:1741984416
X-MC-Ingress-Time: 1576966199329
Received: from pdx1-sub0-mail-a1.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a1.g.dreamhost.com (Postfix) with ESMTP id 2424F7F613;
 Sat, 21 Dec 2019 14:09:54 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=NCPjuclvQkJOZefzSJEs+JjCVus=; b=
 pdSoP7ljQxLL2DenZpxE1GarDSvk+N6DSjfdIWL1TXNB65CiJuO4zywmFe0ND9bC
 i4FEUwDhkcYfxVUEb3Ry6sMCTd/d0n2EcPq2ZGcV6lEaKOAiszQX0BFTBW9n+2M3
 2g7cOkWzoiJeKHvqX7g5frV35TW+J0HraOmchWpKPyU=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a1.g.dreamhost.com (Postfix) with ESMTPSA id 21C5B7F609;
 Sat, 21 Dec 2019 14:09:51 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a1
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <87muc27prn.fsf@HIDDEN>
 <83tv6acgq5.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <83a77n1lgl.fsf@HIDDEN>
Date: Sun, 22 Dec 2019 00:02:48 +0200
In-Reply-To: <83a77n1lgl.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 20 Dec
 2019 09:54:02 +0200")
Message-ID: <87v9q9fibb.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvdduhedgudehfecutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefhvffuohhfffgjkfgfgggtsehttdertddtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtjedrudekieenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdejrddukeeipdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepvghlihiisehgnhhurdhorhhgnecuvehluhhsthgvrhfuihiivgepud
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

tags 38457 fixed
close 38457 27.0.50
quit

> IOW, the default value of minibuffer-message-clear-timeout should not
> be a number.
>
> Other than that, the patch LGTM.  Please push, and thanks again for
> all your work on these matters.

Pushed with the nil default of minibuffer-message-clear-timeout.
Also added documentation to docstrings and to the manual.
Please check if everything is alright.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 20 Dec 2019 14:29:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 09:29:35 2019
Received: from localhost ([127.0.0.1]:46027 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiJHb-0006qS-7B
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 09:29:35 -0500
Received: from mail-wm1-f49.google.com ([209.85.128.49]:39203)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1iiJHZ-0006qA-8F
 for 38457 <at> debbugs.gnu.org; Fri, 20 Dec 2019 09:29:34 -0500
Received: by mail-wm1-f49.google.com with SMTP id 20so9316160wmj.4
 for <38457 <at> debbugs.gnu.org>; Fri, 20 Dec 2019 06:29:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=bFSXR8aeo600A1EXGQZF63IWnIMoGGCrZs9MhIjVCqA=;
 b=Ap+kyI/EBMSZW8ogC1TXtpWi5dnRgfRaNRYFKLEkV8fvov0eKvMWYwWBT5NOTS+x+W
 BGbEIdzdNxXnXsnZD6pnuvwfUEt0ZjTrEho36bbM/ZFpvM6yG+mfInYnDVhvyQEAVANx
 IyQIFUBS5OHX0wlBw1Ikzrr9IEOovC7p/EGL5S9TM2n4hoBp+R6gBAG1c9Z4sIl0ZXJv
 azSL7gKJuHqR+2cSMhlFblBkgbahq7S7P/3zVoNvU9HaPUlkR7Aekbnn+zthm3dcbvSq
 1HTfoRxTV7ZqGY/cVT9xMJQgv+s0v3DGwsGg7W836DIDgeY6p88sx0/9oCzXuMOX7Xcb
 ViBA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=bFSXR8aeo600A1EXGQZF63IWnIMoGGCrZs9MhIjVCqA=;
 b=Cyku7RkQIOEGcgsYFyOjkhgc283lSghqwAM0HzhNxOeEwioGdkJi+ZsmMWZckj4NDd
 1WiXxYCOsTkz18IkMSLET04ioYWkCJwR1bZOJ2aB43kzAa5zvfZbUqLJyI7B70rMZVXR
 jXYiUA67KgvJgw+ql9ivOfoP35Tww4SPNb51awXzTkxyxu4fNTLDo3m49fiZnCGW+jPY
 KLsQfXZy7QfKrGts3HQ6N5FLIAGCfWC7ghCFozUff2P1iWbKrZNWcuXhAh23b0zRb16H
 kIreFJaTwOyZsvpC05AQamWJhZ8v22HsxOR1GvEfGRloNuBhApERRS0zwEDEm6nC0EEt
 SDvQ==
X-Gm-Message-State: APjAAAXM+MVWoLGdapa8n7igZY/RKh6zeISixp29ohz45aN0K1fcs0W7
 lG+l2BrPhE1Ka2LGZKDnOIKDQqDOOW0=
X-Google-Smtp-Source: APXvYqzUmGQreP9tM1MRhDXgKeu6SlAX1ubHxpWXCODKsW7F1crS1AfE8l0EwYeurXylz3Rik+ceWw==
X-Received: by 2002:a1c:6406:: with SMTP id y6mr16747467wmb.144.1576852166911; 
 Fri, 20 Dec 2019 06:29:26 -0800 (PST)
Received: from [192.168.0.149] ([109.110.245.170])
 by smtp.googlemail.com with ESMTPSA id b137sm2134354wme.26.2019.12.20.06.29.25
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Fri, 20 Dec 2019 06:29:26 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Juri Linkov <juri@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
 <87fthgdkq9.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <37de1822-26c5-b45a-e5b9-3ab492507b97@HIDDEN>
Date: Fri, 20 Dec 2019 16:29:25 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <87fthgdkq9.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Hi Juri,

I like the new behavior quite a bit, and thanks for working on it.

Here's something that's a matter of taste, but:

On 20.12.2019 0:16, Juri Linkov wrote:
> +      (setq message (if (string-match-p "\\` *\\[.+\\]\\'" message)
> +                        ;; Make sure we can put-text-property.
> +                        (copy-sequence message)
> +                      (concat " [" message "]")))

I prefer how it looks without an extra space here. Meaning

   (concat "[" message "]")

instead of

   (concat " [" message "]")

. Apparently minibuffer contents always end with a space already?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 20 Dec 2019 07:59:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 02:59:33 2019
Received: from localhost ([127.0.0.1]:45883 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiDC9-0003Dj-0J
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 02:59:33 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50693)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iiDC7-0003DW-Hb
 for 38457 <at> debbugs.gnu.org; Fri, 20 Dec 2019 02:59:31 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47933)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iiDC1-0004iL-M0; Fri, 20 Dec 2019 02:59:25 -0500
Received: from [176.228.60.248] (port=2632 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iiDC0-0006xU-VU; Fri, 20 Dec 2019 02:59:25 -0500
Date: Fri, 20 Dec 2019 09:59:18 +0200
Message-Id: <838sn71l7t.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87sglg9bd5.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 20 Dec 2019 00:52:38 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
 <87fthgdkq9.fsf@HIDDEN> <87sglg9bd5.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Fri, 20 Dec 2019 00:52:38 +0200
> 
> This patch now makes easy to implement message stacking that solves the
> issue of several successive calls to message resulting in the user only
> seeing the last message.  This problem was raised many times, and now
> with a function consisting of 12 lines of code attached below, such
> messages are never lost anymore.

Not sure I understand how this will work in practice, UX-wise.  Will
the mini-window be resized to show several lines of messages?  If so,
did you try this with resize-mini-windows set to nil?

> It's eyebrow-raising how many messages were missed before.
> For example, on startup now it shows 3 lines of messages
> I've never seen before:
> 
>   Desktop: 1 frame, 19 buffers restored.
>   15.095076566 seconds
>   Package cl is deprecated

I guess people who have many things happen at startup will like this
feature.  But I'm not sure we should enable this by default in Emacs
27.  WDYT?

> (defcustom messages-stack-timout 2
                            ^^^^^^
"timeout"




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 20 Dec 2019 07:54:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 02:54:15 2019
Received: from localhost ([127.0.0.1]:45879 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiD71-00036J-Cw
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 02:54:15 -0500
Received: from eggs.gnu.org ([209.51.188.92]:34061)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iiD6z-000367-Qq
 for 38457 <at> debbugs.gnu.org; Fri, 20 Dec 2019 02:54:14 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47857)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iiD6u-00040g-3Y; Fri, 20 Dec 2019 02:54:08 -0500
Received: from [176.228.60.248] (port=2314 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iiD6t-0001RZ-BC; Fri, 20 Dec 2019 02:54:07 -0500
Date: Fri, 20 Dec 2019 09:54:02 +0200
Message-Id: <83a77n1lgl.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87fthgdkq9.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 20 Dec 2019 00:16:46 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
 <87fthgdkq9.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Fri, 20 Dec 2019 00:16:46 +0200
> 
> So this patch implements only the option clear-timeout
> with the 2nd variant by default.

I'm very sorry to have misled you: I meant the 3rd variant, of course.
IOW, the default value of minibuffer-message-clear-timeout should not
be a number.

Other than that, the patch LGTM.  Please push, and thanks again for
all your work on these matters.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 20 Dec 2019 07:34:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 02:34:43 2019
Received: from localhost ([127.0.0.1]:45874 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiCo7-0002f9-KD
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 02:34:43 -0500
Received: from eggs.gnu.org ([209.51.188.92]:44965)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iiCo6-0002ex-Cn
 for 38457 <at> debbugs.gnu.org; Fri, 20 Dec 2019 02:34:42 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47783)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iiCo0-0000Hx-Oc; Fri, 20 Dec 2019 02:34:36 -0500
Received: from [176.228.60.248] (port=1132 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iiCo0-0000JF-48; Fri, 20 Dec 2019 02:34:36 -0500
Date: Fri, 20 Dec 2019 09:34:30 +0200
Message-Id: <83eewz1md5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87sglf9a7h.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 20 Dec 2019 01:17:38 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <87muc27prn.fsf@HIDDEN>
 <83tv6acgq5.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <d2795c7f-80d6-cec8-3b21-ca8542ded4b3@HIDDEN>
 <87sglf9a7h.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, dgutov@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  38457 <at> debbugs.gnu.org
> Date: Fri, 20 Dec 2019 01:17:38 +0200
> 
> >> +(defcustom minibuffer-message-clear-timeout 2
> >
> > Hey now, shouldn't this be nil by default?
> 
> But Eli said:
> 
>   I won't object as long as the default for Emacs 27 is as in the 2nd
>   variant.
> 
> where the 2nd variant was:
> 
>   after-input=t   after-timeout=2 - clear either on input or after timeout

Oops, I'm so sorry.  I meant the 3rd variant, of course.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 19 Dec 2019 23:23:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 18:23:02 2019
Received: from localhost ([127.0.0.1]:45710 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii58I-0007IE-Jr
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 18:23:02 -0500
Received: from egyptian.birch.relay.mailchannels.net ([23.83.209.56]:36173)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ii58H-0007HW-SE
 for 38457 <at> debbugs.gnu.org; Thu, 19 Dec 2019 18:23:02 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id B1A5E21486;
 Thu, 19 Dec 2019 23:23:00 +0000 (UTC)
Received: from pdx1-sub0-mail-a58.g.dreamhost.com
 (100-96-14-23.trex.outbound.svc.cluster.local [100.96.14.23])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 31B50202B7;
 Thu, 19 Dec 2019 23:23:00 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a58.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 19 Dec 2019 23:23:00 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Stop-Whispering: 7d4ac2b22af31761_1576797780443_3065917385
X-MC-Loop-Signature: 1576797780443:3020915209
X-MC-Ingress-Time: 1576797780443
Received: from pdx1-sub0-mail-a58.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a58.g.dreamhost.com (Postfix) with ESMTP id CB65280628;
 Thu, 19 Dec 2019 15:22:57 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=lMdmxHXXGirc4X/PWbM24sCiJgs=; b=
 B1zMdHOGrTEsI4Vbzwp/q1WDrHd2B52IqND5J8Kn6izusMukPahfuZxi5CGH4ZL5
 LgEedU6eg+MBeBl5VY5nrnCOCIlYbyueQB2Ryg6DOwiR/WQgH0Xu7g5H0gjid2BT
 0DkHajN+1ezfeCn6dxeG/tACZIloVhCcS0Un/4D6LH8=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a58.g.dreamhost.com (Postfix) with ESMTPSA id D34FF8061A;
 Thu, 19 Dec 2019 15:22:55 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a58
From: Juri Linkov <juri@HIDDEN>
To: Dmitry Gutov <dgutov@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <87muc27prn.fsf@HIDDEN>
 <83tv6acgq5.fsf@HIDDEN> <87eexdoygh.fsf@HIDDEN>
 <83tv68c0nb.fsf@HIDDEN> <87d0cubfxx.fsf@HIDDEN>
 <83a77y9k35.fsf@HIDDEN> <87eex9jf14.fsf@HIDDEN>
 <83d0cs8uw8.fsf@HIDDEN> <87a77uh5a5.fsf@HIDDEN>
 <83r21561qd.fsf@HIDDEN> <878snd2liu.fsf@HIDDEN>
 <8336dk5k1p.fsf@HIDDEN> <87a77rgajf.fsf@HIDDEN>
 <83immf3pba.fsf@HIDDEN> <87y2vawly3.fsf@HIDDEN>
 <83tv5x38kq.fsf@HIDDEN> <87d0clxjaq.fsf@HIDDEN>
 <83y2v81g5s.fsf@HIDDEN> <87fthgdkq9.fsf@HIDDEN>
 <d2795c7f-80d6-cec8-3b21-ca8542ded4b3@HIDDEN>
Date: Fri, 20 Dec 2019 01:17:38 +0200
In-Reply-To: <d2795c7f-80d6-cec8-3b21-ca8542ded4b3@HIDDEN> (Dmitry Gutov's
 message of "Fri, 20 Dec 2019 00:30:38 +0200")
Message-ID: <87sglf9a7h.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvdduvddgtdeiucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegughhuthhovheshigrnhguvgigrdhruhenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> +(defcustom minibuffer-message-clear-timeout 2
>
> Hey now, shouldn't this be nil by default?

But Eli said:

  I won't object as long as the default for Emacs 27 is as in the 2nd
  variant.

where the 2nd variant was:

  after-input=t   after-timeout=2 - clear either on input or after timeout

Or was it zero-based numbering meaning the 3rd variant on 1-based numbering?

I'm fine with either default value.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 19 Dec 2019 23:22:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 18:22:59 2019
Received: from localhost ([127.0.0.1]:45706 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii58F-0007HO-BO
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 18:22:59 -0500
Received: from bonobo.elm.relay.mailchannels.net ([23.83.212.22]:27483)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ii58D-0007HF-EE
 for 38457 <at> debbugs.gnu.org; Thu, 19 Dec 2019 18:22:58 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 3E76D5A114C;
 Thu, 19 Dec 2019 23:22:56 +0000 (UTC)
Received: from pdx1-sub0-mail-a58.g.dreamhost.com
 (100-96-14-23.trex.outbound.svc.cluster.local [100.96.14.23])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id A0A8B5A120B;
 Thu, 19 Dec 2019 23:22:55 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a58.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 19 Dec 2019 23:22:56 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Tart-Hook: 17f6881a28d85db7_1576797775925_1000142853
X-MC-Loop-Signature: 1576797775924:132244081
X-MC-Ingress-Time: 1576797775924
Received: from pdx1-sub0-mail-a58.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a58.g.dreamhost.com (Postfix) with ESMTP id D14A080621;
 Thu, 19 Dec 2019 15:22:50 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=AuZC5lvy1g0UEYgNu/ajc2p1eZs=; b=
 iKpjBFonARLjQNtGUS/khnRsXMhpAoQJMQJp3B/j+zkW7CceaVVr6x4qbjZNMrR8
 JIJQeTXARzPK8SSdQ1IW/bQgAM/tFCWl6X97+fBcagM+yP3KVwDHWZ6o9+/p/epA
 B+Qn1CSVvrdCosYPZlEXZB4aBcrMG8cT2qLAxfY7aro=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a58.g.dreamhost.com (Postfix) with ESMTPSA id 3B8CE8061A;
 Thu, 19 Dec 2019 15:22:48 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a58
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
 <87fthgdkq9.fsf@HIDDEN>
Date: Fri, 20 Dec 2019 00:52:38 +0200
In-Reply-To: <87fthgdkq9.fsf@HIDDEN> (Juri Linkov's message of "Fri, 
 20 Dec 2019 00:16:46 +0200")
Message-ID: <87sglg9bd5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvdduvddgtdeiucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesmhdtreertdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

>> I think leaving "M-x" (or any other prompt) unobscured in this
>> situation is a nice benefit, and if it simplifies the code, it's even
>> more desirable.
>
> Implemented in a new patch.

This patch now makes easy to implement message stacking that solves the
issue of several successive calls to message resulting in the user only
seeing the last message.  This problem was raised many times, and now
with a function consisting of 12 lines of code attached below, such
messages are never lost anymore.

It's eyebrow-raising how many messages were missed before.
For example, on startup now it shows 3 lines of messages
I've never seen before:

  Desktop: 1 frame, 19 buffers restored.
  15.095076566 seconds
  Package cl is deprecated

I've only seen the last message "Package cl is deprecated" sometimes
when it was not overwritten by another later message.
Now all accumulated messages are displayed together.

It also allows noticing error messages never seen before.
In Gnus it now shows these lines together, not only the last message:

  Error while decoding: (args-out-of-range  *temp*-306008 1 4346)
  Error while decoding: (args-out-of-range  *temp* 1 7357)
  Fontifying...done

This code depends on the previous patch:


--=-=-=
Content-Type: application/emacs-lisp
Content-Disposition: inline; filename=messages-stack.el
Content-Transfer-Encoding: quoted-printable


(defcustom messages-stack-timout 2
  "Number of seconds between messages before clearing the stack."
  :type 'number
  :group 'minibuffer
  :version "27.1")

(defcustom messages-stack-max 8
  "Max size of the message stack."
  :type 'number
  :group 'minibuffer
  :version "27.1")

(defvar messages-stack-separator "\n")

(defvar messages-stack nil)

(defun set-stacked-message (message)
  (let ((last-message (car messages-stack)))
    (unless (and last-message (equal message (aref last-message 1)))
      (when (and last-message (> (float-time) (+ (aref last-message 0)
                                                 messages-stack-timout)))
        (setq messages-stack nil))
      (push (vector (float-time) message) messages-stack)
      (when (> (length messages-stack) messages-stack-max)
        (setf (nthcdr messages-stack-max messages-stack) nil)))
    (mapconcat (lambda (m) (aref m 1))
               (reverse messages-stack)
               messages-stack-separator)))

(setq set-message-function 'set-stacked-message)

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 19 Dec 2019 22:30:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 17:30:49 2019
Received: from localhost ([127.0.0.1]:45683 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii4Jk-00062V-Rr
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:30:48 -0500
Received: from mail-wr1-f51.google.com ([209.85.221.51]:37473)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1ii4Jj-000623-DA
 for 38457 <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:30:48 -0500
Received: by mail-wr1-f51.google.com with SMTP id w15so7584254wru.4
 for <38457 <at> debbugs.gnu.org>; Thu, 19 Dec 2019 14:30:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=gmNbD1JEtLBdFiwy9tv5+H0FP5MVoFBtJusAKKvY/c8=;
 b=XPWMbEmWZfmTFSdFFGsOJHgoxojzZmDNESV3yeY/9RqBOO5rfKdkDqjJkO0/OaI0xO
 F5EPRC28sGM66yRITxBEW3JLak87neINqkJOkIj00gRxgngtftJv7AH6LDZG8ypL0536
 aejJLi2SL7H4RaW0U2b56CpG4mlU6M6HtdBb8r/AaY6ExX2tV/9ownlr2IZEy9JAF+q/
 10XmF270YQ5aaWfCztXQk96uHzKqx4fb5ItF8GBQMAuzsfyVq3SZ1MMTMp22uo6GJL1w
 tMf9BV2wpJKHBWz5gXb3FG3ek4Gwtmr4+MNOnakm9VvXNMQZg796nqYdOb69e4W4AcPg
 dZOg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=gmNbD1JEtLBdFiwy9tv5+H0FP5MVoFBtJusAKKvY/c8=;
 b=IpnWvXazW61OUnRnSMjy1KAJ/x0FTtdNR4aGO1TcUQCpX/RQXqnMVf6r1qcTI0Ztpj
 Jqo9nmSTwQU2eNobBgxHvG7qO+kzafjKUHffBIuq2JLTMsd+QCkCpVTosveaP8+0z5Gk
 gJgsNyW9fCBWYD62dbsMeoLR3VlFpkluTeOvaVyR2n0icW6kLMRx7oBJHQTzFEjYqWL3
 /e0vyLZ9qs3ovzTocY8vi8iMTcZg6i4oloYHdvSVoQ9ZvmbAfaEIUNVVSRsNOxnGpItQ
 K0j+qaqnzkPFSUz7zeT+dQWzCnslrQJErwIFeVTggT2yy5d0QlrIf+lWhdFrEMPJaaNQ
 rStg==
X-Gm-Message-State: APjAAAXSb/+qV9N/eYoj8FfD1O79/ljWaLITtoRZxXhwcxqL1o2XRwXp
 MOdW9zvETiI/ODzSkYespQXe635tWSE=
X-Google-Smtp-Source: APXvYqyp+sJLRHbCNXV/9MuU4OI8FhWIVDsDBrCVtTopyIpPWlc7/tEZE8Ipagt9vOdv+el/CNASWQ==
X-Received: by 2002:a5d:530d:: with SMTP id e13mr11739456wrv.125.1576794641185; 
 Thu, 19 Dec 2019 14:30:41 -0800 (PST)
Received: from [192.168.0.5] ([212.50.117.215])
 by smtp.googlemail.com with ESMTPSA id u8sm7349118wmm.15.2019.12.19.14.30.39
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Thu, 19 Dec 2019 14:30:40 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Juri Linkov <juri@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
 <87fthgdkq9.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <d2795c7f-80d6-cec8-3b21-ca8542ded4b3@HIDDEN>
Date: Fri, 20 Dec 2019 00:30:38 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <87fthgdkq9.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 20.12.2019 0:16, Juri Linkov wrote:
> +(defcustom minibuffer-message-clear-timeout 2

Hey now, shouldn't this be nil by default?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 19 Dec 2019 22:20:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 17:20:55 2019
Received: from localhost ([127.0.0.1]:45656 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii4AA-0005kP-M3
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:20:55 -0500
Received: from azure.elm.relay.mailchannels.net ([23.83.212.7]:35328)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ii4A8-0005kC-1y
 for 38457 <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:20:52 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id CA79C3C1083;
 Thu, 19 Dec 2019 22:20:50 +0000 (UTC)
Received: from pdx1-sub0-mail-a58.g.dreamhost.com
 (100-96-14-23.trex.outbound.svc.cluster.local [100.96.14.23])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 56AAB3C16BF;
 Thu, 19 Dec 2019 22:20:50 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a58.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 19 Dec 2019 22:20:50 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Thread-Cold: 0f434c0567222eed_1576794050579_2785132071
X-MC-Loop-Signature: 1576794050579:3290423846
X-MC-Ingress-Time: 1576794050579
Received: from pdx1-sub0-mail-a58.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a58.g.dreamhost.com (Postfix) with ESMTP id 1077F8060C;
 Thu, 19 Dec 2019 14:20:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=bktbXjCzAl8YnZBXtJ4YdgYEGqA=; b=
 uDH6BvZw1HLsFNm67B14n8IvstTFDynhtGCzbGyUsb58NMFJbUPFDCe4maQ5Oii3
 Rs0yqQn+L3jGDYE8xzubK0u0hBNsklAPYs8j6Fz15nF3LDZVyPWfZ3qpDDMpHXjf
 gZqiHir6lj7z5X74BR0A/k4qW1nGIiUD08i0nujO4DE=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a58.g.dreamhost.com (Postfix) with ESMTPSA id 65AE380617;
 Thu, 19 Dec 2019 14:20:42 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a58
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN> <83y2v81g5s.fsf@HIDDEN>
Date: Fri, 20 Dec 2019 00:16:46 +0200
In-Reply-To: <83y2v81g5s.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 19 Dec
 2019 17:36:15 +0200")
Message-ID: <87fthgdkq9.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvdduuddgudehlecutefuodetggdotefrodftvfcurfhrohhfihhlvgemucggtfgfnhhsuhgsshgtrhhisggvpdfftffgtefojffquffvnecuuegrihhlohhuthemuceftddtnecusecvtfgvtghiphhivghnthhsucdlqddutddtmdenucfjughrpefhvffuohhfffgjkfgfgggtsehmtderredtredtnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtjedrudekieenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdejrddukeeipdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepvghlihiisehgnhhurdhorhhgnecuvehluhhsthgvrhfuihiivgeptd
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

> I think leaving "M-x" (or any other prompt) unobscured in this
> situation is a nice benefit, and if it simplifies the code, it's even
> more desirable.

Implemented in a new patch.

>> after-input=nil after-timeout=0 - never clear the message
>> after-input=t   after-timeout=2 - clear either on input or after timeout
>> after-input=t   after-timeout=0 - clear only when input is available:
>>                                   this has an advantage that user has control when
>>                                   wants to clear message immediately on keypress;
>> after-input=nil after-timeout=2 - clear only after timeout, not on input:
>>                                   this has an advantage that user will never miss
>>                                   a message while typing in the minibuffer,
>>                                   the message will stay for the specified number
>>                                   of seconds regardless of input,
>>                                   so user will have a chance to read it
>>
>> Do all these variants make sense?
>
> I would never want to use variants 1 and 4, but if someone wants them,
> I won't object as long as the default for Emacs 27 is as in the 2nd
> variant.

Actually, supporting an option after-input is not straightforward,
because when clear-minibuffer-message is called, there is no distinction
whether it was called by new input arrived, or by a function calling
'message' with an empty argument.  But really an option after-input
is not necessary, this rules out variants 1 and 4 anyway.

So this patch implements only the option clear-timeout
with the 2nd variant by default.

Also made changes for all your previous comments:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=set-minibuffer-message-2.patch

diff --git a/lisp/minibuffer.el b/lisp/minibuffer.el
index 76d8ca4475..502375ee1e 100644
--- a/lisp/minibuffer.el
+++ b/lisp/minibuffer.el
@@ -746,6 +746,76 @@ minibuffer-message
             (sit-for (or minibuffer-message-timeout 1000000)))
         (delete-overlay ol)))))
 
+(defcustom minibuffer-message-clear-timeout 2
+  "How long to display an echo-area message when the minibuffer is active.
+If the value is a number, it should be specified in seconds.
+If the value is not a number, such messages never time out,
+and the text is displayed until the next input event arrives."
+  :type '(choice (const :tag "Never time out" nil)
+                 (integer :tag "Wait for the number of seconds" 2))
+  :version "27.1")
+
+(defvar minibuffer-message-timer nil)
+(defvar minibuffer-message-overlay nil)
+
+(defun set-minibuffer-message (message)
+  "Temporarily display MESSAGE at the end of the minibuffer.
+The text is displayed for `minibuffer-message-clear-timeout' seconds
+(if the value is a number), or until the next input event arrives,
+whichever comes first."
+  (when (and (not noninteractive)
+             (window-live-p (active-minibuffer-window)))
+    (with-current-buffer (window-buffer (active-minibuffer-window))
+      (setq message (if (string-match-p "\\` *\\[.+\\]\\'" message)
+                        ;; Make sure we can put-text-property.
+                        (copy-sequence message)
+                      (concat " [" message "]")))
+      (unless (or (null minibuffer-message-properties)
+                  ;; Don't overwrite the face properties the caller has set
+                  (text-properties-at 0 message))
+        (setq message (apply #'propertize message minibuffer-message-properties)))
+
+      (when (timerp minibuffer-message-timer)
+        (cancel-timer minibuffer-message-timer)
+        (setq minibuffer-message-timer nil))
+      (when (overlayp minibuffer-message-overlay)
+        (delete-overlay minibuffer-message-overlay)
+        (setq minibuffer-message-overlay nil))
+
+      (setq minibuffer-message-overlay
+            (make-overlay (point-max) (point-max) nil t t))
+      (unless (zerop (length message))
+        ;; The current C cursor code doesn't know to use the overlay's
+        ;; marker's stickiness to figure out whether to place the cursor
+        ;; before or after the string, so let's spoon-feed it the pos.
+        (put-text-property 0 1 'cursor t message))
+      (overlay-put minibuffer-message-overlay 'after-string message)
+
+      (when (numberp minibuffer-message-clear-timeout)
+        (setq minibuffer-message-timer
+              (run-with-timer minibuffer-message-clear-timeout nil
+                              (lambda ()
+                                (when (overlayp minibuffer-message-overlay)
+                                  (delete-overlay minibuffer-message-overlay)
+                                  (setq minibuffer-message-overlay nil)
+                                  (setq minibuffer-message-timer nil))))))
+
+      t)))
+
+(setq set-message-function 'set-minibuffer-message)
+
+(defun clear-minibuffer-message ()
+  "Clear minibuffer message."
+  (when (not noninteractive)
+    (when (timerp minibuffer-message-timer)
+      (cancel-timer minibuffer-message-timer)
+      (setq minibuffer-message-timer nil))
+    (when (overlayp minibuffer-message-overlay)
+      (delete-overlay minibuffer-message-overlay)
+      (setq minibuffer-message-overlay nil))))
+
+(setq clear-message-function 'clear-minibuffer-message)
+
 (defun minibuffer-completion-contents ()
   "Return the user input in a minibuffer before point as a string.
 In Emacs 22, that was what completion commands operated on.
diff --git a/src/keyboard.c b/src/keyboard.c
index 5135fd0bc8..5b1b6f2c95 100644
--- a/src/keyboard.c
+++ b/src/keyboard.c
@@ -2990,6 +2990,8 @@ read_char (int commandflag, Lisp_Object map,
 	  safe_run_hooks (Qecho_area_clear_hook);
 	  clear_message (1, 0);
 	}
+      else if (FUNCTIONP (Vclear_message_function))
+        message1 (0);
     }
 
  reread_for_input_method:
diff --git a/src/xdisp.c b/src/xdisp.c
index 08c6927052..3d232d8e92 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -11706,13 +11706,32 @@ truncate_message_1 (ptrdiff_t nchars, Lisp_Object a2)
 static void
 set_message (Lisp_Object string)
 {
+  Lisp_Object message = Qnil;
+
   eassert (STRINGP (string));
 
-  message_enable_multibyte = STRING_MULTIBYTE (string);
+  if (FUNCTIONP (Vset_message_function))
+    {
+      ptrdiff_t count = SPECPDL_INDEX ();
+      specbind (Qinhibit_quit, Qt);
+      message = safe_call1 (Vset_message_function, string);
+      unbind_to (count, Qnil);
 
-  with_echo_area_buffer (0, -1, set_message_1, 0, string);
-  message_buf_print = false;
-  help_echo_showing_p = false;
+      if (STRINGP (message))
+        {
+          string = message;
+          message = Qnil;
+        }
+    }
+
+  if (NILP (message))
+    {
+      message_enable_multibyte = STRING_MULTIBYTE (string);
+
+      with_echo_area_buffer (0, -1, set_message_1, 0, string);
+      message_buf_print = false;
+      help_echo_showing_p = false;
+    }
 
   if (STRINGP (Vdebug_on_message)
       && STRINGP (string)
@@ -11768,6 +11787,14 @@ clear_message (bool current_p, bool last_displayed_p)
     {
       echo_area_buffer[0] = Qnil;
       message_cleared_p = true;
+
+      if (FUNCTIONP (Vclear_message_function))
+        {
+          ptrdiff_t count = SPECPDL_INDEX ();
+          specbind (Qinhibit_quit, Qt);
+          safe_call (1, Vclear_message_function);
+          unbind_to (count, Qnil);
+        }
     }
 
   if (last_displayed_p)
@@ -34940,6 +34967,14 @@ syms_of_xdisp (void)
 	       doc: /* If non-nil, debug if a message matching this regexp is displayed.  */);
   Vdebug_on_message = Qnil;
 
+  DEFVAR_LISP ("set-message-function", Vset_message_function,
+	       doc: /* If non-nil, function to set message.  */);
+  Vset_message_function = Qnil;
+
+  DEFVAR_LISP ("clear-message-function", Vclear_message_function,
+	       doc: /* If non-nil, function to clear message.  */);
+  Vclear_message_function = Qnil;
+
   DEFVAR_LISP ("redisplay--all-windows-cause", Vredisplay__all_windows_cause,
 	       doc: /*  */);
   Vredisplay__all_windows_cause = Fmake_hash_table (0, NULL);

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 19 Dec 2019 15:36:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 10:36:31 2019
Received: from localhost ([127.0.0.1]:45410 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihxqp-00048c-5D
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 10:36:31 -0500
Received: from eggs.gnu.org ([209.51.188.92]:45004)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ihxqn-00048D-79
 for 38457 <at> debbugs.gnu.org; Thu, 19 Dec 2019 10:36:29 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35112)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ihxqh-0003ql-Ml; Thu, 19 Dec 2019 10:36:23 -0500
Received: from [176.228.60.248] (port=2489 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ihxqh-0002rb-3j; Thu, 19 Dec 2019 10:36:23 -0500
Date: Thu, 19 Dec 2019 17:36:15 +0200
Message-Id: <83y2v81g5s.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87d0clxjaq.fsf@HIDDEN> (message from Juri Linkov on
 Thu, 19 Dec 2019 02:12:09 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
 <87d0clxjaq.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Thu, 19 Dec 2019 02:12:09 +0200
> 
> >> 0. emacs -Q
> >> 1. M-x   ;; activate the minibuffer
> >> 2. C-x o ;; switch back to *scratch*
> >> 3. Eval in *scratch* buffer:
> >>
> >>    (window-live-p (active-minibuffer-window))
> >>    => t
> >
> > OK, but the minibuffer is still active in this case, and leaving it
> > unobscured is still an advantage, right?
> 
> It never occurred to me that someone might want to see the minibuffer
> unobscured when the minibuffer is not the current buffer.

I think leaving "M-x" (or any other prompt) unobscured in this
situation is a nice benefit, and if it simplifies the code, it's even
more desirable.

> >> +(defun set-minibuffer-message (message)
> >> +  "Temporarily display MESSAGE at the end of the minibuffer.
> >> +The text is displayed for `minibuffer-message-wait' seconds,
> >> +or until the next input event arrives, whichever comes first.
> >
> > This text needs to be updated to refer to minibuffer-message-wait's
> > effect on what it does.
> 
> While thinking again about 'minibuffer-message-wait' I realized that
> maybe we need two customizable variables:
> 
> 1. minibuffer-message-clear-after-input
> 2. minibuffer-message-clear-after-timeout
> 
> because users might prefer customization of these behaviors separately.
> Here are all possible combinations (2 is an example of number of seconds,
> 0 means no timeout):
> 
> after-input=nil after-timeout=0 - never clear the message
> after-input=t   after-timeout=2 - clear either on input or after timeout
> after-input=t   after-timeout=0 - clear only when input is available:
>                                   this has an advantage that user has control when
>                                   wants to clear message immediately on keypress;
> after-input=nil after-timeout=2 - clear only after timeout, not on input:
>                                   this has an advantage that user will never miss
>                                   a message while typing in the minibuffer,
>                                   the message will stay for the specified number
>                                   of seconds regardless of input,
>                                   so user will have a chance to read it
> 
> Do all these variants make sense?

I would never want to use variants 1 and 4, but if someone wants them,
I won't object as long as the default for Emacs 27 is as in the 2nd
variant.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 19 Dec 2019 00:16:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 18 19:16:57 2019
Received: from localhost ([127.0.0.1]:44124 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihjUv-0007QZ-7i
	for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 19:16:57 -0500
Received: from brown.birch.relay.mailchannels.net ([23.83.209.23]:32859)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ihjUs-0007QQ-Sg
 for 38457 <at> debbugs.gnu.org; Wed, 18 Dec 2019 19:16:55 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id A40B360084B;
 Thu, 19 Dec 2019 00:16:53 +0000 (UTC)
Received: from pdx1-sub0-mail-a68.g.dreamhost.com
 (100-96-14-23.trex.outbound.svc.cluster.local [100.96.14.23])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 309D160092C;
 Thu, 19 Dec 2019 00:16:53 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a68.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 19 Dec 2019 00:16:53 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Coil-Thread: 246414bc4e0070cd_1576714613446_1050934103
X-MC-Loop-Signature: 1576714613445:3780706834
X-MC-Ingress-Time: 1576714613445
Received: from pdx1-sub0-mail-a68.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a68.g.dreamhost.com (Postfix) with ESMTP id D919F7F715;
 Wed, 18 Dec 2019 16:16:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=7u3XdxOHTYz7aQDo3UAEGHL4frM=; b=
 Eg9r3MGRsgEY1/3qCrv9Q5Jb7iZbe3B747jrzh6p0FBwBivFDppMk4xLfvwqgT8n
 4We4l6lHEPXWC+WisULL2cu2Fdx5J1YWz0Oe+FFDsJorXFZhI/cLg/zsBu38Ryq8
 3AIiX9ljAV3Mv9YD3jB+0oQwQiCQedz5TUXH8eHxrk8=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a68.g.dreamhost.com (Postfix) with ESMTPSA id 4677A7F272;
 Wed, 18 Dec 2019 16:16:45 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a68
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
 <87y2vawly3.fsf@HIDDEN> <83tv5x38kq.fsf@HIDDEN>
Date: Thu, 19 Dec 2019 02:12:09 +0200
In-Reply-To: <83tv5x38kq.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 18 Dec
 2019 18:24:53 +0200")
Message-ID: <87d0clxjaq.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddutddgudelucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> Now I recall why just (window-live-p (active-minibuffer-window))
>> is not enough.  Because it returns non-nil even when the
>> current buffer is not the minibuffer, but the minibuffer was
>> activated earlier.  Test case:
>>
>> 0. emacs -Q
>> 1. M-x   ;; activate the minibuffer
>> 2. C-x o ;; switch back to *scratch*
>> 3. Eval in *scratch* buffer:
>>
>>    (window-live-p (active-minibuffer-window))
>>    => t
>
> OK, but the minibuffer is still active in this case, and leaving it
> unobscured is still an advantage, right?

It never occurred to me that someone might want to see the minibuffer
unobscured when the minibuffer is not the current buffer.

>> A message overlay should not be added to the *scratch* buffer, so it's
>> important to check if old-selected-window is a minibuffer window
>> (i.e. the current buffer is the minibuffer).
>
> OK, but couldn't we instead do something like
>
>   (with-current-buffer (window-buffer (active-minibuffer-window))
>     ....
>
> to ensure we add the overlay in the minibuffer, not in *scratch*?  Or
> am I missing something?

Maybe.  Actually I have no opinion for this case because it never was
a problem when the non-current minibuffer was obscured by messages.

>> Let's iron out the details.  A new patch attached works well
>> in all cases I tested (dabbrev, icomplete, etc.)  But I'm sure
>> it could be improved further because I might have made wrong
>> assumptions on the C side, or something.
>
> Thanks, I have only a few minor comments:
>
>> +(defun set-minibuffer-message (message)
>> +  "Temporarily display MESSAGE at the end of the minibuffer.
>> +The text is displayed for `minibuffer-message-wait' seconds,
>> +or until the next input event arrives, whichever comes first.
>
> This text needs to be updated to refer to minibuffer-message-wait's
> effect on what it does.

While thinking again about 'minibuffer-message-wait' I realized that
maybe we need two customizable variables:

1. minibuffer-message-clear-after-input
2. minibuffer-message-clear-after-timeout

because users might prefer customization of these behaviors separately.
Here are all possible combinations (2 is an example of number of seconds,
0 means no timeout):

after-input=nil after-timeout=0 - never clear the message
after-input=t   after-timeout=2 - clear either on input or after timeout
after-input=t   after-timeout=0 - clear only when input is available:
                                  this has an advantage that user has control when
                                  wants to clear message immediately on keypress;
after-input=nil after-timeout=2 - clear only after timeout, not on input:
                                  this has an advantage that user will never miss
                                  a message while typing in the minibuffer,
                                  the message will stay for the specified number
                                  of seconds regardless of input,
                                  so user will have a chance to read it

Do all these variants make sense?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Dec 2019 16:25:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 18 11:25:15 2019
Received: from localhost ([127.0.0.1]:43819 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihc8Q-0005mm-NJ
	for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 11:25:14 -0500
Received: from eggs.gnu.org ([209.51.188.92]:45117)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ihc8O-0005mO-DZ
 for 38457 <at> debbugs.gnu.org; Wed, 18 Dec 2019 11:25:13 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45587)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ihc8I-0005wG-9P; Wed, 18 Dec 2019 11:25:06 -0500
Received: from [176.228.60.248] (port=4702 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ihc8G-0005fP-TS; Wed, 18 Dec 2019 11:25:05 -0500
Date: Wed, 18 Dec 2019 18:24:53 +0200
Message-Id: <83tv5x38kq.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87y2vawly3.fsf@HIDDEN> (message from Juri Linkov on
 Wed, 18 Dec 2019 01:51:00 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN> 
 <87y2vawly3.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Wed, 18 Dec 2019 01:51:00 +0200
> 
> Now I recall why just (window-live-p (active-minibuffer-window))
> is not enough.  Because it returns non-nil even when the
> current buffer is not the minibuffer, but the minibuffer was
> activated earlier.  Test case:
> 
> 0. emacs -Q
> 1. M-x   ;; activate the minibuffer
> 2. C-x o ;; switch back to *scratch*
> 3. Eval in *scratch* buffer:
> 
>    (window-live-p (active-minibuffer-window))
>    => t

OK, but the minibuffer is still active in this case, and leaving it
unobscured is still an advantage, right?

> A message overlay should not be added to the *scratch* buffer, so it's
> important to check if old-selected-window is a minibuffer window
> (i.e. the current buffer is the minibuffer).

OK, but couldn't we instead do something like

  (with-current-buffer (window-buffer (active-minibuffer-window))
    ....

to ensure we add the overlay in the minibuffer, not in *scratch*?  Or
am I missing something?

> Let's iron out the details.  A new patch attached works well
> in all cases I tested (dabbrev, icomplete, etc.)  But I'm sure
> it could be improved further because I might have made wrong
> assumptions on the C side, or something.

Thanks, I have only a few minor comments:

> +(defun set-minibuffer-message (message)
> +  "Temporarily display MESSAGE at the end of the minibuffer.
> +The text is displayed for `minibuffer-message-wait' seconds,
> +or until the next input event arrives, whichever comes first.

This text needs to be updated to refer to minibuffer-message-wait's
effect on what it does.

> +      else if (!NILP (Vclear_message_function))
> +        message1 (0);

Here and elsewhere, isn't it better to use FUNCTIONP instead of NILP?

> +      if (STRINGP (message))
> +        {
> +          eassert (STRINGP (message));

Since you just verified that 'message' is a string, the eassert is
redundant, right?

> +      message = call1 (Vset_message_function, string);

I'd prefer to use safe_call1 here, in case the function signals an
error, since we are inside redisplay here...

> +          call0 (Vclear_message_function);

...and safe_call here.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Dec 2019 03:38:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 22:38:24 2019
Received: from localhost ([127.0.0.1]:42574 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihQAK-0007iv-I4
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 22:38:24 -0500
Received: from mail-oln040092253104.outbound.protection.outlook.com
 ([40.92.253.104]:6120 helo=APC01-SG2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1ihQAG-0007ic-Tw
 for 38457 <at> debbugs.gnu.org; Tue, 17 Dec 2019 22:38:22 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=TG1ka/NEqXTceW926oyScodrGylLjFApMTV37Z+FUBbws/dZzCrZAH85cHmjqSqSe6rjKiirtlmg9SyCZoB8Ukq7w8ifRMlYbt0RdLoWViw8Kx3QOliaicmfvg93l+mjgSSr5LKaflhG54vsM3eIhuuiPFN7e0JoaDsxL4kDlHj58nrLBF8yDw+ATfGz7gcR0uOxpAvqCw/PFM8T9WNhf/gsADbpE5Rh1aWofITemTPTb1tSxejPVOm9HytzKnKiCaQPeSJPDhjJ/JGkroc7pJuNTYnTXTvG4wAlW9yl27OXBAVtzayxL5HlBvHS33TwviAwQed2lg2xS6uuRQxHEA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=0zQDAFSgjzRepMtP0vsBytNuWGoNRxTBDyt2NiCQCJ0=;
 b=EPvyeU640cu2Ya8a6gPU7JaNIxhAnLmvMK2IQuMKOpXHoXYyzQzfHP+VOgB+EtroiCTYrvgn1Edv/VG5p7j0TDipsA0vn2cqaPGkdGjdkwyVTzVt8M5Thv4J9cAqKI1wUKNaDewQ9Lx3WQVjocLm1HY/ViO+7aotzu6Th93iQ+EEazYCqT4bT1L3afoePkERv5IYXyYzRyq1SVIkhQ19FvpOWd3R4Tj5QbUcoKQ1dXYnboVW0FgKhx4sBMtfiMVF+EWWmuLGGAYOeQy1CaNrXxF3E8U7DQ9oSWGX6/FskVoPCatDIR6Ag316RXCyUI66HIivBl5Rq+7yjuw1Ng7utQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=0zQDAFSgjzRepMtP0vsBytNuWGoNRxTBDyt2NiCQCJ0=;
 b=OWMXzyVNIOh0S4cU2Tef+2C7s47g+J+AG1+fDU21M2gE36P4ySjrZOm73pChLiOfQYN/7luakb2mKVcHEWAIp573nm1eVVM+5dBSu6n9tWrHrnvSr6J9hqUeGMKDNvaHnOjQVFIOBaAHo9K4d6Unz0UhBb5R1x6YlvOiWxHmHEVNx8Ti4OuCOQZ3NkTEssXpscBdOmPggOzvz61FPcZ9txk3xNGgiVJb7ejOlBxTvkrIzSYT7ZH7OjnDtxiOD+ickttGmyDW7vY90XO3+G8ig8ZKVq9sEs6VGberT/4AJyVYXzkMiGI19koDYGa7pKYMxeITEnZkwL10AxEVmwXnfg==
Received: from HK2APC01FT106.eop-APC01.prod.protection.outlook.com
 (10.152.248.59) by HK2APC01HT189.eop-APC01.prod.protection.outlook.com
 (10.152.249.88) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2559.14; Wed, 18 Dec
 2019 03:38:12 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.248.57) by
 HK2APC01FT106.mail.protection.outlook.com (10.152.249.181) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2559.14 via Frontend Transport; Wed, 18 Dec 2019 03:38:12 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:8109F1FF9F697A72D4EB5ABDA92B49BF3B0DBF474BEBA1D7A55D609A2E49D81E;
 UpperCasedChecksum:B15025FEF77D2CB0122DAC5537A7BE8C996A5429D6E304996C8EA8B34634B2E2;
 SizeAsReceived:9473; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2559.012; Wed, 18 Dec 2019
 03:38:12 +0000
Date: Wed, 18 Dec 2019 11:38:03 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Message-ID: <PS1PR03MB3606E727C6933D98CF95A670B7530@HIDDEN>
In-Reply-To: <87sgliwlw7.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN>
 <4c0dabe9-14a8-4e93-148f-c8b319495cb1@HIDDEN>
 <PS1PR03MB36060FFD1D455A09951DFAC3B7500@HIDDEN>
 <87sgliwlw7.fsf@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: a1c58059-4540-40bc-85d2-5abbb9c874a0@Spark
Content-Type: multipart/alternative; boundary="5df99f21_b03e0c6_191"
X-ClientProxiedBy: HK2PR03CA0060.apcprd03.prod.outlook.com
 (2603:1096:202:17::30) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <a1c58059-4540-40bc-85d2-5abbb9c874a0@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.193.168.19) by
 HK2PR03CA0060.apcprd03.prod.outlook.com (2603:1096:202:17::30) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2559.10 via Frontend Transport; Wed, 18 Dec 2019 03:38:11 +0000
X-Readdle-Message-ID: a1c58059-4540-40bc-85d2-5abbb9c874a0@Spark
X-Microsoft-Original-Message-ID: <a1c58059-4540-40bc-85d2-5abbb9c874a0@Spark>
X-TMN: [6TlhZeNKkiuuWnx4N0h3cA/46EGUHvDU]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 074b87e1-4b80-49bc-6db2-08d7836bb505
X-MS-TrafficTypeDiagnostic: HK2APC01HT189:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: bkwRNMUMI0KIlDRLwvofvWeCuyjo145hdw/O5biYO6wmG8X95RsrUjwKHw4xENwBsk5SSPw8jWY6GVY8teVRqTFKPqNnZUJ9zBOX0+J4zxl19VJIBqTd83dq+MK25v0tabUldwyE06gDIh+vvmVG57NEmE8M5fZ1Q9xYAevjGCRWVldoSSJFPRFdJWoMz/gV
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 074b87e1-4b80-49bc-6db2-08d7836bb505
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 18 Dec 2019 03:38:12.0784 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HK2APC01HT189
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5df99f21_b03e0c6_191
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

=E5=9C=A8 2019=E5=B9=B412=E6=9C=8818=E6=97=A5 +0800 AM8:06=EF=BC=8CJuri L=
inkov <juri=40linkov.net>=EF=BC=8C=E5=86=99=E9=81=93=EF=BC=9A
> > =46or the original bug of this thread, I have a feature request:
> > I would like dabbrev-expand to don=E2=80=99t display the messages whe=
n
> > minibuffer is active. It is annoying in everyday use. It cause
> > flickers. I suffer from it too long.
>
> Don't worry. With the new patch you will see no messages from dabbrev-e=
xpand
> because at the end dabbrev-expand already calls '(message nil)' that
> quickly clears the message from the minibuffer.

Yes. I=E2=80=99m waiting for it.
Thanks for your great work.

--5df99f21_b03e0c6_191
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageReplySection">=E5=9C=A8 2019=E5=B9=B412=E6=9C=8818=E6=
=97=A5 &#43;0800 AM8:06=EF=BC=8CJuri Linkov &lt;juri@HIDDEN&gt;=EF=BC=
=8C=E5=86=99=E9=81=93=EF=BC=9A<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">For the original bug o=
f this thread, I have a feature request:<br>
I would like dabbrev-expand to don=E2=80=99t display the messages when<br>
minibuffer is active. It is annoying in everyday use. It cause<br>
flickers. I suffer from it too long.<br></blockquote>
<br>
Don't worry. With the new patch you will see no messages from dabbrev-expan=
d<br>
because at the end dabbrev-expand already calls '(message nil)' that<br>
quickly clears the message from the minibuffer.&nbsp;<br></blockquote>
<br>
<div>Yes. I=E2=80=99m waiting for it.</div>
<div dir=3D"auto">Thanks for your great work.</div>
</div>
</body>
</html>

--5df99f21_b03e0c6_191--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Dec 2019 00:06:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 19:06:58 2019
Received: from localhost ([127.0.0.1]:42532 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihMri-00006g-HM
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 19:06:58 -0500
Received: from bumble.birch.relay.mailchannels.net ([23.83.209.25]:12583)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ihMre-00006N-To
 for 38457 <at> debbugs.gnu.org; Tue, 17 Dec 2019 19:06:55 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id E42CE5012F4;
 Wed, 18 Dec 2019 00:06:53 +0000 (UTC)
Received: from pdx1-sub0-mail-a90.g.dreamhost.com
 (100-96-15-224.trex.outbound.svc.cluster.local [100.96.15.224])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 68A5B501B9F;
 Wed, 18 Dec 2019 00:06:53 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a90.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 18 Dec 2019 00:06:53 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Reign-Trade: 7f7899651321a729_1576627613683_3317762681
X-MC-Loop-Signature: 1576627613683:2861244900
X-MC-Ingress-Time: 1576627613683
Received: from pdx1-sub0-mail-a90.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a90.g.dreamhost.com (Postfix) with ESMTP id 553627F151;
 Tue, 17 Dec 2019 16:06:50 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type:content-transfer-encoding; s=linkov.net; bh=6fOiW6
 t+O6awHs8K5nps0pFLstg=; b=2uWANaCnrJy+W9WO19nLm13XCIVqtP+jaxLIzW
 gOKzqibTVp6wUOxDit2eu8GibgVVJAdF4uGLzhU1aiXGfyFJp9PftghkyuY7qecu
 vdoabVOUVleOcV9PsxRhpmMUGgkFcD5XxdQPp6gW5U9NG8I4p3dcRFTniyO7DWIR
 yL2yY=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a90.g.dreamhost.com (Postfix) with ESMTPSA id 111117F145;
 Tue, 17 Dec 2019 16:06:47 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a90
From: Juri Linkov <juri@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN>
 <4c0dabe9-14a8-4e93-148f-c8b319495cb1@HIDDEN>
 <PS1PR03MB36060FFD1D455A09951DFAC3B7500@HIDDEN>
Date: Wed, 18 Dec 2019 01:53:08 +0200
In-Reply-To: <PS1PR03MB36060FFD1D455A09951DFAC3B7500@HIDDEN>
 (HaiJun Zhang's message of "Tue, 17 Dec 2019 14:27:38 +0800")
Message-ID: <87sgliwlw7.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddtkedgudekucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgfgsehtkeertddtreejnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledruddtjedrudekieenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrddutdejrddukeeipdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepnhgvthhjuhhnvgesohhuthhlohhokhdrtghomhenucevlhhushhtvghrufhiiigvpedt
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 Dmitry Gutov <dgutov@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> For the original bug of this thread, I have a feature request:
> I would like dabbrev-expand to don=E2=80=99t display the messages when
> minibuffer is active.  It is annoying in everyday use.  It cause
> flickers.  I suffer from it too long.

Don't worry.  With the new patch you will see no messages from dabbrev-ex=
pand
because at the end dabbrev-expand already calls '(message nil)' that
quickly clears the message from the minibuffer.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 18 Dec 2019 00:06:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 19:06:54 2019
Received: from localhost ([127.0.0.1]:42529 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihMre-00006M-2K
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 19:06:54 -0500
Received: from anteater.elm.relay.mailchannels.net ([23.83.212.3]:35823)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ihMrb-00006B-UV
 for 38457 <at> debbugs.gnu.org; Tue, 17 Dec 2019 19:06:52 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 7C7683C0A74;
 Wed, 18 Dec 2019 00:06:50 +0000 (UTC)
Received: from pdx1-sub0-mail-a90.g.dreamhost.com
 (100-96-15-224.trex.outbound.svc.cluster.local [100.96.15.224])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 0C8A73C0A59;
 Wed, 18 Dec 2019 00:06:50 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a90.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 18 Dec 2019 00:06:50 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Squirrel-Plucky: 1f6cfb570e0a7437_1576627610281_2466110706
X-MC-Loop-Signature: 1576627610281:2803171925
X-MC-Ingress-Time: 1576627610281
Received: from pdx1-sub0-mail-a90.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a90.g.dreamhost.com (Postfix) with ESMTP id C404C7F14E;
 Tue, 17 Dec 2019 16:06:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=Bc+qVh++rlOCE+eU+WCOFNbKD1M=; b=
 o6i5RRuxYwbZmCC22/dvsZNLC7oP5YHDDhtnKF7eJEo+tPR7MxAYvI5+Izo5+ZDL
 DDBRL/HVkRqZuyzoOtOyiFXqg4KA5ty/Aa7TIGMlcfaPXeX9EbIeyW6YwZXsy+to
 oifB0yJ2og+lPUL10XAf94shxK+fBbmhG42MlCXG4nM=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a90.g.dreamhost.com (Postfix) with ESMTPSA id 7F66E7F13F;
 Tue, 17 Dec 2019 16:06:43 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a90
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN> <83immf3pba.fsf@HIDDEN>
Date: Wed, 18 Dec 2019 01:51:00 +0200
In-Reply-To: <83immf3pba.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 17 Dec
 2019 18:11:05 +0200")
Message-ID: <87y2vawly3.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddtkedgudekucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesmhdtreertdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

>> >>   (if (and
>> >>        ;; When `inhibit-message' is non-nil, the intention was to just
>> >>        ;; log the message to the *Messages* buffer using `message'.
>> >>        (null inhibit-message)
>> >>        (window-live-p (active-minibuffer-window))
>> >>        (window-live-p (old-selected-window))
>> >>        (bufferp (window-buffer (old-selected-window)))
>> >>        (minibufferp (window-buffer (old-selected-window))))
>> >
>> > Btw, can you explain why every part of this condition is needed?  IOW,
>> > why isn't just the below enough?
>> >
>> >    (window-live-p (active-minibuffer-window))
>> >
>> > (I do understand the reason for the test of inhibit-message).
>> >
>> > Maybe the other conditions need a comment to explain them?
>> 
>> Unfortunately, I forgot why they were added, i.e. during testing
>> I added them one by one when noticed that some cases don't work.
>> Now I'll try to reproduce these cases by removing conditions
>> and checking which part doesn't work.

Now I recall why just (window-live-p (active-minibuffer-window))
is not enough.  Because it returns non-nil even when the
current buffer is not the minibuffer, but the minibuffer was
activated earlier.  Test case:

0. emacs -Q
1. M-x   ;; activate the minibuffer
2. C-x o ;; switch back to *scratch*
3. Eval in *scratch* buffer:

   (window-live-p (active-minibuffer-window))
   => t

A message overlay should not be added to the *scratch* buffer, so it's
important to check if old-selected-window is a minibuffer window
(i.e. the current buffer is the minibuffer).

>> But if implementation would be straightforward and if you see no problems
>> then why not.
>
> The implementation looks straightforward to me, since you already
> implemented almost all of it in that ELPA package.  What's left is
> minor details.

Let's iron out the details.  A new patch attached works well
in all cases I tested (dabbrev, icomplete, etc.)  But I'm sure
it could be improved further because I might have made wrong
assumptions on the C side, or something.


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=set-minibuffer-message.patch

diff --git a/lisp/minibuffer.el b/lisp/minibuffer.el
index 76d8ca4475..331b2a44ed 100644
--- a/lisp/minibuffer.el
+++ b/lisp/minibuffer.el
@@ -746,6 +746,78 @@ minibuffer-message
             (sit-for (or minibuffer-message-timeout 1000000)))
         (delete-overlay ol)))))
 
+(defcustom minibuffer-message-wait nil
+  "How long to display an echo-area message when the minibuffer is active.
+If the value is a number, it should be specified in seconds.
+If the value is not a number, such messages never time out."
+  :type '(choice (const :tag "Never time out" nil)
+                 (integer :tag "Wait for the number of seconds" 2)))
+
+(defvar minibuffer-message-timer nil)
+(defvar minibuffer-message-overlay nil)
+
+(defun set-minibuffer-message (message)
+  "Temporarily display MESSAGE at the end of the minibuffer.
+The text is displayed for `minibuffer-message-wait' seconds,
+or until the next input event arrives, whichever comes first.
+Enclose MESSAGE in [...] if this is not yet the case."
+  (when (and (not noninteractive)
+             (window-live-p (active-minibuffer-window))
+             (window-live-p (old-selected-window))
+             (bufferp (window-buffer (old-selected-window)))
+             (minibufferp (window-buffer (old-selected-window))))
+    (setq message (if (string-match-p "\\` *\\[.+\\]\\'" message)
+                      ;; Make sure we can put-text-property.
+                      (copy-sequence message)
+                    (concat " [" message "]")))
+    (unless (or (null minibuffer-message-properties)
+                ;; Don't overwrite the face properties the caller has set
+                (text-properties-at 0 message))
+      (setq message (apply #'propertize message minibuffer-message-properties)))
+
+    (when (timerp minibuffer-message-timer)
+      (cancel-timer minibuffer-message-timer)
+      (setq minibuffer-message-timer nil))
+    (when (overlayp minibuffer-message-overlay)
+      (delete-overlay minibuffer-message-overlay)
+      (setq minibuffer-message-overlay nil))
+
+    (setq minibuffer-message-overlay
+          (make-overlay (point-max) (point-max) nil t t))
+    (unless (zerop (length message))
+      ;; The current C cursor code doesn't know to use the overlay's
+      ;; marker's stickiness to figure out whether to place the cursor
+      ;; before or after the string, so let's spoon-feed it the pos.
+      (put-text-property 0 1 'cursor t message))
+    (overlay-put minibuffer-message-overlay 'after-string message)
+
+    (when (numberp minibuffer-message-wait)
+      (setq minibuffer-message-timer
+            (run-with-timer minibuffer-message-wait nil
+                            (lambda ()
+                              (when (overlayp minibuffer-message-overlay)
+                                (delete-overlay minibuffer-message-overlay)
+                                (setq minibuffer-message-overlay nil))))))
+
+    t))
+
+(setq set-message-function 'set-minibuffer-message)
+
+(defun clear-minibuffer-message ()
+  "Clear minibuffer message."
+  (when (not noninteractive)
+    ;; When this option is a number, the message
+    ;; should be cleared only by timer.
+    (unless (numberp minibuffer-message-wait)
+      (when (timerp minibuffer-message-timer)
+        (cancel-timer minibuffer-message-timer)
+        (setq minibuffer-message-timer nil))
+      (when (overlayp minibuffer-message-overlay)
+        (delete-overlay minibuffer-message-overlay)
+        (setq minibuffer-message-overlay nil)))))
+
+(setq clear-message-function 'clear-minibuffer-message)
+
 (defun minibuffer-completion-contents ()
   "Return the user input in a minibuffer before point as a string.
 In Emacs 22, that was what completion commands operated on.
diff --git a/src/keyboard.c b/src/keyboard.c
index 5135fd0bc8..d9c9213098 100644
--- a/src/keyboard.c
+++ b/src/keyboard.c
@@ -2990,6 +2990,8 @@ read_char (int commandflag, Lisp_Object map,
 	  safe_run_hooks (Qecho_area_clear_hook);
 	  clear_message (1, 0);
 	}
+      else if (!NILP (Vclear_message_function))
+        message1 (0);
     }
 
  reread_for_input_method:
diff --git a/src/xdisp.c b/src/xdisp.c
index 08c6927052..a31a90c7e2 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -11706,13 +11706,33 @@ truncate_message_1 (ptrdiff_t nchars, Lisp_Object a2)
 static void
 set_message (Lisp_Object string)
 {
+  Lisp_Object message = Qnil;
+
   eassert (STRINGP (string));
 
-  message_enable_multibyte = STRING_MULTIBYTE (string);
+  if (!NILP (Vset_message_function))
+    {
+      ptrdiff_t count = SPECPDL_INDEX ();
+      specbind (Qinhibit_quit, Qt);
+      message = call1 (Vset_message_function, string);
+      unbind_to (count, Qnil);
 
-  with_echo_area_buffer (0, -1, set_message_1, 0, string);
-  message_buf_print = false;
-  help_echo_showing_p = false;
+      if (STRINGP (message))
+        {
+          eassert (STRINGP (message));
+          string = message;
+          message = Qnil;
+        }
+    }
+
+  if (NILP (message))
+    {
+      message_enable_multibyte = STRING_MULTIBYTE (string);
+
+      with_echo_area_buffer (0, -1, set_message_1, 0, string);
+      message_buf_print = false;
+      help_echo_showing_p = false;
+    }
 
   if (STRINGP (Vdebug_on_message)
       && STRINGP (string)
@@ -11768,6 +11788,14 @@ clear_message (bool current_p, bool last_displayed_p)
     {
       echo_area_buffer[0] = Qnil;
       message_cleared_p = true;
+
+      if (!NILP (Vclear_message_function))
+        {
+          ptrdiff_t count = SPECPDL_INDEX ();
+          specbind (Qinhibit_quit, Qt);
+          call0 (Vclear_message_function);
+          unbind_to (count, Qnil);
+        }
     }
 
   if (last_displayed_p)
@@ -34940,6 +34968,14 @@ syms_of_xdisp (void)
 	       doc: /* If non-nil, debug if a message matching this regexp is displayed.  */);
   Vdebug_on_message = Qnil;
 
+  DEFVAR_LISP ("set-message-function", Vset_message_function,
+	       doc: /* If non-nil, function to set message.  */);
+  Vset_message_function = Qnil;
+
+  DEFVAR_LISP ("clear-message-function", Vclear_message_function,
+	       doc: /* If non-nil, function to clear message.  */);
+  Vclear_message_function = Qnil;
+
   DEFVAR_LISP ("redisplay--all-windows-cause", Vredisplay__all_windows_cause,
 	       doc: /*  */);
   Vredisplay__all_windows_cause = Fmake_hash_table (0, NULL);

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 17 Dec 2019 16:19:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 11:19:31 2019
Received: from localhost ([127.0.0.1]:42279 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihFZL-0000jh-8Y
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 11:19:31 -0500
Received: from eggs.gnu.org ([209.51.188.92]:37319)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ihFZJ-0000jM-Hj
 for 38457 <at> debbugs.gnu.org; Tue, 17 Dec 2019 11:19:29 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53455)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ihFZD-0003y4-Jf; Tue, 17 Dec 2019 11:19:23 -0500
Received: from [176.228.60.248] (port=4282 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ihFZC-0003zx-Ug; Tue, 17 Dec 2019 11:19:23 -0500
Date: Tue, 17 Dec 2019 18:19:10 +0200
Message-Id: <83eex33oxt.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
In-reply-to: <PS1PR03MB36060FFD1D455A09951DFAC3B7500@HIDDEN>
 (message from HaiJun Zhang on Tue, 17 Dec 2019 14:27:38 +0800)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN>
 <4c0dabe9-14a8-4e93-148f-c8b319495cb1@HIDDEN> 
 <PS1PR03MB36060FFD1D455A09951DFAC3B7500@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, dgutov@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 17 Dec 2019 14:27:38 +0800
> From: HaiJun Zhang <netjune@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> 
> For the original bug of this thread, I have a feature request: 
> I would like dabbrev-expand to don’t display the messages when minibuffer is active. It is annoying in everyday
> use. It cause flickers. I suffer from it too long.

Is that wise?  dabbrev-expand could take quite some time, if it
starts looking in other buffers and there are a lot of them.  If it
keeps silence, you will see Emacs frozen without any indication of
what's going on.  People will consider this a bug and complain.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 17 Dec 2019 16:11:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 11:11:27 2019
Received: from localhost ([127.0.0.1]:42259 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihFRW-00071R-KK
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 11:11:26 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33650)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ihFRV-00071C-16
 for 38457 <at> debbugs.gnu.org; Tue, 17 Dec 2019 11:11:25 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:53264)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ihFRP-00046t-Gx; Tue, 17 Dec 2019 11:11:19 -0500
Received: from [176.228.60.248] (port=3785 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ihFRO-0003IC-D7; Tue, 17 Dec 2019 11:11:19 -0500
Date: Tue, 17 Dec 2019 18:11:05 +0200
Message-Id: <83immf3pba.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87a77rgajf.fsf@HIDDEN> (message from Juri Linkov on
 Tue, 17 Dec 2019 00:29:32 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Tue, 17 Dec 2019 00:29:32 +0200
> 
> > However, I hoped we could have at least part of what you did in Emacs
> > 27, and not lose all of it.  We could install a function like
> > 'minimess-minibuffer-message', and make one of the subroutines of
> > 'message' call it under the right conditions.
> 
> The most low-level functions where it could be called from
> are 'set_message' and 'clear_message'.

I had in mind set_message_1 rather than set_message, but the
difference is not critical for this discussion.

> > Then the message which
> > 'minimess-minibuffer-message' displays could be removed by a timer if
> > the new timeout defcustom is a number, and if that defcustom is not a
> > number (which will be the default), the message stays and sit-for is
> > not called.
> 
> This is almost how 'minimess-minibuffer-message' was implemented,
> with one difference: defcustom is a number by default.
> Why shouldn't it be a number by default?

By making the default not a number, we keep the previous behavior of
'message' in this aspect, thus minimizing potential unintended
consequences.  At the same time, we gain another aspect: we avoid
hiding the minibuffer prompt.  So this will be a partial improvement
wrt the current behavior, with an option for users who would like that
to customize the value to a number, and thus get the message removed
automatically after some delay.

> How the user would be able to remove an old message when the
> function doesn't call sit-for?

Like they do today: type something.  And in some situations, not even
that, if the Lisp program which displayed the message will shortly
follow up with clearing the echo area (that's what happens with
dabbrev, for example).

> > Do you see any danger with the above?  If not, can I persuade you do
> > install such a change?
> 
> I'm not sure if now is the right time to implement this feature.
> But if implementation would be straightforward and if you see no problems
> then why not.

The implementation looks straightforward to me, since you already
implemented almost all of it in that ELPA package.  What's left is
minor details.

> >>   (if (and
> >>        ;; When `inhibit-message' is non-nil, the intention was to just
> >>        ;; log the message to the *Messages* buffer using `message'.
> >>        (null inhibit-message)
> >>        (window-live-p (active-minibuffer-window))
> >>        (window-live-p (old-selected-window))
> >>        (bufferp (window-buffer (old-selected-window)))
> >>        (minibufferp (window-buffer (old-selected-window))))
> >
> > Btw, can you explain why every part of this condition is needed?  IOW,
> > why isn't just the below enough?
> >
> >    (window-live-p (active-minibuffer-window))
> >
> > (I do understand the reason for the test of inhibit-message).
> >
> > Maybe the other conditions need a comment to explain them?
> 
> Unfortunately, I forgot why they were added, i.e. during testing
> I added them one by one when noticed that some cases don't work.
> Now I'll try to reproduce these cases by removing conditions
> and checking which part doesn't work.

Thank you.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 17 Dec 2019 06:28:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 01:28:03 2019
Received: from localhost ([127.0.0.1]:40623 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ih6Kx-0004iZ-30
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 01:28:03 -0500
Received: from mail-oln040092254078.outbound.protection.outlook.com
 ([40.92.254.78]:16718 helo=APC01-PU1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1ih6Kv-0004ha-0d
 for 38457 <at> debbugs.gnu.org; Tue, 17 Dec 2019 01:28:01 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=lTecgmuTM8ujrLFx30a/b+sC9Ge01+sJ3yJBsj6DvcAwXZAbuNRxzkdFs45bZOglf47XWVLuaQ0o4VE0umeKEmas7/JM4XmD7MkRliogICZPN7iSG6TmJFeFt9uWEZDFNYqulDBBZY7sazQyJATecu+N4n0WfslaiE6abjfhd4Q+uD+G0m8ovCnO/lPejAC46W260/cF81OsZoEg+U0nUyxfBrTFib90b7p3AopT8b1fmNY0tOnaNqMiYg5vYFB7UtASYzBEVC2dh3t7d5RrvTla+DLbJX4tiS3DNs/mGY7VV3g68yehunSjEXdtDK+muLS6fO4g4/sWqzvZN0ydIw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=pwerzX6QgKr6WRvSyonZg/b7kLm4RDoFcYNTpZKOC5c=;
 b=h00CcXSdMwoGkYBCrQ3+KhTZWrQ9olBQzwOZWiRN1Uejx3eUMHAnnkqjdioR96v75mkXrJVhaFw6GdV+kWLijfSZtG0Ce9Q7Cqi8M3s6GgFhfzycGAFXeiACdJBV1FMyJWsiHI7suqeDAU+Gk5gpUuYnte8j3eg+z7U7gMjrdEj97grgz+CEhErxS4kY9Xgre4oszdnOrsyBlS5nu/KntoUB0OMkc6SE0ObDR3fVTmAyWWkssa1OVMi5juz4rCiPjosFjbBD+MUU0Tg1+TfcwtgqU1DSPympFOTuDxwljDc+bsSrHu1JpyIcndDAN71j+I2byur9olW2U0+eVQyCOg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=pwerzX6QgKr6WRvSyonZg/b7kLm4RDoFcYNTpZKOC5c=;
 b=iUwmlfrAFiffIqkCg7+K0vllT2e13p4kdxxTEpC3tgNf32o2RXzJd97K5Y3Jj6jKQK3i4yNW8i6VZ+JHnYFvGe62r4xLhKYWddvMdY1Fi8sJE4n/LQgRPzarxMzrOb+nfWNunhpWQ4vMbUDtZ5AK+I3RRdXnniVoDY0Vf4gT1qbAqZtAUnHsIDNO81RtFwwo0NYRpvRkjK7tC7yPsRpeehK23SJFDNtUFmqtfkrQq+bWkwToyIYD1LhT2rIHIoZRvm3pMxjpXjgN7831NLHgg7pvZO4XUNFtuJVxtRWMnKtfSI2/lvNeXyavaHgm+NvXKyJCzOhP89/sXmFg7UpWTA==
Received: from SG2APC01FT116.eop-APC01.prod.protection.outlook.com
 (10.152.250.59) by SG2APC01HT072.eop-APC01.prod.protection.outlook.com
 (10.152.251.19) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2538.15; Tue, 17 Dec
 2019 06:27:52 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.250.58) by
 SG2APC01FT116.mail.protection.outlook.com (10.152.250.216) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2538.15 via Frontend Transport; Tue, 17 Dec 2019 06:27:52 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:BDDFE73AACF8C907BDA2FF571EAEE844E4BE13EAAF9D0BD0D5C66A54E292226B;
 UpperCasedChecksum:201D054FC612CF02B46379A16F4ADD4B0ACAABF029B06DCAE811BCB12F50CBC4;
 SizeAsReceived:9414; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2559.012; Tue, 17 Dec 2019
 06:27:52 +0000
Date: Tue, 17 Dec 2019 14:27:38 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: Juri Linkov <juri@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>, Dmitry
 Gutov <dgutov@HIDDEN>
Message-ID: <PS1PR03MB36060FFD1D455A09951DFAC3B7500@HIDDEN>
In-Reply-To: <4c0dabe9-14a8-4e93-148f-c8b319495cb1@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN>
 <4c0dabe9-14a8-4e93-148f-c8b319495cb1@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: d27eb282-5766-4833-8aa7-cf0bf5ea2edf@Spark
Content-Type: multipart/alternative; boundary="5df87560_2d1d5ae9_191"
X-ClientProxiedBy: HK2PR02CA0177.apcprd02.prod.outlook.com
 (2603:1096:201:21::13) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <d27eb282-5766-4833-8aa7-cf0bf5ea2edf@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.193.168.19) by
 HK2PR02CA0177.apcprd02.prod.outlook.com (2603:1096:201:21::13) with Microsoft
 SMTP Server (version=TLS1_2, cipher=) via Frontend Transport;
 Tue, 17 Dec 2019 06:27:48 +0000
X-Readdle-Message-ID: d27eb282-5766-4833-8aa7-cf0bf5ea2edf@Spark
X-Microsoft-Original-Message-ID: <d27eb282-5766-4833-8aa7-cf0bf5ea2edf@Spark>
X-TMN: [DREH+UCjGc8h0yAKP6j7+wZch95XwogL]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 19b8762d-b3c0-4bdd-18b9-08d782ba3e44
X-MS-TrafficTypeDiagnostic: SG2APC01HT072:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: vzEVDQQ40xFGLnPtuOe8VzqPOmfGEBK1psLnSziQb4gtUgWkRjjXPbUhrbqKJGxA44uFr/DPd6KAXTemSC2ybli9Z4uXiKSX9Vh2VDpsMscvyc/s3DQYBgutf5UFKLxgFg/yv9a9gxaPnRPFPvCRR090FOc4kF206hL6HadMm2uhV7xz7ArZV6KgyNoF4Cwj
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 19b8762d-b3c0-4bdd-18b9-08d782ba3e44
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 17 Dec 2019 06:27:51.9830 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: SG2APC01HT072
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5df87560_2d1d5ae9_191
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

=46or the original bug of this thread, I have a feature request:
I would like dabbrev-expand to don=E2=80=99t display the messages when mi=
nibuffer is active. It is annoying in everyday use. It cause flickers.=C2=
=A0I suffer from it too long.

--5df87560_2d1d5ae9_191
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageBodySection">
<div dir=3D"auto">For the original bug of this thread, I have a feature req=
uest:
<div dir=3D"auto">I would like dabbrev-expand to don=E2=80=99t display the =
messages when minibuffer is active. It is annoying in everyday use. It caus=
e flickers.&nbsp;<span style=3D"caret-color: rgb(39, 39, 40);">I suffer fro=
m it too long.</span></div>
</div>
</div>
</body>
</html>

--5df87560_2d1d5ae9_191--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 16 Dec 2019 23:26:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 16 18:26:46 2019
Received: from localhost ([127.0.0.1]:40511 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igzlF-0001gp-Rm
	for submit <at> debbugs.gnu.org; Mon, 16 Dec 2019 18:26:46 -0500
Received: from mail-wm1-f43.google.com ([209.85.128.43]:33461)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1igzlE-0001gc-He
 for 38457 <at> debbugs.gnu.org; Mon, 16 Dec 2019 18:26:44 -0500
Received: by mail-wm1-f43.google.com with SMTP id d139so951113wmd.0
 for <38457 <at> debbugs.gnu.org>; Mon, 16 Dec 2019 15:26:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=r9Xp4KQlfTe+3FexpyTyiO5lS93Nz90L4Imvt4K1YDE=;
 b=EiM3UlFYykL/Rg80klOypsxjFwcCDnFGhudDAlHInm9jjVyS8rb92pWCUKGnmWvXxr
 U/DpbWiyxN9iWeehbezwvviE3zx4l61uS9gXDyNzujiw/YgWo5UmSolDreLcTqlKGYsl
 ZQ96UBbgH3wZBcpQZcrqdboTkZxMNdRjv4StZOrsMdyw8AlcAwt5twMBv/a/BXld8w5z
 yuaLfo9cdy6Mm0AY0Tc3QW1tHUxfkOvMeQcp019XvpawsPlk6boZRMd1+orm8ltA1Bhp
 /tJcScqlgFkp6AW0/uKbdXHoi1n4dM6HAS+tToiauVatAqz/8ld87YtkCYDyiWWSwhCN
 zehQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=r9Xp4KQlfTe+3FexpyTyiO5lS93Nz90L4Imvt4K1YDE=;
 b=IE3gJAonDxKAEchgl8hOFy8YD9tN7r9OhJ6B4vTtzXRid6BoFfBywpTabn+r5+s1fg
 6yVgSpZtfKWMQ77rLe/hkOY4W9r2fv5Y/mr43uxjWHH/bdsLi4iCX52rz9xK47xA8y51
 MmiaCjJotvP4EWJkf1dpfkogf6dAp3vVz9A1YA3jxWSm2K6Vu3skTAy7nQodnmvUfzog
 /e9KZvMOkx4DU64VxehfCCUvx17cSwz9Fu00sK7bKC01Ru14WfM11xUiFM+iw8I+HQ5U
 coBE23CTEw8Q4bMaJted5ipp9TGXu9blOUJLt+/ChaOxqMM5538EvmzFTyMezuRCAqc8
 Ay8A==
X-Gm-Message-State: APjAAAWcQAtCyKbv6qSw/rdrBQ+eX9YTNvxHRWVMKGs3CGwgOnZdN16Y
 LRiw8bsI9rMi9XSDTYz+w8ZPX/9/wkU=
X-Google-Smtp-Source: APXvYqwV5ejaw4LQa7XemZu7DYMAIm2VZEKrjwcyPSyBfb4aAfQEWesW+yLFhcOqgO51rjuoVP63vw==
X-Received: by 2002:a7b:c774:: with SMTP id x20mr1183420wmk.66.1576538798212; 
 Mon, 16 Dec 2019 15:26:38 -0800 (PST)
Received: from [192.168.0.5] ([212.50.117.215])
 by smtp.googlemail.com with ESMTPSA id a14sm24424242wrx.81.2019.12.16.15.26.36
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Mon, 16 Dec 2019 15:26:37 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Juri Linkov <juri@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
 <87a77rgajf.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <4c0dabe9-14a8-4e93-148f-c8b319495cb1@HIDDEN>
Date: Tue, 17 Dec 2019 01:26:35 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <87a77rgajf.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 17.12.2019 0:29, Juri Linkov wrote:
> How the user would be able
> to remove an old message when the function doesn't call sit-for?

Just like they did for decades until now: by pressing (any) button. 
Which will invoke the next command and clear the echo area.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 16 Dec 2019 22:53:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 16 17:53:01 2019
Received: from localhost ([127.0.0.1]:40478 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igzEb-0006zW-4C
	for submit <at> debbugs.gnu.org; Mon, 16 Dec 2019 17:53:01 -0500
Received: from blue.elm.relay.mailchannels.net ([23.83.212.20]:56344)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1igzEZ-0006zL-RT
 for 38457 <at> debbugs.gnu.org; Mon, 16 Dec 2019 17:53:00 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id B24A834089A;
 Mon, 16 Dec 2019 22:52:58 +0000 (UTC)
Received: from pdx1-sub0-mail-a19.g.dreamhost.com
 (100-96-15-224.trex.outbound.svc.cluster.local [100.96.15.224])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 20BC434165C;
 Mon, 16 Dec 2019 22:52:58 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a19.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Mon, 16 Dec 2019 22:52:58 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Bubble-Minister: 0de51e224545341a_1576536778358_2496516364
X-MC-Loop-Signature: 1576536778358:3717511189
X-MC-Ingress-Time: 1576536778357
Received: from pdx1-sub0-mail-a19.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a19.g.dreamhost.com (Postfix) with ESMTP id 8314A7F028;
 Mon, 16 Dec 2019 14:52:55 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=FtRgODGfGn5aD8H56RiNNHowLaE=; b=
 Rl26FTetDk5tLIYa1vl8mYLhCSwHAtwaKQ/IW2hAycG38Fexcg3fjUMKZvU4R3Vc
 06PhA0uYoOL89UwMiQpfvpkGhVjQCR1yxTKmuVJibuWMo556+dyKQ17WVGhkVYF9
 jHZnkNgE9V1u0RXEBKiAmq+T5bbziZaLK0vFBYeV4c4=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a19.g.dreamhost.com (Postfix) with ESMTPSA id E6F217EFC4;
 Mon, 16 Dec 2019 14:52:53 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a19
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN> <8336dk5k1p.fsf@HIDDEN>
Date: Tue, 17 Dec 2019 00:29:32 +0200
In-Reply-To: <8336dk5k1p.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 16 Dec
 2019 18:09:38 +0200")
Message-ID: <87a77rgajf.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddtiedgtdegucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpeef
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> However, I hoped we could have at least part of what you did in Emacs
> 27, and not lose all of it.  We could install a function like
> 'minimess-minibuffer-message', and make one of the subroutines of
> 'message' call it under the right conditions.

The most low-level functions where it could be called from
are 'set_message' and 'clear_message'.

> Then the message which
> 'minimess-minibuffer-message' displays could be removed by a timer if
> the new timeout defcustom is a number, and if that defcustom is not a
> number (which will be the default), the message stays and sit-for is
> not called.

This is almost how 'minimess-minibuffer-message' was implemented,
with one difference: defcustom is a number by default.
Why shouldn't it be a number by default?  How the user would be able
to remove an old message when the function doesn't call sit-for?

> Do you see any danger with the above?  If not, can I persuade you do
> install such a change?

I'm not sure if now is the right time to implement this feature.
But if implementation would be straightforward and if you see no problems
then why not.

>> (defun minimess-message (orig-fun format-string &rest args)
>>   (if (and
>>        ;; When `inhibit-message' is non-nil, the intention was to just
>>        ;; log the message to the *Messages* buffer using `message'.
>>        (null inhibit-message)
>>        (window-live-p (active-minibuffer-window))
>>        (window-live-p (old-selected-window))
>>        (bufferp (window-buffer (old-selected-window)))
>>        (minibufferp (window-buffer (old-selected-window))))
>
> Btw, can you explain why every part of this condition is needed?  IOW,
> why isn't just the below enough?
>
>    (window-live-p (active-minibuffer-window))
>
> (I do understand the reason for the test of inhibit-message).
>
> Maybe the other conditions need a comment to explain them?

Unfortunately, I forgot why they were added, i.e. during testing
I added them one by one when noticed that some cases don't work.
Now I'll try to reproduce these cases by removing conditions
and checking which part doesn't work.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 16 Dec 2019 16:10:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 16 11:10:02 2019
Received: from localhost ([127.0.0.1]:40305 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igswc-0003tA-Gn
	for submit <at> debbugs.gnu.org; Mon, 16 Dec 2019 11:10:02 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39213)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1igswa-0003sZ-Fu
 for 38457 <at> debbugs.gnu.org; Mon, 16 Dec 2019 11:10:01 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33186)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1igswV-0001OS-2C; Mon, 16 Dec 2019 11:09:55 -0500
Received: from [176.228.60.248] (port=3675 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1igswU-000335-E0; Mon, 16 Dec 2019 11:09:54 -0500
Date: Mon, 16 Dec 2019 18:09:38 +0200
Message-Id: <8336dk5k1p.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <878snd2liu.fsf@HIDDEN> (message from Juri Linkov on
 Mon, 16 Dec 2019 01:59:45 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <83y2vujd0y.fsf@HIDDEN>
 <87blspm0sm.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
 <878snd2liu.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Mon, 16 Dec 2019 01:59:45 +0200
> 
> > IOW, introduce a new option, which will affect the new function we
> > were talking about, a near-clone of minibuffer-message (and will not
> > affect minibuffer-message itself).  When that new option's value is
> > not a number, the near-clone of minibuffer-message should not call
> > sit-for at all; and when that value is a number, use a timer to remove
> > the message after that many seconds if no input arrives before that.
> >
> > In any case, I thought we agreed not to call minibuffer-message from
> > 'message', but define a new function, similar but not identical to
> > minibuffer-message (what I call a "near-clone").  And
> > minibuffer-message-timeout should not affect that new function, it
> > should be a separate option.
> 
> I agree that a new function needs to be created, and agree
> not to call minibuffer-message from 'message'.

OK.

> >> 8693611136
> >> aa89c84e00
> >> 54c792ece6
> >>
> >> Please revert them if you want.
> >
> > Thanks.  Let's revisit these after the implementation of the
> > minibuffer-message's clone is finalized, so that we could know which
> > ones of these are still needed and which aren't.
> 
> Since a new near-clone of minibuffer-message is needed, and
> we agreed to not call minibuffer-message from 'message',
> I reverted all previous changes.
> 
> Now a new feature could be implemented from scratch.
> 
> I created a new ELPA package attached below that
> implements this feature.  So everyone who like it
> can use it even after release.  Also this package
> could be used for experimentation to find the best way
> to use it, that later could be moved to core in Emacs 28.
> 
> I think now we have no moral right to delay the Emacs 27 pretest
> anymore.

Thanks.

However, I hoped we could have at least part of what you did in Emacs
27, and not lose all of it.  We could install a function like
'minimess-minibuffer-message', and make one of the subroutines of
'message' call it under the right conditions.  Then the message which
'minimess-minibuffer-message' displays could be removed by a timer if
the new timeout defcustom is a number, and if that defcustom is not a
number (which will be the default), the message stays and sit-for is
not called.

Do you see any danger with the above?  If not, can I persuade you do
install such a change?

> (defun minimess-message (orig-fun format-string &rest args)
>   (if (and
>        ;; When `inhibit-message' is non-nil, the intention was to just
>        ;; log the message to the *Messages* buffer using `message'.
>        (null inhibit-message)
>        (window-live-p (active-minibuffer-window))
>        (window-live-p (old-selected-window))
>        (bufferp (window-buffer (old-selected-window)))
>        (minibufferp (window-buffer (old-selected-window))))

Btw, can you explain why every part of this condition is needed?  IOW,
why isn't just the below enough?

   (window-live-p (active-minibuffer-window))

(I do understand the reason for the test of inhibit-message).

Maybe the other conditions need a comment to explain them?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.
Merged 38457 38560. Request was from Juri Linkov <juri@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 16 Dec 2019 00:01:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 15 19:01:12 2019
Received: from localhost ([127.0.0.1]:37527 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igdp2-0000r8-0G
	for submit <at> debbugs.gnu.org; Sun, 15 Dec 2019 19:01:12 -0500
Received: from black.elm.relay.mailchannels.net ([23.83.212.19]:7049)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1igdoz-0000qn-Jd
 for 38457 <at> debbugs.gnu.org; Sun, 15 Dec 2019 19:01:10 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 76FB11A15D9;
 Mon, 16 Dec 2019 00:01:08 +0000 (UTC)
Received: from pdx1-sub0-mail-a34.g.dreamhost.com
 (100-96-15-224.trex.outbound.svc.cluster.local [100.96.15.224])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id DDE011A1741;
 Mon, 16 Dec 2019 00:01:07 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a34.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Mon, 16 Dec 2019 00:01:08 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Cooing-Continue: 15a891ca7179da03_1576454468149_3049199648
X-MC-Loop-Signature: 1576454468149:862318028
X-MC-Ingress-Time: 1576454468149
Received: from pdx1-sub0-mail-a34.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a34.g.dreamhost.com (Postfix) with ESMTP id CAC107F5F6;
 Sun, 15 Dec 2019 16:01:04 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=cDhrsLJw/mCjxfXWF0e3X0WG6S8=; b=
 oArOG+90Fc4PQqK6vS9g7pmN8oTPVKXboo80pTGpMceQ0Wug/OABZgyGOACRVl5u
 vWpqPWv6ujf15T7pHgeY/3Qx4ICXEXKZM8pXsiWkWNflsXqt+Y/stY8NaoSNzKWk
 fsvX6lSMEd+/OdZ5wwdDjTOe95C8pC/gDm1jOn1DXAo=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a34.g.dreamhost.com (Postfix) with ESMTPSA id 47D2D7F5F4;
 Sun, 15 Dec 2019 16:01:02 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a34
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <83y2vujd0y.fsf@HIDDEN>
 <87blspm0sm.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN> <83r21561qd.fsf@HIDDEN>
Date: Mon, 16 Dec 2019 01:59:45 +0200
In-Reply-To: <83r21561qd.fsf@HIDDEN> (Eli Zaretskii's message of "Sun, 15 Dec
 2019 17:35:22 +0200")
Message-ID: <878snd2liu.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddtgedgudejucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesmhdtreertdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

>> The main problem with 'minibuffer-message' is that it uses 'sit-for'.
>> If a new function will use the same 'sit-for' to detect when input is
>> available, then it will bring the same problems.  Here's is an example
>> of the problems it causes: I call 'select-window' from 'post-command-hook'
>> to select an output window, but 'sit-for' delays selecting the window
>> for 2 seconds until 'execute-extended-command' finishes displaying
>> the message "You can run the command `%s' with %s" using 'sit-for'.
>> The output window becomes selected only after 2 seconds because
>> a customized function in 'post-command-hook' doesn't run earlier
>> than returning from 'sit-for' in 'execute-extended-command'.
>>
>> 'sit-for' is used in many places, but it's inappropriate for these tasks.
>> What is a possible replacement for 'sit-for'?  For a delay of specified
>> seconds, one solution is to run a timer.  But how to replace another
>> aspect of 'sit-for', namely an ability to stop when input is available?

I'd like to add that the biggest drawback of sit-for is that
no message is displayed when input is available like is in e.g.
do-after-load-evaluation after start, or when the user is typing in
the minibuffer, the user might miss an important message.

> What I had in mind was to go with your idea, viz.:
>
>> Then your proposed implementation should be activated when
>> minibuffer-message-timeout is set to a non-nil value.
>> Otherwise, when it's a number, it should use the timer.
>
> IOW, introduce a new option, which will affect the new function we
> were talking about, a near-clone of minibuffer-message (and will not
> affect minibuffer-message itself).  When that new option's value is
> not a number, the near-clone of minibuffer-message should not call
> sit-for at all; and when that value is a number, use a timer to remove
> the message after that many seconds if no input arrives before that.
>
> In any case, I thought we agreed not to call minibuffer-message from
> 'message', but define a new function, similar but not identical to
> minibuffer-message (what I call a "near-clone").  And
> minibuffer-message-timeout should not affect that new function, it
> should be a separate option.

I agree that a new function needs to be created, and agree
not to call minibuffer-message from 'message'.

>> > Assuming you agree, once this change is made, some of the recent
>> > changes related to these issues should be reverted.  Can I ask you to
>> > review those related changesets and publish a list of those which need
>> > to be reverted or augmented?
>>
>> Here's is a list of related changesets:
>>
>> 8693611136
>> aa89c84e00
>> 54c792ece6
>>
>> Please revert them if you want.
>
> Thanks.  Let's revisit these after the implementation of the
> minibuffer-message's clone is finalized, so that we could know which
> ones of these are still needed and which aren't.

Since a new near-clone of minibuffer-message is needed, and
we agreed to not call minibuffer-message from 'message',
I reverted all previous changes.

Now a new feature could be implemented from scratch.

I created a new ELPA package attached below that
implements this feature.  So everyone who like it
can use it even after release.  Also this package
could be used for experimentation to find the best way
to use it, that later could be moved to core in Emacs 28.

I think now we have no moral right to delay the Emacs 27 pretest
anymore.


--=-=-=
Content-Type: application/emacs-lisp
Content-Disposition: attachment; filename=minimess.el
Content-Transfer-Encoding: quoted-printable

;;; minimess.el --- Use function like minibuffer-message in active minibuff=
er  -*- lexical-binding: t; -*-

;; Copyright (C) 2019  Free Software Foundation, Inc.

;; Author: Juri Linkov <juri@HIDDEN>
;; Keywords: minibuffer
;; Version: 0.1

;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.

;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

;;; Commentary:

;; When the minibuffer is active, use the function like `minibuffer-message'
;; to display the message temporarily at the end of the minibuffer.

;;; Code:

(defgroup minimess ()
  "Use the function like `minibuffer-message' in the active minibuffer."
  :group 'minibuffer)

(defcustom minimess-timeout 2
  "How long to display an echo-area message when the minibuffer is active.
If the value is a number, it should be specified in seconds.
If the value is not a number, such messages never time out."
  :type 'integer)

(defvar minimess-timer nil)
(defvar minimess-overlay nil)

(defvar minimess-properties nil
  "Text properties added to the text shown by `minimess-minibuffer-message'=
.")

(defun minimess-minibuffer-message (message &rest args)
  "Temporarily display MESSAGE at the end of the minibuffer.
The text is displayed for `minimess-timeout' seconds,
or until the next input event arrives, whichever comes first.
Enclose MESSAGE in [...] if this is not yet the case.
If ARGS are provided, then pass MESSAGE through `format-message'."
  (if (not (minibufferp (current-buffer)))
      (progn
        (if args
            (apply #'message message args)
          (message "%s" message))
        (prog1 (sit-for (or minimess-timeout 1000000))
          (message nil)))

    ;; Record message in the *Messages* buffer
    (let ((inhibit-message t))
      (if args
          (apply #'message message args)
        (message "%s" message)))

    (if (or (null args) (member (car args) '("" nil)))
        ;; The caller decided to clear the message
        (progn
          (when (timerp minimess-timer)
            (cancel-timer minimess-timer))
          (when (overlayp minimess-overlay)
            (delete-overlay minimess-overlay)))

      (setq message (if (and (null args)
                             (string-match-p "\\` *\\[.+\\]\\'" message))
                        ;; Make sure we can put-text-property.
                        (copy-sequence message)
                      (concat " [" message "]")))
      (when args (setq message (apply #'format-message message args)))
      (unless (or (null minimess-properties)
                  ;; Don't overwrite the face properties the caller has set
                  (text-properties-at 0 message))
        (setq message (apply #'propertize message minimess-properties)))

      (when (timerp minimess-timer)
        (cancel-timer minimess-timer))
      (when (overlayp minimess-overlay)
        (delete-overlay minimess-overlay))

      (setq minimess-overlay
            (make-overlay (point-max) (point-max) nil t t))
      (unless (zerop (length message))
        ;; The current C cursor code doesn't know to use the overlay's
        ;; marker's stickiness to figure out whether to place the cursor
        ;; before or after the string, so let's spoon-feed it the pos.
        (put-text-property 0 1 'cursor t message))
      (overlay-put minimess-overlay 'after-string message)

      (when (numberp minimess-timeout)
        (setq minimess-timer
              (run-with-timer minimess-timeout nil
                              (lambda () (when (overlayp minimess-overlay)
                                           (delete-overlay minimess-overlay=
))))))

      (when (and (stringp debug-on-message)
                 (stringp message)
                 (string-match-p debug-on-message message))
        (debug message)))))

(defun minimess-message (orig-fun format-string &rest args)
  (if (and
       ;; When `inhibit-message' is non-nil, the intention was to just
       ;; log the message to the *Messages* buffer using `message'.
       (null inhibit-message)
       (window-live-p (active-minibuffer-window))
       (window-live-p (old-selected-window))
       (bufferp (window-buffer (old-selected-window)))
       (minibufferp (window-buffer (old-selected-window))))
      (with-current-buffer (window-buffer (old-selected-window))
        (apply #'minimess-minibuffer-message format-string args))
    (apply orig-fun format-string args)))

(defun minimess-unload-function ()
  "Get free of advices."
  (advice-remove 'message #'minimess-message)
  nil)

(advice-add 'message :around #'minimess-message)

(provide 'minimess)
;;; minimess.el ends here

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 15 Dec 2019 15:35:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 15 10:35:50 2019
Received: from localhost ([127.0.0.1]:37040 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igVvx-0003xx-RB
	for submit <at> debbugs.gnu.org; Sun, 15 Dec 2019 10:35:50 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48098)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1igVvv-0003xl-PB
 for 38457 <at> debbugs.gnu.org; Sun, 15 Dec 2019 10:35:48 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45379)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1igVvq-0007BB-IM; Sun, 15 Dec 2019 10:35:42 -0500
Received: from [176.228.60.248] (port=1253 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1igVvp-0005zX-I5; Sun, 15 Dec 2019 10:35:42 -0500
Date: Sun, 15 Dec 2019 17:35:22 +0200
Message-Id: <83r21561qd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87a77uh5a5.fsf@HIDDEN> (message from Juri Linkov on
 Sun, 15 Dec 2019 01:10:58 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
 <87a77uh5a5.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Sun, 15 Dec 2019 01:10:58 +0200
> 
> > That leaves open the issue of the default value of
> > minibuffer-message-timeout.  I don't think we can change it, because
> > it affects minibuffer-message as well.  But we could have a new
> > option, which would affect only the duplicate function you mention
> > below.  If the new option by default makes the message stay until the
> > next one or until user input, I think this would be an okay solution
> > that satisfies everyone, at least for Emacs 27.
> 
> The main problem with 'minibuffer-message' is that it uses 'sit-for'.
> If a new function will use the same 'sit-for' to detect when input is
> available, then it will bring the same problems.  Here's is an example
> of the problems it causes: I call 'select-window' from 'post-command-hook'
> to select an output window, but 'sit-for' delays selecting the window
> for 2 seconds until 'execute-extended-command' finishes displaying
> the message "You can run the command `%s' with %s" using 'sit-for'.
> The output window becomes selected only after 2 seconds because
> a customized function in 'post-command-hook' doesn't run earlier
> than returning from 'sit-for' in 'execute-extended-command'.
> 
> 'sit-for' is used in many places, but it's inappropriate for these tasks.
> What is a possible replacement for 'sit-for'?  For a delay of specified
> seconds, one solution is to run a timer.  But how to replace another
> aspect of 'sit-for', namely an ability to stop when input is available?

What I had in mind was to go with your idea, viz.:

> Then your proposed implementation should be activated when
> minibuffer-message-timeout is set to a non-nil value.
> Otherwise, when it's a number, it should use the timer.

IOW, introduce a new option, which will affect the new function we
were talking about, a near-clone of minibuffer-message (and will not
affect minibuffer-message itself).  When that new option's value is
not a number, the near-clone of minibuffer-message should not call
sit-for at all; and when that value is a number, use a timer to remove
the message after that many seconds if no input arrives before that.

In any case, I thought we agreed not to call minibuffer-message from
'message', but define a new function, similar but not identical to
minibuffer-message (what I call a "near-clone").  And
minibuffer-message-timeout should not affect that new function, it
should be a separate option.

> There is a need for a hook that would be called when input is available.
> Maybe such hook already exists, I don't know, I searched but found only
> 'echo-area-clear-hook' that is used in this code in 'command_loop_1':

Do we still need such a hook if the idea above is implemented instead?

> > Assuming you agree, once this change is made, some of the recent
> > changes related to these issues should be reverted.  Can I ask you to
> > review those related changesets and publish a list of those which need
> > to be reverted or augmented?
> 
> Here's is a list of related changesets:
> 
> 8693611136
> aa89c84e00
> 54c792ece6
> 
> Please revert them if you want.

Thanks.  Let's revisit these after the implementation of the
minibuffer-message's clone is finalized, so that we could know which
ones of these are still needed and which aren't.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 14 Dec 2019 23:36:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 14 18:36:24 2019
Received: from localhost ([127.0.0.1]:35877 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igGxT-0007cO-LO
	for submit <at> debbugs.gnu.org; Sat, 14 Dec 2019 18:36:24 -0500
Received: from bird.elm.relay.mailchannels.net ([23.83.212.17]:63914)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1igGxR-0007cE-3M
 for 38457 <at> debbugs.gnu.org; Sat, 14 Dec 2019 18:36:22 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id DD0E020D01;
 Sat, 14 Dec 2019 23:36:19 +0000 (UTC)
Received: from pdx1-sub0-mail-a34.g.dreamhost.com
 (100-96-14-23.trex.outbound.svc.cluster.local [100.96.14.23])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 5ACCB20B30;
 Sat, 14 Dec 2019 23:36:19 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a34.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sat, 14 Dec 2019 23:36:19 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Whimsical-Continue: 3875888a02eb42d2_1576366579630_1902538690
X-MC-Loop-Signature: 1576366579630:4233967778
X-MC-Ingress-Time: 1576366579630
Received: from pdx1-sub0-mail-a34.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a34.g.dreamhost.com (Postfix) with ESMTP id 81BD17F5F5;
 Sat, 14 Dec 2019 15:36:18 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=WQGZ5X2o9ESLJtVl4NFHMaIKA5w=; b=
 iiV9/o0BnCieDpnWepx152S91+MkXTi9AVmZ0Sx+om7+jqr0ifHHk4btvv0r1+nj
 8uhQBbNGtIO3yqPRj/8LdOp/ImrytiaO4uzMflip87CbMX9P2Qy/vZz0R3Hy/NQ+
 8WUBPrfp0tUj3VzPpRv9ozzCSM1DzFpffn7I/TnTdII=
Received: from mail.jurta.org (m91-129-107-186.cust.tele2.ee [91.129.107.186])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256
 bits)) (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a34.g.dreamhost.com (Postfix) with ESMTPSA id 87EEA7F5EF;
 Sat, 14 Dec 2019 15:36:15 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a34
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN> <83d0cs8uw8.fsf@HIDDEN>
Date: Sun, 15 Dec 2019 01:10:58 +0200
In-Reply-To: <83d0cs8uw8.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 13 Dec
 2019 10:57:59 +0200")
Message-ID: <87a77uh5a5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrvddtvddguddtucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrddutdejrddukeeinecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledruddtjedrudekiedprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > That would mean bring back all the problems for which these changes
>> > were made.  So it would be the worst of all worlds, and thus makes
>> > very little sense to me.
>> 
>> Then your proposed implementation should be activated when
>> minibuffer-message-timeout is set to a non-nil value.
>> Otherwise, when it's a number, it should use the timer.
>
> That leaves open the issue of the default value of
> minibuffer-message-timeout.  I don't think we can change it, because
> it affects minibuffer-message as well.  But we could have a new
> option, which would affect only the duplicate function you mention
> below.  If the new option by default makes the message stay until the
> next one or until user input, I think this would be an okay solution
> that satisfies everyone, at least for Emacs 27.

The main problem with 'minibuffer-message' is that it uses 'sit-for'.
If a new function will use the same 'sit-for' to detect when input is
available, then it will bring the same problems.  Here's is an example
of the problems it causes: I call 'select-window' from 'post-command-hook'
to select an output window, but 'sit-for' delays selecting the window
for 2 seconds until 'execute-extended-command' finishes displaying
the message "You can run the command `%s' with %s" using 'sit-for'.
The output window becomes selected only after 2 seconds because
a customized function in 'post-command-hook' doesn't run earlier
than returning from 'sit-for' in 'execute-extended-command'.

'sit-for' is used in many places, but it's inappropriate for these tasks.
What is a possible replacement for 'sit-for'?  For a delay of specified
seconds, one solution is to run a timer.  But how to replace another
aspect of 'sit-for', namely an ability to stop when input is available?

There is a need for a hook that would be called when input is available.
Maybe such hook already exists, I don't know, I searched but found only
'echo-area-clear-hook' that is used in this code in 'command_loop_1':

      if (minibuf_level
	  && !NILP (echo_area_buffer[0])
	  && EQ (minibuf_window, echo_area_window)
	  && NUMBERP (Vminibuffer_message_timeout))
	{
	  /* Bind inhibit-quit to t so that C-g gets read in
	     rather than quitting back to the minibuffer.  */
	  ptrdiff_t count = SPECPDL_INDEX ();
	  specbind (Qinhibit_quit, Qt);

	  sit_for (Vminibuffer_message_timeout, 0, 2);

	  /* Clear the echo area.  */
	  message1 (0);
	  safe_run_hooks (Qecho_area_clear_hook);

	  unbind_to (count, Qnil);

	  /* If a C-g came in before, treat it as input now.  */
	  if (!NILP (Vquit_flag))
	    {
	      Vquit_flag = Qnil;
	      Vunread_command_events = list1i (quit_char);
	    }
	}

This code looks very like 'minibuffer-message', and still uses 'sit_for'.

>> > And in any case, minibuffer-message already behaves differently: it
>> > logs the message in *Messages*, something it never did and is not
>> > documented, and you suggested another change, to make it start the
>> > debugger per debug-on-message.  These change behavior of any direct
>> > callers of minibuffer-message in incompatible ways, something I don't
>> > think we have a good reason to do.
>> 
>> I see no reason not to change minibuffer-message.  But if you think
>> it should never change, let's create a duplicate function
>> message-in-minibuffer.
>
> Fine with me, as long as the duplicate is an internal function.  Maybe
> that new internal function should be invoked from message3_nolog
> instead, btw?  That would remove the need to duplicate the
> functionality of message_dolog.
>
> Assuming you agree, once this change is made, some of the recent
> changes related to these issues should be reverted.  Can I ask you to
> review those related changesets and publish a list of those which need
> to be reverted or augmented?

Here's is a list of related changesets:

8693611136
aa89c84e00
54c792ece6

Please revert them if you want.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 13 Dec 2019 09:07:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 04:07:11 2019
Received: from localhost ([127.0.0.1]:33005 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifgul-0004yF-G1
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 04:07:11 -0500
Received: from eggs.gnu.org ([209.51.188.92]:41447)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifguk-0004y1-9e
 for 38457 <at> debbugs.gnu.org; Fri, 13 Dec 2019 04:07:10 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51952)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifgue-0008DH-4W; Fri, 13 Dec 2019 04:07:04 -0500
Received: from [176.228.60.248] (port=3969 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifgud-0006S6-Q5; Fri, 13 Dec 2019 04:07:03 -0500
Date: Fri, 13 Dec 2019 11:07:00 +0200
Message-Id: <83a77w8uh7.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: juri@HIDDEN
In-reply-to: <83pngs909a.fsf@HIDDEN> (message from Eli Zaretskii on Fri, 13
 Dec 2019 09:02:09 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 <83zhfyakwd.fsf@HIDDEN>
 <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
 <87zhfxm9rs.fsf@HIDDEN> <83pngs909a.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, netjune@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Fri, 13 Dec 2019 09:02:09 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org, netjune@HIDDEN, monnier@HIDDEN
> 
> In any case, I hope you agree this is not for Emacs 28.

Sorry, I meant not for Emacs 27.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 13 Dec 2019 08:58:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 03:58:11 2019
Received: from localhost ([127.0.0.1]:32993 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifgm3-0004fd-JP
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 03:58:11 -0500
Received: from eggs.gnu.org ([209.51.188.92]:41588)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifgm2-0004fK-GW
 for 38457 <at> debbugs.gnu.org; Fri, 13 Dec 2019 03:58:10 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51822)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifglw-0002sU-VX; Fri, 13 Dec 2019 03:58:05 -0500
Received: from [176.228.60.248] (port=3354 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifglv-0007m2-KN; Fri, 13 Dec 2019 03:58:04 -0500
Date: Fri, 13 Dec 2019 10:57:59 +0200
Message-Id: <83d0cs8uw8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87eex9jf14.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 13 Dec 2019 01:12:50 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
 <87eex9jf14.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> Date: Fri, 13 Dec 2019 01:12:50 +0200
> 
> >> If you want to set message-in-echo-area to t in the release branch,
> >> that's fine.
> >
> > That would mean bring back all the problems for which these changes
> > were made.  So it would be the worst of all worlds, and thus makes
> > very little sense to me.
> 
> Then your proposed implementation should be activated when
> minibuffer-message-timeout is set to a non-nil value.
> Otherwise, when it's a number, it should use the timer.

That leaves open the issue of the default value of
minibuffer-message-timeout.  I don't think we can change it, because
it affects minibuffer-message as well.  But we could have a new
option, which would affect only the duplicate function you mention
below.  If the new option by default makes the message stay until the
next one or until user input, I think this would be an okay solution
that satisfies everyone, at least for Emacs 27.

> > And in any case, minibuffer-message already behaves differently: it
> > logs the message in *Messages*, something it never did and is not
> > documented, and you suggested another change, to make it start the
> > debugger per debug-on-message.  These change behavior of any direct
> > callers of minibuffer-message in incompatible ways, something I don't
> > think we have a good reason to do.
> 
> I see no reason not to change minibuffer-message.  But if you think
> it should never change, let's create a duplicate function
> message-in-minibuffer.

Fine with me, as long as the duplicate is an internal function.  Maybe
that new internal function should be invoked from message3_nolog
instead, btw?  That would remove the need to duplicate the
functionality of message_dolog.

Assuming you agree, once this change is made, some of the recent
changes related to these issues should be reverted.  Can I ask you to
review those related changesets and publish a list of those which need
to be reverted or augmented?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 13 Dec 2019 08:46:59 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 03:46:59 2019
Received: from localhost ([127.0.0.1]:32989 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifgbD-0004PJ-CP
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 03:46:59 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57113)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifgbA-0004P6-Qa
 for 38457 <at> debbugs.gnu.org; Fri, 13 Dec 2019 03:46:57 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51760)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifgb5-00040e-7M; Fri, 13 Dec 2019 03:46:51 -0500
Received: from [176.228.60.248] (port=2670 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifgb4-0004fy-Ic; Fri, 13 Dec 2019 03:46:51 -0500
Date: Fri, 13 Dec 2019 10:46:46 +0200
Message-Id: <83eex88vex.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87zhfxjf9w.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 13 Dec 2019 01:07:39 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <83r21aak51.fsf@HIDDEN>
 <87eexabg41.fsf@HIDDEN> <83blse9kbj.fsf@HIDDEN>
 <87zhfxjf9w.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: monnier@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Fri, 13 Dec 2019 01:07:39 +0200
> 
> > But 'message' always behaved this way, so using a timeout is change in
> > behavior, whereas my proposal leaves the behavior unchanged, and just
> > makes the prompt still visible, so it avoids confusing the user.  User
> > confusion was the main issue that triggered the series of changes we
> > are discussing, and it will be resolved by my proposal.
> 
> But 'minibuffer-message' never behaved this way because it's very annoying
> when messages remain indefinitely in the minibuffer, and a key is needed
> to be pressed to flush mostly useless messages away.
> 
> Messages in the echo-area and messages in the minibuffer are different
> things for user interaction.

That is exactly my point: these two APIs are very different in the
behavior they provide and support.  It follows that calling
'minibuffer-message' from 'message' under some circumstances is a
radical change in behavior.  Such radical changes are fine when we
introduce radical new UI features, but the changes we discuss here
were made to fix bugs.

I'm saying we can fix those bugs without introducing radical new
features, which AFAIU are not yet finished, and will probably require
many more changes to get them right.  We should limit ourselves to
fixing the most annoying bugs/misfeatures, and leave the more radical
changes for a future major release after Emacs 27.

> OTOH, such messages as "Compilation finished" would significantly impact
> editing of the minibuffer's content in a negative way when displayed
> permanently.

When the user is using the minibuffer, the message is very unlikely to
stay there indefinitely, since user interaction implies user input,
which will remove the message.  OTOH, leaving such messages until the
next input event will let the user determine when will the message be
removed, whereas using a timeout takes that control from the user.
What if the message is important, but the user takes a long time to
read it, or is distracted by something?

> >> If someone wants the message to hang out indefinitely in the minibuffer,
> >> this is possible, minibuffer-message-timeout is configurable:
> >
> > That is a user option, so we cannot change it globally.  We could bind
> > it temporarily, but how can we know which value to use in each and
> > every use case, on the level where you call minibuffer-message from
> > inside 'message'?
> 
> I meant that it should be possible to customize the user option.

And I was talking about the default operation.  The default operation
should be reasonable.

> > No, my suggestion is not to remove the message automatically at all,
> > i.e. leave this aspect of 'message's behavior unchanged.  The message
> > text will be removed when either the user types something, or when
> > some Lisp calls 'message' again to clear the message text.
> 
> It should take into account a user option that specifies the timeout
> after which the message should be removed using a timer.
> 
> If you want to leave the message indefinitely by default that's fine,
> but the users should have an option not to suffer from the
> default behavior that you propose.

We already have that default behavior.  We had it for eons.  I just
propose not to change it yet, because the alternative means a radical
change in the UI and many changes in low-level infrastructure whose
full extent we don't know yet.  The way you've decided to solve these
problems practically requires us to continue making these radical
changes, and that will delay the Emacs 27 release for many moons.

And the timing of removal of the message is just one aspect.  There
are others: the logging in *Messages*, the debug-on-message feature,
and I'm sure we will discover more of them.  The only "easy" way of
solving these is to make 'minibuffer-message' do that stuff as well,
which means incompatible changes in 'minibuffer-message', and is
likely to raise more issues, which will delay Emacs 27 even more.  All
that is the consequence of the basic fact that we both agree on:
'message' and 'minibuffer-message' are two very different beasts, so
making one call the other has got to cause complications.

If we want to release Emacs 27.1 soon (and we should), we cannot
continue on this path, we must find a reasonable way of delaying the
more radical parts of these changes to Emacs 28.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 13 Dec 2019 08:26:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 03:26:09 2019
Received: from localhost ([127.0.0.1]:32974 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifgH3-0003po-CE
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 03:26:09 -0500
Received: from eggs.gnu.org ([209.51.188.92]:55603)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifgH1-0003pc-HU
 for 38457 <at> debbugs.gnu.org; Fri, 13 Dec 2019 03:26:07 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:51569)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifgGv-0002IH-EV; Fri, 13 Dec 2019 03:26:01 -0500
Received: from [176.228.60.248] (port=1406 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifgGu-0002xU-Qx; Fri, 13 Dec 2019 03:26:01 -0500
Date: Fri, 13 Dec 2019 10:25:57 +0200
Message-Id: <83ftho8wdm.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87d0ctnowr.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 13 Dec 2019 00:45:56 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
 <87k172bg7a.fsf@HIDDEN> <83eexa9mxx.fsf@HIDDEN>
 <87d0ctnowr.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: monnier@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Fri, 13 Dec 2019 00:45:56 +0200
> 
> >> > Sorry, I don't think I follow: what did you want to fix in this
> >> > scenario?
> >>
> >> I already fixed this 10 days ago.  If the patch was installed then
> >> you wouldn't say that the current code on master removes the icomplete
> >> overlays.  Because the patch doesn't remove the icomplete overlays.
> >> Its behavior is so smooth that it would be unfortunate to implement
> >> something worse than that.
> >
> > By "the patch" do you mean the patch that introduced a timer to remove
> > the minibuffer message?
> 
> Exactly.
> 
> > If so, I don't understand how would it change the scenario with
> > icomplete, please elaborate.
> 
> Have you tried that patch in action?
> 
> I think it works perfectly well.  But if you don't agree then it's fine
> to enable it optionally.

Sorry, I cannot afford trying it: too much on my plate right now.
Please humor me by explaining what kind of change in behavior it
produces in this scenario.

TIA.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 13 Dec 2019 07:02:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 02:02:23 2019
Received: from localhost ([127.0.0.1]:32922 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifexz-0001US-75
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 02:02:23 -0500
Received: from eggs.gnu.org ([209.51.188.92]:56228)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifexx-0001UF-Pa
 for 38457 <at> debbugs.gnu.org; Fri, 13 Dec 2019 02:02:22 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:50973)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifexr-0004lr-Kx; Fri, 13 Dec 2019 02:02:15 -0500
Received: from [176.228.60.248] (port=4276 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifexq-0002px-Kg; Fri, 13 Dec 2019 02:02:15 -0500
Date: Fri, 13 Dec 2019 09:02:09 +0200
Message-Id: <83pngs909a.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87zhfxm9rs.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 13 Dec 2019 00:58:15 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 <83zhfyakwd.fsf@HIDDEN>
 <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
 <87zhfxm9rs.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, netjune@HIDDEN, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  monnier@HIDDEN,
>   38457 <at> debbugs.gnu.org
> Date: Fri, 13 Dec 2019 00:58:15 +0200
> 
> Really important messages should be displayed permanently in a pop-up window
> like display-delayed-warnings and display-warning.

If you have such plans, I suggest to discuss them on emacs-devel
first.  The really hard nut, IMO, is to decide how we distinguish
really important messages from the rest, and how we communicate this
to 'message'.  In any case, I hope you agree this is not for Emacs 28.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 23:45:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 18:45:49 2019
Received: from localhost ([127.0.0.1]:32814 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifY9V-0004wF-Mq
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:49 -0500
Received: from bisque.elm.relay.mailchannels.net ([23.83.212.18]:36845)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifY9U-0004w1-1i
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:48 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 0D5752C1E3D;
 Thu, 12 Dec 2019 23:45:47 +0000 (UTC)
Received: from pdx1-sub0-mail-a65.g.dreamhost.com
 (100-96-86-154.trex.outbound.svc.cluster.local [100.96.86.154])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 8B42C2C1643;
 Thu, 12 Dec 2019 23:45:46 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a65.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 12 Dec 2019 23:45:46 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Vacuous-Harbor: 464cb6bb348de381_1576194346840_817076722
X-MC-Loop-Signature: 1576194346839:957555455
X-MC-Ingress-Time: 1576194346839
Received: from pdx1-sub0-mail-a65.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTP id 4D7A17F219;
 Thu, 12 Dec 2019 15:45:41 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=t5gBPJrpdr1B1diApsjQorShiKI=; b=
 kx92eHzAAuwxl7SpCg7f2oCd7uOvbNQpeK14EBl8v8WJ6Mplenw4iNB6wiIe+12g
 SS2au1D+6oylRMr8KUA7Ikm6vMBQSty6jB6I5LvHhz4HGtBqzM5Zmz6DadE7LMns
 IwZbvmcUUrFlvLkWdPd1yY7joC70V81SZAhmNL9M9I4=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTPSA id B349F7F21C;
 Thu, 12 Dec 2019 15:45:39 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a65
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN> <83a77y9k35.fsf@HIDDEN>
Date: Fri, 13 Dec 2019 01:12:50 +0200
In-Reply-To: <83a77y9k35.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 12 Dec
 2019 07:41:34 +0200")
Message-ID: <87eex9jf14.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudelkedgudehucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpeef
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> When message-in-echo-area is non-nil, then 'message' has exactly
>> the same behavior as before, as in the previous versions.
>>
>> I propose to use timers in minibuffer-message conditionally
>> only when message-in-echo-area is nil.  Then the behavior
>> of minibuffer-message will be exactly the same as before too
>> when message-in-echo-area is non-nil.
>>
>> If you want to set message-in-echo-area to t in the release branch,
>> that's fine.
>
> That would mean bring back all the problems for which these changes
> were made.  So it would be the worst of all worlds, and thus makes
> very little sense to me.

Then your proposed implementation should be activated when
minibuffer-message-timeout is set to a non-nil value.
Otherwise, when it's a number, it should use the timer.

> And in any case, minibuffer-message already behaves differently: it
> logs the message in *Messages*, something it never did and is not
> documented, and you suggested another change, to make it start the
> debugger per debug-on-message.  These change behavior of any direct
> callers of minibuffer-message in incompatible ways, something I don't
> think we have a good reason to do.

I see no reason not to change minibuffer-message.  But if you think
it should never change, let's create a duplicate function
message-in-minibuffer.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 23:45:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 18:45:41 2019
Received: from localhost ([127.0.0.1]:32811 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifY9N-0004vc-D2
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:41 -0500
Received: from bisque.elm.relay.mailchannels.net ([23.83.212.18]:38091)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifY9L-0004vR-HK
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:40 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 6E0DF580ED4;
 Thu, 12 Dec 2019 23:45:38 +0000 (UTC)
Received: from pdx1-sub0-mail-a65.g.dreamhost.com
 (100-96-45-231.trex.outbound.svc.cluster.local [100.96.45.231])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id DD9795811C7;
 Thu, 12 Dec 2019 23:45:37 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a65.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 12 Dec 2019 23:45:38 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Army-Army: 37164bb00d5904fe_1576194338153_1282477831
X-MC-Loop-Signature: 1576194338153:762460567
X-MC-Ingress-Time: 1576194338153
Received: from pdx1-sub0-mail-a65.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTP id 8A1447F223;
 Thu, 12 Dec 2019 15:45:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=ka3wfoOSRrpoCqUv+WoZvbMqXng=; b=
 RnUl7NRr9vFnTi3WMWS6NJpWE01qikCIuhmC8fHKgcB/MLhsXy+o/wbo3cjsKTJK
 Z4UHx/ORMkps/lRkpAbNdAi5BxqPFdVb4tGeGHal6DWP995KNavf5F/dTj3zNqfS
 VT9IrtfTHS/AzX9yULJY0whEBEhb+PXaiXej9coqpCU=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTPSA id D117B7F219;
 Thu, 12 Dec 2019 15:45:31 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a65
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <83r21aak51.fsf@HIDDEN>
 <87eexabg41.fsf@HIDDEN> <83blse9kbj.fsf@HIDDEN>
Date: Fri, 13 Dec 2019 01:07:39 +0200
In-Reply-To: <83blse9kbj.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 12 Dec
 2019 07:36:32 +0200")
Message-ID: <87zhfxjf9w.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudelkedgudehucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedv
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> The problem is in usability: it would be very annoying if the message
>> displayed at the end of the minibuffer's contents would not vanish
>> after some time.  minibuffer-message removes the message
>> after 2 sec by default.
>
> But 'message' always behaved this way, so using a timeout is change in
> behavior, whereas my proposal leaves the behavior unchanged, and just
> makes the prompt still visible, so it avoids confusing the user.  User
> confusion was the main issue that triggered the series of changes we
> are discussing, and it will be resolved by my proposal.

But 'minibuffer-message' never behaved this way because it's very annoying
when messages remain indefinitely in the minibuffer, and a key is needed
to be pressed to flush mostly useless messages away.

Messages in the echo-area and messages in the minibuffer are different
things for user interaction.  Most messages are useless, but they don't
get into the way of editing in a buffer when the minibuffer is not active
and useless messages are displayed in the echo-area far away from the
editing area in the buffer.

OTOH, such messages as "Compilation finished" would significantly impact
editing of the minibuffer's content in a negative way when displayed
permanently.

>> If someone wants the message to hang out indefinitely in the minibuffer,
>> this is possible, minibuffer-message-timeout is configurable:
>
> That is a user option, so we cannot change it globally.  We could bind
> it temporarily, but how can we know which value to use in each and
> every use case, on the level where you call minibuffer-message from
> inside 'message'?

I meant that it should be possible to customize the user option.

>> But this means that your proposed implementation still should use timers
>> to remove the echo-area with the appended message after the amount of time
>> specified by minibuffer-message-timeout is passed (when its value is a number).
>
> No, my suggestion is not to remove the message automatically at all,
> i.e. leave this aspect of 'message's behavior unchanged.  The message
> text will be removed when either the user types something, or when
> some Lisp calls 'message' again to clear the message text.

It should take into account a user option that specifies the timeout
after which the message should be removed using a timer.

If you want to leave the message indefinitely by default that's fine,
but the users should have an option not to suffer from the
default behavior that you propose.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 23:45:29 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 18:45:29 2019
Received: from localhost ([127.0.0.1]:32805 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifY9A-0004ux-Th
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:29 -0500
Received: from camel.birch.relay.mailchannels.net ([23.83.209.29]:18663)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifY99-0004up-EF
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:27 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 52599142335;
 Thu, 12 Dec 2019 23:45:26 +0000 (UTC)
Received: from pdx1-sub0-mail-a65.g.dreamhost.com
 (100-96-88-132.trex.outbound.svc.cluster.local [100.96.88.132])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id B314214232B;
 Thu, 12 Dec 2019 23:45:25 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a65.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 12 Dec 2019 23:45:26 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Spot-Supply: 46fec69b404fce87_1576194325972_428653755
X-MC-Loop-Signature: 1576194325971:403164010
X-MC-Ingress-Time: 1576194325971
Received: from pdx1-sub0-mail-a65.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTP id 715067F223;
 Thu, 12 Dec 2019 15:45:20 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=iEdF1UsM1ZsspLtuA/QxEcoGGjs=; b=
 wBlZod/NIRK0p8vEcYBd2QBQsw2/O9ytmjzcrVYex0+tD3AuTCHVxuTVfL3gl2ie
 9fIw0EEySmE+gnyg5yE3KHOtYbH50N8kUU9721taQ3kx8Ap1Q9Qux9SpcgUJzmKq
 CkgkwgXE10adg9MIo8xoR/Ne3tahCy3+GaPAm9v4wlw=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTPSA id EF3267F21C;
 Thu, 12 Dec 2019 15:45:17 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a65
From: Juri Linkov <juri@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 <83zhfyakwd.fsf@HIDDEN>
 <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
Date: Fri, 13 Dec 2019 00:58:15 +0200
In-Reply-To: <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
 (HaiJun Zhang's message of "Thu, 12 Dec 2019 12:33:09 +0800")
Message-ID: <87zhfxm9rs.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudelkedgudehucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopehnvghtjhhunhgvsehouhhtlhhoohhkrdgtohhmnecuvehluhhsthgvrhfuihiivgeptd
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>,
 monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> The importance levels for me:
>
>     (1) Inputing in minibuffer
>     (2) Inputing in buffer window
>     (3) Messages in minibuffer window
>
> I think messages(In (3)) should not disturb (1). Because they are so less important. 
> And when user is busy editing in (2), he may never notice messages in
> minibuffer because they are cleared quickly.  So important messages
> should not use minibuffer.  They should use mode-line or something else.

Really important messages should be displayed permanently in a pop-up window
like display-delayed-warnings and display-warning.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 23:45:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 18:45:19 2019
Received: from localhost ([127.0.0.1]:32802 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifY91-0004uc-LW
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:19 -0500
Received: from antelope.elm.relay.mailchannels.net ([23.83.212.4]:35523)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifY90-0004uR-Bi
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 18:45:19 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id F1B168C17B2;
 Thu, 12 Dec 2019 23:45:16 +0000 (UTC)
Received: from pdx1-sub0-mail-a65.g.dreamhost.com
 (100-96-89-10.trex.outbound.svc.cluster.local [100.96.89.10])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 3A6848C11FD;
 Thu, 12 Dec 2019 23:45:16 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a65.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Thu, 12 Dec 2019 23:45:16 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Stop-Minister: 51908b3f035201f7_1576194316497_1050489276
X-MC-Loop-Signature: 1576194316497:1453082204
X-MC-Ingress-Time: 1576194316496
Received: from pdx1-sub0-mail-a65.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTP id E8B4C7F224;
 Thu, 12 Dec 2019 15:45:12 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=ocCjVAHAAPeUTRde6HSlEks2xow=; b=
 KuQQjxFtAPfrEkR1t4ujvgwIjb6xnRCUESn2kPnCr5lPBFkKSq80D5T0/aH/JBjs
 BxNR3qPcnMrRowvIs8/WGSCV1pNFlMRxOWahdXjxSAfcxMsy6ES8vdiXlLHS7iM/
 TyZkwHBNH6pkaE+nRdYh+eSBimat3q9oUr7lfHNwInw=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a65.g.dreamhost.com (Postfix) with ESMTPSA id 35B137F220;
 Thu, 12 Dec 2019 15:45:09 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a65
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
 <87k172bg7a.fsf@HIDDEN> <83eexa9mxx.fsf@HIDDEN>
Date: Fri, 13 Dec 2019 00:45:56 +0200
In-Reply-To: <83eexa9mxx.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 12 Dec
 2019 06:39:54 +0200")
Message-ID: <87d0ctnowr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudelkedgudegucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > Sorry, I don't think I follow: what did you want to fix in this
>> > scenario?
>>
>> I already fixed this 10 days ago.  If the patch was installed then
>> you wouldn't say that the current code on master removes the icomplete
>> overlays.  Because the patch doesn't remove the icomplete overlays.
>> Its behavior is so smooth that it would be unfortunate to implement
>> something worse than that.
>
> By "the patch" do you mean the patch that introduced a timer to remove
> the minibuffer message?

Exactly.

> If so, I don't understand how would it change the scenario with
> icomplete, please elaborate.

Have you tried that patch in action?

I think it works perfectly well.  But if you don't agree then it's fine
to enable it optionally.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 13:21:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 08:21:55 2019
Received: from localhost ([127.0.0.1]:59188 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifOPi-0002Kf-SR
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 08:21:55 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:18812)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ifOPg-0002KS-Mb
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 08:21:53 -0500
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 02C9681E25;
 Thu, 12 Dec 2019 08:21:47 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 137308181D;
 Thu, 12 Dec 2019 08:21:45 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1576156905;
 bh=bACxd394lDHO2orZSHk4MKKrHMU/zZiCoG8cI2gd/Bw=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=eFlP4ykRQ7ycJxKzR6eo1/M+hbUbIHMi1+cKQ3Ozw/TNHoULFgiV+6PXgPAgWUREy
 HmMTZDGCLWGMyfnc2s3mWDf+4QzcCchzQZAmLfWIA6AWS6vMms/H3QdKBi5bzTO1vk
 KJqNmSEHy1aRRkpwgFg5akdIx7371wAfCq/AiLEb3ro8sZRkqu/Ckouuq2Y7vdCrKm
 6lJkY/y9HzVmHRHoAuBV51EQuy0f0LvKTvrS06LJa7mW5bhNmyt223gXqebch9l7XR
 Gqxqwmj7bgXuxb5oF8gYtn/UwJU08hfBB0BC7nHF0pgdcsCjVX8+Nh4x6AvBYalXbG
 CTg6RxLiffAZg==
Received: from pastel (unknown [45.72.154.226])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id A8BB8120786;
 Thu, 12 Dec 2019 08:21:44 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Message-ID: <jwva77xvfzs.fsf-monnier+emacs@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 <83zhfyakwd.fsf@HIDDEN>
Date: Thu, 12 Dec 2019 08:21:36 -0500
In-Reply-To: <83zhfyakwd.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 11 Dec
 2019 18:26:26 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.019 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, HaiJun Zhang <netjune@HIDDEN>, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> In general, people who set resize-mini-windows to nil are always in
> danger of seeing only part of the message Emacs displays.

Actually, with your proposal of putting point right between the
minibuffer content and the message, while there is still a risk that
some of the message is not visible, you at least ensure that some part
of the message is visible, which is already better than what we
currently have (where the message is invisible if EOB is after
window-end).

I think it's pretty close to the best that can be done in this respect.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 11:09:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 06:09:05 2019
Received: from localhost ([127.0.0.1]:59078 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifMLB-0004U7-NE
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 06:09:05 -0500
Received: from mail-wr1-f45.google.com ([209.85.221.45]:34435)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raaahh@HIDDEN>) id 1ifML9-0004Tb-8h
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 06:09:04 -0500
Received: by mail-wr1-f45.google.com with SMTP id t2so2299370wrr.1
 for <38457 <at> debbugs.gnu.org>; Thu, 12 Dec 2019 03:09:03 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=sender:subject:to:cc:references:from:message-id:date:user-agent
 :mime-version:in-reply-to:content-language:content-transfer-encoding;
 bh=uvrN3eT9hjYsAhBar+93jfsULfmbSta8njXsmKJ1wUY=;
 b=AOJIsTMQMqKuUoVZuO/osk0d2xZ7vLvNmDX+057+NdlSmhTH9nl6mGP2FOnqbaI0IL
 650pt3DxkkvtM6UbSr8PInxsOwosc2jMTf/KYvMY+4GlQtwH0hecsQMlHMRas2zDL0g5
 6Sda2aqGFbkgI5BHcS5/vO7hjG7Ssh9NsAvRyonRW0Phrz9NxYdpZY2QvD9SLTC02ra0
 fmU2HoJIYjDzqdBbzuDesRLav91As/R98WWBKZZKVLrKqKDqgYzvr53d5bge30mIhJhb
 ST7l6CiExVMr40KyFX8sPiyBmrBMGOWcnOuxNgkebc5P1pJ81wYCzE9xvOWAWbxZ9Dtb
 kqew==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:sender:subject:to:cc:references:from:message-id
 :date:user-agent:mime-version:in-reply-to:content-language
 :content-transfer-encoding;
 bh=uvrN3eT9hjYsAhBar+93jfsULfmbSta8njXsmKJ1wUY=;
 b=ohGglETW5cdK+8WuEIGhVGgAZ6dWR9xcMuvSC0BKLbId9c1ASOUQnN9aGSYjpqIoWi
 fhjTBuZ9r1iqV5+waWFt9ZFSitACr3VTLvgYpUv4VjEWrP1AaHzVH/fJBwXb1adjRjLn
 PQ29x6MmDp47Tzl+PSzNvt0fgAxgntbROiJofTtd54cwZ0xDhcDWO1ru13BGH2f+LujS
 o1vD/6Mp3HkOtUmW3EzlriPJCBzwxfAs1EpVPS61Id7iBULfVdtyFWkXLOt2lJ+U484A
 06BBDDy9bwwVJwCZV2w4Vqti2LE0VCCm9+dkZo1emUKQ4zQBd91BXeWSZel9GutHqPNt
 qzYQ==
X-Gm-Message-State: APjAAAVRZ4UIb7aCn0AXaWWVejvPwi2UZiTAMmCUn3K+TEEnza0Gdn0s
 QMc3KL6zfQDkPczYQHME1h24WehF
X-Google-Smtp-Source: APXvYqyC1A84A+63UdPMLb3NtaPm5vK2itg6BKlM3itCputDx6xdcXuGn4NINxA7Jy/xELs310g8iA==
X-Received: by 2002:adf:c54e:: with SMTP id s14mr5895052wrf.385.1576148937370; 
 Thu, 12 Dec 2019 03:08:57 -0800 (PST)
Received: from [192.168.0.5] ([212.50.117.215])
 by smtp.googlemail.com with ESMTPSA id a184sm5904673wmf.29.2019.12.12.03.08.55
 (version=TLS1_2 cipher=ECDHE-RSA-AES128-GCM-SHA256 bits=128/128);
 Thu, 12 Dec 2019 03:08:56 -0800 (PST)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
To: Eli Zaretskii <eliz@HIDDEN>, Juri Linkov <juri@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <83r21aak51.fsf@HIDDEN>
 <87eexabg41.fsf@HIDDEN> <83blse9kbj.fsf@HIDDEN>
From: Dmitry Gutov <dgutov@HIDDEN>
Message-ID: <f71f9343-3d5a-09d0-af6d-df433c68ec50@HIDDEN>
Date: Thu, 12 Dec 2019 13:08:54 +0200
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.9.0
MIME-Version: 1.0
In-Reply-To: <83blse9kbj.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

On 12.12.2019 7:36, Eli Zaretskii wrote:
>> From: Juri Linkov<juri@HIDDEN>
>> Cc:monnier@HIDDEN,38457 <at> debbugs.gnu.org
>> Date: Thu, 12 Dec 2019 01:24:30 +0200
>>
>> The problem is in usability: it would be very annoying if the message
>> displayed at the end of the minibuffer's contents would not vanish
>> after some time.  minibuffer-message removes the message
>> after 2 sec by default.
> But 'message' always behaved this way, so using a timeout is change in
> behavior, whereas my proposal leaves the behavior unchanged, and just
> makes the prompt still visible, so it avoids confusing the user.  User
> confusion was the main issue that triggered the series of changes we
> are discussing, and it will be resolved by my proposal.

I think that makes a lot of sense.

Since the minibuffer is not obscured, there is no such urgency to remove 
the message on a timer, and it might even be better for usability to 
keep it. Backward compatibility also requires that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 05:41:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 00:41:50 2019
Received: from localhost ([127.0.0.1]:58938 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifHET-0007oi-AS
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 00:41:50 -0500
Received: from eggs.gnu.org ([209.51.188.92]:44637)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifHER-0007oS-JB
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 00:41:48 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60112)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifHEM-0007ra-99; Thu, 12 Dec 2019 00:41:42 -0500
Received: from [176.228.60.248] (port=2267 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifHEL-0000yM-Jw; Thu, 12 Dec 2019 00:41:42 -0500
Date: Thu, 12 Dec 2019 07:41:34 +0200
Message-Id: <83a77y9k35.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87d0cubfxx.fsf@HIDDEN> (message from Juri Linkov on
 Thu, 12 Dec 2019 01:28:10 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <87d0cubfxx.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org,  stephen.berman@HIDDEN
> Date: Thu, 12 Dec 2019 01:28:10 +0200
> 
> When message-in-echo-area is non-nil, then 'message' has exactly
> the same behavior as before, as in the previous versions.
> 
> I propose to use timers in minibuffer-message conditionally
> only when message-in-echo-area is nil.  Then the behavior
> of minibuffer-message will be exactly the same as before too
> when message-in-echo-area is non-nil.
> 
> If you want to set message-in-echo-area to t in the release branch,
> that's fine.

That would mean bring back all the problems for which these changes
were made.  So it would be the worst of all worlds, and thus makes
very little sense to me.

And in any case, minibuffer-message already behaves differently: it
logs the message in *Messages*, something it never did and is not
documented, and you suggested another change, to make it start the
debugger per debug-on-message.  These change behavior of any direct
callers of minibuffer-message in incompatible ways, something I don't
think we have a good reason to do.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 05:36:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 00:36:46 2019
Received: from localhost ([127.0.0.1]:58933 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifH9a-0007fV-M3
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 00:36:46 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58497)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifH9Z-0007fG-Jw
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 00:36:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60085)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifH9U-0000Sj-7c; Thu, 12 Dec 2019 00:36:40 -0500
Received: from [176.228.60.248] (port=1963 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifH9T-000094-I3; Thu, 12 Dec 2019 00:36:40 -0500
Date: Thu, 12 Dec 2019 07:36:32 +0200
Message-Id: <83blse9kbj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87eexabg41.fsf@HIDDEN> (message from Juri Linkov on
 Thu, 12 Dec 2019 01:24:30 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <83r21aak51.fsf@HIDDEN>
 <87eexabg41.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: monnier@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Thu, 12 Dec 2019 01:24:30 +0200
> 
> The problem is in usability: it would be very annoying if the message
> displayed at the end of the minibuffer's contents would not vanish
> after some time.  minibuffer-message removes the message
> after 2 sec by default.

But 'message' always behaved this way, so using a timeout is change in
behavior, whereas my proposal leaves the behavior unchanged, and just
makes the prompt still visible, so it avoids confusing the user.  User
confusion was the main issue that triggered the series of changes we
are discussing, and it will be resolved by my proposal.

> If someone wants the message to hang out indefinitely in the minibuffer,
> this is possible, minibuffer-message-timeout is configurable:

That is a user option, so we cannot change it globally.  We could bind
it temporarily, but how can we know which value to use in each and
every use case, on the level where you call minibuffer-message from
inside 'message'?

> But this means that your proposed implementation still should use timers
> to remove the echo-area with the appended message after the amount of time
> specified by minibuffer-message-timeout is passed (when its value is a number).

No, my suggestion is not to remove the message automatically at all,
i.e. leave this aspect of 'message's behavior unchanged.  The message
text will be removed when either the user types something, or when
some Lisp calls 'message' again to clear the message text.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 05:29:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 00:29:49 2019
Received: from localhost ([127.0.0.1]:58929 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifH2n-0007S4-OV
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 00:29:49 -0500
Received: from eggs.gnu.org ([209.51.188.92]:35128)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifH2l-0007RZ-OE
 for 38457 <at> debbugs.gnu.org; Thu, 12 Dec 2019 00:29:44 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:60043)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifH2f-00042y-Dx; Thu, 12 Dec 2019 00:29:37 -0500
Received: from [176.228.60.248] (port=1535 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifH2e-00047Q-E7; Thu, 12 Dec 2019 00:29:37 -0500
Date: Thu, 12 Dec 2019 07:29:28 +0200
Message-Id: <83d0cu9knb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
In-reply-to: <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
 (message from HaiJun Zhang on Thu, 12 Dec 2019 12:33:09 +0800)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 <83zhfyakwd.fsf@HIDDEN> 
 <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Thu, 12 Dec 2019 12:33:09 +0800
> From: HaiJun Zhang <netjune@HIDDEN>
> Cc: monnier@HIDDEN, 38457 <at> debbugs.gnu.org, juri@HIDDEN
> 
>  (And I don't understand why we are arguing, since you just said in
>  another message that you liked my proposal…) 
> 
> Yes. I like your proposal that message do these things internally. Because the input prompt should always be
> considered, so all these things can be done in ‘message’. Then it seems that we don’t need another api(like
> minibuffer-message)?
> 
> Is the UI of your proposal like this?
> (1) Display combination of the prompt and the message with no timeout.
> (2) If user inputs something, the message is cleared and only prompt is displayed.

Yes.

> The last question: 
> What is the use of minibuffer-message-timeout. It is defined in C. When does it take effect?

It affects how long minibuffer-message waits before removing the
message text, if there are no input events.  Any input event removes
the message even if the timeout didn't expire.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 04:40:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 23:40:08 2019
Received: from localhost ([127.0.0.1]:58919 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifGGm-0005kt-Fn
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 23:40:08 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48388)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ifGGl-0005kd-8Y
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 23:40:07 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59459)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ifGGf-0000JR-Md; Wed, 11 Dec 2019 23:40:01 -0500
Received: from [176.228.60.248] (port=2497 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ifGGf-0007Q8-5U; Wed, 11 Dec 2019 23:40:01 -0500
Date: Thu, 12 Dec 2019 06:39:54 +0200
Message-Id: <83eexa9mxx.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87k172bg7a.fsf@HIDDEN> (message from Juri Linkov on
 Thu, 12 Dec 2019 01:12:33 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <83y2vujd0y.fsf@HIDDEN>
 <87blspm0sm.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
 <87k172bg7a.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: monnier@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Thu, 12 Dec 2019 01:12:33 +0200
> 
> > Sorry, I don't think I follow: what did you want to fix in this
> > scenario?
> 
> I already fixed this 10 days ago.  If the patch was installed then
> you wouldn't say that the current code on master removes the icomplete
> overlays.  Because the patch doesn't remove the icomplete overlays.
> Its behavior is so smooth that it would be unfortunate to implement
> something worse than that.

By "the patch" do you mean the patch that introduced a timer to remove
the minibuffer message?

If so, I don't understand how would it change the scenario with
icomplete, please elaborate.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 12 Dec 2019 04:33:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 23:33:32 2019
Received: from localhost ([127.0.0.1]:58906 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifGAN-0005aX-Ue
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 23:33:32 -0500
Received: from mail-oln040092254098.outbound.protection.outlook.com
 ([40.92.254.98]:6296 helo=APC01-PU1-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1ifGAK-0005aE-Jk
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 23:33:30 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=mr8e0uiV7mbHy1HtWWVWNCE5P7oqP3f2FO349oP1qM8TjycMhDndfNVnj2Nhf/EOVJIGTr/0BSv7PuT9DoUWMAkBB93l8PmxvCuQBZ89DFnF+HZwbC2EiC63EeGFHeg1gEbRdnha8jXDDkGYeiJpJcHTAJCcmcnGzxNq1LMYPr/byDMTsnpCsH5zGR2ObcoQjqgNfkWKGYCw+Gz4mW6HLlw9EDTSKhRZgS0Tv+sMw/wt/CTMMJ6FJGsNVan+sjq2um01MW4XViZRLA64YDJAILsV4P7GmH2AA4HiNgSLC83XIrBB825Zjk4TQX3ypNNDT3HmgzkmmQdPw8vM+QCmvg==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=72+1FbBMP0LbYs8o5XvaL5SyS7JMIjbjbPEswvYyo8A=;
 b=IY7BNg4ncuO/EPh3h/AUcpQqYxwHX5wwsB191oUZc6kaXXz907Cj1wlqEa7Q/9WfkOlr5Z9mQSlcfZVleKwaVSIan3Ue2syIx9ymxaYBbyCeTQiRnrUT7CIdDhTEkzvw7ZrES9uNFqbfmNE6WLjyEYtYIOCR0bvxJtFJw5Yg2AtStnY5z6mkr5GskBMfxZzvxV5Qt1+p9+gQ3GgRA0Voa7tixzBCwgNFP6b08StBywvFlMOQpAgUc1sykyArG8QgRa8NlHbeLlm1xNrMCG4nbnXMpc//tOCt4Emcieju8ZnikbEUHO66lwXF1q7vFgcFR73CNnDALbwUjenE5JknUQ==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=72+1FbBMP0LbYs8o5XvaL5SyS7JMIjbjbPEswvYyo8A=;
 b=ZFNGrPjS5f/fNkIe5eFv03bFEQQKVZnsflVDbzR2cFOfYrocmsPnABDeozMOza81WooXstnyrdonY1YajxhWMmzlPJ4UEZjQjIZAEiqzi33gogf5n2QivoMO6DDnf9muinPlVch6R43NJTSFMvoTuDRYtWrT5WUro+4E906OoO+BBlikWHcEMrDz9hSKCJxqSb7v89Y3v2Y4XOiiFJKP9hTFEr7GgZtCXXxlYMRHctCD3uPC/vNLJU33qzByvDEQxB1ltxiDzMIo9+KvIlatkl9lGF9u8bUZjCOixWSWI1HQepdfuaLNvFN2UKAoAnWr0U+cuG0BE7/F++Vtev5h0w==
Received: from HK2APC01FT023.eop-APC01.prod.protection.outlook.com
 (10.152.248.54) by HK2APC01HT241.eop-APC01.prod.protection.outlook.com
 (10.152.249.25) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2538.15; Thu, 12 Dec
 2019 04:33:20 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.248.57) by
 HK2APC01FT023.mail.protection.outlook.com (10.152.248.222) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2538.15 via Frontend Transport; Thu, 12 Dec 2019 04:33:20 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:4081D10F09D3DABBC6111FD9B22D83652DB9EBB0CFFD61AC9FE6F0B64E5EDDD1;
 UpperCasedChecksum:F7122F68C0964124CD773565D8CF4ED1D852AF244FB1190964C9F748D9CC0541;
 SizeAsReceived:9455; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2538.016; Thu, 12 Dec 2019
 04:33:20 +0000
Date: Thu, 12 Dec 2019 12:33:09 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Message-ID: <PS1PR03MB3606C60E305BAC460BB2FC36B7550@HIDDEN>
In-Reply-To: <83zhfyakwd.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 <83zhfyakwd.fsf@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: c2dd69c1-1cf3-46b1-959c-e2ae7ccb7083@Spark
Content-Type: multipart/alternative; boundary="5df1c30a_34cc3acf_422"
X-ClientProxiedBy: HK0PR03CA0115.apcprd03.prod.outlook.com
 (2603:1096:203:b0::31) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <c2dd69c1-1cf3-46b1-959c-e2ae7ccb7083@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.199.222.221) by
 HK0PR03CA0115.apcprd03.prod.outlook.com (2603:1096:203:b0::31) with Microsoft
 SMTP Server (version=TLS1_2, cipher=) via Frontend Transport;
 Thu, 12 Dec 2019 04:33:18 +0000
X-Readdle-Message-ID: c2dd69c1-1cf3-46b1-959c-e2ae7ccb7083@Spark
X-Microsoft-Original-Message-ID: <c2dd69c1-1cf3-46b1-959c-e2ae7ccb7083@Spark>
X-TMN: [u9b4KjKSs+jmcBNHMa503dMu1ZPoy2kY]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 698de079-6dc3-4182-578c-08d77ebc6a5c
X-MS-TrafficTypeDiagnostic: HK2APC01HT241:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: /UW979qT6RDXAtdFwQZlY/fIW20AltY6cnPOLSV7ebu7Qs6LsF2yPjU5u8ji2/4IO8P7huitmztoeLtXzZ1I2geZbjbaJ2v1vQwXg9ctBhoLkyBi9rEjBrYVp2E3G0PrjdhZk/4W52f8N6k+UNVTnTGdMZTB8g7yEKCiZiWobiKGmYeGzv26BrNUMDRB/F8s
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 698de079-6dc3-4182-578c-08d77ebc6a5c
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 12 Dec 2019 04:33:20.2630 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HK2APC01HT241
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5df1c30a_34cc3acf_422
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

=E5=9C=A8 2019=E5=B9=B412=E6=9C=8812=E6=97=A5 +0800 AM12:26=EF=BC=8CEli Z=
aretskii <eliz=40gnu.org>=EF=BC=8C=E5=86=99=E9=81=93=EF=BC=9A
> In general, people who set resize-mini-windows to nil are always in
> danger of seeing only part of the message Emacs displays.
>

=46or the combination of prompt and message, there is a worst case: the m=
essage may never be displayed because no space in minibuffer window. The =
user may never notice it.


> > Another question:
> > When emacs displays combination of the prompt and the message, if use=
r input something, doesn=E2=80=99t the
> > message disappears=3F
>
> It does disappear, and the prompt remains. Again, lime with the
> current master.
>

When user is inputing something in minibuffer, I think there is hardly an=
y message so important to let user pause the inputing and wait for the ne=
xt message, except they are BBC news.

The importance levels for me:

=C2=A0 =C2=A0 (1) Inputing in minibuffer
=C2=A0 =C2=A0 (2) Inputing in buffer window
=C2=A0 =C2=A0 (3) Messages in minibuffer window

I think messages(In (3)) should not disturb (1). Because they are so less=
 important.
And when user is busy editing in (2), he may never notice messages in min=
ibuffer because they are cleared quickly. So important messages should no=
t use minibuffer. They should use mode-line or something else.

One example for using mode-line:
Magit is a git tool in emacs. When push with magit, it display =E2=80=9Cp=
ush=E2=80=9D in mode-line and clear it when done.


> > This is what the current code does,
> >
> > The current code doesn=E2=80=99t display the message transiently. It =
displays it forever.
>
> By =22the current code=22 I meant the current master branch.

I meant the code before minibuffer-message is added.


> There, the
> message is displayed for 2 sec, and then disappears, even if the user
> didn't press any key. Which is different from how 'message' behaves
> when there=E2=80=99s no prompt.

I like this behaviour. There are two sub-behaviours:

=C2=A0 =C2=A0 (1) Display the combination of prompt and message. After 2s=
, display prompt only
=C2=A0 =C2=A0 (2) Display message only. After 2s, back to display prompt =
only.

The problem(for UI only) with (1) is that there is a worst case mentioned=
 above (when resize-mini-windows is nil). But it is well for almost 99%.

Both of them are OK to me. I just think that (2) may be more simple and m=
ay have less conflicts with other packages.

By the way, ivy (a popular package for emacs) uses (2). It works in minib=
uffer. When a message comes, it displays the message. After a moment, it =
clears the message and restores its UI.


>
> > User needs to press a key to
> > restore to the prompt. Is this a bug=3F
>
> No, I don't think it's a bug. If some Lisp program displays a message
> and doesn't follow it with a nil message, it means that Lisp program
> =5Fwants=5F the message to remain on display until the user dismisses i=
t.
>
The current behaviour in emacs-26(and the master branch before minibuffer=
-message is added) is that emacs hides the prompt and displays the messag=
e forever. Most lisp programs don=E2=80=99t display the nil message. So t=
he prompt will not be resotred automatically.

I think it is hard for lisp programs to display the nil message(It may ha=
ve to setup a timer). So most of them don=E2=80=99t do this. I don=E2=80=99=
t know one of them.

And I think inputing in minibuffer or editing in buffer is much more impo=
rtant than these messages. If the message is too important, it should go =
to mode-line or else.


> What indicator=3F
>
See the example of magit above.

> (And I don't understand why we are arguing, since you just said in
> another message that you liked my proposal=E2=80=A6)
Yes. I like your proposal that message do these things internally. Becaus=
e the input prompt should always be considered, so all these things can b=
e done in =E2=80=98message=E2=80=99. Then it seems that we don=E2=80=99t =
need another api(like minibuffer-message)=3F

Is the UI of your proposal like this=3F
(1) Display combination of the prompt and the message with no timeout.
(2) If user inputs something, the message is cleared and only prompt is d=
isplayed.

It is also simple. I like it.


The last question:
What is the use of minibuffer-message-timeout. It is defined in C. When d=
oes it take effect=3F



--5df1c30a_34cc3acf_422
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageReplySection">=E5=9C=A8 2019=E5=B9=B412=E6=9C=8812=E6=
=97=A5 &#43;0800 AM12:26=EF=BC=8CEli Zaretskii &lt;eliz@HIDDEN&gt;=EF=BC=
=8C=E5=86=99=E9=81=93=EF=BC=9A<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">In general, people who=
 set resize-mini-windows to nil are always in<br>
danger of seeing only part of the message Emacs displays.<br>
<br></blockquote>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">For the combination of prompt and message, there is a wor=
st case: the message may never be displayed because no space in minibuffer =
window. The user may never notice it.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">Another question:<br>
When emacs displays combination of the prompt and the message, if user inpu=
t something, doesn=E2=80=99t the<br>
message disappears?<br></blockquote>
<br>
It does disappear, and the prompt remains. Again, lime with the<br>
current master.<br>
<br></blockquote>
<div dir=3D"auto"><br></div>
When user is inputing something in minibuffer, I think there is hardly any =
message so important to let user pause the inputing and wait for the next m=
essage, except they are BBC news.
<div dir=3D"auto"><br></div>
<div dir=3D"auto">The importance levels for me:</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">&nbsp; &nbsp; (1) Inputing in minibuffer<br>
&nbsp; &nbsp; (2) Inputing in buffer window<br>
&nbsp; &nbsp; (3) Messages in minibuffer window</div>
<div dir=3D"auto"><br>
<div dir=3D"auto">I think messages(In (3)) should not disturb (1). Because =
they are so less important.&nbsp;</div>
<div dir=3D"auto">And when user is busy editing in (2), he may never notice=
 messages in minibuffer because they are cleared quickly. So important mess=
ages should not use minibuffer. They should use mode-line or something else=
.&nbsp;</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">One example for using mode-line:</div>
<div dir=3D"auto">Magit is a git tool in emacs. When push with magit, it di=
splay =E2=80=9Cpush=E2=80=9D in mode-line and clear it when done.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">This is what the curre=
nt code does,<br>
<br>
The current code doesn=E2=80=99t display the message transiently. It displa=
ys it forever.<br></blockquote>
<br>
By &quot;the current code&quot; I meant the current master branch. &nbsp;</=
blockquote>
<div>
<div dir=3D"auto" style=3D"caret-color: rgb(39, 39, 40);"><br></div>
<div dir=3D"auto" style=3D"caret-color: rgb(39, 39, 40);">I meant the code =
before minibuffer-message is added.</div>
</div>
<div><br></div>
<div dir=3D"auto"><br></div>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">There, the<br>
message is displayed for 2 sec, and then disappears, even if the user<br>
didn't press any key. Which is different from how 'message' behaves<br>
when there=E2=80=99s no prompt.&nbsp;</blockquote>
<div dir=3D"auto"><br></div>
<div>I like this behaviour. There are two sub-behaviours:</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">&nbsp; &nbsp; (1) Display the combination of prompt and m=
essage. After 2s, display prompt only</div>
<div dir=3D"auto">&nbsp; &nbsp; (2) Display message only. After 2s, back to=
 display prompt only.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">The problem(for UI only) with (1) is that there is a wors=
t case mentioned above (when resize-mini-windows is nil). But it is well fo=
r almost 99%.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">Both of them are OK to me. I just think that (2) may be m=
ore simple and may have less conflicts with other packages.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">By the way, ivy (a popular package for emacs) uses (2). I=
t works in minibuffer. When a message comes, it displays the message. After=
 a moment, it clears the message and restores its UI.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;"><br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">User needs to press a =
key to<br>
restore to the prompt. Is this a bug?<br></blockquote>
<br>
No, I don't think it's a bug. If some Lisp program displays a message<br>
and doesn't follow it with a nil message, it means that Lisp program<br>
_wants_ the message to remain on display until the user dismisses it.<br>
<br></blockquote>
<div dir=3D"auto">The current behaviour in emacs-26(and the master branch b=
efore minibuffer-message is added) is that emacs hides the prompt and displ=
ays the message forever. Most lisp programs don=E2=80=99t display the nil m=
essage. So the prompt will not be resotred automatically.</div>
<div dir=3D"auto"><br></div>
I think it is hard for lisp programs to display the nil message(It may have=
 to setup a timer). So most of them don=E2=80=99t do this. I don=E2=80=99t =
know one of them.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">And I think inputing in minibuffer or editing in buffer i=
s much more important than these messages. If the message is too important,=
 it should go to mode-line or else.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">What indicator?<br>
<br></blockquote>
See the example of magit above.</div>
<div dir=3D"auto"><br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">(And I don't understan=
d why we are arguing, since you just said in<br>
another message that you liked my proposal=E2=80=A6)&nbsp;<br></blockquote>
Yes. I like your proposal that message do these things internally. Because =
the input prompt should always be considered, so all these things can be do=
ne in =E2=80=98message=E2=80=99. Then it seems that we don=E2=80=99t need a=
nother api(like minibuffer-message)?</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">Is the UI of your proposal like this?</div>
<div dir=3D"auto">(1) Display combination of the prompt and the message wit=
h no timeout.</div>
<div dir=3D"auto">(2) If user inputs something, the message is cleared and =
only prompt is displayed.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">It is also simple. I like it.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">The last question:&nbsp;</div>
<div dir=3D"auto">What is the use of minibuffer-message-timeout. It is defi=
ned in C. When does it take effect?</div>
<div dir=3D"auto"><br>
<div dir=3D"auto"><br></div>
</div>
</div>
</div>
</body>
</html>

--5df1c30a_34cc3acf_422--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 23:38:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 18:38:08 2019
Received: from localhost ([127.0.0.1]:58798 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifBYW-0004ba-3o
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 18:38:08 -0500
Received: from cadetblue.birch.relay.mailchannels.net ([23.83.209.28]:37596)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifBYU-0004bQ-Mx
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 18:38:07 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id A00DA5E185A;
 Wed, 11 Dec 2019 23:38:05 +0000 (UTC)
Received: from pdx1-sub0-mail-a85.g.dreamhost.com
 (100-96-45-231.trex.outbound.svc.cluster.local [100.96.45.231])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 15E285E061E;
 Wed, 11 Dec 2019 23:38:05 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a85.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 11 Dec 2019 23:38:05 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Desert-Skirt: 6f85f3fe2d822a92_1576107485364_674447463
X-MC-Loop-Signature: 1576107485364:3383684064
X-MC-Ingress-Time: 1576107485364
Received: from pdx1-sub0-mail-a85.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a85.g.dreamhost.com (Postfix) with ESMTP id BC76CACBAE;
 Wed, 11 Dec 2019 15:37:59 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=BnzSgKu+NAzsdjEAuT1cA1UjZ+o=; b=
 f2zeUEo2QYVM1+vIO4NvM8FKns1Hs1jbhoWGgnS/9/FeUa9ZyultFKWKf7aIoJLC
 NLrn/V3twTpjW7p/FqnRAXVvoDa9RwmvmR9P6/Eo7zBTHDTHkc5IQR6Q7a666P1G
 X6TayR3OBEM6gjBTNavoAgZb0XFWDwXTrA6ZqApqyKs=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a85.g.dreamhost.com (Postfix) with ESMTPSA id AE03AACD55;
 Wed, 11 Dec 2019 15:37:57 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a85
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
Date: Thu, 12 Dec 2019 01:28:10 +0200
In-Reply-To: <83tv68c0nb.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 10 Dec
 2019 05:36:24 +0200")
Message-ID: <87d0cubfxx.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudeliedguddtucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedv
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> Such variable already exists.  It's called message-in-echo-area.
>> You can enable it in the release branch if you want.
>> But then please reopen bug#34614, bug#19064, bug#17272, bug#446.
>
> Sorry, I don't understand the proposal.  How will this variable help
> if we leave the current code in 'message' as it is?  And what do you
> mean by "enabling" message-in-echo-area?

When message-in-echo-area is non-nil, then 'message' has exactly
the same behavior as before, as in the previous versions.

I propose to use timers in minibuffer-message conditionally
only when message-in-echo-area is nil.  Then the behavior
of minibuffer-message will be exactly the same as before too
when message-in-echo-area is non-nil.

If you want to set message-in-echo-area to t in the release branch,
that's fine.

Then everyone who doesn't fear timers can customize it to nil.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 23:38:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 18:38:01 2019
Received: from localhost ([127.0.0.1]:58791 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifBYO-0004aN-NP
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 18:38:01 -0500
Received: from cheetah.birch.relay.mailchannels.net ([23.83.209.34]:55656)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifBYN-0004aD-Ek
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 18:37:59 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 699B62C1527;
 Wed, 11 Dec 2019 23:37:58 +0000 (UTC)
Received: from pdx1-sub0-mail-a85.g.dreamhost.com
 (100-96-88-132.trex.outbound.svc.cluster.local [100.96.88.132])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id E8BA82C1FEE;
 Wed, 11 Dec 2019 23:37:57 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a85.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 11 Dec 2019 23:37:58 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Plucky-Shelf: 4bd9276323a6a8da_1576107478235_3776748451
X-MC-Loop-Signature: 1576107478234:361988401
X-MC-Ingress-Time: 1576107478234
Received: from pdx1-sub0-mail-a85.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a85.g.dreamhost.com (Postfix) with ESMTP id B4F53ACBAE;
 Wed, 11 Dec 2019 15:37:52 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type:content-transfer-encoding; s=linkov.net; bh=+sQRNz
 unIxrFrYKyFxknKiYam+k=; b=Z8O0XRbp8SZNz4YBidNNHucDZxPfbIHxhEVNEe
 rPHxZHycm0qznoGFQeUIAycHUt9BUjkKV44xjezDb0fwvq2/JLAmUdQdT8Yc5ogY
 aA6eawCBFqfpVQDtvIWu4TUj6TiiUKqHpawD0vXGxVLqNCBTxfQb94AYmxIjYc+p
 TGvrw=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a85.g.dreamhost.com (Postfix) with ESMTPSA id 61C5FACE1F;
 Wed, 11 Dec 2019 15:37:49 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a85
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <83r21aak51.fsf@HIDDEN>
Date: Thu, 12 Dec 2019 01:24:30 +0200
In-Reply-To: <83r21aak51.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 11 Dec
 2019 18:42:50 +0200")
Message-ID: <87eexabg41.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudeliedguddtucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgfgsehtkeertddtreejnecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledrleeirdegvdenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrdeliedrgedvpdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepvghlihiisehgnhhurdhorhhgnecuvehluhhsthgvrhfuihiivgeptd
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> The original problem was, AFAIU, that various minibuffer prompts
>> become obscured by echo-area display of messages.  So one possible
>> solution is to modify the subroutines of 'message', e.g.,
>> set_message_1, to detect the conditions of the minibuffer being
>> active, and insert the contents of the minibuffer into the echo-area
>> buffer before the message text.  Does anyone see problems with this?
>
> Juri, could you please share your opinion about this proposal?  you
> worked on changes related to this issues a lot lately, so you probably
> know about this more than anyone else.  Do you see any problem with
> the above?  If workable, I think its advantage is that it minimizes
> behavior changes, while preserving the main traits of the solution: to
> avoid obscuring minibuffer prompts by asynchronous messages.

The problem is not in implementation.  Of course, it's possible
to display the minibuffer's contents with an appended message
in the echo-area like Isearch does.

The problem is in usability: it would be very annoying if the message
displayed at the end of the minibuffer's contents would not vanish
after some time.  minibuffer-message removes the message
after 2 sec by default.

If someone wants the message to hang out indefinitely in the minibuffer,
this is possible, minibuffer-message-timeout is configurable:

  minibuffer-message-timeout is a variable defined in =E2=80=98C source c=
ode=E2=80=99.
  Its value is 2
  Documentation:
  How long to display an echo-area message when the minibuffer is active.
  If the value is a number, it should be specified in seconds.
  If the value is not a number, such messages never time out.

But this means that your proposed implementation still should use timers
to remove the echo-area with the appended message after the amount of tim=
e
specified by minibuffer-message-timeout is passed (when its value is a nu=
mber).




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 23:37:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 18:37:53 2019
Received: from localhost ([127.0.0.1]:58788 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifBYH-0004Zu-DT
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 18:37:53 -0500
Received: from black.elm.relay.mailchannels.net ([23.83.212.19]:50963)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ifBYF-0004Zi-J1
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 18:37:52 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 85247580CC7;
 Wed, 11 Dec 2019 23:37:50 +0000 (UTC)
Received: from pdx1-sub0-mail-a85.g.dreamhost.com
 (100-96-83-29.trex.outbound.svc.cluster.local [100.96.83.29])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id C1F79580CE0;
 Wed, 11 Dec 2019 23:37:49 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a85.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 11 Dec 2019 23:37:50 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Harmony-Name: 4c3f60664c659ac4_1576107470092_278526126
X-MC-Loop-Signature: 1576107470092:1676283256
X-MC-Ingress-Time: 1576107470092
Received: from pdx1-sub0-mail-a85.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a85.g.dreamhost.com (Postfix) with ESMTP id 2C283ACBAE;
 Wed, 11 Dec 2019 15:37:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=6YH0XEv+d45+6MswQBQJBaV2hpo=; b=
 P6wmKiAY8LwqAvXTS2+4T+1mSaVtF1A5xDfdj4FkPsIO+AXkwWKIpke22PgfAljH
 gHttGmD2tSGFiZb52aGpaU5cDv6Id9fJoC7yTXVuRHjPyf8uhBWhBQNRfXc3JThJ
 QEBw8u2BUD6a5vRmw3D2glY/+XrY045/Dw988osKLCQ=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a85.g.dreamhost.com (Postfix) with ESMTPSA id B70EBAC950;
 Wed, 11 Dec 2019 15:37:42 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a85
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <83y2vujd0y.fsf@HIDDEN>
 <87blspm0sm.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
Date: Thu, 12 Dec 2019 01:12:33 +0200
In-Reply-To: <831rtabzs6.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 11 Dec
 2019 18:19:37 +0200")
Message-ID: <87k172bg7a.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudeliedguddtucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedu
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > Btw, the current code on master also removes the overlays where
>> > icomplete shows the completion candidates.  You can try it:
>> >
>> >   . Evaluate:
>> >
>> >     (defun my-message ()
>> >       (interactive)
>> >       (message "my most important message"))
>> >     (global-set-key [f5] 'my-message)
>> >
>> >   . M-x icomplete-mode RET
>> >   . C-x C-f
>> >   . F5
>> >
>> > After "C-x C-f" the list of candidates will be displayed in the
>> > minibuffer; pressing F5 removes the list and shows the message
>> > instead.
>>
>> That's not fair.  I fixed this already a week ago.
>> But you didn't allow me to install the fix.
>
> Sorry, I don't think I follow: what did you want to fix in this
> scenario?

I already fixed this 10 days ago.  If the patch was installed then
you wouldn't say that the current code on master removes the icomplete
overlays.  Because the patch doesn't remove the icomplete overlays.
Its behavior is so smooth that it would be unfortunate to implement
something worse than that.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 18:53:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 13:53:49 2019
Received: from localhost ([127.0.0.1]:58683 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if77N-00040R-3o
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 13:53:49 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:19636)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1if77K-00040E-TV
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 13:53:47 -0500
Received: from pmg3.iro.umontreal.ca (localhost [127.0.0.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 62AE644CFEB;
 Wed, 11 Dec 2019 13:53:41 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg3.iro.umontreal.ca (Proxmox) with ESMTP id 698D844CFE9;
 Wed, 11 Dec 2019 13:53:39 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1576090419;
 bh=TOEYAfHz9PsMNV4VTnCcnjmKL0jiucD2FOLVFeypBBk=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=BLJig8SgtPFl8SZlBiGbCbbjEtldPzp2vIUvIxPXyo64PCmad2EeaEPE9rnnPWg+0
 lcCP9P7ummHNTlmyLHkLMTgZBW0cLtv+GJNJXTp198dKG7gxgSTJvoo1tZEcRfHHig
 9kRKdYTYKt1K+HajptT7PEMdwQJ7TAlkwaAa2AAWrVPmSDMuDH6HyHHeuNn4OFnKXp
 A9OYexJdpDHnvRJy8r9MxEyh8DWD2u5Iy5UE7cnT/Gz66kEEMNJgud8Pwu501eDiwH
 DhJ5yqCU79OgePk1eFZmgI1OB2oedSlg51UrWU0C0+CNicDia+nXvKMTEXwN0H6he/
 CaivNDfAwlAMg==
Received: from pastel (unknown [45.72.154.226])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id EE16D120175;
 Wed, 11 Dec 2019 13:53:38 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Message-ID: <jwv1rtawv7r.fsf-monnier+emacs@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
 <jwvk172wyy9.fsf-monnier+emacs@HIDDEN> <83k172ah0l.fsf@HIDDEN>
Date: Wed, 11 Dec 2019 13:53:31 -0500
In-Reply-To: <83k172ah0l.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 11 Dec
 2019 19:50:18 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.025 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> You understood correctly: I do not consider this a bug (tho it might be
>> purely accidental, as I suspect it is: it's likely the result of the
>> fact that the list of completion is removed by icomplete before
>> processing a command and re-added afterwards, and minibuffer-message
>> adds a 2s wait during the execution of the command, i.e. at a point in
>> time where icomplete's list is not displayed).
>
> I actually thought this was the result of adding an overlay at the
> end, which "covers" the icomplete's overlay.  But I didn't look
> closely at the code, so maybe I'm wrong.

Could be as well, I don't actually know, the above is just my
best guess.  In any case I think it's not a bug (not sure if I'd go so
far as to call it a feature, tho).


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 17:50:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 12:50:34 2019
Received: from localhost ([127.0.0.1]:58659 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if68A-0001jV-By
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 12:50:34 -0500
Received: from eggs.gnu.org ([209.51.188.92]:42915)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if688-0001jJ-UR
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 12:50:33 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47420)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if683-0000wD-ER; Wed, 11 Dec 2019 12:50:27 -0500
Received: from [176.228.60.248] (port=2518 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if682-00030K-MQ; Wed, 11 Dec 2019 12:50:27 -0500
Date: Wed, 11 Dec 2019 19:50:18 +0200
Message-Id: <83k172ah0l.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-reply-to: <jwvk172wyy9.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Wed, 11 Dec 2019 12:34:26 -0500)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <83y2vujd0y.fsf@HIDDEN>
 <87blspm0sm.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
 <jwvk172wyy9.fsf-monnier+emacs@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: Juri Linkov <juri@HIDDEN>,  38457 <at> debbugs.gnu.org
> Date: Wed, 11 Dec 2019 12:34:26 -0500
> 
> You understood correctly: I do not consider this a bug (tho it might be
> purely accidental, as I suspect it is: it's likely the result of the
> fact that the list of completion is removed by icomplete before
> processing a command and re-added afterwards, and minibuffer-message
> adds a 2s wait during the execution of the command, i.e. at a point in
> time where icomplete's list is not displayed).

I actually thought this was the result of adding an overlay at the
end, which "covers" the icomplete's overlay.  But I didn't look
closely at the code, so maybe I'm wrong.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 17:34:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 12:34:38 2019
Received: from localhost ([127.0.0.1]:58655 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if5sj-0001Kl-Un
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 12:34:38 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:1123)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1if5si-0001KY-1I
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 12:34:36 -0500
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 8B97E100350;
 Wed, 11 Dec 2019 12:34:30 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 799F81000BA;
 Wed, 11 Dec 2019 12:34:28 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1576085668;
 bh=c1LkDZejS0A9RMq6OCwNF2ZDFiav8TIL8XTfg+3hDeQ=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=pbq9hBQMEMYj1GOlTvKUaZO+K4MvmwqEjjDP2NcIKBASjDG/65xj6HZbJ27pm1FIF
 xZjjUs9T4DoeFKtbukDq8TObVtyz3Yu7dikGB4PiEly214chIgS6NCgIw8qb1FQeyC
 8V6CVrWwBaDop2daCAo2Q+h1VtG3uhxuODbAucBuelW1Dyoinb5ITqgBW1AqaGqFBh
 922kw4bV2dFWWmu6D1mljHoMNHg+l9G44JjA4PsZsycH7Zwsr3Vt+e1hyHfOJwpocE
 qtqWHzj5iEtuUfNrbwgFqCw40nKaJ357cb4mTyBhEvJj6IrjRq80fD8uVFAlZnJ1ED
 NVRzB5MxcjZiQ==
Received: from pastel (unknown [45.72.154.226])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 4155A1209C1;
 Wed, 11 Dec 2019 12:34:28 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Message-ID: <jwvk172wyy9.fsf-monnier+emacs@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <83y2vujd0y.fsf@HIDDEN>
 <87blspm0sm.fsf@HIDDEN> <837e3ckbem.fsf@HIDDEN>
 <871rtjn0kt.fsf@HIDDEN> <83lfrrigj8.fsf@HIDDEN>
 <87eexiqps5.fsf@HIDDEN> <83lfrphp94.fsf@HIDDEN>
 <87wob7g2jk.fsf@HIDDEN> <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN> <831rtabzs6.fsf@HIDDEN>
Date: Wed, 11 Dec 2019 12:34:26 -0500
In-Reply-To: <831rtabzs6.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 11 Dec
 2019 18:19:37 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL -0.020 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> my point was that while the message is displayed, the icomplete-mode
> candidates are not displayed.  (FWIW, I don't consider this a bug we
> should fix, and neither does Stefan, AFAIU.)

You understood correctly: I do not consider this a bug (tho it might be
purely accidental, as I suspect it is: it's likely the result of the
fact that the list of completion is removed by icomplete before
processing a command and re-added afterwards, and minibuffer-message
adds a 2s wait during the execution of the command, i.e. at a point in
time where icomplete's list is not displayed).


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 16:43:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 11:43:07 2019
Received: from localhost ([127.0.0.1]:58618 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if54t-0006Db-Ky
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:43:07 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39404)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if54s-0006D9-DS
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:43:06 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45331)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if54m-0001PO-TI; Wed, 11 Dec 2019 11:43:00 -0500
Received: from [176.228.60.248] (port=2380 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if54m-0003zU-9E; Wed, 11 Dec 2019 11:43:00 -0500
Date: Wed, 11 Dec 2019 18:42:50 +0200
Message-Id: <83r21aak51.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: juri@HIDDEN
In-reply-to: <83h828b0lz.fsf@HIDDEN> (message from Eli Zaretskii on Tue, 10
 Dec 2019 18:34:48 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 10 Dec 2019 18:34:48 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> 
> The original problem was, AFAIU, that various minibuffer prompts
> become obscured by echo-area display of messages.  So one possible
> solution is to modify the subroutines of 'message', e.g.,
> set_message_1, to detect the conditions of the minibuffer being
> active, and insert the contents of the minibuffer into the echo-area
> buffer before the message text.  Does anyone see problems with this?

Juri, could you please share your opinion about this proposal?  you
worked on changes related to this issues a lot lately, so you probably
know about this more than anyone else.  Do you see any problem with
the above?  If workable, I think its advantage is that it minimizes
behavior changes, while preserving the main traits of the solution: to
avoid obscuring minibuffer prompts by asynchronous messages.

TIA




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 16:31:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 11:31:00 2019
Received: from localhost ([127.0.0.1]:58601 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if4tA-0005sh-17
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:31:00 -0500
Received: from eggs.gnu.org ([209.51.188.92]:60665)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if4t8-0005sQ-Bm
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:30:58 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45110)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if4t3-0002K2-6w; Wed, 11 Dec 2019 11:30:53 -0500
Received: from [176.228.60.248] (port=1621 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if4se-0002MX-TU; Wed, 11 Dec 2019 11:30:30 -0500
Date: Wed, 11 Dec 2019 18:30:20 +0200
Message-Id: <83v9qmakpv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <875zinpb5p.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 11 Dec 2019 08:35:30 +0100)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
 <87a77zpbab.fsf@HIDDEN> <875zinpb5p.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, rms@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org,  stephen.berman@HIDDEN,  Richard Stallman
>  <rms@HIDDEN>,  juri@HIDDEN
> Date: Wed, 11 Dec 2019 08:35:30 +0100
> 
> (But I want to emphasise that I think Juri's patch is the right
> long-term solution -- it's been great the past few weeks not having
> anything, at random, hide what I'm working on in the minibuffer.)

I think the solution I proposed later, to insert the minibuffer
contents before the message text, is a more correct long-term
solution, since it has a much more narrow implications, and doesn't
change the behavior of such low-level pervasive APIs.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 16:29:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 11:29:13 2019
Received: from localhost ([127.0.0.1]:58596 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if4rR-0005nf-J0
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:29:13 -0500
Received: from eggs.gnu.org ([209.51.188.92]:47772)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if4rP-0005nS-NC
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:29:11 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45056)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if4rK-0008M1-61; Wed, 11 Dec 2019 11:29:06 -0500
Received: from [176.228.60.248] (port=1525 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if4rA-0005Pt-5d; Wed, 11 Dec 2019 11:28:56 -0500
Date: Wed, 11 Dec 2019 18:28:47 +0200
Message-Id: <83y2viaksg.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87a77zpbab.fsf@HIDDEN> (message from Lars Ingebrigtsen on Wed, 
 11 Dec 2019 08:32:44 +0100)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
 <87a77zpbab.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, rms@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: juri@HIDDEN,  38457 <at> debbugs.gnu.org,  stephen.berman@HIDDEN,
>   Richard Stallman <rms@HIDDEN>
> Date: Wed, 11 Dec 2019 08:32:44 +0100
> 
> I agree that the timing for this change was unfortunate, especially for
> such a low-level change.  It does make sense to me to back out the
> change for now and then apply it to master again once the emacs-27
> branch has been cut.  (Or perhaps doing it the other way around is
> easier -- cut the emacs-27 branch and then revert the change there.)
> 
> I think you're right in that there may be other interactions that we
> still don't have a full overview of.

Do you have an opinion on my later suggestion, to insert the
minibuffer contents before the message text, when 'message' is called
with a minibuffer being active?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 16:26:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 11:26:53 2019
Received: from localhost ([127.0.0.1]:58592 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if4p8-0005jy-0i
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:26:53 -0500
Received: from eggs.gnu.org ([209.51.188.92]:58616)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if4p6-0005jm-UD
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:26:49 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45014)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if4oz-0005Kt-TD; Wed, 11 Dec 2019 11:26:42 -0500
Received: from [176.228.60.248] (port=1372 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if4ou-0002Li-PS; Wed, 11 Dec 2019 11:26:41 -0500
Date: Wed, 11 Dec 2019 18:26:26 +0200
Message-Id: <83zhfyakwd.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
In-reply-to: <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
 (message from HaiJun Zhang on Wed, 11 Dec 2019 11:59:48 +0800)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN> 
 <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Wed, 11 Dec 2019 11:59:48 +0800
> From: HaiJun Zhang <netjune@HIDDEN>
> Cc: monnier@HIDDEN, 38457 <at> debbugs.gnu.org, juri@HIDDEN
> 
>  I explained in more detail how I suggested to implement thius: by
>  inserting the minibuffer contents before the message text. What is
>  complex about that?
> 
> Because resize-mini-windows may be nil. And the message may be invisible. 

The current master has the same problem.

In general, people who set resize-mini-windows to nil are always in
danger of seeing only part of the message Emacs displays.

> Another question: 
> When emacs displays combination of the prompt and the message, if user input something, doesn’t the
> message disappears?

It does disappear, and the prompt remains.  Again, lime with the
current master.

>  This is what the current code does,  
> 
> The current code doesn’t display the message transiently. It displays it forever.

By "the current code" I meant the current master branch.  There, the
message is displayed for 2 sec, and then disappears, even if the user
didn't press any key.  Which is different from how 'message' behaves
when there's no prompt.

> User needs to press a key to
> restore to the prompt. Is this a bug?

No, I don't think it's a bug.  If some Lisp program displays a message
and doesn't follow it with a nil message, it means that Lisp program
_wants_ the message to remain on display until the user dismisses it.

>  and the problem with that is that
>  some uses of 'message' don't expect the message to stay for 2 seconds,
>  and some expect it to stay forever. This information is not explicit
>  in the call to 'message', so there's no way of communicating in down
>  to minibuffer-message. 
> 
> Do you mean the scene “Foo…” followed by “Foo…done”?

That's one scenario, yes.  But it is not the only one.

> I don’t think this is a problem. These are just status which are not important. And they disappears quickly
> when user is busy editing.

With the current master, it doesn't disappear quickly, it stays for 2 sec.

> And the really important ones may put an indicator on the mode-line.

What indicator?

(And I don't understand why we are arguing, since you just said in
another message that you liked my proposal...)




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 16:19:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 11:19:55 2019
Received: from localhost ([127.0.0.1]:58588 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if4iR-0005Zg-7b
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:19:55 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50431)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if4iP-0005ZS-CW
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:19:53 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44833)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if4iJ-0006mC-OY; Wed, 11 Dec 2019 11:19:47 -0500
Received: from [176.228.60.248] (port=4933 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if4iH-0001Ol-Lh; Wed, 11 Dec 2019 11:19:46 -0500
Date: Wed, 11 Dec 2019 18:19:37 +0200
Message-Id: <831rtabzs6.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <871rtcf29h.fsf@HIDDEN> (message from Juri Linkov on
 Wed, 11 Dec 2019 01:45:30 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
 <871rtcf29h.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: monnier@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Wed, 11 Dec 2019 01:45:30 +0200
> 
> > Btw, the current code on master also removes the overlays where
> > icomplete shows the completion candidates.  You can try it:
> >
> >   . Evaluate:
> >
> >     (defun my-message ()
> >       (interactive)
> >       (message "my most important message"))
> >     (global-set-key [f5] 'my-message)
> >
> >   . M-x icomplete-mode RET
> >   . C-x C-f
> >   . F5
> >
> > After "C-x C-f" the list of candidates will be displayed in the
> > minibuffer; pressing F5 removes the list and shows the message
> > instead.
> 
> That's not fair.  I fixed this already a week ago.
> But you didn't allow me to install the fix.

Sorry, I don't think I follow: what did you want to fix in this
scenario?

I'm guessing this is about the timer you proposed that would remove
the text shown by minibuffer-message.  If so, my point above was not
about the time it takes to remove that text with the current master,
my point was that while the message is displayed, the icomplete-mode
candidates are not displayed.  (FWIW, I don't consider this a bug we
should fix, and neither does Stefan, AFAIU.)

Am I missing something?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 16:11:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 11:11:27 2019
Received: from localhost ([127.0.0.1]:58580 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1if4aF-0005Lc-2n
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:11:27 -0500
Received: from eggs.gnu.org ([209.51.188.92]:46728)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1if4aC-0005LG-Vg
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 11:11:25 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:44665)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1if4a7-0003ef-0H; Wed, 11 Dec 2019 11:11:19 -0500
Received: from [176.228.60.248] (port=4415 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1if4a5-0000Yl-Ud; Wed, 11 Dec 2019 11:11:18 -0500
Date: Wed, 11 Dec 2019 18:11:08 +0200
Message-Id: <834ky6c06b.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
In-reply-to: <PS1PR03MB360606EE622388E9E8364C09B75A0@HIDDEN>
 (message from HaiJun Zhang on Wed, 11 Dec 2019 11:35:11 +0800)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> 
 <PS1PR03MB360606EE622388E9E8364C09B75A0@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Wed, 11 Dec 2019 11:35:11 +0800
> From: HaiJun Zhang <netjune@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org
> 
> Is there cases where input prompt can be ignored and replaced?

Sorry, I don't understand: what do you mean by "replaced"?

In general, prompts should not be ignored.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 07:35:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 02:35:41 2019
Received: from localhost ([127.0.0.1]:56883 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iewX7-0001Sb-MW
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 02:35:41 -0500
Received: from quimby.gnus.org ([95.216.78.240]:52274)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iewX6-0001SO-Br
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 02:35:40 -0500
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1iewWx-0007YN-IB; Wed, 11 Dec 2019 08:35:33 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
 <87a77zpbab.fsf@HIDDEN>
Date: Wed, 11 Dec 2019 08:35:30 +0100
In-Reply-To: <87a77zpbab.fsf@HIDDEN> (Lars Ingebrigtsen's message of "Wed,
 11 Dec 2019 08:32:44 +0100")
Message-ID: <875zinpb5p.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Lars Ingebrigtsen <larsi@HIDDEN> writes: > I agree that
 the timing for this change was unfortunate, especially for > such a low-level
 change. It does make sense to me to back out the > change for now and then
 apply it to master again once th [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnus.org]
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN,
 Richard Stallman <rms@HIDDEN>, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Lars Ingebrigtsen <larsi@HIDDEN> writes:

> I agree that the timing for this change was unfortunate, especially for
> such a low-level change.  It does make sense to me to back out the
> change for now and then apply it to master again once the emacs-27
> branch has been cut.

(But I want to emphasise that I think Juri's patch is the right
long-term solution -- it's been great the past few weeks not having
anything, at random, hide what I'm working on in the minibuffer.)

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 07:32:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 11 02:32:56 2019
Received: from localhost ([127.0.0.1]:56878 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iewUS-0001OY-8Y
	for submit <at> debbugs.gnu.org; Wed, 11 Dec 2019 02:32:56 -0500
Received: from quimby.gnus.org ([95.216.78.240]:52170)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1iewUR-0001OM-DH
 for 38457 <at> debbugs.gnu.org; Wed, 11 Dec 2019 02:32:55 -0500
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1iewUH-0007SV-Vf; Wed, 11 Dec 2019 08:32:48 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
Date: Wed, 11 Dec 2019 08:32:44 +0100
In-Reply-To: <83d0cxd2fv.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 09 Dec
 2019 16:00:04 +0200")
Message-ID: <87a77zpbab.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Eli Zaretskii <eliz@HIDDEN> writes: > We already have 2 bug
 reports about it for 2 separate > packages, and we cannot leave them unsolved.
 I'm sure this is just > the tip of a very large iceberg. Both were for the
 same thing, though, and was fixed by Juri's patch. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: ingebrigtsen.no]
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN,
 Richard Stallman <rms@HIDDEN>, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> We already have 2 bug reports about it for 2 separate
> packages, and we cannot leave them unsolved.  I'm sure this is just
> the tip of a very large iceberg.

Both were for the same thing, though, and was fixed by Juri's patch.

> How do you propose we move forward?  You think we should install the
> timer proposed by Juri instead?

I think that looked like the right solution.

> We are developing Emacs 27 for more than 1.5 years.  We need to start
> its release cycle very soon, and we should start from a stable code
> base.

I agree that the timing for this change was unfortunate, especially for
such a low-level change.  It does make sense to me to back out the
change for now and then apply it to master again once the emacs-27
branch has been cut.  (Or perhaps doing it the other way around is
easier -- cut the emacs-27 branch and then revert the change there.)

I think you're right in that there may be other interactions that we
still don't have a full overview of.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 04:00:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 23:00:08 2019
Received: from localhost ([127.0.0.1]:56828 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ietAW-0003gQ-6N
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 23:00:08 -0500
Received: from mail-oln040092253035.outbound.protection.outlook.com
 ([40.92.253.35]:4736 helo=APC01-SG2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1ietAT-0003e7-It
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 23:00:06 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=Awd8oycPYQu1tEwW8GVPGO7h9+X13mD9nhEuOPVmIChtqiO/KXh2EP1ZKet/2y2Mn1NkcBcjP55QATn3Lci2Wvk/m4YNMS3DZpkL9M2z9YTxChwn7xq3POFmdAzG1aIiit2mxcWOw3XhXzu6OUV7L7QhVwF4Q/ToN7RlhkWWsFZDDYTFwGQlMM9zP3bmS80nrEO6g41sujJLcqKAPFqutpBQ450vq1AUg6imoUjJtofvRr3p2gow85MlOjlNFiOcWjGZVv+X66SIa7YAXQgTbK1qgyWZagE5wfRC9epVUwlVIq/iNFtGDE0luuZr2LX58Aaty7tao5PIGYjhWnzKKw==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=EMfBMNWTVWMT7alIe+lG4y2gyl+eJphUjR0BaULqT1I=;
 b=aF+EjciIGA9C1XRBYu2aVcKknHEC2CCeUrclftctJCodAEJW47o2h+ZGj3gz8eZ7aoftR67qWlnJ7Ruh1Sk/V1BmOzL7MeI4OHbZBxEamDoTAp4gOmoKDNqOpJUq97czMNx7HHTrt18LjJHCAVR8u0u8y4p3SEwuk65pjX+9+hNsOBBjTrz6bCIN1lHGyROoQVXv/xe3BNvEn11+SpmlWtSAna5d8KolW8Zm72zCsFwim43qwaw63MfP6tzb9JJYnzLYwq8BmQUGfoMePz+aIeji7qzxevLhEWkQMVr1mWMgIYlzHSZ8FgY3sgICqzIIKJpgnzWUM5p55yv7LHFjaw==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=EMfBMNWTVWMT7alIe+lG4y2gyl+eJphUjR0BaULqT1I=;
 b=VKbVa/nQYKMSnK3aImwUoXCLrq/liGASk8ejtacGj4diRqMzAj3EvE32+aNRUi8fBiCYA534hAyh4ugeyYzwL8XQQRobZbGY+BKfyx3jmdmqYIh2MJhbrPbTbqLMTySBayLYeVy1Vui2+t1fZSEqVQVdUr17eoc2uqff/PI3Pfv32idP4dHMgdTS6/ruTJDUV/u4bd/lI499rsHu5808Y3k5njhWY1+Wo/7hhJ9DOlySjBg6RfVAAuq0NyBySiKca2Ndcl+rMwXAeW56W6xupmn/Wlx9w1rYX1YwT8w5ydvBwaqMTP5xT7JENW7F487U42hVBu/d9nO6f/VeFKP3zQ==
Received: from HK2APC01FT061.eop-APC01.prod.protection.outlook.com
 (10.152.248.51) by HK2APC01HT109.eop-APC01.prod.protection.outlook.com
 (10.152.249.110) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2495.25; Wed, 11 Dec
 2019 03:59:57 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.248.56) by
 HK2APC01FT061.mail.protection.outlook.com (10.152.249.105) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2495.25 via Frontend Transport; Wed, 11 Dec 2019 03:59:57 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:C96D1960B86ABFA99CE7D6FCE1C9FD59395985057F78BB8F37EE96416DD6007E;
 UpperCasedChecksum:A0853E21D9AAEE9883757C8D2BE4FC92CA88F0558C0230E8599425DD2351AA99;
 SizeAsReceived:9354; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2538.012; Wed, 11 Dec 2019
 03:59:57 +0000
Date: Wed, 11 Dec 2019 11:59:48 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Message-ID: <PS1PR03MB36065ABCF82674C23A0FC11AB75A0@HIDDEN>
In-Reply-To: <835zinbkct.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 <835zinbkct.fsf@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: 18306602-f41e-46b2-9407-ea9a55548b67@Spark
Content-Type: multipart/alternative; boundary="5df069b9_4f97e3e4_422"
X-ClientProxiedBy: HK0PR01CA0069.apcprd01.prod.exchangelabs.com
 (2603:1096:203:a6::33) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <18306602-f41e-46b2-9407-ea9a55548b67@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.199.222.221) by
 HK0PR01CA0069.apcprd01.prod.exchangelabs.com (2603:1096:203:a6::33) with
 Microsoft SMTP Server (version=TLS1_2, cipher=) via Frontend Transport;
 Wed, 11 Dec 2019 03:59:56 +0000
X-Readdle-Message-ID: 18306602-f41e-46b2-9407-ea9a55548b67@Spark
X-Microsoft-Original-Message-ID: <18306602-f41e-46b2-9407-ea9a55548b67@Spark>
X-TMN: [eJ9oMfq20lzRAsPcVOwt/ucvcRlwq8ju]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 2cc8ab6f-e2f8-435c-2363-08d77dee9602
X-MS-TrafficTypeDiagnostic: HK2APC01HT109:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: E8UpgO26JSkBvwwEuEbcvaGSDYoEw4QeD5hP8Xu18V5UhNx0UVz3DQim/Un7/nRXQcfOQ8EvmqsAObzW0/fPJBg9+4+LqWn0pzETRh8YlhDy124PWQvQIC+AusRTBHl8wPnM81Pby3Fo0v7XAbTwTas26xBM3rxjSJNNVk5qn9JWogMeuRyxNgSxMsPTRRVU
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 2cc8ab6f-e2f8-435c-2363-08d77dee9602
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 11 Dec 2019 03:59:57.0864 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HK2APC01HT109
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5df069b9_4f97e3e4_422
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

=E5=9C=A8 2019=E5=B9=B412=E6=9C=8811=E6=97=A5 +0800 AM11:40=EF=BC=8CEli Z=
aretskii <eliz=40gnu.org>=EF=BC=8C=E5=86=99=E9=81=93=EF=BC=9A
> I explained in more detail how I suggested to implement thius: by
> inserting the minibuffer contents before the message text. What is
> complex about that=3F
>

Because=C2=A0resize-mini-windows may be nil. And the message may be invis=
ible.

Another question:
When emacs displays combination of the prompt and the message, if user in=
put something, doesn=E2=80=99t the message disappears=3F

>
> This is what the current code does,

The current code doesn=E2=80=99t display the message transiently. It disp=
lays it forever. User needs to press a key to restore to the prompt. Is t=
his a bug=3F

> and the problem with that is that
> some uses of 'message' don't expect the message to stay for 2 seconds,
> and some expect it to stay forever. This information is not explicit
> in the call to 'message', so there's no way of communicating in down
> to minibuffer-message.

Do you mean the scene =E2=80=9C=46oo=E2=80=A6=E2=80=9D followed by =E2=80=
=9C=46oo=E2=80=A6done=E2=80=9D=3F
I don=E2=80=99t think this is a problem. These are just status which are =
not important. And they disappears quickly when user is busy editing. And=
 the really important ones may put an indicator on the mode-line.





--5df069b9_4f97e3e4_422
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageReplySection">=E5=9C=A8 2019=E5=B9=B412=E6=9C=8811=E6=
=97=A5 &#43;0800 AM11:40=EF=BC=8CEli Zaretskii &lt;eliz@HIDDEN&gt;=EF=BC=
=8C=E5=86=99=E9=81=93=EF=BC=9A<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">I explained in more de=
tail how I suggested to implement thius: by<br>
inserting the minibuffer contents before the message text. What is<br>
complex about that?<br>
<br></blockquote>
<div dir=3D"auto"><br></div>
Because&nbsp;resize-mini-windows may be nil. And the message may be invisib=
le.
<div dir=3D"auto"><br></div>
<div dir=3D"auto">Another question:&nbsp;</div>
<div dir=3D"auto">When emacs displays combination of the prompt and the mes=
sage, if user input something, doesn=E2=80=99t the message disappears?<br>
<div dir=3D"auto"><br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;"><br>
This is what the current code does, &nbsp;</blockquote>
<div><br></div>
<div dir=3D"auto"><span style=3D"caret-color: rgb(39, 39, 40);">The current=
 code doesn=E2=80=99t display the message transiently. It displays it forev=
er. User needs to press a key to restore to the prompt. Is this a bug?</spa=
n><br></div>
<div dir=3D"auto"><span style=3D"caret-color: rgb(39, 39, 40);"><br></span>=
</div>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">and the problem with t=
hat is that<br>
some uses of 'message' don't expect the message to stay for 2 seconds,<br>
and some expect it to stay forever. This information is not explicit<br>
in the call to 'message', so there's no way of communicating in down<br>
to minibuffer-message.&nbsp;<br></blockquote>
<div><br></div>
<div dir=3D"auto">Do you mean the scene =E2=80=9CFoo=E2=80=A6=E2=80=9D foll=
owed by =E2=80=9CFoo=E2=80=A6done=E2=80=9D?</div>
<div dir=3D"auto">I don=E2=80=99t think this is a problem. These are just s=
tatus which are not important. And they disappears quickly when user is bus=
y editing. And the really important ones may put an indicator on the mode-l=
ine.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
</div>
</div>
</div>
</body>
</html>

--5df069b9_4f97e3e4_422--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 03:40:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 22:40:53 2019
Received: from localhost ([127.0.0.1]:56823 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iesrt-00035Z-Gl
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 22:40:53 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39901)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iesrs-00035K-Dg
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 22:40:52 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36074)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iesrm-0005Fq-QF; Tue, 10 Dec 2019 22:40:46 -0500
Received: from [176.228.60.248] (port=2691 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iesrm-0001h7-7y; Tue, 10 Dec 2019 22:40:46 -0500
Date: Wed, 11 Dec 2019 05:40:34 +0200
Message-Id: <835zinbkct.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
In-reply-to: <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
 (message from HaiJun Zhang on Wed, 11 Dec 2019 11:24:37 +0800)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> 
 <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Wed, 11 Dec 2019 11:24:37 +0800
> From: HaiJun Zhang <netjune@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
> 
> Display combination of the prompt and the message is good but may be complex to implement it.

I explained in more detail how I suggested to implement thius: by
inserting the minibuffer contents before the message text.  What is
complex about that?

> What about display message transiently and then restore to prompt?
> 
> I see the doc string of minibuffer-message-timeout says: 
> 
>  How long to display an echo-area message when the minibuffer is active.
>  If the value is a number, it should be specified in seconds.
>  If the value is not a number, such messages never time out.
> 
> If minibuffer is active, the message will be displayed  for a moment(like 1s) and then disappears.
> If minibuffer is not active, the message will be displayed forever. I think this is simpler and also good for me.
> 
> What is the problem of this behaviour?

This is what the current code does, and the problem with that is that
some uses of 'message' don't expect the message to stay for 2 seconds,
and some expect it to stay forever.  This information is not explicit
in the call to 'message', so there's no way of communicating in down
to minibuffer-message.





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 03:35:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 22:35:31 2019
Received: from localhost ([127.0.0.1]:56818 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iesmg-0002y9-Qd
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 22:35:31 -0500
Received: from mail-oln040092255050.outbound.protection.outlook.com
 ([40.92.255.50]:47168 helo=APC01-HK2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1iesme-0002xi-Mu
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 22:35:30 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=fm54k+95HIhKuNp0jUk3GlN+ztgFtYwGuVXrH4KqlrL47w5KMwXyAEZ7/Pfe1fl5P/ADK2kqJqzjXCInK2pdQskaqBfq8ArosLG/ymotaph10D9CEAxSoZhbCiih+bQ/Fr65rAZZHH5S/iP1G5zXwEeA6kefhcwyFeqeJR0Jlni5n6ezohk0tRL78rYgD1rNfl1sHRxpzWOchPMtw6cvoKw+C/cyNPeBjpyBINpxqLPJmANSiDElQUOTQ/Jnkk9eDNcFtNGJ48rk/WHWF1XnuvUNC+d9vJzX0uun5O6fizEpx9sFuMYRU5C3axYJWfTAOpy6HQK6uTfKtVaBvFS1pQ==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=GGB3xCgwSeQFUEsu1xh2kIZpBRh6cX+qe9Zk1vZbdHE=;
 b=AYsGAq+7s4L4cYg3rOW36tt+AhxHn1qfQ83tDmcjDtok2urPbjnSqhFltO0VPlY59h28TtQfsXMda9+2qNLFAvY+SQ9HX5VeFwvcKiuWEqIgLetsOnJFNNeUNue+mpB5Slf9U1MCVIBVfRf+LgaV72xqDpgcAl5ezqEh5U0Pk830tKbSQs1bf8a3UGDr/jm+swFm+9iJOqx2c7ITo7RwSWsRLHgWoGb/iqOJrwCGUnURxAMKFmKpT6PH7tomDiVxSahUx/LOjIrk1g5IMxO331RN4Iee8lj3JCvCPDsByIjXngmy4xpZ19nK8lPMvuseKKkKs7KPb/EsT9ELp3MaUg==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=GGB3xCgwSeQFUEsu1xh2kIZpBRh6cX+qe9Zk1vZbdHE=;
 b=BYILKA5MyOcPGMbQthaK4ubEMon7FWtsMblsJz4+BP6U8zQjYQxvO8S21vJVu/1ZJDkaveEhtnSN4qtB/iEuU91/MnvRANsr267+kVd0SvM+d8c288siwDLm/PntBrAN6SC6vz91E7Mys1g96wfANECAi45yXwoYcHCQezjXIfAOYzH9xPauDBWFWnw8lPtmy8+ssp5TtHxmpp5SzqBK5J/5NGnuP8wTAF1iBDgMH5LYpTpWHa5Bm8Coyag6R+AR5e4iMASEmZeGKidV1xkItEtQC3IqJxmPfxNscVE4FD1QgdBNhXctg4/S3EQxSkdl88SpAI623aAWmBsRL5PqUw==
Received: from HK2APC01FT033.eop-APC01.prod.protection.outlook.com
 (10.152.248.58) by HK2APC01HT213.eop-APC01.prod.protection.outlook.com
 (10.152.249.23) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2495.25; Wed, 11 Dec
 2019 03:35:19 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.248.56) by
 HK2APC01FT033.mail.protection.outlook.com (10.152.248.190) with Microsoft
 SMTP Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2495.25 via Frontend Transport; Wed, 11 Dec 2019 03:35:19 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:F871D042D3FB9102079EE8E484A5759F84156819865306E1B0F3C2510B94F2D6;
 UpperCasedChecksum:407E3250AF803DD1309059D416248D3AC0BDFDA63351335700C2780DAFBCED00;
 SizeAsReceived:9185; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2538.012; Wed, 11 Dec 2019
 03:35:19 +0000
Date: Wed, 11 Dec 2019 11:35:11 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: juri@HIDDEN, Stefan Monnier <monnier@HIDDEN>, Eli
 Zaretskii <eliz@HIDDEN>
Message-ID: <PS1PR03MB360606EE622388E9E8364C09B75A0@HIDDEN>
In-Reply-To: <83h828b0lz.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: 8eea5ec0-b95f-49a1-b666-95673d712529@Spark
Content-Type: multipart/alternative; boundary="5df063f4_cc1016f_422"
X-ClientProxiedBy: HK2PR02CA0178.apcprd02.prod.outlook.com
 (2603:1096:201:21::14) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <8eea5ec0-b95f-49a1-b666-95673d712529@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.199.222.221) by
 HK2PR02CA0178.apcprd02.prod.outlook.com (2603:1096:201:21::14) with Microsoft
 SMTP Server (version=TLS1_2, cipher=) via Frontend Transport;
 Wed, 11 Dec 2019 03:35:18 +0000
X-Readdle-Message-ID: 8eea5ec0-b95f-49a1-b666-95673d712529@Spark
X-Microsoft-Original-Message-ID: <8eea5ec0-b95f-49a1-b666-95673d712529@Spark>
X-TMN: [AKNMTkHse/hXzA7IdHcllnni61DVz2aZ]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: eb720c21-d97e-4c6d-1cf5-08d77deb2554
X-MS-TrafficTypeDiagnostic: HK2APC01HT213:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 3PHyDVW9GqffRzDE4CRr+p/beuhX2Fw8Q3e4jTfyKbScW+KEHa0ZAfBoPK3ZtWmbC5tWKJ4kQhCgFgbTAQcJaanZ7AlxiNSd6XK0n79Zie1ZsO6yn/xNJsz32NBb/1RyRQqWhCfTdw1TLfqVN0hGo/WNt3mUWCfX0rKbnxQG7NCnCSnYmG4SoR0cGjsPiOaA
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: eb720c21-d97e-4c6d-1cf5-08d77deb2554
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 11 Dec 2019 03:35:19.5499 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: HK2APC01HT213
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5df063f4_cc1016f_422
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

=E5=9C=A8 2019=E5=B9=B412=E6=9C=8811=E6=97=A5 +0800 AM12:36=EF=BC=8CEli Z=
aretskii <eliz=40gnu.org>=EF=BC=8C=E5=86=99=E9=81=93=EF=BC=9A
> The original problem was, A=46AIU, that various minibuffer prompts
> become obscured by echo-area display of messages. So one possible
> solution is to modify the subroutines of 'message', e.g.,
> set=5Fmessage=5F1, to detect the conditions of the minibuffer being
> active, and insert the contents of the minibuffer into the echo-area
> buffer before the message text. Does anyone see problems with this=3F
>

I like this idea.

I think we don=E2=80=99t need many message-xxx like functions. Only =E2=80=
=99message=E2=80=99 is enough. And it should always check if minibuffer i=
s active and process it.

Is there cases where input prompt can be ignored and replaced=3F


--5df063f4_cc1016f_422
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageReplySection">=E5=9C=A8 2019=E5=B9=B412=E6=9C=8811=E6=
=97=A5 &#43;0800 AM12:36=EF=BC=8CEli Zaretskii &lt;eliz@HIDDEN&gt;=EF=BC=
=8C=E5=86=99=E9=81=93=EF=BC=9A<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">The original problem w=
as, AFAIU, that various minibuffer prompts<br>
become obscured by echo-area display of messages. So one possible<br>
solution is to modify the subroutines of 'message', e.g.,<br>
set_message_1, to detect the conditions of the minibuffer being<br>
active, and insert the contents of the minibuffer into the echo-area<br>
buffer before the message text. Does anyone see problems with this?<br>
<br></blockquote>
<div dir=3D"auto"><br></div>
I like this idea.
<div dir=3D"auto"><br></div>
<div dir=3D"auto">I think we don=E2=80=99t need many message-xxx like funct=
ions. Only =E2=80=99message=E2=80=99 is enough. And it should always check =
if minibuffer is active and process it.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">Is there cases where input prompt can be ignored and repl=
aced?</div>
<div dir=3D"auto"><br></div>
</div>
</body>
</html>

--5df063f4_cc1016f_422--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 11 Dec 2019 03:24:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 22:24:58 2019
Received: from localhost ([127.0.0.1]:56808 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iescU-0002er-7d
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 22:24:58 -0500
Received: from mail-oln040092255093.outbound.protection.outlook.com
 ([40.92.255.93]:52374 helo=APC01-HK2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1iescR-0002ec-RB
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 22:24:56 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=iJgRIYcSuGzu6+zJa194Cf2fyNUtqVxbSjnMJ9ePLq+LsiycWgSVxWrvlg62k3lY7xtBInkA+trXabYUx6NCOiOPck2kinEZkvVrETavIsJGX/nEIrWSFFOJNgoYhM53L2zE5au0G1oLAz0iCtEP0wojhYYcz0ayxYGuhXliOVlN9HfAu3HwtpQ7x/g7mmP4GrN+RrFG+lkI2AEjVvtNBKqt1JzhjEHcvoEcXVrm4uHigYP6cwBPWzKKdctJISDrlovKdzfc+MlZ4X0RjDMk5MP+ZQ9dS56kaz3F8YuXsKChKm7RZchf0DzQ46Hnz7dVbbPFgSeSWcAf40o0orxIdA==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=bXd7PikrLaXQjx+U9utBmos2n34yL3UEWx3po2UJYkw=;
 b=nTNiSBlLqKHzQ6o2yvc0bF9Mlw2EAqFi3Lx9t2G1JUiBFtqKqsI+M6lcSV3V/ukfMHIVzDrgUYEvc/N9k7jVIwfgQp7N8ZmEd9AeWrZXLFumBAFzfhL68R6ElYW3UUCZSa7gzDXVjeLSpZ/P+/+qY94/QjnEfkt+i3QmAbj04u8rfYGvI0dPo4RiI0k3QsUBfPJEPy6jTofA70tUro9koDseKMwmo0b8jkAITMRHGenCBRrwoTFvtJw4TKBM3qfq6DupeeEEEK94rSRcegQUoR5MipnpIGtATx0zyvj9X47iCrMUoFG8amkdrzqKfWHjKPFpqBrKUEg4UmqexZyNkw==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=bXd7PikrLaXQjx+U9utBmos2n34yL3UEWx3po2UJYkw=;
 b=q/+p21HV8pUC/bdTfRzd2VaSaro5EYZsBxZCUPlr0j/Rtjt67sC0z84Oe1u9dvaeje2p1+7JiQpiwmpxj+TAZS4tMOxLOlWPSociT452huzfjRfezJDcrfqjWyvhSLIWLgFz2VkRynYREZf/yv9h1Xz2PH6l1FvVhSwh1/RccLOTFDmvq6W5Wx2uMLvz5uzimViwQH77HI0NRY4aNcuEdHWGkk+tY+o/yGwyNOlU2rpZxdqwGhbbL4CsuKQoakxng87djIO5JHZ/uMXtOF9iHPonAu/CzgXCzSn7mli39z8R8X1hjyM/UsRNsjUaxJAQobQSFjB1X/wCMOdc3VdjGw==
Received: from PU1APC01FT013.eop-APC01.prod.protection.outlook.com
 (10.152.252.57) by PU1APC01HT097.eop-APC01.prod.protection.outlook.com
 (10.152.253.52) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2495.25; Wed, 11 Dec
 2019 03:24:46 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.252.56) by
 PU1APC01FT013.mail.protection.outlook.com (10.152.252.78) with Microsoft SMTP
 Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2495.25 via Frontend Transport; Wed, 11 Dec 2019 03:24:46 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:9A30A75E6B2B32EE9D9A0A9AE2BFF400433A8AAD1AAA03FEC6DCE3A78B4C358D;
 UpperCasedChecksum:9A29B6276A4358065EABA6151DA932A3EFFBB450A24FEFCE9C0908A7584C8F6E;
 SizeAsReceived:9252; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2538.012; Wed, 11 Dec 2019
 03:24:46 +0000
Date: Wed, 11 Dec 2019 11:24:37 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>, Eli Zaretskii
 <eliz@HIDDEN>
Message-ID: <PS1PR03MB3606FEDEF8FA6C432E89FCB0B75A0@HIDDEN>
In-Reply-To: <83eexcax6b.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: 5959a137-1114-4f8f-9401-bdc5dee67522@Spark
Content-Type: multipart/alternative; boundary="5df0617b_bf72b14_422"
X-ClientProxiedBy: HK2PR02CA0210.apcprd02.prod.outlook.com
 (2603:1096:201:20::22) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <5959a137-1114-4f8f-9401-bdc5dee67522@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.199.222.221) by
 HK2PR02CA0210.apcprd02.prod.outlook.com (2603:1096:201:20::22) with Microsoft
 SMTP Server (version=TLS1_2, cipher=) via Frontend Transport;
 Wed, 11 Dec 2019 03:24:45 +0000
X-Readdle-Message-ID: 5959a137-1114-4f8f-9401-bdc5dee67522@Spark
X-Microsoft-Original-Message-ID: <5959a137-1114-4f8f-9401-bdc5dee67522@Spark>
X-TMN: [8UTVnhdZvmWaHAdQxGiJsmrzGHUS9fDs]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 93d66e82-aeb2-4d33-bae1-08d77de9ac2c
X-MS-TrafficTypeDiagnostic: PU1APC01HT097:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: yUmu6CjzU9hxbLc9WYu5cSjcuAbzFiz87D6eQje0eXDI/lj/YEE1Irs7K1AHeMW6G5tmHrO6emQBaIiYwyyzAnW0dF6GI8mDQHvzbjWBUXgnJzWWfvJx4mtHg8VqwdA2fufG8GGcz6uYuQCBY3F9khXPG+8xn9e7PadDiUZczkH+LvN6C2BaV3BkCJdC6jOL
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 93d66e82-aeb2-4d33-bae1-08d77de9ac2c
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 11 Dec 2019 03:24:46.8397 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: PU1APC01HT097
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5df0617b_bf72b14_422
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

=E5=9C=A8 2019=E5=B9=B412=E6=9C=8811=E6=97=A5 +0800 AM1:50=EF=BC=8CEli Za=
retskii <eliz=40gnu.org>=EF=BC=8C=E5=86=99=E9=81=93=EF=BC=9A
>
> If resize-mini-windows is nil, the result will be the same as with the
> current code, which calls minibuffer-message: the message is partially
> or completely invisible.
>
> > BTW, we should probably think about replacing =60message=60 with some=
thing
> > that lets the caller give more information about the intended behavio=
r
> > (e.g. to also solve the issue of several successive calls to message
> > resulting in the user only seeing the last message). Of course, this
> > would be for Emacs-28.
>
> Right.
>

Display combination of the prompt and the message is good but may be comp=
lex to implement it.
What about display message transiently and then restore to prompt=3F

I see the doc string of minibuffer-message-timeout says:

	How long to display an echo-area message when the minibuffer is active.
If the value is a number, it should be specified in seconds.
If the value is not a number, such messages never time out.

If minibuffer is active, the message will be displayed =C2=A0for a moment=
(like 1s) and then disappears.
If minibuffer is not active, the message will be displayed forever. I thi=
nk this is simpler and also good for me.

What is the problem of this behaviour=3F Is it easier to implement=3F



--5df0617b_bf72b14_422
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageReplySection">=E5=9C=A8 2019=E5=B9=B412=E6=9C=8811=E6=
=97=A5 &#43;0800 AM1:50=EF=BC=8CEli Zaretskii &lt;eliz@HIDDEN&gt;=EF=BC=8C=
=E5=86=99=E9=81=93=EF=BC=9A<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;"><br>
If resize-mini-windows is nil, the result will be the same as with the<br>
current code, which calls minibuffer-message: the message is partially<br>
or completely invisible.<br>
<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">BTW, we should probabl=
y think about replacing `message` with something<br>
that lets the caller give more information about the intended behavior<br>
(e.g. to also solve the issue of several successive calls to message<br>
resulting in the user only seeing the last message). Of course, this<br>
would be for Emacs-28.<br></blockquote>
<br>
Right.<br>
<br></blockquote>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">Display combination of the prompt and the message is good=
 but may be complex to implement it.</div>
<div dir=3D"auto">What about display message transiently and then restore t=
o prompt?</div>
<div dir=3D"auto"><br></div>
I see the doc string of minibuffer-message-timeout says:
<div dir=3D"auto"><br></div>
<blockquote style=3D"margin: 0 0 0 40px; border: none; padding: 0px;" class=
=3D"spark_indent">
<div dir=3D"auto">How long to display an echo-area message when the minibuf=
fer is active.</div>
<div dir=3D"auto">If the value is a number, it should be specified in secon=
ds.</div>
<div dir=3D"auto">If the value is not a number, such messages never time ou=
t.</div>
</blockquote>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">If minibuffer is active, the message will be displayed &n=
bsp;for a moment(like 1s) and then disappears.</div>
<div dir=3D"auto">If minibuffer is not active, the message will be displaye=
d forever. I think this is simpler and also good for me.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto">What is the problem of this behaviour? Is it easier to im=
plement?</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><br></div>
</div>
</body>
</html>

--5df0617b_bf72b14_422--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 23:56:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 18:56:48 2019
Received: from localhost ([127.0.0.1]:56737 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iepN2-00051a-4X
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 18:56:48 -0500
Received: from anteater.elm.relay.mailchannels.net ([23.83.212.3]:54577)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1iepN0-00051S-9Q
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 18:56:47 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id DF5F7581049;
 Tue, 10 Dec 2019 23:56:44 +0000 (UTC)
Received: from pdx1-sub0-mail-a28.g.dreamhost.com
 (100-96-86-154.trex.outbound.svc.cluster.local [100.96.86.154])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 5D622580EA8;
 Tue, 10 Dec 2019 23:56:44 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a28.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Tue, 10 Dec 2019 23:56:44 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Spicy-Illustrious: 71cc6a6464915d4e_1576022204613_3107338037
X-MC-Loop-Signature: 1576022204613:1090212378
X-MC-Ingress-Time: 1576022204613
Received: from pdx1-sub0-mail-a28.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a28.g.dreamhost.com (Postfix) with ESMTP id C9099A96DF;
 Tue, 10 Dec 2019 15:56:39 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=e2q4WWhGXaYqNof9+CL6lBx72wg=; b=
 QLCpYREng5KBgirLkk8+oCWqOAiCpcKNGiG7jSGATmSukrZ2qGQYT1db4JSrcKcp
 4ml/EHwJOlLUVYIBrS/Zgzz9i+Laq6YTzrAnLfl+1nR/AXjD+wfPPOa9UEcC1xdq
 +I/UWD6jwlkVEwPcz5tJ6PZyVFfUFthRbSPT47I7jCw=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a28.g.dreamhost.com (Postfix) with ESMTPSA id 5C0B1A9E89;
 Tue, 10 Dec 2019 15:56:36 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a28
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <83d0cwawst.fsf@HIDDEN>
Date: Wed, 11 Dec 2019 01:45:30 +0200
In-Reply-To: <83d0cwawst.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 10 Dec
 2019 19:57:06 +0200")
Message-ID: <871rtcf29h.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudelgedguddtucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedt
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, monnier@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> Btw, the current code on master also removes the overlays where
> icomplete shows the completion candidates.  You can try it:
>
>   . Evaluate:
>
>     (defun my-message ()
>       (interactive)
>       (message "my most important message"))
>     (global-set-key [f5] 'my-message)
>
>   . M-x icomplete-mode RET
>   . C-x C-f
>   . F5
>
> After "C-x C-f" the list of candidates will be displayed in the
> minibuffer; pressing F5 removes the list and shows the message
> instead.

That's not fair.  I fixed this already a week ago.
But you didn't allow me to install the fix.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 21:45:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 16:45:34 2019
Received: from localhost ([127.0.0.1]:56713 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ienK1-00011G-PD
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 16:45:33 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:57038)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ienK0-000111-8J
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 16:45:32 -0500
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 91DCD1009A5;
 Tue, 10 Dec 2019 16:45:26 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id D77151004A7;
 Tue, 10 Dec 2019 16:45:23 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1576014323;
 bh=C08Yev3AbtptQiIQQ3F8YRtSCcV7vx4QaiTgwlFiTOU=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=ORVlaG1erBk0vnfsrIF4StP0w1wSpPKnV+H/CFLWPAvTlXm87MTR0Yb0ib14LOCCw
 fn5tYZ6fNeRFp9bc04uqVKGDpYv+bQlfidUy4bxRBeJRErk9x8svgYvEI2dREHwJ81
 z90E06y5rbw8uw1YT5lwTHhlYWvgo1hOZqlLDDn3xEvpwjT0B3hwchoYQ9WFQxxEMa
 QGrra103ybbUbBthPOJW78q5TUVbdrtVgr6JOIGSL6dzs/OYjjj5DHqLxHvMzqW/Y5
 SmVZ41IMlzbox/4tHalzL/hUeees8MPdmo7/AmuNAKDHZR/weKEPs/mAwpMOVaghZK
 pvPKEBXRjiMbQ==
Received: from lechazo (lechon.iro.umontreal.ca [132.204.27.242])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id C7F421203A5;
 Tue, 10 Dec 2019 16:45:23 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
Message-ID: <jwvv9qnvox0.fsf-monnier+emacs@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <jwvimmovumi.fsf-monnier+emacs@HIDDEN>
 <83a780aqlj.fsf@HIDDEN>
Date: Tue, 10 Dec 2019 16:45:21 -0500
In-Reply-To: <83a780aqlj.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 10 Dec
 2019 22:11:04 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.012 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> With the current code (i.e. with minibuffer-message), if
>> resize-mini-windows is nil and the minibuffer is large enough to matter,
>> the message is still (partially) visible as long as the currently
>> displayed part of the minibuffer includes EOB, which is the usual case.
>> 
>> If we simply copy the minibuffer's content to the echo area without
>> preserving window-start, it will be more disruptive and will make it more
>> likely that the message isn't visible.
>
> There's some misunderstanding here: what I had in mind was to insert
> the minibuffer contents into the echo-area buffer, put the point after
> that, and then insert the text which 'message' was called to display.

Then I guess window-start may be changed by the redisplay to keep point
displayed, so I think that'll work fine.

> IOW, I don't understand why you are worried about window-start, since
> it should always be at point-min, and the mini-window should resize to
> show all the text.

The above was under the (explicit) assumption of resize-mini-windows
being nil.  There can be other cases where window-start isn't point-min
(e.g. if the minibuffer is too large to fit in the max size of the mini
window).

But no, I'm not worried about it ;-)


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 20:11:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 15:11:24 2019
Received: from localhost ([127.0.0.1]:56660 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ielqu-0006Pn-Ks
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 15:11:24 -0500
Received: from eggs.gnu.org ([209.51.188.92]:33919)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ielqs-0006PS-CQ
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 15:11:22 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59313)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ielqn-000653-1z; Tue, 10 Dec 2019 15:11:17 -0500
Received: from [176.228.60.248] (port=3262 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ielqm-0000YJ-4n; Tue, 10 Dec 2019 15:11:16 -0500
Date: Tue, 10 Dec 2019 22:11:04 +0200
Message-Id: <83a780aqlj.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-reply-to: <jwvimmovumi.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Tue, 10 Dec 2019 14:45:35 -0500)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN> <jwvimmovumi.fsf-monnier+emacs@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: juri@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Tue, 10 Dec 2019 14:45:35 -0500
> 
> With the current code (i.e. with minibuffer-message), if
> resize-mini-windows is nil and the minibuffer is large enough to matter,
> the message is still (partially) visible as long as the currently
> displayed part of the minibuffer includes EOB, which is the usual case.
> 
> If we simply copy the minibuffer's content to the echo area without
> preserving window-start, it will be more disruptive and will make it more
> likely that the message isn't visible.

There's some misunderstanding here: what I had in mind was to insert
the minibuffer contents into the echo-area buffer, put the point after
that, and then insert the text which 'message' was called to display.
With this, window-start will be at point-min of the echo-area buffer,
or am I missing something?

IOW, I don't understand why you are worried about window-start, since
it should always be at point-min, and the mini-window should resize to
show all the text.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 19:45:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 14:45:51 2019
Received: from localhost ([127.0.0.1]:56644 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ielSA-0005cX-UH
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 14:45:51 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:34396)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ielS9-0005cD-8S
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 14:45:49 -0500
Received: from pmg2.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id B1A6481E25;
 Tue, 10 Dec 2019 14:45:43 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg2.iro.umontreal.ca (Proxmox) with ESMTP id 92853812DF;
 Tue, 10 Dec 2019 14:45:41 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1576007141;
 bh=uI62YEpmITGWxglTBZ54PMXlhRzNN0l/RVITAHNE3ZU=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=iV5NiFOwqFwlIcUGUp/6tXp3zrAmEK+WTsVyHlIZYVrskdps7euS5N5L8xWJ0+rfE
 Hyfgnh7wtPSG2+RWFBAcmrYFbZjLqlLcB0XHcGF34u/pAjAhZlZgWy4EOY0tpaEYS1
 6X9r5Dy2jQSn8YGNFDPogQtB9x2SE48FjeO/5Nk0Nbuia6wCAC8kBH5TuAB9NjzGmQ
 tdKLU4L0gcnGIqWhpux2WEc0gGPrXgL4U3j/jUyeqckUWgdE0rnfCPgI0ZGZx1Txhn
 CUBOCSP7nsBOGpScx661AeTRbnJbKupMMSd9C9zm3X1COd+sGDVW3ku6J4yHvtpedH
 R/VFSdSQ6JUcA==
Received: from lechazo (lechon.iro.umontreal.ca [132.204.27.242])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id 5D9A3121180;
 Tue, 10 Dec 2019 14:45:41 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
Message-ID: <jwvimmovumi.fsf-monnier+emacs@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
Date: Tue, 10 Dec 2019 14:45:35 -0500
In-Reply-To: <83eexcax6b.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 10 Dec
 2019 19:49:00 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.009 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

>> I guess there could be some visible artifacts of this subterfuge in the
>> case where the minibuffer's content is currently affected by overlays
>> (since we presumably wouldn't copy those to the echo-area), but I'm not
>> sure this would be a real problem.
> We could copy the overlays, if that's important.

My gut feeling is that it's not important.

>> Another issue could be when the minibuffer is large, in which case we'll
>> want to try and preserve the window-start but also we'll want to make
>> sure the new message is visible.
> You mean, if resize-mini-windows is nil?

In any case where the window-start isn't point-min.
That can be due to resize-mini-windows being nil or any other reason.

> Otherwise, I see no problem.

I'm not terribly worried about it either.
I just mentioned it as a problem I could imagine coming up.

> If resize-mini-windows is nil, the result will be the same as with the
> current code, which calls minibuffer-message: the message is partially
> or completely invisible.

With the current code (i.e. with minibuffer-message), if
resize-mini-windows is nil and the minibuffer is large enough to matter,
the message is still (partially) visible as long as the currently
displayed part of the minibuffer includes EOB, which is the usual case.

If we simply copy the minibuffer's content to the echo area without
preserving window-start, it will be more disruptive and will make it more
likely that the message isn't visible.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 17:57:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:57:28 2019
Received: from localhost ([127.0.0.1]:56573 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iejlH-0002TS-Pp
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:57:28 -0500
Received: from eggs.gnu.org ([209.51.188.92]:42071)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iejlF-0002TF-JJ
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:57:25 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56826)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iejlA-0000eU-3e; Tue, 10 Dec 2019 12:57:20 -0500
Received: from [176.228.60.248] (port=3054 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iejl8-0002mf-5o; Tue, 10 Dec 2019 12:57:18 -0500
Date: Tue, 10 Dec 2019 19:57:06 +0200
Message-Id: <83d0cwawst.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: monnier@HIDDEN
In-reply-to: <83eexcax6b.fsf@HIDDEN> (message from Eli Zaretskii on Tue, 10
 Dec 2019 19:49:00 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
 <83eexcax6b.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 10 Dec 2019 19:49:00 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
> 
> > I guess there could be some visible artifacts of this subterfuge in the
> > case where the minibuffer's content is currently affected by overlays
> > (since we presumably wouldn't copy those to the echo-area), but I'm not
> > sure this would be a real problem.
> 
> We could copy the overlays, if that's important.

Btw, the current code on master also removes the overlays where
icomplete shows the completion candidates.  You can try it:

  . Evaluate:

    (defun my-message ()
      (interactive)
      (message "my most important message"))
    (global-set-key [f5] 'my-message)

  . M-x icomplete-mode RET
  . C-x C-f
  . F5

After "C-x C-f" the list of candidates will be displayed in the
minibuffer; pressing F5 removes the list and shows the message
instead.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 17:54:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:54:18 2019
Received: from localhost ([127.0.0.1]:56567 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iejiE-0002Oi-Ax
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:54:18 -0500
Received: from userp2130.oracle.com ([156.151.31.86]:46098)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1iejiB-0002O4-LY
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:54:16 -0500
Received: from pps.filterd (userp2130.oracle.com [127.0.0.1])
 by userp2130.oracle.com (8.16.0.27/8.16.0.27) with SMTP id xBAHruYJ120149;
 Tue, 10 Dec 2019 17:54:09 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2019-08-05;
 bh=yGRwXOjBghKcT/gPyYEVIt33pU8VmQhEiyAI2xofGn8=;
 b=kqLFckFKtNDFXtTr3oqQXJJvYirlnhr+6HgK/nmNjJJTfaNoBRwgUTWgyzVUc1gsmx1u
 Nn6ux81ejSEK1wOtfH3NnR52unPb5RYDkJCHehje1hqvgOc0hPgvrVJLlAw0EXsLZrMY
 Lcog0eaiJxBmbWatUfIeFSJ1X/klzUUf8t/5lLDOTzoo3KedkG4Ox6Aut+fD/ptDKDgI
 xzBRBn9ueDSIdjt6SFxmcFNrWI5fsxeh9oXkm9mq0HxtHKai4e3X3fVfFsju7LvowQtb
 bchs90ZGrrHXWjxSkyW2gveekB2jjRsV+upLNtW2nc5vpkKmHcGx6swa9461LbsdlxfQ fw== 
Received: from aserp3030.oracle.com (aserp3030.oracle.com [141.146.126.71])
 by userp2130.oracle.com with ESMTP id 2wrw4n4nha-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 10 Dec 2019 17:54:09 +0000
Received: from pps.filterd (aserp3030.oracle.com [127.0.0.1])
 by aserp3030.oracle.com (8.16.0.27/8.16.0.27) with SMTP id xBAHmH6g025049;
 Tue, 10 Dec 2019 17:52:09 GMT
Received: from userv0122.oracle.com (userv0122.oracle.com [156.151.31.75])
 by aserp3030.oracle.com with ESMTP id 2wt13dfpsj-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 10 Dec 2019 17:52:08 +0000
Received: from abhmp0009.oracle.com (abhmp0009.oracle.com [141.146.116.15])
 by userv0122.oracle.com (8.14.4/8.14.4) with ESMTP id xBAHq76O014478;
 Tue, 10 Dec 2019 17:52:07 GMT
MIME-Version: 1.0
Message-ID: <a546f51f-2172-40dc-ad02-e48e087d5ee2@default>
Date: Tue, 10 Dec 2019 09:52:06 -0800 (PST)
From: Drew Adams <drew.adams@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, HaiJun Zhang <netjune@HIDDEN>
Subject: RE: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <PS1PR03MB3606267CCD08725BFF6BEC85B75B0@HIDDEN>
 <83immob1p3.fsf@HIDDEN>
In-Reply-To: <83immob1p3.fsf@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4927.0 (x86)]
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9467
 signatures=668685
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=564
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1911140001 definitions=main-1912100151
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9467
 signatures=668685
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0
 priorityscore=1501 malwarescore=0
 suspectscore=0 phishscore=0 bulkscore=0 spamscore=0 clxscore=1015
 lowpriorityscore=0 mlxscore=0 impostorscore=0 mlxlogscore=624 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.0.1-1911140001
 definitions=main-1912100152
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> There's no need for something as drastic as C-g.  You could instead
> press left-arrow, for example, or some other similarly harmless key.

Yes.  It might be good to (somewhere) point
this out in the Emacs manual.  Some aspects
of (useful) minibuffer interaction might not
be obvious.

> No one argues against fixing this annoyance.  But the fix should not
> cause more problems than the problem it fixes, and it should not
> change behavior in incompatible ways. In addition, we want to start
> the Emacs 27 release cycle soon, so we don't want invasive changes in
> infrastructure used all over the place.

+1




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 17:54:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:54:13 2019
Received: from localhost ([127.0.0.1]:56563 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieji8-0002OK-Vb
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:54:13 -0500
Received: from aserp2120.oracle.com ([141.146.126.78]:48976)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1ieji6-0002Nu-8G
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:54:10 -0500
Received: from pps.filterd (aserp2120.oracle.com [127.0.0.1])
 by aserp2120.oracle.com (8.16.0.27/8.16.0.27) with SMTP id xBAHs3QJ107997;
 Tue, 10 Dec 2019 17:54:03 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2019-08-05;
 bh=rw+5s7aVwQEW2PLbJUZkVITbO6CHLRpet0re0FKAoOI=;
 b=nyBF5wS0GCE8eGihPjO2S9dlM/WT1Z1Be9XlJ0QofB55N4QYMwiFehjnMle5RHbCWV1/
 JaGrG07kIn03zQgvs1k7TgjsagRlR9LdNGbKge6UirXpb4AI9Yc0hdOfMzLS4hla992a
 M8rCcAG4p97syzJntwy4AVqYwZK2RA0lxkn0AuChIC4aBrgI068QF8czY24ie7JJBRN8
 QvhcVm2myJS8mv1SSVztBKkbR2NUuepmwtwkXbf57yZETvL0TJl1k2wjKp6EwaPQ1RRB
 ecWFReeZdny0sPtMSpScevLX9n2Bfmz2+RTvpgJXMNBF9Hn0Bt4zF1AGnGUviuDTvBm8 UQ== 
Received: from aserp3020.oracle.com (aserp3020.oracle.com [141.146.126.70])
 by aserp2120.oracle.com with ESMTP id 2wr41q7um0-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 10 Dec 2019 17:54:03 +0000
Received: from pps.filterd (aserp3020.oracle.com [127.0.0.1])
 by aserp3020.oracle.com (8.16.0.27/8.16.0.27) with SMTP id xBAHs0mH045168;
 Tue, 10 Dec 2019 17:54:03 GMT
Received: from aserv0121.oracle.com (aserv0121.oracle.com [141.146.126.235])
 by aserp3020.oracle.com with ESMTP id 2wt6bcwkhs-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 10 Dec 2019 17:54:00 +0000
Received: from abhmp0009.oracle.com (abhmp0009.oracle.com [141.146.116.15])
 by aserv0121.oracle.com (8.14.4/8.13.8) with ESMTP id xBAHrN9r014965;
 Tue, 10 Dec 2019 17:53:23 GMT
MIME-Version: 1.0
Message-ID: <543d065c-9ee7-44bf-9fa5-99b7449c3498@default>
Date: Tue, 10 Dec 2019 09:53:22 -0800 (PST)
From: Drew Adams <drew.adams@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>, juri@HIDDEN, Stefan Monnier
 <monnier@HIDDEN>
Subject: RE: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <<8736e3vve8.fsf@HIDDEN>> <<8736e2coyv.fsf@HIDDEN>>
 <<83y2vujd0y.fsf@HIDDEN>> <<87blspm0sm.fsf@HIDDEN>>
 <<837e3ckbem.fsf@HIDDEN>> <<871rtjn0kt.fsf@HIDDEN>>
 <<83lfrrigj8.fsf@HIDDEN>> <<87eexiqps5.fsf@HIDDEN>>
 <<83lfrphp94.fsf@HIDDEN>> <<87wob7g2jk.fsf@HIDDEN>>
 <<83k177ebs0.fsf@HIDDEN>> <<AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>>
 <<87muc27prn.fsf@HIDDEN>> <<83tv6acgq5.fsf@HIDDEN>>
 <<87eexdoygh.fsf@HIDDEN>> <<83tv68c0nb.fsf@HIDDEN>>
 <<83h828b0lz.fsf@HIDDEN>>
In-Reply-To: <<83h828b0lz.fsf@HIDDEN>>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4927.0 (x86)]
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9467
 signatures=668685
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=999
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1911140001 definitions=main-1912100152
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9467
 signatures=668685
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0
 priorityscore=1501 malwarescore=0
 suspectscore=0 phishscore=0 bulkscore=0 spamscore=0 clxscore=1015
 lowpriorityscore=0 mlxscore=0 impostorscore=0 mlxlogscore=999 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.0.1-1911140001
 definitions=main-1912100152
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Actually, the more I think about this the less I like the idea of
> calling minibuffer-message instead of 'message' under some
> circumstances, any circumstances.  minibuffer-message is meant for
> very different use case: temporarily displaying a message for a short
> time.  The messages it displays are usually ephemeral and dispensable;
> if the user misses such a message, no big deal.
>=20
> By contrast, 'message' is used for similar use cases, but also for
> radically different ones, including those where several related
> messages are displayed in quick succession (a notable example is
> "Foo..." followed by "Foo...done"), or where a message is left in the
> echo area indefinitely if no input event arrives.  Crucially, Lisp
> programs do not tell 'message' which use case is required; instead,
> the following calls to 'message' or other events produce the required
> effects.  To produce the same effect with minibuffer-message will
> require too many changes all over the place.
>=20
> So I think it is simply wrong to call minibuffer-message instead of
> 'message'.  There are too many different behavior aspects.  Several
> examples were already given, including debug-on-message.  One other
> aspect that I just bumped into is recording messages in the *Messages*
> buffer: minibuffer-message never did that, until a recent (and
> undocumented) change, also related to attempts to fix messages
> overwriting y-or-n-p prompts, so now we have one more incompatible
> change in minibuffer-message's behavior waiting to bite us down the
> road.
>=20
> Therefore, I suggest to take a step back and discuss a better solution
> for these problems.

+1

I couldn't agree more.  In fact, I said
all of that in earlier messages here.

> The original problem was, AFAIU, that various minibuffer prompts
> become obscured by echo-area display of messages.  So one possible
> solution is to modify the subroutines of 'message', e.g.,
> set_message_1, to detect the conditions of the minibuffer being
> active, and insert the contents of the minibuffer into the echo-area
> buffer before the message text. Does anyone see problems with this?

I don't think that's a great approach.  It's
not about whether the minibuffer is active.

As a useful first approximation for approaching
these problems, perhaps just assume that the
minibuffer is _always_ active.  There's always
the possibility that some minibuffer interaction
is in progress.

Now, how to deal with some other interaction
that (fairly) wants to jump in and interrupt?

That's the question - whether that's a report
from an async process or a new confirmation
dialog, or whatever.

In general, I think such other interactions
should be the focus of our fixes.  For any
such: should it maybe be modal?  Should it
maybe report elsewhere (e.g. in some popup
buffer)?  Does it need to be logged, and if
so should that maybe be elsewhere than in
`*Messages*'?

Focusing on reports by async operations and
dialogs (e.g. confirmation dialogs) that
either should be modal or should happen
otherwise than by simply reading a key/char,
would be a good start, I think.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 17:54:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:54:10 2019
Received: from localhost ([127.0.0.1]:56561 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieji6-0002O6-Dl
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:54:10 -0500
Received: from aserp2120.oracle.com ([141.146.126.78]:48920)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <drew.adams@HIDDEN>) id 1ieji4-0002Nr-NM
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:54:09 -0500
Received: from pps.filterd (aserp2120.oracle.com [127.0.0.1])
 by aserp2120.oracle.com (8.16.0.27/8.16.0.27) with SMTP id xBAHs0gO107912;
 Tue, 10 Dec 2019 17:54:03 GMT
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=oracle.com;
 h=mime-version :
 message-id : date : from : sender : to : cc : subject : references :
 in-reply-to : content-type : content-transfer-encoding; s=corp-2019-08-05;
 bh=hL5gSeDugyOzMZXbzoPVftPicHbB4y3yOEree0JDo1A=;
 b=D4CavB+2Sx3DEz7j1nwNe5t6zQODJP64u867GWylWOCfIoJ6l59AoynIox51lYsdFZ8y
 b6J6kuDb8IPwCp7T7Dgk5yWORlqwPRYLTJRBnHMzDVriDxNVEMAxhtpYWCx89hLGYXQi
 5W07r/CK7C+Q+0qav0pUmV+RpuSRjVJjBixgrHtVXHK1xvorXQMEEY6e5vjNykqU8Ohg
 yzP8jhpamOF5nXDeVf0ZPifCsC/62XA3MCLoC3QhhdAF7O6wJcu9pZpyn50QFKvU8AaC
 AVab88K8xM/1dhgHmqYyktC6JVZx2KgdlpGDgVVkvZv9L9qS8CeRlwBVbtey+6kkD36H Tg== 
Received: from userp3020.oracle.com (userp3020.oracle.com [156.151.31.79])
 by aserp2120.oracle.com with ESMTP id 2wr41q7ukp-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 10 Dec 2019 17:54:02 +0000
Received: from pps.filterd (userp3020.oracle.com [127.0.0.1])
 by userp3020.oracle.com (8.16.0.27/8.16.0.27) with SMTP id xBAHmef0024036;
 Tue, 10 Dec 2019 17:52:02 GMT
Received: from userv0121.oracle.com (userv0121.oracle.com [156.151.31.72])
 by userp3020.oracle.com with ESMTP id 2wte9admcv-1
 (version=TLSv1.2 cipher=ECDHE-RSA-AES256-GCM-SHA384 bits=256 verify=OK);
 Tue, 10 Dec 2019 17:52:01 +0000
Received: from abhmp0009.oracle.com (abhmp0009.oracle.com [141.146.116.15])
 by userv0121.oracle.com (8.14.4/8.13.8) with ESMTP id xBAHq0Vv020197;
 Tue, 10 Dec 2019 17:52:00 GMT
MIME-Version: 1.0
Message-ID: <22c4d2d5-be81-471e-a521-4756d08f0c16@default>
Date: Tue, 10 Dec 2019 09:51:59 -0800 (PST)
From: Drew Adams <drew.adams@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>, Juri Linkov <juri@HIDDEN>, Eli
 Zaretskii <eliz@HIDDEN>
Subject: RE: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <PS1PR03MB3606267CCD08725BFF6BEC85B75B0@HIDDEN>
In-Reply-To: <PS1PR03MB3606267CCD08725BFF6BEC85B75B0@HIDDEN>
X-Priority: 3
X-Mailer: Oracle Beehive Extensions for Outlook 2.0.1.9.1  (1003210) [OL
 16.0.4927.0 (x86)]
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9467
 signatures=668685
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0 suspectscore=0
 malwarescore=0
 phishscore=0 bulkscore=0 spamscore=0 mlxscore=0 mlxlogscore=999
 adultscore=0 classifier=spam adjust=0 reason=mlx scancount=1
 engine=8.0.1-1911140001 definitions=main-1912100151
X-Proofpoint-Virus-Version: vendor=nai engine=6000 definitions=9467
 signatures=668685
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0
 priorityscore=1501 malwarescore=0
 suspectscore=0 phishscore=0 bulkscore=0 spamscore=0 clxscore=1011
 lowpriorityscore=0 mlxscore=0 impostorscore=0 mlxlogscore=999 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.0.1-1911140001
 definitions=main-1912100152
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> This is not a big problem. But minibuffer is a
> basic UI of emacs. If it always has these bugs,=20
> users may think that minibuffer is not a good=20
> design.

The minibuffer does _not_ "have these bugs".
The problem is not the minibuffer.

The problems are (1) asynchronous reporting
that simply fires off a `message' blindly and
(2) read-key interaction misused for important,
essentially modal dialog, which, if during a
minibuffer interaction, can be problematic.

Emacs should provide other, safer ways to
report status or impose a separate, modal
dialog - ways that don't interfere with the
minibuffer or the echo area.

`message-box' and similar might be a start.
But the behavior should be loggable, and it
should be manipulable by program in various
ways (prompting, whether modal, etc.), and
it should be customizable by users.

And developers should then be encouraged to
change any existing code that provides async
reporting or intermediate `y-or-n-p'-style
dialogs to use the new constructs.

At least those who use such things should be
made aware that if they interrupt ongoing
interactions then they can cause trouble.
___

And for the record, I disagree with simply
automatically converting `message' behavior
to `minibuffer-message' behavior in any
systematic way.

And I disagree with replacing `read-key'
behavior for code like `y-or-n-p' with
some read-from-the-minibuffer behavior in
any systematic way.

Some given uses of these things might be
misguided and could be switched to using
`minibuffer-message' - i.e., case by case.
I'm not against `minibuffer-message' - it
has its uses.  But its uses mainly involve
providing feedback about the ongoing
minibuffer interaction - not reporting an
outside event.

One of the demonstrations of the "dangerous
problem" was from Juri changing the value of
variable `dired-deletion-confirmer' (which
is _not_ a user option) from `yes-or-no-p'
to `y-or-n-p', and then pointing to a
resulting possible loss of user data.

Well, duh - don't do that.  That variable is
there presumably for possible use by code in
a context where the deletion dialog is sure,
and controlled in some way.

Many users seem to have chosen to just
replace `yes-or-no-p' with `y-or-n-p, e.g.
by aliasing.  I think this is a practice
that should be discouraged, or at least
shouldn't be encouraged.  Code that uses
`yes-or-no-p' should be able to depend on
its response not getting lost.  Blindly
substituting `y-or-n-p' is a bad idea, IMO.

Like the problem of async reporting, reading
a key/char can be problematic.  Emacs can
hopefully come up with additional ways,
better in some contexts, to prompt for a key
that reduce or eliminate the problem.  But
foregoing quick key/char reading by forcing
use of the minibuffer is a bad "fix".

Yes, there is a _real_ problem to be solved.
There may even be more than one problem.
(Async reporting is not the same as reading
a key/char.  The fixes are not necessarily
the same.)

But no, the one-size-fits-all approach taken
so far is not a good solution, IMO.

It screws the minibuffer - an editable
buffer allowing complex user interactions.

It screws with the difference, when using
the minibuffer, between (1) the behavior of
`message' (use the echo area, temporal
interruption dismissable by typing) and (2)
that of `minibuffer-message' (append output
to the minibuffer input, no interruption -
interfere spatially, not temporally).

Each of those, minibuffer-message' and
`message', has its particular uses and
behavior while the minibuffer is active.
And the various key/char-reading functions
also have their particular uses.  None of
these should be tossed or stifled.

Throwing all that to the wind, neutering
it with a one-size-fits-all behavior, is a
step backward.  We should fix the various
problems carefully - very carefully, and
in context.

Don't start with the supposition that the
minibuffer is the problem.  It's code that
interferes with a minibuffer interaction
that's the problem.

Whether, when, and how to interrupt an
existing dialog is the question.  The
answer is, "it depends".

Emacs should be able to let a minibuffer
interaction coexist safely with async
reporting or key/char reading - without
just stuffing in timeouts and tossing
everything into `minibuffer-message'.

In some cases an interaction (user dialog)
may need to be _modal_ - finish reading a
confirmation before allowing other action.
This is about such an interaction coming
about while another, minibuffer, dialog
already exists.

In other cases that's not necessary.  The
calling code that prompts for what should
be a modal interaction should DTRT.  It's
not up to another, minibuffer, interaction
to protect against such disruption.
___

Just one opinion - expressed in more detail
in this and some other bug threads.

The fact that this "fix" is spread over
several bug threads, dealing with different=20
problematic behaviors, is perhaps a sign
that this approach is not TRT.

And such a far-reaching change should, I
think, have been discussed in emacs-devel.

Instead, in these bug threads we've been
told that this is only a minor, localized
change that will not affect 3rd-party code.
That does _not_ seem to be the case, and I
don't see how it could be.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 17:49:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:49:21 2019
Received: from localhost ([127.0.0.1]:56554 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iejdQ-0002HZ-QA
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:49:21 -0500
Received: from eggs.gnu.org ([209.51.188.92]:39626)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iejdO-0002HM-M0
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:49:19 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:56622)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iejdJ-0004ls-9t; Tue, 10 Dec 2019 12:49:13 -0500
Received: from [176.228.60.248] (port=2558 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iejdI-0001pJ-Gd; Tue, 10 Dec 2019 12:49:13 -0500
Date: Tue, 10 Dec 2019 19:49:00 +0200
Message-Id: <83eexcax6b.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stefan Monnier <monnier@HIDDEN>
In-reply-to: <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN> (message from Stefan
 Monnier on Tue, 10 Dec 2019 12:08:14 -0500)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN> <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: juri@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Tue, 10 Dec 2019 12:08:14 -0500
> 
> [ I presume that additionally from inserting the minibuffer's contents
>   we'd add some delimiters to clearly separate the message from the
>   minibuffer's contents.  ]

Something like minibuffer-message's "[..]", perhaps?

> I guess there could be some visible artifacts of this subterfuge in the
> case where the minibuffer's content is currently affected by overlays
> (since we presumably wouldn't copy those to the echo-area), but I'm not
> sure this would be a real problem.

We could copy the overlays, if that's important.

> Another issue could be when the minibuffer is large, in which case we'll
> want to try and preserve the window-start but also we'll want to make
> sure the new message is visible.

You mean, if resize-mini-windows is nil?  Otherwise, I see no problem.

If resize-mini-windows is nil, the result will be the same as with the
current code, which calls minibuffer-message: the message is partially
or completely invisible.

> BTW, we should probably think about replacing `message` with something
> that lets the caller give more information about the intended behavior
> (e.g. to also solve the issue of several successive calls to message
> resulting in the user only seeing the last message).  Of course, this
> would be for Emacs-28.

Right.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 17:08:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:08:26 2019
Received: from localhost ([127.0.0.1]:56509 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieizp-0001AO-Oi
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:08:25 -0500
Received: from mailscanner.iro.umontreal.ca ([132.204.25.50]:46102)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <monnier@HIDDEN>) id 1ieizo-00019x-5M
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:08:24 -0500
Received: from pmg1.iro.umontreal.ca (localhost.localdomain [127.0.0.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 5F145100791;
 Tue, 10 Dec 2019 12:08:18 -0500 (EST)
Received: from mail01.iro.umontreal.ca (unknown [172.31.2.1])
 by pmg1.iro.umontreal.ca (Proxmox) with ESMTP id 2F16D1003B1;
 Tue, 10 Dec 2019 12:08:16 -0500 (EST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=iro.umontreal.ca;
 s=mail; t=1575997696;
 bh=fiaLDX+FXLwHcV1C5B3iNq0cLa0UxEGD0Nm2R3uEeMY=;
 h=From:To:Cc:Subject:References:Date:In-Reply-To:From;
 b=NyzJvVSGhw1Y5s7U4T2ae4VwVkDztO/f+VZtJd8BNy4ltiPd68T8YHuuqPdGBu0Oq
 4h0wlK8E1dl21OpU+CKt0dziL/+e5lz/CclBWLyIpGB1u9VrFd7ubIbbbqUy873WGC
 nwvxiqlApA5i17XnHglnQctoZ0inzy5EMqu8VNqAf7s06e8pV0EkYUZFWYtRWPflR5
 OnsDoKqJTQW63gyK8akbG2NKboJLFbgD5d2eBX9EPWkiqTCilSpjvyCDTjoVuJ3alJ
 Zd0TXy6YtjejAs9DLdIx5yzRBgoO+w2yDzbEAEzJ81UkhYceyX5JDSRgOkJOyEDthX
 Agt0fT0WQkL/g==
Received: from alfajor (modemcable157.163-203-24.mc.videotron.ca
 [24.203.163.157])
 by mail01.iro.umontreal.ca (Postfix) with ESMTPSA id D8D6B121355;
 Tue, 10 Dec 2019 12:08:15 -0500 (EST)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Message-ID: <jwvy2vkrue0.fsf-monnier+emacs@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
 <83h828b0lz.fsf@HIDDEN>
Date: Tue, 10 Dec 2019 12:08:14 -0500
In-Reply-To: <83h828b0lz.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 10 Dec
 2019 18:34:48 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-SPAM-INFO: Spam detection results:  0
 ALL_TRUSTED                -1 Passed through trusted hosts only via SMTP
 AWL 0.032 Adjusted score from AWL reputation of From: address
 BAYES_00                 -1.9 Bayes spam probability is 0 to 1%
 DKIM_SIGNED               0.1 Message has a DKIM or DK signature,
 not necessarily valid
 DKIM_VALID -0.1 Message has at least one valid DKIM or DK signature
 DKIM_VALID_AU -0.1 Message has a valid DKIM or DK signature from author's
 domain
X-SPAM-LEVEL: 
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> The original problem was, AFAIU, that various minibuffer prompts
> become obscured by echo-area display of messages.  So one possible
> solution is to modify the subroutines of 'message', e.g.,
> set_message_1, to detect the conditions of the minibuffer being
> active, and insert the contents of the minibuffer into the echo-area
> buffer before the message text.

Ha!  Clever!

> Does anyone see problems with this?

[ I presume that additionally from inserting the minibuffer's contents
  we'd add some delimiters to clearly separate the message from the
  minibuffer's contents.  ]

I guess there could be some visible artifacts of this subterfuge in the
case where the minibuffer's content is currently affected by overlays
(since we presumably wouldn't copy those to the echo-area), but I'm not
sure this would be a real problem.

One such case of overlays is when icomplete-mode is enabled, and it
would simply temporarily hide the completion-list displayed by
icomplete-mode, which seems quite harmless or maybe even beneficial.

Another issue could be when the minibuffer is large, in which case we'll
want to try and preserve the window-start but also we'll want to make
sure the new message is visible.

BTW, we should probably think about replacing `message` with something
that lets the caller give more information about the intended behavior
(e.g. to also solve the issue of several successive calls to message
resulting in the user only seeing the last message).  Of course, this
would be for Emacs-28.


        Stefan





Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 16:35:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 11:35:08 2019
Received: from localhost ([127.0.0.1]:56461 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieiTc-0008L5-4F
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 11:35:08 -0500
Received: from eggs.gnu.org ([209.51.188.92]:47699)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ieiTa-0008Ka-UK
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 11:35:07 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54920)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ieiTV-0001Vz-EA; Tue, 10 Dec 2019 11:35:01 -0500
Received: from [176.228.60.248] (port=1886 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ieiTU-0000Na-Iu; Tue, 10 Dec 2019 11:35:01 -0500
Date: Tue, 10 Dec 2019 18:34:48 +0200
Message-Id: <83h828b0lz.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: juri@HIDDEN, Stefan Monnier <monnier@HIDDEN>
In-reply-to: <83tv68c0nb.fsf@HIDDEN> (message from Eli Zaretskii on Tue, 10
 Dec 2019 05:36:24 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 10 Dec 2019 05:36:24 +0200
> From: Eli Zaretskii <eliz@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
> 
> > > I don't see how this is a "hack" when it uses the same technique as
> > > your changes in 'message': checking a variable that is bound by other
> > > functions.  The advantage of my proposal is that it makes the new
> > > functionality opt-in, so that any commands which need this could have
> > > it by simply binding a variable, and would otherwise maintain its old
> > > behavior, which was there for eons.
> > 
> > Such variable already exists.  It's called message-in-echo-area.
> > You can enable it in the release branch if you want.
> > But then please reopen bug#34614, bug#19064, bug#17272, bug#446.
> 
> Sorry, I don't understand the proposal.  How will this variable help
> if we leave the current code in 'message' as it is?  And what do you
> mean by "enabling" message-in-echo-area?

Actually, the more I think about this the less I like the idea of
calling minibuffer-message instead of 'message' under some
circumstances, any circumstances.  minibuffer-message is meant for
very different use case: temporarily displaying a message for a short
time.  The messages it displays are usually ephemeral and dispensable;
if the user misses such a message, no big deal.

By contrast, 'message' is used for similar use cases, but also for
radically different ones, including those where several related
messages are displayed in quick succession (a notable example is
"Foo..." followed by "Foo...done"), or where a message is left in the
echo area indefinitely if no input event arrives.  Crucially, Lisp
programs do not tell 'message' which use case is required; instead,
the following calls to 'message' or other events produce the required
effects.  To produce the same effect with minibuffer-message will
require too many changes all over the place.

So I think it is simply wrong to call minibuffer-message instead of
'message'.  There are too many different behavior aspects.  Several
examples were already given, including debug-on-message.  One other
aspect that I just bumped into is recording messages in the *Messages*
buffer: minibuffer-message never did that, until a recent (and
undocumented) change, also related to attempts to fix messages
overwriting y-or-n-p prompts, so now we have one more incompatible
change in minibuffer-message's behavior waiting to bite us down the
road.

Therefore, I suggest to take a step back and discuss a better solution
for these problems.

The original problem was, AFAIU, that various minibuffer prompts
become obscured by echo-area display of messages.  So one possible
solution is to modify the subroutines of 'message', e.g.,
set_message_1, to detect the conditions of the minibuffer being
active, and insert the contents of the minibuffer into the echo-area
buffer before the message text.  Does anyone see problems with this?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 16:11:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 11:11:40 2019
Received: from localhost ([127.0.0.1]:56429 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iei6u-0007cR-53
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 11:11:40 -0500
Received: from eggs.gnu.org ([209.51.188.92]:41368)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1iei6s-0007cE-G4
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 11:11:38 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54354)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1iei6m-0007A6-U3; Tue, 10 Dec 2019 11:11:32 -0500
Received: from [176.228.60.248] (port=4402 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1iei6m-0006AA-6I; Tue, 10 Dec 2019 11:11:32 -0500
Date: Tue, 10 Dec 2019 18:11:20 +0200
Message-Id: <83immob1p3.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: HaiJun Zhang <netjune@HIDDEN>
In-reply-to: <PS1PR03MB3606267CCD08725BFF6BEC85B75B0@HIDDEN>
 (message from HaiJun Zhang on Tue, 10 Dec 2019 15:19:37 +0800)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN> 
 <PS1PR03MB3606267CCD08725BFF6BEC85B75B0@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> Date: Tue, 10 Dec 2019 15:19:37 +0800
> From: HaiJun Zhang <netjune@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
> 
> I reported the bug #34614.
> 
> I meet the bug(#34614 like) everyday. One common scene: I push a commit with magit. And then open a file
> with C-xC-f, a message (“git finished.”) comes and replace the find-file prompt. I need to press C-g and
> C-xC-f again.

There's no need for something as drastic as C-g.  You could instead
press left-arrow, for example, or some other similarly harmless key.

> This is not a big problem. But minibuffer is a basic UI of emacs. If it always has these bugs, users may think
> that minibuffer is not a good design. 

No one argues against fixing this annoyance.  But the fix should not
cause more problems than the problem it fixes, and it should not
change behavior in incompatible ways.  In addition, we want to start
the Emacs 27 release cycle soon, so we don't want invasive changes in
infrastructure used all over the place.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 07:19:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 02:19:58 2019
Received: from localhost ([127.0.0.1]:54877 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieZoM-00054a-9g
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 02:19:58 -0500
Received: from mail-oln040092253096.outbound.protection.outlook.com
 ([40.92.253.96]:24803 helo=APC01-SG2-obe.outbound.protection.outlook.com)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <netjune@HIDDEN>) id 1ieZoJ-00054J-PL
 for 38457 <at> debbugs.gnu.org; Tue, 10 Dec 2019 02:19:57 -0500
ARC-Seal: i=1; a=rsa-sha256; s=arcselector9901; d=microsoft.com; cv=none;
 b=ABdluKNSYXQWnJZLfvX6jKvgnYeb/uvoPzlOXsW1Twe4iEBBaxpoAyHpRnUVzU/8BPFAAFXwUWt4b8wSc69LLq4onCCQwXEYblSaHv4mnT8n+H71FjyxzqMLCYjnOZutQNXYEBVi4/P6AQSv3sFkUOmE91udATimf2LiySNHAG8LZrMRCM+aT/JuRWTOtcp1KWnK8JCvaV+24BGEPMu60IDqSn1qO5Lymf0cSHos9+874un/Mbk8WIm4kIG7OgfZdQJDXMWHFJDKzjdpGIxweqCe6DyunoExaLa1lzjhDMe8BfFU+W6J8H835qn2f8eBrnGwHbkME1bzV9NPYhTxvg==
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=microsoft.com; 
 s=arcselector9901;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=YDnJnvTN3HNGFlO94wFrmqAD4niBX/Cv1onVM0X4zOk=;
 b=Qv22vTZGeW28DgS3Ygc9PQoPJ+iEjCdSx5cr8drZucJCXuJYYiZSwgDDckbt5YDwoJao2WrBZTcFUyIy6HHMND1hnAR1BzTLgf4lK617Pdun7BLCQL2k6ntqeRq+hiTNsH5DhgPIX0aavu1PnTH6GY8UNcIYEmSi2NIxU93CFO6ecJbiQDuTnbL66UfBSAATek5bGDf5sRyJh9HtOS5TOyOuTLof/G4wgfW+NtXvs2joXvhzx7e301b1aB+xIf01rkT5hM8unBwDRnK8CN0REDE/VMFF8BpPsrawrrtIgTeulV1nJbz0oahLS5VWtsP5PrFo1sLi5I6NhxER6SSU6A==
ARC-Authentication-Results: i=1; mx.microsoft.com 1; spf=pass
 smtp.mailfrom=outlook.com; dmarc=pass action=none header.from=outlook.com;
 dkim=pass header.d=outlook.com; arc=none
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=outlook.com;
 s=selector1;
 h=From:Date:Subject:Message-ID:Content-Type:MIME-Version:X-MS-Exchange-SenderADCheck;
 bh=YDnJnvTN3HNGFlO94wFrmqAD4niBX/Cv1onVM0X4zOk=;
 b=O953wv5oyFN5tEMfolTfQyTLFzFG68AdawnrwVW39yzz8kF2nw6Ire+2sFSHgVtVcVpv5SsUbRYDE1jftiuHSxvqkgzcqKqa8au2k9jJLQbrfYNrfipKPdjwhs7s0FUvXduvfYJ/cp9JeYFIfDSDtOo7wfB6GwFfu6gJwjlqnNKHJxRM5cSvLmUAJG5wZnXZ88kn0mKNPXacw6+996Qww2qktr/xxWKa2h4AJijdOJDuvBddC830wSznnHke/ApYItUeozbI5hOXZETX4UFwdhqlWJgoaK/38JGiszQ0Qlb8o/edoAHYYDT1TgxcGbArhNnKZSIy35E+XmQeZb6zzA==
Received: from SG2APC01FT042.eop-APC01.prod.protection.outlook.com
 (10.152.250.53) by SG2APC01HT237.eop-APC01.prod.protection.outlook.com
 (10.152.251.202) with Microsoft SMTP Server (version=TLS1_2,
 cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id 15.20.2495.25; Tue, 10 Dec
 2019 07:19:47 +0000
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com (10.152.250.55) by
 SG2APC01FT042.mail.protection.outlook.com (10.152.251.18) with Microsoft SMTP
 Server (version=TLS1_2, cipher=TLS_ECDHE_RSA_WITH_AES_256_GCM_SHA384) id
 15.20.2495.25 via Frontend Transport; Tue, 10 Dec 2019 07:19:47 +0000
X-IncomingTopHeaderMarker: OriginalChecksum:C66E2833AD6FD30D461AEBACAC36EFFD97EDF7504E4E9F35B08551D50E03FDD1;
 UpperCasedChecksum:EBFE4E7958FCDC52C66FCF2653B0F5FC9EBF5CF575C4ADFC56B7C41EB5CB4BCD;
 SizeAsReceived:9143; Count:48
Received: from PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4]) by PS1PR03MB3606.apcprd03.prod.outlook.com
 ([fe80::b05a:28e4:205a:d7d4%5]) with mapi id 15.20.2538.012; Tue, 10 Dec 2019
 07:19:47 +0000
Date: Tue, 10 Dec 2019 15:19:37 +0800
From: HaiJun Zhang <netjune@HIDDEN>
To: Juri Linkov <juri@HIDDEN>, Eli Zaretskii <eliz@HIDDEN>
Message-ID: <PS1PR03MB3606267CCD08725BFF6BEC85B75B0@HIDDEN>
In-Reply-To: <83tv68c0nb.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN> <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN> <83tv68c0nb.fsf@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to
 message change
X-Readdle-Message-ID: dfa4034b-22ce-4782-b042-48b5923fab6e@Spark
Content-Type: multipart/alternative; boundary="5def470e_580bd78f_422"
X-ClientProxiedBy: HK2PR02CA0130.apcprd02.prod.outlook.com
 (2603:1096:202:16::14) To PS1PR03MB3606.apcprd03.prod.outlook.com
 (2603:1096:803:4e::17)
X-Microsoft-Original-Message-ID: <dfa4034b-22ce-4782-b042-48b5923fab6e@Spark>
MIME-Version: 1.0
Received: from [192.168.1.103] (1.199.222.221) by
 HK2PR02CA0130.apcprd02.prod.outlook.com (2603:1096:202:16::14) with Microsoft
 SMTP Server (version=TLS1_2, cipher=) via Frontend Transport;
 Tue, 10 Dec 2019 07:19:45 +0000
X-Readdle-Message-ID: dfa4034b-22ce-4782-b042-48b5923fab6e@Spark
X-Microsoft-Original-Message-ID: <dfa4034b-22ce-4782-b042-48b5923fab6e@Spark>
X-TMN: [WMiLcTuvPa2dEUzQ0j6iCJzeX5nILV5l]
X-MS-PublicTrafficType: Email
X-IncomingHeaderCount: 48
X-EOPAttributedMessage: 0
X-MS-Office365-Filtering-Correlation-Id: 1eace4ee-8c85-48c9-f37a-08d77d4155e0
X-MS-TrafficTypeDiagnostic: SG2APC01HT237:
X-Microsoft-Antispam: BCL:0;
X-Microsoft-Antispam-Message-Info: 9Zo9jlzcTvc4nqR5Urj2VI8zBgtXFomiZYdL76BB1JHdX8PmLoWpY16d8XeL6DHELZMgYLFQe0YEzeoNmLb9FGW6t+e+ZU7xoEmJ7m7qeBRs6I/2Yj0I0tch4ghmi+28dMFZmIm5cfwF+iOHrIE5a5PRUvYt2fAJElkaI/e40F1Z9g2T7HFtSGIm7kDwDAkV
X-OriginatorOrg: outlook.com
X-MS-Exchange-CrossTenant-Network-Message-Id: 1eace4ee-8c85-48c9-f37a-08d77d4155e0
X-MS-Exchange-CrossTenant-OriginalArrivalTime: 10 Dec 2019 07:19:47.0122 (UTC)
X-MS-Exchange-CrossTenant-FromEntityHeader: Hosted
X-MS-Exchange-CrossTenant-Id: 84df9e7f-e9f6-40af-b435-aaaaaaaaaaaa
X-MS-Exchange-CrossTenant-FromEntityHeader: Internet
X-MS-Exchange-CrossTenant-RMS-PersistedConsumerOrg: 00000000-0000-0000-0000-000000000000
X-MS-Exchange-Transport-CrossTenantHeadersStamped: SG2APC01HT237
X-Spam-Score: 1.0 (+)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--5def470e_580bd78f_422
Content-Type: text/plain; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

I reported the bug=C2=A0=2334614.

I meet the bug(=2334614 like) everyday. One common scene: I push a commit=
 with magit. And then open a file with C-xC-f, a message (=E2=80=9Cgit fi=
nished.=E2=80=9D) comes and replace the find-file prompt. I need to press=
 C-g and C-xC-f again.

This is not a big problem. But minibuffer is a basic UI of emacs. If it a=
lways has these bugs, users may think that minibuffer is not a good desig=
n.

=E5=9C=A8 2019=E5=B9=B412=E6=9C=8810=E6=97=A5 +0800 AM11:37=EF=BC=8CEli Z=
aretskii <eliz=40gnu.org>=EF=BC=8C=E5=86=99=E9=81=93=EF=BC=9A
> > =46rom: Juri Linkov <juri=40linkov.net>
> > Cc: 38457=40debbugs.gnu.org, stephen.berman=40gmx.net
> > Date: Tue, 10 Dec 2019 01:45:18 +0200
> >
> > > And the original bug reports definitely were about y-or-n-p.
> >
> > bug=2334614 was not about y-or-n-p. It was about any command that use=
s
> > the minibuffer.
>
> I was talking about the 3 bug reports mentioned in the change's log.
>
> > > I don't see how this is a =22hack=22 when it uses the same techniqu=
e as
> > > your changes in 'message': checking a variable that is bound by oth=
er
> > > functions. The advantage of my proposal is that it makes the new
> > > functionality opt-in, so that any commands which need this could ha=
ve
> > > it by simply binding a variable, and would otherwise maintain its o=
ld
> > > behavior, which was there for eons.
> >
> > Such variable already exists. It's called message-in-echo-area.
> > You can enable it in the release branch if you want.
> > But then please reopen bug=2334614, bug=2319064, bug=2317272, bug=234=
46.
>
> Sorry, I don't understand the proposal. How will this variable help
> if we leave the current code in 'message' as it is=3F And what do you
> mean by =22enabling=22 message-in-echo-area=3F
>
> > > Type M-x, then press =465 =3D> the debugger doesn't start, although=
 the
> > > message appears that should have triggered the debugger.
> >
> > This is exactly the purpose of the pretest - you are testing a new fe=
ature
> > or a bug fix, then discover that some feature doesn't work, report it=
,
> > and the following patch implements the missing feature.
>
> I expect to see a lot of such problems, and consequently a lot of
> patches. More importantly, I expect quite a few of those to slip into
> the release. That's because minibuffer-message's behavior is very
> different from that of 'message', and these differences will bite us
> every turn for a long time.
>
> This is not the right way of fixing the problems with overwriting the
> prompts by messages. It will certainly prolong the pretest too much,
> and most probably leave some problems undiscovered and unsolved.
>
> > Looking at the recent log, there are many fixes in core functions
> > with potentially destabilizing changes still committed every day.
> > How fixes in minibuffer-message are different from other
> > more risky fixes in other core functions=3F
>
> They are much more risky because they are in an infrastructure used
> all over the place, and also because the method selected for
> displaying such messages by minibuffer-message changes the behavior in
> very significant ways, so it will certainly cause many unintended
> consequences.
>
> The patch below also changes the behavior of minibuffer-message wrt
> debug-on-message, doesn't it=3F If so, we cannot install it as shown.
>
> We must find a better solution for the original problems, or decide to
> postpone the solution till after Emacs 27. Please help me in this
> matter.
>
> Thanks.
>
>
>

--5def470e_580bd78f_422
Content-Type: text/html; charset="utf-8"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: inline

<html xmlns=3D"http://www.w3.org/1999/xhtml"><head>
<meta http-equiv=3D"Content-Type" content=3D"text/html; charset=3Dutf-8"><t=
itle></title>
</head>
<body>
<div name=3D"messageBodySection">
<div dir=3D"auto">I reported the bug&nbsp;<span style=3D"caret-color: rgb(3=
9, 39, 40);">#34614.</span></div>
<div dir=3D"auto"><span style=3D"caret-color: rgb(39, 39, 40);"><br></span>=
</div>
<div dir=3D"auto">I meet the bug(<u>#34614</u> like) everyday. One common s=
cene: I push a commit with magit. And then open a file with C-xC-f, a messa=
ge (=E2=80=9Cgit finished.=E2=80=9D) comes and replace the find-file prompt=
. I need to press C-g and C-xC-f again.</div>
<div dir=3D"auto"><br></div>
<div dir=3D"auto"><span style=3D"caret-color: rgb(39, 39, 40);">This is not=
 a big problem. But minibuffer is a basic UI of emacs. If it always has the=
se bugs, users may think that minibuffer is not a good design.</span>
<div dir=3D"auto" style=3D"caret-color: rgb(39, 39, 40);"><br></div>
</div>
</div>
<div name=3D"messageReplySection">=E5=9C=A8 2019=E5=B9=B412=E6=9C=8810=E6=
=97=A5 &#43;0800 AM11:37=EF=BC=8CEli Zaretskii &lt;eliz@HIDDEN&gt;=EF=BC=
=8C=E5=86=99=E9=81=93=EF=BC=9A<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #1abc9c;">
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">From: Juri Linkov &lt;=
juri@HIDDEN&gt;<br>
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN<br>
Date: Tue, 10 Dec 2019 01:45:18 &#43;0200<br>
<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #3498db;">And the original bug r=
eports definitely were about y-or-n-p.<br></blockquote>
<br>
bug#34614 was not about y-or-n-p. It was about any command that uses<br>
the minibuffer.<br></blockquote>
<br>
I was talking about the 3 bug reports mentioned in the change's log.<br>
<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #3498db;">I don't see how this i=
s a &quot;hack&quot; when it uses the same technique as<br>
your changes in 'message': checking a variable that is bound by other<br>
functions. The advantage of my proposal is that it makes the new<br>
functionality opt-in, so that any commands which need this could have<br>
it by simply binding a variable, and would otherwise maintain its old<br>
behavior, which was there for eons.<br></blockquote>
<br>
Such variable already exists. It's called message-in-echo-area.<br>
You can enable it in the release branch if you want.<br>
But then please reopen bug#34614, bug#19064, bug#17272, bug#446.<br></block=
quote>
<br>
Sorry, I don't understand the proposal. How will this variable help<br>
if we leave the current code in 'message' as it is? And what do you<br>
mean by &quot;enabling&quot; message-in-echo-area?<br>
<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #3498db;">Type M-x, then press F=
5 =3D&gt; the debugger doesn't start, although the<br>
message appears that should have triggered the debugger.<br></blockquote>
<br>
This is exactly the purpose of the pretest - you are testing a new feature<=
br>
or a bug fix, then discover that some feature doesn't work, report it,<br>
and the following patch implements the missing feature.<br></blockquote>
<br>
I expect to see a lot of such problems, and consequently a lot of<br>
patches. More importantly, I expect quite a few of those to slip into<br>
the release. That's because minibuffer-message's behavior is very<br>
different from that of 'message', and these differences will bite us<br>
every turn for a long time.<br>
<br>
This is not the right way of fixing the problems with overwriting the<br>
prompts by messages. It will certainly prolong the pretest too much,<br>
and most probably leave some problems undiscovered and unsolved.<br>
<br>
<blockquote type=3D"cite" class=3D"spark_quote" style=3D"margin: 5px 5px; p=
adding-left: 10px; border-left: thin solid #e67e22;">Looking at the recent =
log, there are many fixes in core functions<br>
with potentially destabilizing changes still committed every day.<br>
How fixes in minibuffer-message are different from other<br>
more risky fixes in other core functions?<br></blockquote>
<br>
They are much more risky because they are in an infrastructure used<br>
all over the place, and also because the method selected for<br>
displaying such messages by minibuffer-message changes the behavior in<br>
very significant ways, so it will certainly cause many unintended<br>
consequences.<br>
<br>
The patch below also changes the behavior of minibuffer-message wrt<br>
debug-on-message, doesn't it? If so, we cannot install it as shown.<br>
<br>
We must find a better solution for the original problems, or decide to<br>
postpone the solution till after Emacs 27. Please help me in this<br>
matter.<br>
<br>
Thanks.<br>
<br>
<br>
<br></blockquote>
</div>
</body>
</html>

--5def470e_580bd78f_422--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 10 Dec 2019 03:36:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 22:36:47 2019
Received: from localhost ([127.0.0.1]:54667 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieWKN-0002sC-5E
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 22:36:47 -0500
Received: from eggs.gnu.org ([209.51.188.92]:46822)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ieWKK-0002rz-ML
 for 38457 <at> debbugs.gnu.org; Mon, 09 Dec 2019 22:36:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45121)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ieWKE-0000vf-RW; Mon, 09 Dec 2019 22:36:38 -0500
Received: from [176.228.60.248] (port=2407 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ieWKE-00013T-8L; Mon, 09 Dec 2019 22:36:38 -0500
Date: Tue, 10 Dec 2019 05:36:24 +0200
Message-Id: <83tv68c0nb.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87eexdoygh.fsf@HIDDEN> (message from Juri Linkov on
 Tue, 10 Dec 2019 01:45:18 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87eexdoygh.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: 38457 <at> debbugs.gnu.org,  stephen.berman@HIDDEN
> Date: Tue, 10 Dec 2019 01:45:18 +0200
> 
> > And the original bug reports definitely were about y-or-n-p.
> 
> bug#34614 was not about y-or-n-p.  It was about any command that uses
> the minibuffer.

I was talking about the 3 bug reports mentioned in the change's log.

> > I don't see how this is a "hack" when it uses the same technique as
> > your changes in 'message': checking a variable that is bound by other
> > functions.  The advantage of my proposal is that it makes the new
> > functionality opt-in, so that any commands which need this could have
> > it by simply binding a variable, and would otherwise maintain its old
> > behavior, which was there for eons.
> 
> Such variable already exists.  It's called message-in-echo-area.
> You can enable it in the release branch if you want.
> But then please reopen bug#34614, bug#19064, bug#17272, bug#446.

Sorry, I don't understand the proposal.  How will this variable help
if we leave the current code in 'message' as it is?  And what do you
mean by "enabling" message-in-echo-area?

> >   Type M-x, then press F5 => the debugger doesn't start, although the
> >     message appears that should have triggered the debugger.
> 
> This is exactly the purpose of the pretest - you are testing a new feature
> or a bug fix, then discover that some feature doesn't work, report it,
> and the following patch implements the missing feature.

I expect to see a lot of such problems, and consequently a lot of
patches.  More importantly, I expect quite a few of those to slip into
the release.  That's because minibuffer-message's behavior is very
different from that of 'message', and these differences will bite us
every turn for a long time.

This is not the right way of fixing the problems with overwriting the
prompts by messages.  It will certainly prolong the pretest too much,
and most probably leave some problems undiscovered and unsolved.

> Looking at the recent log, there are many fixes in core functions
> with potentially destabilizing changes still committed every day.
> How fixes in minibuffer-message are different from other
> more risky fixes in other core functions?

They are much more risky because they are in an infrastructure used
all over the place, and also because the method selected for
displaying such messages by minibuffer-message changes the behavior in
very significant ways, so it will certainly cause many unintended
consequences.

The patch below also changes the behavior of minibuffer-message wrt
debug-on-message, doesn't it?  If so, we cannot install it as shown.

We must find a better solution for the original problems, or decide to
postpone the solution till after Emacs 27.  Please help me in this
matter.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 9 Dec 2019 23:55:23 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 18:55:23 2019
Received: from localhost ([127.0.0.1]:54584 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieSs7-00017S-6J
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 18:55:23 -0500
Received: from fossa.birch.relay.mailchannels.net ([23.83.209.62]:25971)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ieSs5-00017A-29
 for 38457 <at> debbugs.gnu.org; Mon, 09 Dec 2019 18:55:21 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id E5F102C0A3E;
 Mon,  9 Dec 2019 23:55:19 +0000 (UTC)
Received: from pdx1-sub0-mail-a95.g.dreamhost.com
 (100-96-92-172.trex.outbound.svc.cluster.local [100.96.92.172])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 692C02C0D46;
 Mon,  9 Dec 2019 23:55:19 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a95.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Mon, 09 Dec 2019 23:55:19 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Celery-Squirrel: 6ccc222773619cc9_1575935719711_2959410946
X-MC-Loop-Signature: 1575935719710:363169154
X-MC-Ingress-Time: 1575935719710
Received: from pdx1-sub0-mail-a95.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a95.g.dreamhost.com (Postfix) with ESMTP id 6F47A9BAE1;
 Mon,  9 Dec 2019 15:55:18 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=iRIdYBBKLesc7UP+0EXpi+shU6c=; b=
 mpxJIzaHyBAfSgCJKHomYCs0rB7Qo1U75NWru8PjhXwHnQe89zmrgms5BrNIl1GI
 6+i7hFDqKjHZrKyEVEgcN/bY3avMNpGTgmyfxueFp0IlRr9BBrLjCzEDVOb/nav8
 Diu6k0AR79kMgmloBUfkVW09M7AZbe84qUmVYT+OU44=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a95.g.dreamhost.com (Postfix) with ESMTPSA id 483569B61E;
 Mon,  9 Dec 2019 15:55:14 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a95
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
Date: Tue, 10 Dec 2019 01:45:18 +0200
In-Reply-To: <83tv6acgq5.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 09 Dec
 2019 05:36:50 +0200")
Message-ID: <87eexdoygh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudelvddgudduucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgesthdtredttdertdenucfhrhhomheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqeenucfkphepledurdduvdelrdeliedrgedvnecurfgrrhgrmhepmhhouggvpehsmhhtphdphhgvlhhopehmrghilhdrjhhurhhtrgdrohhrghdpihhnvghtpeeluddruddvledrleeirdegvddprhgvthhurhhnqdhprghthheplfhurhhiucfnihhnkhhovhcuoehjuhhriheslhhinhhkohhvrdhnvghtqedpmhgrihhlfhhrohhmpehjuhhriheslhhinhhkohhvrdhnvghtpdhnrhgtphhtthhopegvlhhiiiesghhnuhdrohhrghenucevlhhushhtvghrufhiiigvpedu
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> No, it was not only about y-or-n-p, but about any command that uses the minibuffer.
>
> As it turns out, not any command, because "M-x" and "C-x C-f" also use
> the minibuffer.
>
> And the original bug reports definitely were about y-or-n-p.

bug#34614 was not about y-or-n-p.  It was about any command that uses
the minibuffer.

> I don't see how this is a "hack" when it uses the same technique as
> your changes in 'message': checking a variable that is bound by other
> functions.  The advantage of my proposal is that it makes the new
> functionality opt-in, so that any commands which need this could have
> it by simply binding a variable, and would otherwise maintain its old
> behavior, which was there for eons.

Such variable already exists.  It's called message-in-echo-area.
You can enable it in the release branch if you want.
But then please reopen bug#34614, bug#19064, bug#17272, bug#446.

> Here's one more problem with the new behavior of 'message':
>
>   emacs -Q
>
>   Evaluate:
>
>   (defun my-mesage ()
>     (interactive)
>     (message "my most important message"))
>   (global-set-key [f5] 'my-mesage)
>   (setq debug-on-message "important")
>
>   Press F5, observe the debugger pop up, as expected.
>   Type C-] to exit the debugger.
>   Type M-x, then press F5 => the debugger doesn't start, although the
>     message appears that should have triggered the debugger.

This is exactly the purpose of the pretest - you are testing a new feature
or a bug fix, then discover that some feature doesn't work, report it,
and the following patch implements the missing feature.

Looking at the recent log, there are many fixes in core functions
with potentially destabilizing changes still committed every day.
How fixes in minibuffer-message are different from other
more risky fixes in other core functions?

diff --git a/lisp/minibuffer.el b/lisp/minibuffer.el
index 8af8aca30e..125a711b54 100644
--- a/lisp/minibuffer.el
+++ b/lisp/minibuffer.el
@@ -749,7 +749,11 @@ minibuffer-message
               (put-text-property 0 1 'cursor t message))
             (overlay-put ol 'after-string message)
             (sit-for (or minibuffer-message-timeout 1000000)))
-        (delete-overlay ol)))))
+        (delete-overlay ol)))
+    (when (and (stringp debug-on-message)
+               (stringp message)
+               (string-match-p debug-on-message message))
+      (debug message))))
 
 (defun minibuffer-completion-contents ()
   "Return the user input in a minibuffer before point as a string.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 9 Dec 2019 15:56:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 10:56:07 2019
Received: from localhost ([127.0.0.1]:54310 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieLOI-00077F-W0
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 10:56:07 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48128)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ieLOE-00076i-Ep
 for 38457 <at> debbugs.gnu.org; Mon, 09 Dec 2019 10:56:04 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34745)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ieLO8-0006O4-MN; Mon, 09 Dec 2019 10:55:56 -0500
Received: from [176.228.60.248] (port=3499 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ieLNy-0007EN-TE; Mon, 09 Dec 2019 10:55:47 -0500
Date: Mon, 09 Dec 2019 17:55:30 +0200
Message-Id: <8336dtcx3h.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: juri@HIDDEN
In-reply-to: <83d0cxd2fv.fsf@HIDDEN> (message from Eli Zaretskii on Mon, 09
 Dec 2019 16:00:04 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN> <83d0cxd2fv.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, larsi@HIDDEN, stephen.berman@HIDDEN, rms@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Here's one more problem with the new behavior of 'message':

  emacs -Q

  Evaluate:

  (defun my-mesage ()
    (interactive)
    (message "my most important message"))
  (global-set-key [f5] 'my-mesage)
  (setq debug-on-message "important")

  Press F5, observe the debugger pop up, as expected.
  Type C-] to exit the debugger.
  Type M-x, then press F5 => the debugger doesn't start, although the
    message appears that should have triggered the debugger.

The problem with dabbrev-expand and Tramp is similar, in that it stems
from the fact that 'message' leaves the text in the echo area until
the next keypress, whereas 'minibuffer-message' actively removes the
message before returning (instead of letting someone else remove it
when needed).

I think the more general underlying problem here is that
'minibuffer-message' behaves very differently from 'message'.  What we
need is to keep the original behavior of 'message', but teach it not
to overwrite the minibuffer contents under certain conditions.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 9 Dec 2019 14:00:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 09:00:47 2019
Received: from localhost ([127.0.0.1]:52800 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieJag-0002xW-NU
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:00:47 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50411)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ieJae-0002x3-PD
 for 38457 <at> debbugs.gnu.org; Mon, 09 Dec 2019 09:00:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33254)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ieJaY-00086q-Vz; Mon, 09 Dec 2019 09:00:39 -0500
Received: from [176.228.60.248] (port=4268 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ieJaG-0003eV-K2; Mon, 09 Dec 2019 09:00:25 -0500
Date: Mon, 09 Dec 2019 16:00:04 +0200
Message-Id: <83d0cxd2fv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Lars Ingebrigtsen <larsi@HIDDEN>
In-reply-to: <87r21eosfk.fsf@HIDDEN> (message from Lars Ingebrigtsen on Mon, 
 09 Dec 2019 08:43:11 +0100)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
 <87r21eosfk.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN,
 Richard Stallman <rms@HIDDEN>, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Lars Ingebrigtsen <larsi@HIDDEN>
> Cc: Juri Linkov <juri@HIDDEN>,  38457 <at> debbugs.gnu.org,
>   stephen.berman@HIDDEN
> Date: Mon, 09 Dec 2019 08:43:11 +0100
> 
> > As it turns out, not any command, because "M-x" and "C-x C-f" also use
> > the minibuffer.
> >
> > And the original bug reports definitely were about y-or-n-p.
> 
> That's true, but I think the way it works now is a huge improvement.
> Just about whatever I'm doing now, asynchronous messaging does not
> overwrite prompts/M-x actions, and that's really nice.
> 
> The bug reports may have been about y-or-n-p, but it's a general problem
> that's been solved in a general way now.  Reverting this would be a step
> in the wrong direction.

I didn't suggest to revert it, I suggested to modify it so that we
could selectively enable the feature where it doesn't have adverse
side effects.  By contrast, what we have now summarily enables the
feature for every use of the minibuffer, and we will then have to
somehow disable or augment it in every case where it does have adverse
side effects.  We already have 2 bug reports about it for 2 separate
packages, and we cannot leave them unsolved.  I'm sure this is just
the tip of a very large iceberg.

How do you propose we move forward?  You think we should install the
timer proposed by Juri instead?  That would make this change even more
invasive than it already is, and will again affect every use of the
minibuffer, and then some.  And I have no doubt that the delay in
removing the message is not the only side effect of the change in how
'message' now works, it's just the first one we noticed.  This is a
sure way to delay Emacs 27 even further.

We are developing Emacs 27 for more than 1.5 years.  We need to start
its release cycle very soon, and we should start from a stable code
base.  I have been asking people since July to avoid putting
destabilizing changes on master.  The change in 'message' destabilized
what we had before, and the proposed timer will destabilize it even
more.  How long do we want the Emacs 27.1 pretest to last? a year?
more?

We could also revert the change now and reapply it after the emacs-27
branch is cut.  That would mean the original use case with y-or-n-p
will not be fixed until Emacs 28.  Personally, I think it would be a
pity to leave that issue unsolved in Emacs 27, but if I cannot get us
to agree to any other solution, maybe that's what we should do.

More generally, I need everyone's help in making Emacs 27.1 happen
soon enough.  I cannot do it if people discount my gut feelings about
Emacs stability when those gut feelings are strong enough for me to
object to changes.  It's unfair to expect me to agree to something
when every bit of my experience screams that it's wrong.  If I cannot
get people to bear with me even on rare occasions when I have those
gut feelings, I guess I'm unfit for the job, and someone else should
take over.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 9 Dec 2019 07:43:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 02:43:24 2019
Received: from localhost ([127.0.0.1]:52548 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieDhU-0005nt-4m
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 02:43:24 -0500
Received: from quimby.gnus.org ([95.216.78.240]:49264)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1ieDhS-0005ne-Hk
 for 38457 <at> debbugs.gnu.org; Mon, 09 Dec 2019 02:43:22 -0500
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=marnie)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1ieDhI-0002po-MM; Mon, 09 Dec 2019 08:43:15 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN> <83tv6acgq5.fsf@HIDDEN>
Date: Mon, 09 Dec 2019 08:43:11 +0100
In-Reply-To: <83tv6acgq5.fsf@HIDDEN> (Eli Zaretskii's message of "Mon, 09 Dec
 2019 05:36:50 +0200")
Message-ID: <87r21eosfk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Eli Zaretskii <eliz@HIDDEN> writes: > As it turns out, not
 any command, because "M-x" and "C-x C-f" also use > the minibuffer. > > And
 the original bug reports definitely were about y-or-n-p. That's true, but
 I think the way it works now is a huge improvement. Just about whatever I'm
 doing now, asynchronous messaging does not overwrite prompts/M-x actions,
 and that's really nice. 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
 blocked.  See
 http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
 for more information. [URIs: gnu.org]
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN,
 Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

> As it turns out, not any command, because "M-x" and "C-x C-f" also use
> the minibuffer.
>
> And the original bug reports definitely were about y-or-n-p.

That's true, but I think the way it works now is a huge improvement.
Just about whatever I'm doing now, asynchronous messaging does not
overwrite prompts/M-x actions, and that's really nice.

The bug reports may have been about y-or-n-p, but it's a general problem
that's been solved in a general way now.  Reverting this would be a step
in the wrong direction.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 9 Dec 2019 03:37:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 22:37:17 2019
Received: from localhost ([127.0.0.1]:52476 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ie9rJ-0004Q2-4O
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 22:37:17 -0500
Received: from eggs.gnu.org ([209.51.188.92]:40267)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ie9rG-0004Po-P4
 for 38457 <at> debbugs.gnu.org; Sun, 08 Dec 2019 22:37:15 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:54461)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ie9rA-0001sN-Vh; Sun, 08 Dec 2019 22:37:09 -0500
Received: from [176.228.60.248] (port=2164 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ie9r8-00071R-Qb; Sun, 08 Dec 2019 22:37:08 -0500
Date: Mon, 09 Dec 2019 05:36:50 +0200
Message-Id: <83tv6acgq5.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87muc27prn.fsf@HIDDEN> (message from Juri Linkov on
 Sun, 08 Dec 2019 23:50:28 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
 <87muc27prn.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: bug-gnu-emacs@HIDDEN,  38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
> Date: Sun, 08 Dec 2019 23:50:28 +0200
> 
> > The original problem which the change in 'message' tried to solve, the one
> > reported in bugs #17272 and #19064, was about calling 'message' when
> > y-or-n-p is prompting the user.  So how about if we modify the conditions
> > under which 'message' calls 'minibuffer-message' such that this happens
> > only when y-or-n-p is in progress?  E.g., y-or-n-p could bind some variable
> > that 'message' would check.
> 
> No, it was not only about y-or-n-p, but about any command that uses the minibuffer.

As it turns out, not any command, because "M-x" and "C-x C-f" also use
the minibuffer.

And the original bug reports definitely were about y-or-n-p.

> > Maybe yes-or-no-p should do the same.
> >
> > This will allow us to fix the original bugs without such wide implications as we have now.
> >
> > And while at that, I don't think we need the new function message-on-echo-area; the additional logic could be added to 'message's original code.
> >
> > WDYT?
> 
> Inventing hacks and workarounds is too risky and error-prone
> than installing the proper and safest solution.

I don't see how this is a "hack" when it uses the same technique as
your changes in 'message': checking a variable that is bound by other
functions.  The advantage of my proposal is that it makes the new
functionality opt-in, so that any commands which need this could have
it by simply binding a variable, and would otherwise maintain its old
behavior, which was there for eons.

This issue is basically the only one that's left before we can cut the
release branch.  Please help me resolve this issue so that we could
start the pretest of Emacs 27.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 8 Dec 2019 21:56:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 16:56:46 2019
Received: from localhost ([127.0.0.1]:52343 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ie4Xl-0005xP-Rg
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 16:56:46 -0500
Received: from brown.birch.relay.mailchannels.net ([23.83.209.23]:34854)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ie4Xj-0005xE-MY
 for 38457 <at> debbugs.gnu.org; Sun, 08 Dec 2019 16:56:44 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 7DDC760072D;
 Sun,  8 Dec 2019 21:56:42 +0000 (UTC)
Received: from pdx1-sub0-mail-a35.g.dreamhost.com
 (100-96-6-199.trex.outbound.svc.cluster.local [100.96.6.199])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 02BC56006DE;
 Sun,  8 Dec 2019 21:56:41 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a35.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sun, 08 Dec 2019 21:56:42 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Celery-Harbor: 27df81ec23d0c4bc_1575842202312_2711376561
X-MC-Loop-Signature: 1575842202312:684504542
X-MC-Ingress-Time: 1575842202312
Received: from pdx1-sub0-mail-a35.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a35.g.dreamhost.com (Postfix) with ESMTP id B6B6681F1D;
 Sun,  8 Dec 2019 13:56:36 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type:content-transfer-encoding; s=linkov.net; bh=iHdF+O
 4426lfn5TrrKjf/D8Xmao=; b=jUXS3WpwLBdCoJmFb6VNxzfYUBqDRB2PIGSfuM
 maeWuxrEFAmCKHMbVUFOWMQIW1JyR+WbbNVuExc0gjsNMckYyYWnIj9WQMfBqI6D
 96NwIVoSUwR3R01hXRljJItSAzzPUNP8e4wRUWtWkjUkRjpRoglUfg4J7cpX2IUG
 XRTy4=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a35.g.dreamhost.com (Postfix) with ESMTPSA id 63F49A123C;
 Sun,  8 Dec 2019 13:56:33 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a35
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
Date: Sun, 08 Dec 2019 23:50:28 +0200
In-Reply-To: <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN> (Eli Zaretskii's
 message of "Sun, 08 Dec 2019 07:18:09 +0200")
Message-ID: <87muc27prn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > > I just suggested another possible solution: bind
>> > > 'minibuffer-message-timeout' to zero when calling
>> 'minibuffer-message'
>> > > from 'message'.  Would that work, or will it have some unwanted
>> side
>> > > effects?
>> >
>> > K=E9vin posted a patch that binds 'minibuffer-message-timeout' to
>> zero, but
>> > it makes each message disappear before the user has a chance to read
>> it.
>>
>> But that's how 'message' behaved as well, didn't it?
>
> In case the answer is NO, here's an alternative proposal.

Yes, the answer is NO.

> The original problem which the change in 'message' tried to solve, the =
one
> reported in bugs #17272 and #19064, was about calling 'message' when
> y-or-n-p is prompting the user.  So how about if we modify the conditio=
ns
> under which 'message' calls 'minibuffer-message' such that this happens
> only when y-or-n-p is in progress?  E.g., y-or-n-p could bind some vari=
able
> that 'message' would check.

No, it was not only about y-or-n-p, but about any command that uses the m=
inibuffer.

> Maybe yes-or-no-p should do the same.
>
> This will allow us to fix the original bugs without such wide implicati=
ons as we have now.
>
> And while at that, I don't think we need the new function message-on-ec=
ho-area; the additional logic could be added to 'message's original code.
>
> WDYT?

Inventing hacks and workarounds is too risky and error-prone
than installing the proper and safest solution.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Dec 2019 21:56:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 16:56:50 2019
Received: from localhost ([127.0.0.1]:52346 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ie4Xq-0005xj-8L
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 16:56:50 -0500
Received: from lists.gnu.org ([209.51.188.17]:33046)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ie4Xp-0005xd-Nr
 for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 16:56:49 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:44097)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <juri@HIDDEN>) id 1ie4Xn-0003Ox-LX
 for bug-gnu-emacs@HIDDEN; Sun, 08 Dec 2019 16:56:49 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,RCVD_IN_DNSWL_NONE,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <juri@HIDDEN>) id 1ie4Xl-0004Kt-NB
 for bug-gnu-emacs@HIDDEN; Sun, 08 Dec 2019 16:56:47 -0500
Received: from caracal.birch.relay.mailchannels.net ([23.83.209.30]:18842)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <juri@HIDDEN>)
 id 1ie4Xk-0004HQ-37; Sun, 08 Dec 2019 16:56:45 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 7DDC760072D;
 Sun,  8 Dec 2019 21:56:42 +0000 (UTC)
Received: from pdx1-sub0-mail-a35.g.dreamhost.com
 (100-96-6-199.trex.outbound.svc.cluster.local [100.96.6.199])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 02BC56006DE;
 Sun,  8 Dec 2019 21:56:41 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a35.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sun, 08 Dec 2019 21:56:42 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Celery-Harbor: 27df81ec23d0c4bc_1575842202312_2711376561
X-MC-Loop-Signature: 1575842202312:684504542
X-MC-Ingress-Time: 1575842202312
Received: from pdx1-sub0-mail-a35.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a35.g.dreamhost.com (Postfix) with ESMTP id B6B6681F1D;
 Sun,  8 Dec 2019 13:56:36 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type:content-transfer-encoding; s=linkov.net; bh=iHdF+O
 4426lfn5TrrKjf/D8Xmao=; b=jUXS3WpwLBdCoJmFb6VNxzfYUBqDRB2PIGSfuM
 maeWuxrEFAmCKHMbVUFOWMQIW1JyR+WbbNVuExc0gjsNMckYyYWnIj9WQMfBqI6D
 96NwIVoSUwR3R01hXRljJItSAzzPUNP8e4wRUWtWkjUkRjpRoglUfg4J7cpX2IUG
 XRTy4=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a35.g.dreamhost.com (Postfix) with ESMTPSA id 63F49A123C;
 Sun,  8 Dec 2019 13:56:33 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a35
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
 <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
Date: Sun, 08 Dec 2019 23:50:28 +0200
In-Reply-To: <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN> (Eli Zaretskii's
 message of "Sun, 08 Dec 2019 07:18:09 +0200")
Message-ID: <87muc27prn.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 23.83.209.30
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: 38457 <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

>> > > I just suggested another possible solution: bind
>> > > 'minibuffer-message-timeout' to zero when calling
>> 'minibuffer-message'
>> > > from 'message'.  Would that work, or will it have some unwanted
>> side
>> > > effects?
>> >
>> > K=E9vin posted a patch that binds 'minibuffer-message-timeout' to
>> zero, but
>> > it makes each message disappear before the user has a chance to read
>> it.
>>
>> But that's how 'message' behaved as well, didn't it?
>
> In case the answer is NO, here's an alternative proposal.

Yes, the answer is NO.

> The original problem which the change in 'message' tried to solve, the =
one
> reported in bugs #17272 and #19064, was about calling 'message' when
> y-or-n-p is prompting the user.  So how about if we modify the conditio=
ns
> under which 'message' calls 'minibuffer-message' such that this happens
> only when y-or-n-p is in progress?  E.g., y-or-n-p could bind some vari=
able
> that 'message' would check.

No, it was not only about y-or-n-p, but about any command that uses the m=
inibuffer.

> Maybe yes-or-no-p should do the same.
>
> This will allow us to fix the original bugs without such wide implicati=
ons as we have now.
>
> And while at that, I don't think we need the new function message-on-ec=
ho-area; the additional logic could be added to 'message's original code.
>
> WDYT?

Inventing hacks and workarounds is too risky and error-prone
than installing the proper and safest solution.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 8 Dec 2019 05:18:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 00:18:25 2019
Received: from localhost ([127.0.0.1]:50337 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idoxd-0007c1-3S
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 00:18:25 -0500
Received: from eggs.gnu.org ([209.51.188.92]:53067)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1idoxb-0007bY-GX
 for 38457 <at> debbugs.gnu.org; Sun, 08 Dec 2019 00:18:23 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41595)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1idoxT-0002sF-Qp; Sun, 08 Dec 2019 00:18:16 -0500
Received: from [109.253.218.96] (port=31850 helo=[10.134.197.159])
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1idoxS-0007O0-Vh; Sun, 08 Dec 2019 00:18:15 -0500
Date: Sun, 08 Dec 2019 07:18:09 +0200
User-Agent: K-9 Mail for Android
In-Reply-To: <83k177ebs0.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
 charset=utf-8
Content-Transfer-Encoding: quoted-printable
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
To: bug-gnu-emacs@HIDDEN,Juri Linkov <juri@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
Message-ID: <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On December 8, 2019 5:28:31 AM GMT+02:00, Eli Zaretskii <eliz@gnu=2Eorg> wr=
ote:
> > From: Juri Linkov <juri@linkov=2Enet>
> > Cc: stephen=2Eberman@gmx=2Enet,  38457@debbugs=2Egnu=2Eorg
> > Date: Sun, 08 Dec 2019 01:05:03 +0200
> >=20
> > > I just suggested another possible solution: bind
> > > 'minibuffer-message-timeout' to zero when calling
> 'minibuffer-message'
> > > from 'message'=2E  Would that work, or will it have some unwanted
> side
> > > effects?
> >=20
> > K=C3=A9vin posted a patch that binds 'minibuffer-message-timeout' to
> zero, but
> > it makes each message disappear before the user has a chance to read
> it=2E
>=20
> But that's how 'message' behaved as well, didn't it?

In case the answer is NO, here's an alternative proposal=2E

The original problem which the change in 'message' tried to solve, the one=
 reported in bugs #17272 and #19064, was about calling 'message' when y-or-=
n-p is prompting the user=2E  So how about if we modify the conditions unde=
r which 'message' calls 'minibuffer-message' such that this happens only wh=
en y-or-n-p is in progress?  E=2Eg=2E, y-or-n-p could bind some variable th=
at 'message' would check=2E

Maybe yes-or-no-p should do the same=2E

This will allow us to fix the original bugs without such wide implications=
 as we have now=2E

And while at that, I don't think we need the new function message-on-echo-=
area; the additional logic could be added to 'message's original code=2E

WDYT?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Dec 2019 05:18:21 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 00:18:21 2019
Received: from localhost ([127.0.0.1]:50334 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idoxY-0007bj-Q4
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 00:18:21 -0500
Received: from lists.gnu.org ([209.51.188.17]:51621)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1idoxX-0007ba-Is
 for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 00:18:19 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:33900)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <eliz@HIDDEN>) id 1idoxW-0008PQ-Fv
 for bug-gnu-emacs@HIDDEN; Sun, 08 Dec 2019 00:18:19 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-2.9 required=5.0 tests=ALL_TRUSTED,BAYES_00,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41595)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1idoxT-0002sF-Qp; Sun, 08 Dec 2019 00:18:16 -0500
Received: from [109.253.218.96] (port=31850 helo=[10.134.197.159])
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_128_CBC_SHA1:128)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1idoxS-0007O0-Vh; Sun, 08 Dec 2019 00:18:15 -0500
Date: Sun, 08 Dec 2019 07:18:09 +0200
User-Agent: K-9 Mail for Android
In-Reply-To: <83k177ebs0.fsf@HIDDEN>
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
 <83k177ebs0.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain;
 charset=utf-8
Content-Transfer-Encoding: quoted-printable
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
To: bug-gnu-emacs@HIDDEN,Juri Linkov <juri@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
Message-ID: <AE02ADC8-6567-4EB1-8A44-E60BC4B5807A@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: submit
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On December 8, 2019 5:28:31 AM GMT+02:00, Eli Zaretskii <eliz@gnu=2Eorg> wr=
ote:
> > From: Juri Linkov <juri@linkov=2Enet>
> > Cc: stephen=2Eberman@gmx=2Enet,  38457@debbugs=2Egnu=2Eorg
> > Date: Sun, 08 Dec 2019 01:05:03 +0200
> >=20
> > > I just suggested another possible solution: bind
> > > 'minibuffer-message-timeout' to zero when calling
> 'minibuffer-message'
> > > from 'message'=2E  Would that work, or will it have some unwanted
> side
> > > effects?
> >=20
> > K=C3=A9vin posted a patch that binds 'minibuffer-message-timeout' to
> zero, but
> > it makes each message disappear before the user has a chance to read
> it=2E
>=20
> But that's how 'message' behaved as well, didn't it?

In case the answer is NO, here's an alternative proposal=2E

The original problem which the change in 'message' tried to solve, the one=
 reported in bugs #17272 and #19064, was about calling 'message' when y-or-=
n-p is prompting the user=2E  So how about if we modify the conditions unde=
r which 'message' calls 'minibuffer-message' such that this happens only wh=
en y-or-n-p is in progress?  E=2Eg=2E, y-or-n-p could bind some variable th=
at 'message' would check=2E

Maybe yes-or-no-p should do the same=2E

This will allow us to fix the original bugs without such wide implications=
 as we have now=2E

And while at that, I don't think we need the new function message-on-echo-=
area; the additional logic could be added to 'message's original code=2E

WDYT?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 8 Dec 2019 03:29:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 07 22:29:04 2019
Received: from localhost ([127.0.0.1]:50227 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idnFo-0004sc-Ju
	for submit <at> debbugs.gnu.org; Sat, 07 Dec 2019 22:29:04 -0500
Received: from eggs.gnu.org ([209.51.188.92]:55707)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1idnFm-0004s1-FS
 for 38457 <at> debbugs.gnu.org; Sat, 07 Dec 2019 22:29:03 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:40511)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1idnFe-0004fn-FQ; Sat, 07 Dec 2019 22:28:55 -0500
Received: from [176.228.60.248] (port=1666 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1idnFZ-0002WE-Mw; Sat, 07 Dec 2019 22:28:51 -0500
Date: Sun, 08 Dec 2019 05:28:31 +0200
Message-Id: <83k177ebs0.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87wob7g2jk.fsf@HIDDEN> (message from Juri Linkov on
 Sun, 08 Dec 2019 01:05:03 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN> <87wob7g2jk.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=iso-8859-1
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: stephen.berman@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Sun, 08 Dec 2019 01:05:03 +0200
> 
> > I just suggested another possible solution: bind
> > 'minibuffer-message-timeout' to zero when calling 'minibuffer-message'
> > from 'message'.  Would that work, or will it have some unwanted side
> > effects?
> 
> Kvin posted a patch that binds 'minibuffer-message-timeout' to zero, but
> it makes each message disappear before the user has a chance to read it.

But that's how 'message' behaved as well, didn't it?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 8 Dec 2019 03:03:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 07 22:03:05 2019
Received: from localhost ([127.0.0.1]:50121 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idmqf-0002D8-GJ
	for submit <at> debbugs.gnu.org; Sat, 07 Dec 2019 22:03:05 -0500
Received: from antelope.elm.relay.mailchannels.net ([23.83.212.4]:38718)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1idmqd-0002CL-0A
 for 38457 <at> debbugs.gnu.org; Sat, 07 Dec 2019 22:03:03 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id E677D2C1286;
 Sat,  7 Dec 2019 23:39:57 +0000 (UTC)
Received: from pdx1-sub0-mail-a14.g.dreamhost.com
 (100-96-86-105.trex.outbound.svc.cluster.local [100.96.86.105])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 67ECC2C074A;
 Sat,  7 Dec 2019 23:39:57 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a14.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Sat, 07 Dec 2019 23:39:57 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Skirt-Desert: 02703e6a2fc2c37b_1575761997652_87938588
X-MC-Loop-Signature: 1575761997652:3519119599
X-MC-Ingress-Time: 1575761997651
Received: from pdx1-sub0-mail-a14.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a14.g.dreamhost.com (Postfix) with ESMTP id DE7778640C;
 Sat,  7 Dec 2019 15:39:56 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type:content-transfer-encoding; s=linkov.net; bh=MXTUtr
 BAy8i8lk2b+RPwV/npUy8=; b=HXBAnrV8ijqoX7htSvnVW9ptR7SzRwyGMsoX1p
 XzNx/M8pfV7Wu+REaOUth52PgP62OGkXTB5cAeNDu8quZQSEeN11wdngXeT5EgaY
 0uekmBv1kZqGJxqojypgHDSNBzOb07sywCcHnQlBR18MVnOzBn5uTXagUE+Kx8s8
 9F9So=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a14.g.dreamhost.com (Postfix) with ESMTPSA id D42F3863FF;
 Sat,  7 Dec 2019 15:39:54 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a14
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
 <83lfrphp94.fsf@HIDDEN>
Date: Sun, 08 Dec 2019 01:05:03 +0200
In-Reply-To: <83lfrphp94.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 06 Dec
 2019 09:44:39 +0200")
Message-ID: <87wob7g2jk.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
X-VR-OUT-STATUS: OK
X-VR-OUT-SCORE: -100
X-VR-OUT-SPAMCAUSE: gggruggvucftvghtrhhoucdtuddrgedufedrudekiedguddvucetufdoteggodetrfdotffvucfrrhhofhhilhgvmecuggftfghnshhusghstghrihgsvgdpffftgfetoffjqffuvfenuceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmnecujfgurhephffvufhofhffjgfkfgggtgfgsehtkeertddtredunecuhfhrohhmpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqnecukfhppeeluddruddvledrleeirdegvdenucfrrghrrghmpehmohguvgepshhmthhppdhhvghlohepmhgrihhlrdhjuhhrthgrrdhorhhgpdhinhgvthepledurdduvdelrdeliedrgedvpdhrvghtuhhrnhdqphgrthhhpefluhhrihcunfhinhhkohhvuceojhhurhhisehlihhnkhhovhdrnhgvtheqpdhmrghilhhfrhhomhepjhhurhhisehlihhnkhhovhdrnhgvthdpnhhrtghpthhtohepvghlihiisehgnhhurdhorhhgnecuvehluhhsthgvrhfuihiivgeptd
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > That is why I suggest to find a simpler, safer solution for that iss=
ue
>> > now, and if you insist on using a timer (which I personally consider
>> > not a good idea), then do this after the release branch is cut.
>>=20
>> Using a timer is the right thing to do, there is no simpler solution,
>> it solves all problems.
>
> Sorry, I object to installing a timer-based solution at this time.  It
> is too radical and is likely to cause numerous unintended consequences
> all over the place.
>
> I just suggested another possible solution: bind
> 'minibuffer-message-timeout' to zero when calling 'minibuffer-message'
> from 'message'.  Would that work, or will it have some unwanted side
> effects?

K=E9vin posted a patch that binds 'minibuffer-message-timeout' to zero, b=
ut
it makes each message disappear before the user has a chance to read it.

With a timer-based approach each message disappears too, except
the last message that the user has a chance to read.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 6 Dec 2019 17:15:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 06 12:15:38 2019
Received: from localhost ([127.0.0.1]:46994 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idHCc-00008c-Aj
	for submit <at> debbugs.gnu.org; Fri, 06 Dec 2019 12:15:38 -0500
Received: from mail-wm1-f53.google.com ([209.85.128.53]:35627)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1idHCY-00007c-Oi
 for 38457 <at> debbugs.gnu.org; Fri, 06 Dec 2019 12:15:35 -0500
Received: by mail-wm1-f53.google.com with SMTP id c20so6626372wmb.0
 for <38457 <at> debbugs.gnu.org>; Fri, 06 Dec 2019 09:15:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=NAB8AaCs6YJjFAkrTe8eY5uub0BqF31A00O1ZcQ8ymo=;
 b=bfsTHn9G7UKFc70G1tiniCngvA2p3vJunp8IFp95iWVLWXn7nVut1Ib1NeNWThkV8v
 eI2TvaTPupqZqk3Zw9S/CdgPnlKu5Ps8Yy51FVTnCY85axTOf1UQkTFcjZSoIUwGwWyN
 /1HwRilD2CSKS91vDjUxM6XTVUh4VdB1UEIWCkIOhseMjahh+xAuxKOoYjoY7kj0ccHm
 z2p8iOnAvaX2wpMJycODCqA3C+8beI37SNQGe0NuQCXqn8icm83AXtPKx6pXfJVcGc8l
 RO+4VVwX7nOr2Y79HI0ajHlh3AEDvakRw27pLFPg/oxHpONBFLw45rU40Aqd+ej0JDCB
 uVRA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=NAB8AaCs6YJjFAkrTe8eY5uub0BqF31A00O1ZcQ8ymo=;
 b=fHXGbPxY0n75eWLWTmAx6friHQ4tiLPcX9fAPSw/B8iJRCgKXSoJAqKqeqdi/BOsyo
 2yDji8c+myuZAiu8SKk7aGTNJ3v6W4sH0BbX55XkJ57M4JHNlhAH4h7wMT64t94yQEL+
 eP/9QVOOorQ9+JbFtWh066Ufg9WVDoNckICtBM1pfO5UuHro5Dpvh7eBJsj/AfR0B4pE
 aNwvh0HSvbQPIklLg3l0pLL5thwuY6SsooplrpR16eoBXYWDD9cvPJ6l/S05P18wuZqC
 9FrwsrElzKOj/FSsvWPvwcj0X1n+knxOKsGqIIoVCtrQHDFz7scrahQCHWXpgdpvvA6o
 OYCA==
X-Gm-Message-State: APjAAAUoerApFz3SQbQ61phs118DXkVsdOTUMtIlkRipcqlh6O3LLh+d
 2N4xYGf3+V4hUSI949MvbvU=
X-Google-Smtp-Source: APXvYqzQmi7irTTtsSxC7OpB7/vCwg9i/GqbJkezEzC+lG6htFRWsFMxGzGeSkv9SPRNn+98C2WjOA==
X-Received: by 2002:a05:600c:cd:: with SMTP id
 u13mr11732013wmm.24.1575652528867; 
 Fri, 06 Dec 2019 09:15:28 -0800 (PST)
Received: from little-buster
 (2a01cb04010fc800344a427cd486b589.ipv6.abo.wanadoo.fr.
 [2a01:cb04:10f:c800:344a:427c:d486:b589])
 by smtp.gmail.com with ESMTPSA id t13sm4161526wmt.23.2019.12.06.09.15.27
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 06 Dec 2019 09:15:27 -0800 (PST)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <87y2vqaj8n.fsf@HIDDEN>
 <87o8wmqpvd.fsf@HIDDEN> <83muc5hpds.fsf@HIDDEN>
Date: Fri, 06 Dec 2019 18:15:27 +0100
In-Reply-To: <83muc5hpds.fsf@HIDDEN> (Eli Zaretskii's message of "Fri, 06 Dec
 2019 09:41:51 +0200")
Message-ID: <87immtwf2o.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN,
 Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain

Eli Zaretskii <eliz@HIDDEN> writes:

> One possibility is for 'message' to bind 'minibuffer-message-timeout'
> to zero when it calls 'minibuffer-message'.  Would this work in all
> the use cases discovered to day?

FWIW the following patch does remove the delay before {the dabbrev
expansion shows up,TRAMP proceeds with each step}:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=minibuffer-message-timeout.patch

diff --git a/src/editfns.c b/src/editfns.c
index 72a9cdba7a..3ee00fcc1b 100644
--- a/src/editfns.c
+++ b/src/editfns.c
@@ -2895,6 +2895,8 @@ accent (\\=`) and apostrophe (\\=') are special in the format; see
 
       /* Avoid possible recursion.  */
       specbind (Qmessage_in_echo_area, Qt);
+      /* Do not delay callers (bug#38457).  */
+      specbind (intern ("minibuffer-message-timeout"), INT_TO_INTEGER (0));
 
       record_unwind_current_buffer ();
       Fset_buffer (Fwindow_buffer (Fold_selected_window ()));

--=-=-=
Content-Type: text/plain


Though that makes each message flicker briefly and disappear before the
user has a chance to read it.

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 6 Dec 2019 16:15:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 06 11:15:46 2019
Received: from localhost ([127.0.0.1]:46935 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idGGg-00052w-8u
	for submit <at> debbugs.gnu.org; Fri, 06 Dec 2019 11:15:46 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57070)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1idGGa-000512-M4
 for 38457 <at> debbugs.gnu.org; Fri, 06 Dec 2019 11:15:42 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43248)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1idGGQ-0007DI-3O; Fri, 06 Dec 2019 11:15:31 -0500
Received: from [176.228.60.248] (port=4550 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1id8FN-00016O-HJ; Fri, 06 Dec 2019 02:41:54 -0500
Date: Fri, 06 Dec 2019 09:41:51 +0200
Message-Id: <83muc5hpds.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87o8wmqpvd.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 06 Dec 2019 02:06:30 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <87y2vqaj8n.fsf@HIDDEN>
 <87o8wmqpvd.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, kevin.legouguec@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: Eli Zaretskii <eliz@HIDDEN>,  38457 <at> debbugs.gnu.org,
>   stephen.berman@HIDDEN
> Date: Fri, 06 Dec 2019 02:06:30 +0200
> 
> > I think the regression Stephen noticed is more widespread than just
> > dabbrev-expand: e.g. TRAMP is also affected[1].
> 
> I know that TRAMP is affected.  I had no time to address this before, sorry,
> but now this is fixed by the previous patch I sent 3 days ago that uses a timer.

We need to fix this without a timer, and we need to fix this before
the emacs-27 branch is cut.

One possibility is for 'message' to bind 'minibuffer-message-timeout'
to zero when it calls 'minibuffer-message'.  Would this work in all
the use cases discovered to day?

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 6 Dec 2019 16:15:45 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 06 11:15:45 2019
Received: from localhost ([127.0.0.1]:46929 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idGGf-00052S-1v
	for submit <at> debbugs.gnu.org; Fri, 06 Dec 2019 11:15:45 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57056)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1idGGa-000510-Ld
 for 38457 <at> debbugs.gnu.org; Fri, 06 Dec 2019 11:15:41 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:43179)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1idGGQ-00026X-3O; Fri, 06 Dec 2019 11:15:31 -0500
Received: from [176.228.60.248] (port=4720 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1id8I4-0001Dp-2Z; Fri, 06 Dec 2019 02:44:40 -0500
Date: Fri, 06 Dec 2019 09:44:39 +0200
Message-Id: <83lfrphp94.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87eexiqps5.fsf@HIDDEN> (message from Juri Linkov on
 Fri, 06 Dec 2019 02:10:20 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN> <87eexiqps5.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: stephen.berman@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Fri, 06 Dec 2019 02:10:20 +0200
> 
> > That is why I suggest to find a simpler, safer solution for that issue
> > now, and if you insist on using a timer (which I personally consider
> > not a good idea), then do this after the release branch is cut.
> 
> Using a timer is the right thing to do, there is no simpler solution,
> it solves all problems.

Sorry, I object to installing a timer-based solution at this time.  It
is too radical and is likely to cause numerous unintended consequences
all over the place.

I just suggested another possible solution: bind
'minibuffer-message-timeout' to zero when calling 'minibuffer-message'
from 'message'.  Would that work, or will it have some unwanted side
effects?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 6 Dec 2019 00:19:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 05 19:19:52 2019
Received: from localhost ([127.0.0.1]:45419 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1id1Lc-0005aQ-00
	for submit <at> debbugs.gnu.org; Thu, 05 Dec 2019 19:19:52 -0500
Received: from crocodile.birch.relay.mailchannels.net ([23.83.209.45]:41221)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1id1La-0005aI-35
 for 38457 <at> debbugs.gnu.org; Thu, 05 Dec 2019 19:19:50 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id D3D98600DE3;
 Fri,  6 Dec 2019 00:19:48 +0000 (UTC)
Received: from pdx1-sub0-mail-a86.g.dreamhost.com
 (100-96-196-51.trex.outbound.svc.cluster.local [100.96.196.51])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 4850D600E7F;
 Fri,  6 Dec 2019 00:19:48 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a86.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Fri, 06 Dec 2019 00:19:48 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Minister-Broad: 62e7d84676456e16_1575591588521_1372636722
X-MC-Loop-Signature: 1575591588521:2217652652
X-MC-Ingress-Time: 1575591588521
Received: from pdx1-sub0-mail-a86.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a86.g.dreamhost.com (Postfix) with ESMTP id B42F5823AB;
 Thu,  5 Dec 2019 16:19:45 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=d6aDJZljiWf9pffBvLumeZIG49A=; b=
 w711HIVAwTUQhzIgR0xjPaUfSIMEK9xvlvsxdFRoc6eTa+J8owGyRsUg5Fu60IzV
 Wclw3soqllm5CjCADIdENNurddKuzMsWJrYjcVtF0PBUBs33dmap4t1+kEb9WcAG
 W7u7QnKmpdGhBrvoJKC2Eybof0dSoaBf4SSJTHOjRho=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a86.g.dreamhost.com (Postfix) with ESMTPSA id C1E3C823B9;
 Thu,  5 Dec 2019 16:19:43 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a86
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
 <83lfrrigj8.fsf@HIDDEN>
Date: Fri, 06 Dec 2019 02:10:20 +0200
In-Reply-To: <83lfrrigj8.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 05 Dec
 2019 05:43:07 +0200")
Message-ID: <87eexiqps5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> > Let's not rock the boat too much so close to the release cycle because
>> > of a very minor problem which caused these changes.  You may not see
>> > any problems with it now, but I'm certain we will bump into numerous
>> > problems very soon if we make such significant changes in this
>> > infrastructure, which is used everywhere in Emacs.
>>
>> There may be a misunderstanding here.  I was talking about the
>> changes for development in master, not for the release branch.
>> If you think it would be too risky to release with these changes,
>> then fine, these changes could be removed in the release branch.
>
> The master branch will become the release branch very soon.  If you
> want to wait with these changes after the emacs-27 branch is cut, it's
> fine by me, but we need to solve the issue with dabbrev-expand for the
> release branch as well.
>
> That is why I suggest to find a simpler, safer solution for that issue
> now, and if you insist on using a timer (which I personally consider
> not a good idea), then do this after the release branch is cut.

Using a timer is the right thing to do, there is no simpler solution,
it solves all problems.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 6 Dec 2019 00:19:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 05 19:19:46 2019
Received: from localhost ([127.0.0.1]:45416 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1id1LW-0005a6-NN
	for submit <at> debbugs.gnu.org; Thu, 05 Dec 2019 19:19:46 -0500
Received: from fossa.birch.relay.mailchannels.net ([23.83.209.62]:23264)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1id1LV-0005Zy-69
 for 38457 <at> debbugs.gnu.org; Thu, 05 Dec 2019 19:19:45 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 0A8C320D5A;
 Fri,  6 Dec 2019 00:19:44 +0000 (UTC)
Received: from pdx1-sub0-mail-a86.g.dreamhost.com
 (100-96-15-77.trex.outbound.svc.cluster.local [100.96.15.77])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 94FA821A15;
 Fri,  6 Dec 2019 00:19:43 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a86.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Fri, 06 Dec 2019 00:19:43 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Print-Abaft: 1856d3ba7c92820a_1575591583847_307722224
X-MC-Loop-Signature: 1575591583846:3630515446
X-MC-Ingress-Time: 1575591583846
Received: from pdx1-sub0-mail-a86.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a86.g.dreamhost.com (Postfix) with ESMTP id 51BD6823AB;
 Thu,  5 Dec 2019 16:19:38 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=WKML0iu9l8OhEc1T4SwWWpGWyKI=; b=
 cQEukiJ1uvuJ7U+lP615ul7JoN7uyNwWaYNiQ3s202cpOEWsVgMpHIs6cZTMQhCd
 sAg6Kqxnj3P3Ke/m15zaSYYTBLUrG44iAk5iYVHALEM8tGRu1YxZslmOyCRPkPEB
 OJl4hS2bAX3TiNnTwai9jzIzz2VyFKXLy0JVNdooJD4=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a86.g.dreamhost.com (Postfix) with ESMTPSA id E4E3D823BF;
 Thu,  5 Dec 2019 16:19:35 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a86
From: Juri Linkov <juri@HIDDEN>
To: =?iso-8859-1?Q?K=E9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <87y2vqaj8n.fsf@HIDDEN>
Date: Fri, 06 Dec 2019 02:06:30 +0200
In-Reply-To: <87y2vqaj8n.fsf@HIDDEN> (=?iso-8859-1?Q?=22K=E9vin?= Le
 Gouguec"'s message of "Thu, 05 Dec 2019 16:24:08 +0100")
Message-ID: <87o8wmqpvd.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, Eli Zaretskii <eliz@HIDDEN>, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>>> > So please try to find a simpler fix for this problem, one that doesn't
>>> > involve a timer.
>>>
>>> This is the simplest and the safest solution.
>>
>> The simplest solution would be to prevent dabbrev-expand from
>> displaying the message in the first place; there are conditions for
>> that which evidently the new implementation somehow triggers.
>>
>>> I wanted to implement it earlier but had no time before.  I see no
>>> problems with it.
>>
>> Let's not rock the boat too much so close to the release cycle because
>> of a very minor problem which caused these changes.  You may not see
>> any problems with it now, but I'm certain we will bump into numerous
>> problems very soon if we make such significant changes in this
>> infrastructure, which is used everywhere in Emacs.
>
> Mmm, as you say, the message infrastructure is used everywhere in Emacs,
> and it has received significant changes in aa89c84e00d.
>
> I think the regression Stephen noticed is more widespread than just
> dabbrev-expand: e.g. TRAMP is also affected[1].

I know that TRAMP is affected.  I had no time to address this before, sorry,
but now this is fixed by the previous patch I sent 3 days ago that uses a timer.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 5 Dec 2019 16:36:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 05 11:36:55 2019
Received: from localhost ([127.0.0.1]:45086 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1icu7b-0003A9-1K
	for submit <at> debbugs.gnu.org; Thu, 05 Dec 2019 11:36:55 -0500
Received: from eggs.gnu.org ([209.51.188.92]:36781)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1icu7Z-00039y-2R
 for 38457 <at> debbugs.gnu.org; Thu, 05 Dec 2019 11:36:53 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42628)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1icu7T-0001hE-Cw; Thu, 05 Dec 2019 11:36:47 -0500
Received: from [176.228.60.248] (port=1221 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1icu7S-0006rb-Nf; Thu, 05 Dec 2019 11:36:47 -0500
Date: Thu, 05 Dec 2019 18:36:43 +0200
Message-Id: <834kyeivac.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: =?utf-8?Q?K=C3=A9vin?= Le Gouguec <kevin.legouguec@HIDDEN>
In-reply-to: <87y2vqaj8n.fsf@HIDDEN> (message from =?utf-8?Q?K=C3=A9vin?=
 Le Gouguec on Thu, 05 Dec 2019 16:24:08 +0100)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <87y2vqaj8n.fsf@HIDDEN>
MIME-version: 1.0
Content-type: text/plain; charset=utf-8
Content-Transfer-Encoding: 8bit
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN, juri@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Kévin Le Gouguec <kevin.legouguec@HIDDEN>
> Cc: Juri Linkov <juri@HIDDEN>,  38457 <at> debbugs.gnu.org,
>   stephen.berman@HIDDEN
> Date: Thu, 05 Dec 2019 16:24:08 +0100
> 
> Mmm, as you say, the message infrastructure is used everywhere in Emacs,
> and it has received significant changes in aa89c84e00d.
> 
> I think the regression Stephen noticed is more widespread than just
> dabbrev-expand: e.g. TRAMP is also affected[1].  Does it make sense to
> address each symptom individually?

I didn't say individually, I said I would like to see a simpler
change, one that doesn't yet again change the infrastructure
significantly.

For example, to fix the dabbrev case we could bind
minibuffer-message-timeout to zero in progress-reporter-do-update.

> Were dabbrev, TRAMP, and possibly others wrong to assume that they
> could call (message …) without causing 2-second delays?

No.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 5 Dec 2019 15:24:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 05 10:24:18 2019
Received: from localhost ([127.0.0.1]:45035 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1icszK-0001JI-B1
	for submit <at> debbugs.gnu.org; Thu, 05 Dec 2019 10:24:18 -0500
Received: from mail-wr1-f53.google.com ([209.85.221.53]:44092)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kevin.legouguec@HIDDEN>) id 1icszJ-0001J4-11
 for 38457 <at> debbugs.gnu.org; Thu, 05 Dec 2019 10:24:17 -0500
Received: by mail-wr1-f53.google.com with SMTP id q10so4070458wrm.11
 for <38457 <at> debbugs.gnu.org>; Thu, 05 Dec 2019 07:24:16 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version:content-transfer-encoding;
 bh=kv6TcD7hfO7P4en/NqrNanAHy9vFfMTA0ysx+7+/2Aw=;
 b=PZVaV2YwpJQtZRDWXTMWHEKaXVBsXrf3/9ZMFdPHPhH6sVae4hZC2GEGB4JjeEH0qa
 j9zY+ZFZqs40+s2oR9LCFeUj3zfJpUABYmV685J3qIpF03nR271am1mF5k/0+SOLnKBs
 yck1xnNWqsBc+HHt12TMGrcu+uen5u+akyK3LpSFAJzWp2Lzq6iHWVzsQzIeiT9viN83
 pbygTvAV8lLyPmiZ9dWkMXO5p/NHCVMmVP5oCrhgSYxEFKHMq0JvVZtrjCDdLKnDXdfq
 ebJd82z6lo/RIqfVm867gfla0iorjVUMAmA7VcqYzRR/kDD3Je/CWdInAN+4USmzkfDR
 41WA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version:content-transfer-encoding;
 bh=kv6TcD7hfO7P4en/NqrNanAHy9vFfMTA0ysx+7+/2Aw=;
 b=puUbDUNqoTkQObh+T4AaXKt0lX9h7OTVRndJkVBiLu9eLKGbGBEvmow/aXiQ//w2T6
 7WjgJLlG3KoWu40zyMQCubAa6qDLQMPyDqIB+qpCvpMS4wrsi+/Qaz48qI5VlSauE3cq
 mfKPkZMFVfmDZIrBVn5vuCFqpZbstZ5q2uqhbrWx+shMh+LjnCtIOP19LlPqw1HFUsRo
 TEFiFFnwPESEX2TrtLG0EwUZvz6ZoAHFUqLstG9s7rnVZbl1EzmywnL7BXVXJjBA4r3M
 1rs2i8n4h2+2m6+i6V2XronzSOnTtb9j+ZtIzcSh1Lyyk0orUEF1Q0D1crsXKyk3D4cr
 odLg==
X-Gm-Message-State: APjAAAXilIPCP0IhIVFWJQWUmy5UAPJhnz6MqgVvaqD/k9w9XhZ80Siz
 XVZRM3/3rO6Q6TrFCfiQs1E=
X-Google-Smtp-Source: APXvYqzV5WA4sX8+WAi7oXqTbAaQ852DHc+9CenXKNoQHa+GLWsn++IFRBWHVNevUrlEC2CkPeUgtQ==
X-Received: by 2002:a5d:44ca:: with SMTP id z10mr11536334wrr.266.1575559451200; 
 Thu, 05 Dec 2019 07:24:11 -0800 (PST)
Received: from little-buster
 (2a01cb04010fc800344a427cd486b589.ipv6.abo.wanadoo.fr.
 [2a01:cb04:10f:c800:344a:427c:d486:b589])
 by smtp.gmail.com with ESMTPSA id a24sm130080wmb.29.2019.12.05.07.24.09
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Thu, 05 Dec 2019 07:24:10 -0800 (PST)
From: =?utf-8?Q?K=C3=A9vin_Le_Gouguec?= <kevin.legouguec@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN>
Date: Thu, 05 Dec 2019 16:24:08 +0100
In-Reply-To: <837e3ckbem.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 04 Dec
 2019 05:38:41 +0200")
Message-ID: <87y2vqaj8n.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN,
 Juri Linkov <juri@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Eli Zaretskii <eliz@HIDDEN> writes:

>> From: Juri Linkov <juri@HIDDEN>
>>=20
>> > So please try to find a simpler fix for this problem, one that doesn't
>> > involve a timer.
>>=20
>> This is the simplest and the safest solution.
>
> The simplest solution would be to prevent dabbrev-expand from
> displaying the message in the first place; there are conditions for
> that which evidently the new implementation somehow triggers.
>
>> I wanted to implement it earlier but had no time before.  I see no
>> problems with it.
>
> Let's not rock the boat too much so close to the release cycle because
> of a very minor problem which caused these changes.  You may not see
> any problems with it now, but I'm certain we will bump into numerous
> problems very soon if we make such significant changes in this
> infrastructure, which is used everywhere in Emacs.

Mmm, as you say, the message infrastructure is used everywhere in Emacs,
and it has received significant changes in aa89c84e00d.

I think the regression Stephen noticed is more widespread than just
dabbrev-expand: e.g. TRAMP is also affected[1].  Does it make sense to
address each symptom individually?  Were dabbrev, TRAMP, and possibly
others wrong to assume that they could call (message =E2=80=A6) without cau=
sing
2-second delays?

NB: I am not saying that Juri's initial patch is the simplest nor the
safest.  It just seems to me that aa89c84e00d has already "rocked the
boat" quite a bit, and addressing this specific bug report by tweaking
dabbrev-expand will only take care of the tip of the iceberg, to
continue the nautical metaphor=E2=80=A6


[1] C-x C-f /ssh:localhost: RET

    =E2=87=92 This hangs for 10 seconds unless the user furiously spams some
    command (e.g. C-n), as each of the following message takes 2 seconds
    to disappear:

    > Tramp: Opening connection for localhost using ssh...
    > Tramp: Sending command =E2=80=98exec ssh   -o ControlMaster=3Dauto -o=
 ControlPath=3D'tramp.%C' -o ControlPersist=3Dno -e none localhost=E2=80=99
    > Tramp: Waiting for prompts from remote shell...done
    > Tramp: Found remote shell prompt on =E2=80=98localhost=E2=80=99
    > Tramp: Opening connection for localhost using ssh...done

    I haven't reported this as a separate issue yet, because I am
    assuming that both bugs are caused by recent changes in message and
    should be fixed there=E2=80=A6




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 5 Dec 2019 03:43:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 04 22:43:22 2019
Received: from localhost ([127.0.0.1]:42899 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ici2z-0000lJ-NG
	for submit <at> debbugs.gnu.org; Wed, 04 Dec 2019 22:43:21 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54199)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ici2x-0000l4-8T
 for 38457 <at> debbugs.gnu.org; Wed, 04 Dec 2019 22:43:20 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:34049)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ici2r-0000jN-6L; Wed, 04 Dec 2019 22:43:13 -0500
Received: from [176.228.60.248] (port=2114 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ici2q-0007zP-EY; Wed, 04 Dec 2019 22:43:13 -0500
Date: Thu, 05 Dec 2019 05:43:07 +0200
Message-Id: <83lfrrigj8.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <871rtjn0kt.fsf@HIDDEN> (message from Juri Linkov on
 Thu, 05 Dec 2019 01:16:34 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN> <871rtjn0kt.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: stephen.berman@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Thu, 05 Dec 2019 01:16:34 +0200
> 
> > Let's not rock the boat too much so close to the release cycle because
> > of a very minor problem which caused these changes.  You may not see
> > any problems with it now, but I'm certain we will bump into numerous
> > problems very soon if we make such significant changes in this
> > infrastructure, which is used everywhere in Emacs.
> 
> There may be a misunderstanding here.  I was talking about the
> changes for development in master, not for the release branch.
> If you think it would be too risky to release with these changes,
> then fine, these changes could be removed in the release branch.

The master branch will become the release branch very soon.  If you
want to wait with these changes after the emacs-27 branch is cut, it's
fine by me, but we need to solve the issue with dabbrev-expand for the
release branch as well.

That is why I suggest to find a simpler, safer solution for that issue
now, and if you insist on using a timer (which I personally consider
not a good idea), then do this after the release branch is cut.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 4 Dec 2019 23:27:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 04 18:27:42 2019
Received: from localhost ([127.0.0.1]:42792 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ice3Z-00020Y-My
	for submit <at> debbugs.gnu.org; Wed, 04 Dec 2019 18:27:41 -0500
Received: from bongo.elm.relay.mailchannels.net ([23.83.212.21]:57695)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ice3Y-00020P-18
 for 38457 <at> debbugs.gnu.org; Wed, 04 Dec 2019 18:27:40 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 7D94814187D;
 Wed,  4 Dec 2019 23:27:37 +0000 (UTC)
Received: from pdx1-sub0-mail-a19.g.dreamhost.com
 (100-96-45-206.trex.outbound.svc.cluster.local [100.96.45.206])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 16E4D1415BD;
 Wed,  4 Dec 2019 23:27:37 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a19.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Wed, 04 Dec 2019 23:27:37 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Abaft-Daffy: 216b845f35168610_1575502057327_3503392965
X-MC-Loop-Signature: 1575502057327:4174198862
X-MC-Ingress-Time: 1575502057327
Received: from pdx1-sub0-mail-a19.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a19.g.dreamhost.com (Postfix) with ESMTP id 5DAB9B76EF;
 Wed,  4 Dec 2019 15:27:33 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=qmuLv6bxVFMSa5psSBpVs8Cf9YY=; b=
 1k76PtZzI03LB7+OKOOfWTXw4W3E223OOT/ASnLK6SNpavz62JiswSyhiyWwwNoR
 icf553PwoXT2jCF+SE2ihnQjuLp6rHrgQKak1BrwmWFZQ2hMTvTZveo4c26ohzlK
 hT/Ayr249ZFcpdTCmQ2vRZIDkK9EMd4c57SSnBvSb20=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a19.g.dreamhost.com (Postfix) with ESMTPSA id 70543B76F2;
 Wed,  4 Dec 2019 15:27:30 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a19
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
 <837e3ckbem.fsf@HIDDEN>
Date: Thu, 05 Dec 2019 01:16:34 +0200
In-Reply-To: <837e3ckbem.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 04 Dec
 2019 05:38:41 +0200")
Message-ID: <871rtjn0kt.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

>> I wanted to implement it earlier but had no time before.  I see no
>> problems with it.
>
> Let's not rock the boat too much so close to the release cycle because
> of a very minor problem which caused these changes.  You may not see
> any problems with it now, but I'm certain we will bump into numerous
> problems very soon if we make such significant changes in this
> infrastructure, which is used everywhere in Emacs.

There may be a misunderstanding here.  I was talking about the
changes for development in master, not for the release branch.
If you think it would be too risky to release with these changes,
then fine, these changes could be removed in the release branch.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 4 Dec 2019 03:39:11 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 03 22:39:11 2019
Received: from localhost ([127.0.0.1]:41327 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1icLVO-00082r-Vc
	for submit <at> debbugs.gnu.org; Tue, 03 Dec 2019 22:39:11 -0500
Received: from eggs.gnu.org ([209.51.188.92]:48959)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1icLVM-00082U-FT
 for 38457 <at> debbugs.gnu.org; Tue, 03 Dec 2019 22:39:09 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:41102)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1icLVA-0000PK-O4; Tue, 03 Dec 2019 22:38:56 -0500
Received: from [176.228.60.248] (port=1968 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1icLV6-0007KV-4e; Tue, 03 Dec 2019 22:38:52 -0500
Date: Wed, 04 Dec 2019 05:38:41 +0200
Message-Id: <837e3ckbem.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <87blspm0sm.fsf@HIDDEN> (message from Juri Linkov on
 Wed, 04 Dec 2019 01:44:57 +0200)
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN> <87blspm0sm.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Cc: stephen.berman@HIDDEN,  38457 <at> debbugs.gnu.org
> Date: Wed, 04 Dec 2019 01:44:57 +0200
> 
> > So please try to find a simpler fix for this problem, one that doesn't
> > involve a timer.
> 
> This is the simplest and the safest solution.

The simplest solution would be to prevent dabbrev-expand from
displaying the message in the first place; there are conditions for
that which evidently the new implementation somehow triggers.

> I wanted to implement it earlier but had no time before.  I see no
> problems with it.

Let's not rock the boat too much so close to the release cycle because
of a very minor problem which caused these changes.  You may not see
any problems with it now, but I'm certain we will bump into numerous
problems very soon if we make such significant changes in this
infrastructure, which is used everywhere in Emacs.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 3 Dec 2019 23:47:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 03 18:47:16 2019
Received: from localhost ([127.0.0.1]:41233 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1icHsy-0002Id-87
	for submit <at> debbugs.gnu.org; Tue, 03 Dec 2019 18:47:16 -0500
Received: from chocolate.birch.relay.mailchannels.net ([23.83.209.35]:55321)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1icHsv-0002IM-Pf
 for 38457 <at> debbugs.gnu.org; Tue, 03 Dec 2019 18:47:14 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id 6FA83215A0;
 Tue,  3 Dec 2019 23:47:12 +0000 (UTC)
Received: from pdx1-sub0-mail-a18.g.dreamhost.com
 (100-96-6-199.trex.outbound.svc.cluster.local [100.96.6.199])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 0394D2158B;
 Tue,  3 Dec 2019 23:47:12 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a18.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Tue, 03 Dec 2019 23:47:12 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Zesty-Chief: 0adc6bf379aadc9f_1575416832247_4160652782
X-MC-Loop-Signature: 1575416832247:3855278037
X-MC-Ingress-Time: 1575416832246
Received: from pdx1-sub0-mail-a18.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a18.g.dreamhost.com (Postfix) with ESMTP id A7C03A3A52;
 Tue,  3 Dec 2019 15:47:10 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=OS57rkIdGx1Su6BdTsImFnLr5Xs=; b=
 BedhIFDyD59yzn+ZRGahXi8uXusxXQxUPOqqW9XLqyQyPy8mRzh1o7dTl0VpMP3e
 T6rpyV+ADYg5bXkiU3RDgO5DpIj3i0sgaLfOBAXL26PYwtjyw68xuBRNqRxtZ9cj
 RO3bAfTRJzeAK45kReOaA886+YDxPcko3HVUwePvM3c=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a18.g.dreamhost.com (Postfix) with ESMTPSA id 1D89EA3A56;
 Tue,  3 Dec 2019 15:47:08 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a18
From: Juri Linkov <juri@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
 <83y2vujd0y.fsf@HIDDEN>
Date: Wed, 04 Dec 2019 01:44:57 +0200
In-Reply-To: <83y2vujd0y.fsf@HIDDEN> (Eli Zaretskii's message of "Tue, 03 Dec
 2019 05:36:45 +0200")
Message-ID: <87blspm0sm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

> So please try to find a simpler fix for this problem, one that doesn't
> involve a timer.

This is the simplest and the safest solution.  I wanted to implement it
earlier but had no time before.  I see no problems with it.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 3 Dec 2019 03:37:05 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 02 22:37:05 2019
Received: from localhost ([127.0.0.1]:39203 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ibyzp-0003RG-0b
	for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 22:37:05 -0500
Received: from eggs.gnu.org ([209.51.188.92]:52021)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ibyzo-0003Qn-0V
 for 38457 <at> debbugs.gnu.org; Mon, 02 Dec 2019 22:37:04 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:49756)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ibyzf-0001RM-Vj; Mon, 02 Dec 2019 22:36:56 -0500
Received: from [176.228.60.248] (port=1736 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ibyzf-0001z8-Fd; Mon, 02 Dec 2019 22:36:55 -0500
Date: Tue, 03 Dec 2019 05:36:45 +0200
Message-Id: <83y2vujd0y.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
In-reply-to: <8736e2coyv.fsf@HIDDEN> (message from Juri Linkov on
 Tue, 03 Dec 2019 01:00:40 +0200)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org, stephen.berman@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Juri Linkov <juri@HIDDEN>
> Date: Tue, 03 Dec 2019 01:00:40 +0200
> Cc: 38457 <at> debbugs.gnu.org
> 
> > 0. emacs -Q
> > 1. M-! te M-/
> >
> > => It takes about 4 seconds on my machine for the expansion "text" to
> > appear, during which the minibuffer displays "[Scanning for
> > dabbrevs...100%]" and then "[Scanning for dabbrevs...done]".  On builds
> > without this regression, the expansion is virtually instantaneous and no
> > message is seen in the minibuffer.
> 
> This is because of the current limitation of minibuffer-message.
> It uses sit-for to wait for 2 seconds per every message.
> This should be fixed by using the timer, so there will be no delays
> anymore:

Please don't make this change, or any other changes in this stuff that
significantly modify the internals of these basic APIs.  I'm that
close to ask to revert the entire message-in-echo-area change, because
it's already too invasive and runs a high risk of disrupting too many
commands.  We don't want the pretest of Emacs 27.1 to last forever for
these reasons.

So please try to find a simpler fix for this problem, one that doesn't
involve a timer.  If it isn't possible, let's indeed consider removing
the message-in-echo-area changes for now.

Sorry for that, but we should keep in mind that Emacs 27.1 pretest is
coming soon, and any deep changes in low-level infrastructure used all
over the place should wait for the next release.

Thanks.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 3 Dec 2019 00:15:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 02 19:15:19 2019
Received: from localhost ([127.0.0.1]:39146 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ibvqZ-0006Ob-N8
	for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 19:15:19 -0500
Received: from mout.gmx.net ([212.227.15.18]:48835)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stephen.berman@HIDDEN>) id 1ibvqX-0006OM-VL
 for 38457 <at> debbugs.gnu.org; Mon, 02 Dec 2019 19:15:18 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1575332107;
 bh=M4nQqC8M9vRS8YoHajo5ZlOSzmECncKhYgD3Log4N+E=;
 h=X-UI-Sender-Class:From:To:Cc:Subject:References:Date:In-Reply-To;
 b=Wis5craD8ZcmWW9MueBlsBPpT/VSPAsBVbQv9b5ywhfxdOEdnbKD6HCpkNbTCF/M6
 6f8/Y7bUfSShGPNbmJmqF0QvKfiGC93xO1t4/9PfbC4ldBB+aFqNrJzyy3NbEU4oRN
 6jzKUzscH92s3F6mCHz5TCfZCanpKcub77QePBDs=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from strobe-lfs84 ([188.109.175.134]) by mail.gmx.com (mrgmx004
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1N8ob6-1hg6hx1RN0-015nmL; Tue, 03
 Dec 2019 01:15:07 +0100
From: Stephen Berman <stephen.berman@HIDDEN>
To: Juri Linkov <juri@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
References: <8736e3vve8.fsf@HIDDEN> <8736e2coyv.fsf@HIDDEN>
Date: Tue, 03 Dec 2019 01:15:05 +0100
In-Reply-To: <8736e2coyv.fsf@HIDDEN> (Juri Linkov's message of "Tue, 
 03 Dec 2019 01:00:40 +0200")
Message-ID: <87a78auuwm.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:V3nvX2vX1hRP/X/so6UFd3lf/ToUrYp5qIFovVSEW7rCIi/dNoI
 RMvs+Yy4xEBu1EMjSdLdJIWKRzBF7GQ6LObrxwPKY36Nn65QQMsjxuj9u9R89vL8ICccPAE
 dI51NDqAaESoxKpvuCYno8AGYeOu6iJNwWN9iG/FzcFZ6pyiClOUNjYXxxg5Ydyj4Tg9BFv
 fy2DJniB10J4MF98qQfUQ==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:+fLF5XnlVOQ=:clrZL+FYtFpufTaq6mq0AS
 WTeWLxh9ekz/T/NxGsN9aVNDN0h2MAORbcEIdnxjt13Qto2XdsWri7J/8+RNOOk62hwkp/4JG
 neHvGuhfDGVEJztGNeLkNJ+7YORpBYmBfRVtKA7d5bGq3XzrSUuPXKGAVNYjhy1uKiSP07aX2
 E5TvYI0iY/DEQQyo/zorgGe7dCXnEkQvBBGHauTpaNlmA+LWFDlFJ2wMFnB8XLdHhWfVN56KE
 qur4Eb6chiyan5RFPO/j05kS8k3fuEJw9E7MV/wSg+YbxbHdfj+cc7H8bn+DDjfW78nHyU30x
 29wQOcrijpML1I3EsR559TXKdarzakAX+/u1jGASgBOkk8mgLYCeBQ3j2j0WYgN3FyBCSLSnn
 1wKKn5M1xzGUcB5f2LPeS3an54zDvI2iML6Lr54Ppf22AjgarLIdL7EeLV7l/iBilCM9dD+5A
 Q7FY1x99U0XZMXgDGTDcBjyoYsBYxQkYYE3rIxg3zpfgmqrWwO7HWPYaYkTZGU1iAtAIoV1HB
 /5qEgJ4UB6ictN7ZvktcRvjHENtdglScv/ZB68ZRoX0xGIPifQXhw4ioxH7jOD9xYr/YbMwZg
 bQnc9o7HDSR+3TgKo9niwdB47Mme+JTnKuTL38WEqJB4SeUFN2uqM4VPrpwVXXE0qj0u4kvGJ
 M0tlDtrxSC5ELBEuB20EpyK/6nyT93QmOPk+AwYUl4Xw8lCfRfwLBMYhXn/3L3w6ChORusAdI
 XlrNw3vq099RrlEilPk3x+ba1srgx1hKowULYXpxbLTeLL088dJHDvlV9NVR+U8TRb3nUEej0
 51BZbMj349n309SjlRhZ4hlCtpOj5dpCEzkdjVH7NBFnxhsfHPhK9YfCSw15rsCyPhAU0ZqpP
 eCBqiudtWYN5XdKy39ZRJQypiOlzYIuVTr6D5Sv2ZJnWyTFGaf+TaU5esjgCmiFQF7CYDg4xd
 GHQdzD/eHPWXOJi8iyWIGAwitka1M6YsY3UJiIV2HAwsenr6eee1N3ECRtl/Zs45Bw2xanMAl
 s+NV7rOD2b6E4y9jUU99/dA+MBsb7BJBH3UcPApSZb1YuiHHt7YoYALgLHejH5mbkx5A0TfZL
 Z9I/yBw4q+VFnwwtLFZgBSfjd1BxvzuVkHa0PSuwKiD6DtTtRc70kuwRQ2YzutTwngXRsCRaK
 /Nd9T8Vq/14Xi/tKCriTjTvUccCFdWaXSsv8cDEhu5n4avX1W3ZJp7uuS3cVJlpJgrZtufEZf
 juaj5lEP1ekvi20ez6Yl20KcYeobBDmQqNvMH8wEOla/bJfK+hR8ng0TTN40=
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

On Tue, 03 Dec 2019 01:00:40 +0200 Juri Linkov <juri@HIDDEN> wrote:

>> 0. emacs -Q
>> 1. M-! te M-/
>>
>> => It takes about 4 seconds on my machine for the expansion "text" to
>> appear, during which the minibuffer displays "[Scanning for
>> dabbrevs...100%]" and then "[Scanning for dabbrevs...done]".  On builds
>> without this regression, the expansion is virtually instantaneous and no
>> message is seen in the minibuffer.
>
> This is because of the current limitation of minibuffer-message.
> It uses sit-for to wait for 2 seconds per every message.
> This should be fixed by using the timer, so there will be no delays
> anymore:

I confirm that this patch eliminates the dabbrev-expand delay.
Simultaneously with the expansion, the message "[Scanning for
dabbrevs...done]" is displayed, which is uninformative and hence a bit
annoying, but otherwise seems harmless.  Thanks for the fix.

Steve Berman




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 2 Dec 2019 23:46:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 02 18:46:47 2019
Received: from localhost ([127.0.0.1]:39120 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ibvOw-00059m-Az
	for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 18:46:47 -0500
Received: from bonobo.birch.relay.mailchannels.net ([23.83.209.22]:3554)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <juri@HIDDEN>) id 1ibvOu-00059b-BW
 for 38457 <at> debbugs.gnu.org; Mon, 02 Dec 2019 18:46:45 -0500
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from relay.mailchannels.net (localhost [127.0.0.1])
 by relay.mailchannels.net (Postfix) with ESMTP id C61FD21DF4;
 Mon,  2 Dec 2019 23:46:42 +0000 (UTC)
Received: from pdx1-sub0-mail-a98.g.dreamhost.com
 (100-96-4-107.trex.outbound.svc.cluster.local [100.96.4.107])
 (Authenticated sender: dreamhost)
 by relay.mailchannels.net (Postfix) with ESMTPA id 3545A21D14;
 Mon,  2 Dec 2019 23:46:42 +0000 (UTC)
X-Sender-Id: dreamhost|x-authsender|jurta@HIDDEN
Received: from pdx1-sub0-mail-a98.g.dreamhost.com ([TEMPUNAVAIL].
 [64.90.62.162]) (using TLSv1.2 with cipher DHE-RSA-AES256-GCM-SHA384)
 by 0.0.0.0:2500 (trex/5.18.5); Mon, 02 Dec 2019 23:46:42 +0000
X-MC-Relay: Neutral
X-MailChannels-SenderId: dreamhost|x-authsender|jurta@HIDDEN
X-MailChannels-Auth-Id: dreamhost
X-Drop-Bored: 08bb3c133af82ef5_1575330402516_98482903
X-MC-Loop-Signature: 1575330402516:2956078607
X-MC-Ingress-Time: 1575330402515
Received: from pdx1-sub0-mail-a98.g.dreamhost.com (localhost [127.0.0.1])
 by pdx1-sub0-mail-a98.g.dreamhost.com (Postfix) with ESMTP id 025318018D;
 Mon,  2 Dec 2019 15:46:36 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=linkov.net; h=from:to:cc
 :subject:references:date:in-reply-to:message-id:mime-version
 :content-type; s=linkov.net; bh=mvtWIyO0sYFoCzoHYyO2gfmjhC4=; b=
 feoNzSwhsP+roTTo3PIN/+BX1uEwcUS1xYBLSH6pgatBSEd8NdELVqvdTEzoYjv8
 1yIybhvAIQycvF3uVMoFR/JwduPI5awrEStWwPrU116d2F0qRkYAZJ2H8471Q5HY
 esgpchOzBIjw6UXlM5BvVpWEanVPy+SHgo1C778SVvM=
Received: from mail.jurta.org (m91-129-96-42.cust.tele2.ee [91.129.96.42])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 (Authenticated sender: jurta@HIDDEN)
 by pdx1-sub0-mail-a98.g.dreamhost.com (Postfix) with ESMTPSA id 5FC5C8018A;
 Mon,  2 Dec 2019 15:46:34 -0800 (PST)
X-DH-BACKEND: pdx1-sub0-mail-a98
From: Juri Linkov <juri@HIDDEN>
To: Stephen Berman <stephen.berman@HIDDEN>
Subject: Re: bug#38457: 27.0.50; dabbrev-expand regression due to message
 change
Organization: LINKOV.NET
References: <8736e3vve8.fsf@HIDDEN>
Date: Tue, 03 Dec 2019 01:00:40 +0200
In-Reply-To: <8736e3vve8.fsf@HIDDEN> (Stephen Berman's message of "Mon, 02
 Dec 2019 12:06:55 +0100")
Message-ID: <8736e2coyv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (x86_64-pc-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

--=-=-=
Content-Type: text/plain

> 0. emacs -Q
> 1. M-! te M-/
>
> => It takes about 4 seconds on my machine for the expansion "text" to
> appear, during which the minibuffer displays "[Scanning for
> dabbrevs...100%]" and then "[Scanning for dabbrevs...done]".  On builds
> without this regression, the expansion is virtually instantaneous and no
> message is seen in the minibuffer.

This is because of the current limitation of minibuffer-message.
It uses sit-for to wait for 2 seconds per every message.
This should be fixed by using the timer, so there will be no delays
anymore:


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline; filename=minibuffer-message-timer.patch

diff --git a/lisp/minibuffer.el b/lisp/minibuffer.el
index a7bdde478f..3febdeb174 100644
--- a/lisp/minibuffer.el
+++ b/lisp/minibuffer.el
@@ -702,6 +702,9 @@ minibuffer
 (defvar minibuffer-message-properties nil
   "Text properties added to the text shown by `minibuffer-message'.")
 
+(defvar minibuffer-message-timer nil)
+(defvar minibuffer-message-overlay nil)
+
 (defun minibuffer-message (message &rest args)
   "Temporarily display MESSAGE at the end of the minibuffer.
 The text is displayed for `minibuffer-message-timeout' seconds,
@@ -732,24 +735,23 @@ minibuffer-message
                 ;; Don't overwrite the face properties the caller has set
                 (text-properties-at 0 message))
       (setq message (apply #'propertize message minibuffer-message-properties)))
-    (let ((ol (make-overlay (point-max) (point-max) nil t t))
-          ;; A quit during sit-for normally only interrupts the sit-for,
-          ;; but since minibuffer-message is used at the end of a command,
-          ;; at a time when the command has virtually finished already, a C-g
-          ;; should really cause an abort-recursive-edit instead (i.e. as if
-          ;; the C-g had been typed at top-level).  Binding inhibit-quit here
-          ;; is an attempt to get that behavior.
-          (inhibit-quit t))
-      (unwind-protect
-          (progn
-            (unless (zerop (length message))
-              ;; The current C cursor code doesn't know to use the overlay's
-              ;; marker's stickiness to figure out whether to place the cursor
-              ;; before or after the string, so let's spoon-feed it the pos.
-              (put-text-property 0 1 'cursor t message))
-            (overlay-put ol 'after-string message)
-            (sit-for (or minibuffer-message-timeout 1000000)))
-        (delete-overlay ol)))))
+
+    (when (timerp minibuffer-message-timer)
+      (cancel-timer minibuffer-message-timer))
+    (when (overlayp minibuffer-message-overlay)
+      (delete-overlay minibuffer-message-overlay))
+    (setq minibuffer-message-overlay
+          (make-overlay (point-max) (point-max) nil t t))
+    (setq minibuffer-message-timer
+          (run-with-timer (or minibuffer-message-timeout 1) nil
+                          (lambda () (when (overlayp minibuffer-message-overlay)
+                                       (delete-overlay minibuffer-message-overlay)))))
+    (unless (zerop (length message))
+      ;; The current C cursor code doesn't know to use the overlay's
+      ;; marker's stickiness to figure out whether to place the cursor
+      ;; before or after the string, so let's spoon-feed it the pos.
+      (put-text-property 0 1 'cursor t message))
+    (overlay-put minibuffer-message-overlay 'after-string message)))
 
 (defun minibuffer-completion-contents ()
   "Return the user input in a minibuffer before point as a string.

--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at 38457 <at> debbugs.gnu.org:


Received: (at 38457) by debbugs.gnu.org; 2 Dec 2019 16:02:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 02 11:02:34 2019
Received: from localhost ([127.0.0.1]:38809 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ibo9i-0000AL-7f
	for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 11:02:34 -0500
Received: from eggs.gnu.org ([209.51.188.92]:43277)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eliz@HIDDEN>) id 1ibo9g-0000A4-E3
 for 38457 <at> debbugs.gnu.org; Mon, 02 Dec 2019 11:02:32 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38658)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <eliz@HIDDEN>)
 id 1ibo9b-0001BK-8m; Mon, 02 Dec 2019 11:02:27 -0500
Received: from [176.228.60.248] (port=3197 helo=home-c4e4a596f7)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <eliz@HIDDEN>)
 id 1ibo9a-0005sL-HA; Mon, 02 Dec 2019 11:02:27 -0500
Date: Mon, 02 Dec 2019 18:02:16 +0200
Message-Id: <83sgm2lnqv.fsf@HIDDEN>
From: Eli Zaretskii <eliz@HIDDEN>
To: Stephen Berman <stephen.berman@HIDDEN>
In-reply-to: <8736e3vve8.fsf@HIDDEN> (message from Stephen Berman on Mon, 02
 Dec 2019 12:06:55 +0100)
Subject: Re: bug#38457: 27.0.50;
 dabbrev-expand regression due to message change
References: <8736e3vve8.fsf@HIDDEN>
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38457
Cc: 38457 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

> From: Stephen Berman <stephen.berman@HIDDEN>
> Date: Mon, 02 Dec 2019 12:06:55 +0100
> 
> 0. emacs -Q
> 1. M-! te M-/
> 
> => It takes about 4 seconds on my machine for the expansion "text" to
> appear, during which the minibuffer displays "[Scanning for
> dabbrevs...100%]" and then "[Scanning for dabbrevs...done]".  On builds
> without this regression, the expansion is virtually instantaneous and no
> message is seen in the minibuffer.
> 
> Git bisect pinpoints the following change:
> 
> aa89c84e00d8dc85100e6fedab7631c415e6364d is the first bad commit
> commit aa89c84e00d8dc85100e6fedab7631c415e6364d
> Author: Juri Linkov <juri@HIDDEN>
> Date:   Wed Nov 27 01:43:49 2019 +0200
> 
>     message uses minibuffer-message in the active minibuffer (bug#17272 bug#19064)
> 
>     * doc/lispref/display.texi (Displaying Messages): Explain the
>     behavior of using minibuffer-message if the minibuffer is active.
> 
>     * src/editfns.c (Fmessage_in_echo_area): New function with body
>     copied from Fmessage.
>     (Fmessage): Call minibuffer-message in the active minibuffer,
>     otherwise call Fmessage_in_echo_area.
>     (message-in-echo-area): New variable.
> 
>     * lisp/isearch.el (isearch--momentary-message, isearch-message):
>     * lisp/minibuffer.el (minibuffer-message, minibuffer-completion-help):
>     Use 'message-in-echo-area' instead of 'message' where necessary.
> 
>     * lisp/autorevert.el (auto-revert-handler):
>     * lisp/man.el (Man-bgproc-sentinel):
>     * lisp/subr.el (do-after-load-evaluation):
>     Revert recent changes that replaced 'message' with 'minibuffer-message'.
>     This is not needed anymore since 'message' uses 'minibuffer-message'
>     in the active minibuffer.

I guess the new message-in-echo-area confuses dabbrev.el because it
switches buffers, and dabbrev.el has special logic for that, which
triggers the message, and the subsequent wait.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 2 Dec 2019 11:07:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 02 06:07:03 2019
Received: from localhost ([127.0.0.1]:37151 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ibjXj-000511-LF
	for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 06:07:03 -0500
Received: from lists.gnu.org ([209.51.188.17]:48255)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <stephen.berman@HIDDEN>) id 1ibjXi-00050g-0R
 for submit <at> debbugs.gnu.org; Mon, 02 Dec 2019 06:07:02 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:39672)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <stephen.berman@HIDDEN>) id 1ibjXg-000681-IP
 for bug-gnu-emacs@HIDDEN; Mon, 02 Dec 2019 06:07:01 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: **
X-Spam-Status: No, score=2.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 SPOOFED_FREEMAIL,URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <stephen.berman@HIDDEN>) id 1ibjXf-0004lj-E0
 for bug-gnu-emacs@HIDDEN; Mon, 02 Dec 2019 06:07:00 -0500
Received: from mout.gmx.net ([212.227.15.19]:39987)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <stephen.berman@HIDDEN>)
 id 1ibjXf-0004kz-0Q
 for bug-gnu-emacs@HIDDEN; Mon, 02 Dec 2019 06:06:59 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=gmx.net;
 s=badeba3b8450; t=1575284817;
 bh=94olzQv8PevAFbQUYsFOTPXMxxZWzA5Haur2Pwp4OVY=;
 h=X-UI-Sender-Class:From:To:Subject:Date;
 b=XRw8YuzFD5TzCQkDKKESEZnCqQNYYqz4KBW2zSw5n594YuNzV6yJAKAfoQmM5KcGo
 B4oGvHqyH90j7kiA6diIzD993WpnmBUXcytXfLezYhSEXTNAcF9sC906R3GHPDOVlD
 GFDvKVQ2F8MRWQF62TAcd6zLax88GjQWgoN0b9TY=
X-UI-Sender-Class: 01bb95c1-4bf8-414a-932a-4f6e2808ef9c
Received: from strobe-lfs84 ([188.109.175.134]) by mail.gmx.com (mrgmx004
 [212.227.17.190]) with ESMTPSA (Nemesis) id 1MVNAr-1iAxra0APn-00SKGI for
 <bug-gnu-emacs@HIDDEN>; Mon, 02 Dec 2019 12:06:57 +0100
From: Stephen Berman <stephen.berman@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 27.0.50; dabbrev-expand regression due to message change
Date: Mon, 02 Dec 2019 12:06:55 +0100
Message-ID: <8736e3vve8.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Provags-ID: V03:K1:WCxaPjg/jn+n1T0jYgCtCv1TdPaUiqdZhqk+jufhqNZUSi23wwd
 XDddwxrSIU2Lng9kR1cJ3VOpqYy161KIdWOHLCads7Y5RWJAd+Wkh9bptkUK7E5MDb7D4Xz
 K3LiayTN6iaFlXZfRjzauW7zkcRuCLkwPW0iiURaT6KNh2jUySt6XahNlmzuD+UrcrgX7lv
 +xYUYWWbHVQ4A0sll6jYg==
X-UI-Out-Filterresults: notjunk:1;V03:K0:ax1dYgNL/MQ=:jqME3+ZJB0Fb5JHYY/Cl8C
 p3qDILLEtt/zsWQ0E5iwSL+p1TggoYuB86S3EL1MhWv8NowiENqEgGF9SoxFO7tz51Qoo5Hc0
 0IgJT0xND34ZJxi8mJ22438o0EaQ7g80IWchh0FWn6viakiaDQGvVkl7bosiVrZln2m4dOnBy
 ltHhM3guPeKlLsD8BmEOVnGmeTgL2s6+qysGkEZ5vslrVsQH4KGrlf+w4ew6sFfZW1A/3TBag
 kRvUgZ60GWI9Ec/9LFfItUKvK32dICCm4K+WaOnwovCfHeSOIMeCULmKIwFTiuAX6BsRpfNJ+
 Hcb97Ilw3bl1Abwdp+56H+woogmJeqVV3hute890KpRhRcS5/8KjskkBQqTI1ssHgQyX9EW1E
 FR8i0We/UIeVWZj/Ry9acLbAu+Jp+QtQerrsproWirt4vvL+jeX26aFpuhYddUu2j23CdacZ2
 /UdlvFSH9sadag6IQ6WRibnWJv++yJikwLnrOeVtYU2qvT38WJXRI9eUEyFDfedXFqcsSHzpN
 swmtKZzrRmwLo0hOl7JAQpi0SxFfYHv5L181hEHfsou24xe2rUsiaBdT6EDOL/mxPXWrPuVZR
 6vad3nxjGd+TbnPJTj6UqvjA5/EGrxJzWbQZFr4WYWc54lKLep6YUB2ly7f/vRsRnFOIDPslR
 HFAcYyClDQ9VdIFRFJXM52a7cYGEjL7BRd/UTQubVAWMg9EKfzOIHr19RMnzmND+lYrAbbjHe
 /ih7OgEiRUX3MidlcmEz3voJlt+0/U12dlsTxpsYaDcioZpFDLDrzrWrxFTgQs3cw8i4iYBUf
 fZK2aFrnTTBtC47rhdkiQlRLx33UTNKFRSO5gNhfoldXo6han3aSyfOvnRhTIPA9wyAIuULwB
 +PINuTKt88B8xkMdkjXGPaGaSCuXpklbQ6aT7TiYjDwAeY2DjonWQG/OHZgg3Y8m4uFR9GKQM
 r2EE5YgiaTqI718mBt5mAhzCuLQXlsKm/t+zbQKeXoEEXZIiQH3GU9sbZ2+JnIJlj4Nu/HjwS
 4YOlenP1r1ZCoA9cGYRTVf8kO6Bcv+fxdREA187sf7UWUYULQttL3LguVpagKpuN8V/wCPRUp
 nhCGzXjfhkDSLKikqk4l9ahhYiY37I6ustNGMQULx5sMgZwdenZ0uPPGKw4iWZjwln7LQ71+B
 OaxOel6qr7KSIJSacEQ+ebUzqVBFDcf9htBbGI+0SgsEfKHz+HcDGpP9ycFhDrhxQTl0DvEbj
 b6BIxJ5y2d3y4znpOzGSQ1Npx1ppkHi3T7q1BDmlnYGBbKptZ2HUkCnVNwG8=
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 212.227.15.19
X-Spam-Score: 0.6 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

0. emacs -Q
1. M-! te M-/

=3D> It takes about 4 seconds on my machine for the expansion "text" to
appear, during which the minibuffer displays "[Scanning for
dabbrevs...100%]" and then "[Scanning for dabbrevs...done]".  On builds
without this regression, the expansion is virtually instantaneous and no
message is seen in the minibuffer.

Git bisect pinpoints the following change:

aa89c84e00d8dc85100e6fedab7631c415e6364d is the first bad commit
commit aa89c84e00d8dc85100e6fedab7631c415e6364d
Author: Juri Linkov <juri@HIDDEN>
Date:   Wed Nov 27 01:43:49 2019 +0200

    message uses minibuffer-message in the active minibuffer (bug#17272 bu=
g#19064)

    * doc/lispref/display.texi (Displaying Messages): Explain the
    behavior of using minibuffer-message if the minibuffer is active.

    * src/editfns.c (Fmessage_in_echo_area): New function with body
    copied from Fmessage.
    (Fmessage): Call minibuffer-message in the active minibuffer,
    otherwise call Fmessage_in_echo_area.
    (message-in-echo-area): New variable.

    * lisp/isearch.el (isearch--momentary-message, isearch-message):
    * lisp/minibuffer.el (minibuffer-message, minibuffer-completion-help):
    Use 'message-in-echo-area' instead of 'message' where necessary.

    * lisp/autorevert.el (auto-revert-handler):
    * lisp/man.el (Man-bgproc-sentinel):
    * lisp/subr.el (do-after-load-evaluation):
    Revert recent changes that replaced 'message' with 'minibuffer-message=
'.
    This is not needed anymore since 'message' uses 'minibuffer-message'
    in the active minibuffer.


In GNU Emacs 27.0.50 (build 27, x86_64-pc-linux-gnu, GTK+ Version 3.24.5, =
cairo version 1.16.0)
 of 2019-12-01 built on strobe-lfs84
Repository revision: 9f2145f42daab13aed5cf89fdb6a7c5579819ec0
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.12003000
System Description: Linux From Scratch

Configured using:
 'configure --with-cairo 'CFLAGS=3D-Og -g3'
 PKG_CONFIG_PATH=3D/opt/qt5/lib/pkgconfig'

Configured features:
XPM JPEG TIFF GIF PNG RSVG CAIRO SOUND DBUS GSETTINGS GLIB NOTIFY
INOTIFY ACL GNUTLS LIBXML2 FREETYPE HARFBUZZ M17N_FLT LIBOTF ZLIB
TOOLKIT_SCROLL_BARS GTK3 X11 XDBE XIM MODULES THREADS JSON PDUMPER LCMS2
GMP




Acknowledgement sent to Stephen Berman <stephen.berman@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#38457; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Wed, 22 Jan 2020 01:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.